<?php

class cvote extends bhCommon {

    public function __construct()
    {
        parent::__construct();
    }


    /**
     *
     */
    public function template()
    {
        if ($template = p_getall('vote_template', array('states' => 1), array(), '', 'sort DESC')) {
            foreach ($template as & $value) {
                $value['cover_image'] = getVoteImageCover($value);
            }
        }
        $config = array(
            'is_personal' => getConfig('is_personal', 1)
        );

        $this->json(array('template' => $template, 'config' => $config));
    }


    /**
     *
     */
    public function init()
    {
        $template_id = $this->get('template_id', 23);
        $template = p_get('vote_template', array('template_id' => $template_id));

        $template['cover_image_url'] = getVoteImageCover($template);


        $luck = p_getall('luck', array('member_id' => $this->member['id'], 'is_delete' => 1, 'complete' => 2, 'status' => 1, 'examine' => 2));

        if ($luck) {
            foreach ($luck as & $value) {
                $goods = p_get('luck_goods', array('luck_id' => $value['id']));
                $value['lottery_explain'] = $goods['name'];
            }
        }

        $images = array(
            'popular_selected' => $this->image_url . 'icon/popular-selected.png',
            'brand' => $this->image_url . 'icon/brand.png',
            'activity' => $this->image_url . 'icon/activity-selected.png',
            'usercenter_selected' => $this->image_url . 'icon/usercenter-selected.png',
            'hot' => $this->image_url . 'icon/hot.png',
            'discovery_selected' => $this->image_url . 'icon/discovery-selected.png',
            'discovery' => $this->image_url . 'icon/discovery.png',
            'inventory' => $this->image_url . 'icon/inventory.png',
            'close2' => $this->image_url . 'icon/close2.png',
            'inventory_selected' => $this->image_url . 'icon/inventory-selected.png',
            'usercenter' => $this->image_url . 'icon/usercenter.png',
            'preference_selected' => $this->image_url . 'icon/preference-selected.png',
			'icon13' => $this->image_url . 'icon13.png'
        );

        $data = array(
            'template' => $template,

            's_start_nyr' => date('Y-m-d'),
            's_start_sf' => date('H:i', time() + 10),
            's_end_nyr' => date('Y-m-d', time() + 86400 * 2),

            'start_nyr' => date('Y-m-d'),
            'start_sf' => date('H:i', time() + 10),
            'end_nyr' => date('Y-m-d', time() + 86400 * 2),

            'time' => time(),
            'surplus_time' => 86400 * 100 - 1,
            'xcx_title' => getConfig('xcx_title', '投票抽奖助手'),
            'home_days' => getConfig('home_days', 0),
            'images' => $images,
            'luck' => $luck,
            'vote_examine' => getConfig('vote_examine', 2) ? : 2
        );
        $this->json($data);
    }


    /**
     *
     */
    public function index()
    {
        $id = intval($this->get('id'));
        $vote = p_get('vote_activity', array('id' => $id, 'status' => 2, 'complete' => 2, 'is_delete' => 1));

        if (empty($vote)) {
            $this->json('投票不存在', 0);
        }

        $sql = "UPDATE " . prefix('vote_activity') . " SET view_num = view_num + 1 WHERE id={$id}";
        if (!pdo_query($sql)) {
            throw new Exception('投票失败');
        }

        $vote['cover_image'] = getVoteImageCover($vote);
        $vote['bg_image'] = getImage($vote['bg_image']);
        $vote['votes_bg_image'] = getImage($vote['votes_bg_image']);

        $vote['start_time_msg'] = date('Y年m月d日', $vote['start_time']);
        $vote['end_time_msg'] = date('Y年m月d日', $vote['end_time']);
        $vote['end_time_msg_jq'] = date('Y年m月d日 H时 i分', $vote['end_time']);

        $vote['describe_img'] = $vote['describe_img'] ? json_decode($vote['describe_img'], true) : [];
        $vote['view_num']++;

        $joins = p_getall('vote_join', array('activity_id' => $id, 'status' => 1));
        $my_joins = false;
        $vote_nums = array();
        foreach ($joins as $k => & $line) {
            if ($line['thumb']) {
                $line['thumb'] = json_decode($line['thumb'], true);
                $line['thumb'] = array_map('getImage', $line['thumb']);
            }

            if ($line['uid'] == $this->member['id']) {
                $my_joins = true;
            }
            $line['no'] = $k + 1;
            $vote_nums[] = $line['vote_num'];
        }
        $new_joins = $joins;

        array_multisort($vote_nums, SORT_DESC, $joins);

        $is_joins = $vote['sign_enabled'] == 2 && $vote['sign_start_time'] < time() && $vote['sign_end_time'] > time();

        $vote_complaint = getConfig('vote_complaint');
        $vote_complaint = $vote_complaint ? json_decode($vote_complaint, true) : [];

        $vote_goods = p_getall('vote_goods', array('vote_id' => $id));
        if ($vote_goods) {
            foreach ($vote_goods as & $value) {
                $value['image'] = getImage($value['image']);
            }
        }
        $ad = array();
        if ($vote['is_luck'] == 2 && $vote['luck_id'] > 0) {
            $vote['luck'] = p_get('luck', array('id' => $vote['luck_id']));
            $luck_goods = p_get('luck_goods', array('luck_id' => $vote['luck']['id']));
            $luck_goods['image'] = $luck_goods['image'] ? getImage($luck_goods['image']) : $this->images('prize_default_picture', 'prize_default_picture.png');
            $vote['luck_goods'] = $luck_goods;
        } else {
            $ad = $this->vote->getAdvertisement(4);
        }

        $data = array(
            'vote' => $vote,
            'is_my' => $vote['member_id'] == $this->member['id'],
            'rank' => $joins,
            'joins' => $new_joins,
            'my_joins' => $my_joins,
            'is_joins' => $is_joins,
            'vote_complaint' => $vote_complaint,
            'map_appkey' => getConfig('map_appkey'),
            'surplus_time' => $vote['end_time'] - time(),
            'is_auth' => $this->is_auth,
            'vote_goods' => $vote_goods,
            'ad' => $ad,
        );

        $this->json($data);
    }


    /**
     *
     */
    public function vote()
    {
        $id = intval($this->get('id'));
        $join = p_get('vote_join', array('id' => $id, 'status' => 1));
        if (empty($join)) {
            $this->json('选手不存在', 2);
        }
        $vote = p_get('vote_activity', array('id' => $join['activity_id']));
        if ($vote['start_time'] > time()) {
            $this->json('投票活动未开始', 2);
        }
        if ($vote['end_time'] < time()) {
            $this->json('投票活动已结束', 2);
        }

        if ($vote['is_suspend'] == 2) {
            $this->json('活动已暂停,请稍后再投', 2);
        }

        if ($vote['sex_type'] > 0 && $this->member['sex'] != $vote['sex_type']) {
            $this->json('该投票仅限用' . ($vote['sex_type'] == 1 ? '男' : '女') . '性用户参加', 2);
        }

        if ($vote['region_type'] == 2 && $vote['region']) {
            if (!$local = $this->get('local')) {
                $this->json('该地区不在投票范围内', 2);
            }
            $local = explode(',', $local);
            $vote['region'] = json_decode($vote['region'], true);
            foreach ($vote['region'] as $key => $l) {
                if ($vote['region'][$key] != $local[$key]) {
                    $this->json('该地区不在投票范围内', 2);
                }
            }
        }

        $today = strtotime(date('Y-m-d'));
        $vote_num = p_getcolumn('vote_vote_log', array('uid' => $this->member['id'], 'activity_id' => $vote['id'], 'today' => $today), 'COUNT(*)') ? : 0;

        if ($vote_num >= $vote['day_votes']) {
            $this->json('每天只能投' . $vote['day_votes'] . '票', 2);
        }
        if ($vote['is_repeat'] == 1) {
            $vote_num = p_getcolumn('vote_vote_log', array('uid' => $this->member['id'], 'activity_id' => $vote['id'], 'join_id' => $id), 'COUNT(*)') ? : 0;
            if ($vote_num > 0) {
                $this->json('每个选手,不能重复投票', 2);
            }
        }

        try{
            pdo_begin();

            $sql = "UPDATE " . prefix('vote_activity') . " SET vote_num = vote_num + 1 WHERE id={$vote['id']}";
            if (!pdo_query($sql)) {
                throw new Exception('投票失败');
            }
            $sql = "UPDATE " . prefix('vote_join') . " SET vote_num = vote_num + 1 WHERE id={$id}";
            if (!pdo_query($sql)) {
                throw new Exception('投票失败');
            }
            $insert = array(
                'uid' => $this->member['id'],
                'activity_id' => $vote['id'],
                'join_id' => $id,
                'today' => $today,
                'c_time' => time(),
                'ip' => getip()
            );
            if (!p_insert('vote_vote_log', $insert)) {
                throw new Exception('投票失败');
            }
            pdo_commit();
            $this->json('');
        } catch (Exception $e){
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }
    }


    /**
     *
     */
    public function detail()
    {
        $id = intval($this->get('id'));
        $join = p_get('vote_join', array('id' => $id));
        if (empty($join)) {
            $this->json('选手不存在', 0);
        }
        if ($join['thumb']) {
            $join['thumb'] = json_decode($join['thumb'], true);
            $join['thumb'] = array_map('getImage', $join['thumb']);
        }

        $join['share_thumb'] = $join['share_thumb'] ? getImage($join['share_thumb']) : $join['thumb'][0];

        $vote = p_get('vote_activity', array('id' => $join['activity_id']));
        $vote['bg_image'] = getImage($vote['bg_image']);
        $is_joins = $vote['sign_enabled'] == 2 && $vote['sign_start_time'] < time() && $vote['sign_end_time'] > time();

        $limit = $join['vote_num'] > 3 ? 3 : $join['vote_num'];
        $propup = array();
        if ($limit > 0) {
            $propup = p_getall('vote_vote_log', array('join_id' => $id, 'activity_id' => $join['activity_id']), array(), '', '', $limit);
            foreach ($propup as & $value) {
                $value['member'] = p_getcolumn('memberinfo', array('id' => $value['uid']), 'headimgurl');
            }
        }
        $my_joins = p_get('vote_join', array('uid' => $this->member['id'], 'activity_id' => $vote['id']));
        $sql = "SELECT COUNt(*) FROM " . prefix('vote_join') . " WHERE activity_id={$vote['id']} AND id<{$id}";
        $num = (p_fetchcolumn($sql) ? : 0) + 1;


        $ad = array();
        if ($vote['is_luck'] == 2 && $vote['luck_id'] > 0) {
            $vote['luck'] = p_get('luck', array('id' => $vote['luck_id']));
            $luck_goods = p_get('luck_goods', array('luck_id' => $vote['luck']['id']));
            $luck_goods['image'] = $luck_goods['image'] ? getImage($luck_goods['image']) : $this->images('prize_default_picture', 'prize_default_picture.png');
            $vote['luck_goods'] = $luck_goods;
        } else {
            $ad = $this->vote->getAdvertisement(4);
        }
        $data = array(
            'join' => $join,
            'is_my' => $vote['member_id'] == $this->member['id'],
            'is_joins' => $is_joins,
            'propup' => $propup,
            'my_joins' => $my_joins,
            'vote' => $vote,
            'num' => $num,
            'is_auth' => $this->is_auth,
            'map_appkey' => getConfig('map_appkey'),
            'bomb_off' => getConfig('bomb_off'),
            'ad' => $ad

        );

        $this->json($data);
    }


    /**
     *
     */
    public function complaint()
    {
        $vote_id = $this->get('id');
        $content = $this->get('content');

        if (empty($vote_id) || empty($content)) {
            $this->json('请选择举报内容', 0);
        }
        p_insert('vote_complaint', array(
            'vote_id' => $vote_id,
            'content' => $content,
            'member_id' => $this->member['id'],
            'created' => time()
        ));
        $this->json();
    }


    /**
     *
     */
    public function sign()
    {
        $id = $this->get('id');
        $join = p_get('vote_join', array('activity_id' => $id, 'uid' => $this->member['id']));

        $imgs = array();
        if ($join) {
            if ($join['thumb_url'] = json_decode($join['thumb'], true)) {

                foreach ($join['thumb_url'] as $value) {
                    $imgs[] = array(
                        'url' => getImage($value),
                        'path' => $value
                    );
                }

            }

            $join['share_thumb_url'] = getImage($join['share_thumb']);
        }
        $join['thumb'] = $imgs;
        $join && $join['thumb_url'] = getImage(json_decode($join['thumb'], true));

        $images = array(
            'icon13' => $this->image_url . 'icon13.png'
        );

        $data = array('join' => $join, 'images' => $images);

        $this->json($data);
    }


    /**
     *
     */
    public function signup()
    {
        $activity_id = intval($this->get('activity_id'));
        $vote = p_get('vote_activity', array('id' => $activity_id, 'complete' => 2, 'status' => 2, 'is_delete' => 1));
        if (empty($vote)) {
            $this->json('投票活动不存在', 0);
        }
        if ($vote['sign_enabled'] == 1
            || $vote['sign_start_time'] > time()
            || $vote['sign_end_time'] < time()
        ) {
            $this->json('暂时无法参与报名', 0);
        }

        $join = p_get('vote_join', array('activity_id' => $vote['id'], 'uid' => $this->member['id']));
        if ($join && $join['status'] == 1) {
            $this->json('审核已通过,无法修改', 0);
        }

        $thumb = $this->get('thumb');
        $thumb = json_decode(html_entity_decode($thumb), true);
        $image = array();
        foreach ($thumb as $value) {
            $image[] = $value['path'];
        }

        $data = array(
            'thumb' => json_encode($image),
            'name' => $this->get('name'),
            'phone' => $this->get('phone'),
            'wechat' => $this->get('wechat'),
            'intro' => $this->get('intro'),
            'share_thumb' => $this->get('share_thumb')
        );
        if (empty($data['thumb'])
            || empty($data['name']
        )) {
            $this->json('报名封面和报名基本信息必填', 0);
        }

        if ($vote['sign_phone'] == 2 && empty($data['phone'])) {
            $this->json('报名手机号必填', 0);
        }
        if ($vote['sign_wx'] == 2 && empty($data['wechat'])) {
            $this->json('报名微信号必填', 0);
        }

        $option = array(
            'appid' => $this->w['uniaccount']['key'],
            'secret' => $this->w['uniaccount']['secret'],
        );

        $wxObj = new Wxadoc($option);
        $res = $wxObj->checkText(json_encode($data, JSON_UNESCAPED_UNICODE));
        if (isset($res['errcode']) && $res['errcode'] == 87014) {
            $this->json('内容包含敏感信息,你修改后再提交', 0);
        }

        if ($join) {
            $join['status'] == 2 && $data['status'] = 0;
            p_update('vote_join', $data, array('activity_id' => $vote['id'], 'uid' => $this->member['id']));

        } else {
            $data['c_time'] = time();
            $data['activity_id'] = $activity_id;
            $data['type'] = 2;
            $data['uid'] = $this->member['id'];
            $data['is_img'] = $vote['type'];
            p_insert('vote_join', $data);
        }

        $this->json('');
    }


    /**
     *
     */
    public function administration()
    {
        $id = $this->get('id');
        $vote = p_get('vote_activity', array('id' => $id, 'member_id' => $this->member['id'], 'complete' => 2, 'is_delete' => 1));
        if (empty($vote)) {
            $this->json('该投票活动不存在', 0);
        }
        $vote['cover_image'] =  getVoteImageCover($vote);

        $t = time();
        if ($vote['start_time'] > $t) {
            $vote['msg'] = array(
                'color' => '#f2f1f6',
                'msg' => '未开始'
            );
        } else if ($t < $vote['end_time']) {
            $vote['msg'] = array(
                'color' => '#d15243',
                'msg' => '进行中'
            );
        } else {
            $vote['msg'] = array(
                'color' => '#999',
                'msg' => '已结束'
            );
        }
        $vote['start_time_msg'] = date('Y-m-d H:i', $vote['start_time']);

        $data = array(
            'vote' => $vote,
            'audit_number' => p_getcolumn('vote_join', array('activity_id' => $id, 'status' => 0), 'COUNT(*)') ? : 0
        );
        $this->json($data);
    }


    /**
     *
     */
    public function checkList()
    {
        $id = $this->get('id');
        $status = intval($this->get('status', 0));
        $vote = p_get('vote_activity', array('id' => $id, 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
        if (empty($vote)) {
            $this->json('无操作权限', 0);
        }
        $vote['cover_image'] = getVoteImageCover($vote);

        $join = p_getall('vote_join', array('activity_id' => $id, 'status' => $status), array(), '', 'id desc');
        if ($join) {
            foreach ($join as & $value) {
                if ($vote['type'] == 1) {
                    $thumb = json_decode($value['thumb'], true);
                    $value['thumb'] = getImage($thumb[0]);
                }

                $value['isSelected'] = false;
            }
        }
        $data = array(
            'vote' => $vote,
            'join' => $join
        );
        $this->json($data);
    }


    /**
     *
     */
    public function joinDetails()
    {
        $id = $this->get('id');
        $join = p_get('vote_join', array('id' => $id));
        if (empty($join)) {
            $this->json('选手不存在', 0);
        }
        $vote = p_get('vote_activity', array('id' => $join['activity_id'], 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
        if (empty($vote)) {
            $this->json('无操作权限', 0);
        }
        if ($this->get('op') == 'update') {
            $data = array(
                'name' => $this->get('name'),
                'phone' => $this->get('phone'),
                'wechat' => $this->get('wechat'),
                'intro' => $this->get('intro'),
                'share_thumb' => $this->get('share_thumb')
            );
            $thumb = $this->get('thumb');
            $thumb = json_decode(html_entity_decode($thumb), true);
            $image = array();
            foreach ($thumb as $value) {
                $image[] = $value['path'];
            }
            $data['thumb'] = json_encode($image);

            if (empty($data['thumb'])|| empty($data['name'])) {
                $this->json('报名封面和报名基本信息必填', 0);
            }
            p_update('vote_join', $data, array('id' => $id));
            $this->json();

        } else {
            if ($join['thumb']) {
                $join['thumb'] = json_decode($join['thumb']);
                foreach ($join['thumb'] as & $value) {
                    $value = array(
                        'url' => getImage($value),
                        'path' =>  $value
                    );
                }
            }
            $join['share_thumb_url'] = getImage($join['share_thumb']);
            $member = p_get('memberinfo', array('id' => $join['uid']));
            $data = array(
                'join' => $join,
                'vote' => $vote,
                'member' => $member,
                'images' => array(
                    'icon13' => $this->image_url . 'icon13.png'
                )
            );
            $this->json($data);
        }
    }


    /**
     *
     */
    public function examine()
    {
        $ids = $this->get('ids');
        $status = $this->get('status');

        if (empty($ids) || !in_array($status, array(1, 2))) {
            $this->json();
        }
        $ids = explode(',', $ids);
        foreach ($ids as $id) {
            $join = p_get('vote_join', array('id' => $id));
            if (empty($join)) {
                continue;
            }
            $vote = p_get('vote_activity', array('id' => $join['activity_id'], 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
            if (empty($vote)) {
                continue;
            }
            if ($status == 1) {
                $sql = "UPDATE " . prefix('vote_activity') . " SET join_num = join_num + 1 WHERE id={$vote['id']}";
                pdo_query($sql);
            }

            p_update('vote_join', array('status' => $status), array('id' => $id));
        }
        $this->json();
    }


    /**
     *
     */
    public function delete()
    {
        $ids = $this->get('ids');
        if (!$ids = explode(',', $ids)) {
            $this->json();
        }
        foreach ($ids as $id) {
            $join = p_get('vote_join', array('id' => $id));
            if (empty($join)) {
                continue;
            }
            $vote = p_get('vote_activity', array('id' => $join['activity_id'], 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
            if (empty($vote)) {
                continue;
            }
            if ($join['status'] == 1) {
                $sql = "UPDATE " . prefix('vote_activity') . " SET join_num = join_num - 1 WHERE id={$vote['id']}";
                pdo_query($sql);
            }

            p_delete('vote_join', array('id' => $id));
        }
        $this->json();

    }



    /**
     *
     */
    public function addJoin()
    {
        $name = $this->get('name');
        $thumb = $this->get('thumb');
        $intro = $this->get('intro');
        $id = $this->get('id');

        $vote = p_get('vote_activity', array('id' => $id, 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
        if (empty($vote)) {
            $this->json('无操作权限', 0);
        }

        if (empty($name)) {
            $this->json('请填写姓名', 0);
        }
        if ($vote['type'] == 1 && empty($thumb)) {
            $this->json('请上传图片', 0);
        }
        $array = array();

        $thumb = json_decode(html_entity_decode($thumb), true);
        if ($thumb) {
            foreach ($thumb as $item) {
                $array[] = $item['path'];
            }
        }

        $share_thumb = $this->get('share_thumb');

        $insert = array(
            'name' => $name,
            'thumb' => json_encode($array),
            'intro' => $intro,
            'status' => 1,
            'c_time' => time(),
            'activity_id' => $id,
            'is_img' => $vote['type'],
            'share_thumb' => $share_thumb
        );
        if (p_insert('vote_join', $insert)) {
            $sql = "UPDATE " . prefix('vote_activity') . " SET join_num = join_num + 1 WHERE id={$vote['id']}";
            pdo_query($sql);
        }


        $this->json();
    }


    /**
     *
     */
    public function update()
    {
        $id = $this->get('id');

        $vote = p_get('vote_activity', array('id' => $id, 'complete' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
        if (empty($vote)) {
            $this->json('无操作权限', 0);
        }

        $update = array();
        if ($cover_image = $this->get('cover_image')) {
            $update['cover_image'] = $cover_image;
        }
        if ($suspend = $this->get('suspend')) {
            $update['is_suspend'] = $suspend;
        }
        if ($is_delete = $this->get('is_delete')) {
            $update['is_delete'] = 2;
            p_delete('home', array('relation_id' => $id, 'type' => 2));
        }

        p_update('vote_activity', $update, array('id' => $id));

        $this->json();
    }


    /**
     *
     */
    public function embed()
    {
        $type = $this->get('type', 1);
        $data = array(
            'appid' => $this->w['uniaccount']['key'],
            'path' => $type == 1 ? 'bh_vote/pages/vote/webView/webView' : 'bh_vote/pages/vote/detailsView/detailsView'
        );


        $this->json($data);
    }


    /**
     *
     */
    public function poster()
    {
        $id = $this->get('id');

        $vote = p_get('vote_activity', array('id' => $id, 'complete' => 2, 'is_delete' => 1));
        if (empty($vote)) {
            $this->json('活动不存在', 0);
        }

        if ($vote['cover_image'] && !isMy()) {
            $vote['cover_image'] = getImageLocal($this, $vote['cover_image']);
        } else {
            $vote['cover_image'] = getVoteImageCover($vote);
        }

        $xcx_path = 'bh_vote/pages/vote/webView/webView';
        $xcx_code = $this->vote->createWxCode($this, $id . '_' . $this->member['id'], $xcx_path, 'vote-' . $id . '_' . $this->member['id'] . '.png');

        $data = array(
            'vote' => $vote,
            'xcx_code' => $xcx_code
        );
        $this->json($data);
    }


    /**
     *
     */
    public function addBomb()
    {
        if (getConfig('bomb_off') == 2) {
            $this->json('弹幕功能已关闭');
        }
        $content = $this->get('content');
        $id = $this->get('id');
        $vote_id = $this->get('vote_id');
        if (empty($content) || empty($id) || empty($vote_id)) {
            $this->json();
        }

        if (getConfig('bomb_status') == 2) {
            $this->json();
        }

        p_insert('vote_danmu', array(
            'uid' => $this->member['id'],
            'content' => $content,
            'activity_id' => $vote_id,
            'join_id' => $id,
            'c_time' => time(),
        ));
        $this->json();
    }


    /**
     *
     */
    public function getBomb()
    {
        $id = $this->get('id');
        $sql = "SELECT A.content,B.nickname FROM " . prefix('vote_danmu'). ' AS A LEFT JOIN ' . prefix('memberinfo') . ' AS B ON A.uid=B.id WHERE A.join_id=' . $id . get_uniacid('A.') . ' ORDER BY A.id DESC';
        $bomb = p_fetchall($sql);

        $data = array('bomb' => $bomb);
        $this->json($data);
    }


    /**
     *
     */
    public function prizeAddress()
    {
        $id = $this->get('id');
        $luck = p_get('vote_activity', array('id' => $id, 'member_id' => $this->member['id'], 'complete' => 2));
        if (empty($luck)) {
            $this->json('无查看权限');
        }
        $info = p_getall('vote_goods_info', array('vote_id' => $id));
        foreach ($info as & $value) {
            $address = p_get('address', array('member_id' => $value['in_member_id']));
            $value['address'] = "{$address['name']}, {$address['phone']}, {$address['address']}";
            $value['member'] = p_get('memberinfo', array('id' => $value['in_member_id']));
        }
        $this->json(array('address' => $info));
    }


    /**
     *
     */
    public function apply()
    {
        $p = $this->get('p', 1);
        $page_size = 8;
        $limit = ($p - 1) * $page_size;
        $where = array('uid' => $this->member['id']);
        if ($this->get('type') == 2) {
            $where['in_prize'] = 2;
        }

        $apply = p_getall('vote_join', $where, array(),'', array('id desc'), "{$limit}, {$page_size}");
        if ($apply) {
            foreach ($apply as & $value) {
                $value['vote'] = p_get('vote_activity', array('id' => $value['activity_id']));
                $value['goods'] = p_getall('vote_goods', array('vote_id' => $value['activity_id']));
                $value['vote']['cover_image'] = getVoteImageCover($value['vote']);
                $value['vote']['end_time'] = date('Y-m-d H:i', $value['vote']['end_time']). ' 结束';

                $value['member'] = p_get('memberinfo', array('id' => $value['vote']['member_id']));
            }
        }

        $data = array('apply' => $apply);
        $this->json($data);
    }


    /**
     *
     */
    public function myLaunch()
    {
        $p = $this->get('p', 1);
        $page_size = 8;
        $limit = ($p - 1) * $page_size;
        $launch = p_getall('vote_activity', array('member_id' => $this->member['id'], 'is_delete' => 1, 'complete' => 2), array(),'', array('id desc'), "{$limit}, {$page_size}");

        if (!empty($launch)) {
            foreach ($launch as & $value) {
                $value['cover_image'] = getVoteImageCover($value);

                if ($value['lottery_type'] == 1) {
                    $value['lottery'] = date('m月d日 H:i', $value['lottery_value']);
                } elseif ($value['lottery_type'] == 2) {
                    $value['lottery'] = '满' . $value['lottery_value'] . '人';
                } else {
                    $value['lottery'] = '';
                }
                if ($value['status'] == 2) {
                    $value['locking'] = 2;
                    $value['msg'] = $value['end_time'] > time() ? '进行中' : '已结束';
                } else {
                    $value['msg'] = $value['status'] == 1 ? '审核中' : '审核未通过';
                    $value['locking'] = $value['status'];
                }

                $value['end_time'] = date('Y-m-d H:i', $value['end_time']). ' 结束';

            }
        }
        $data = array('launch' => $launch);
        $this->json($data);
    }


    /**
     *
     */
    public function edit()
    {
        $id = $this->get('id');

        $vote = p_get('vote_activity', array('id' => $id, 'member_id' => $this->member['id'], 'is_delete' => 1, 'complete' => 2));

        if (empty($vote)) {
            $this->json('投票不存在或无操作权限', 0);
        }

        if ($this->get('op') == 'up') {
            $data = array(
                'cover_image' => $this->get('cover_image'),
                'title' => $this->get('title'),
                'describe' => $this->get('describe'),
                'type' => $this->get('type'),
                'start_time' => strtotime($this->get('start_time')),
                'end_time' => strtotime($this->get('end_time')),
                'sex_type' => $this->get('sex_type'),
                'sponsor_enabled' => $this->get('sponsor_enabled'),
                'sign_enabled' => $this->get('sign_enabled'),
                'day_votes' => $this->get('day_votes'),
                'is_repeat' => $this->get('is_repeat'),
                'is_luck' => $this->get('is_luck')
            );
            if ($data['is_luck'] == 2 && $this->get('luck_id') > 0) {
                $data['luck_id'] = $this->get('luck_id');
            }

            $describe_img = $this->get('describe_img');
            $describe_img = json_decode(html_entity_decode($describe_img), true);
            if ($describe_img) {
                $data['describe_img'] = json_encode($describe_img);
            }

            $region = $this->get('region');
            $region = json_decode(html_entity_decode($region), true);
            if ($region) {
                $r = array();
                if ($region[0] != '不限') {
                    foreach ($region as $value) {
                        if ($value != '不限') {
                            $r[] = $value;
                        }
                    }
                    if ($r) {
                        $data['region_type'] = 2;
                        $data['region'] = json_encode($r);
                    }
                } else {
                    $data['region_type'] = 1;
                    $data['region'] = '';
                }
            }

            if ($data['sponsor_enabled'] == 2) {
                $data['sponsor_name'] = $this->get('sponsor_name');
                $data['sponsor_phone'] = $this->get('sponsor_phone');
            }

            if ($data['sign_enabled'] == 2) {
                $data['sign_start_time'] = strtotime($this->get('sign_start_time'));
                $data['sign_end_time'] = strtotime($this->get('sign_end_time'));
                $data['sign_phone'] = $this->get('sign_phone');
                $data['sign_wx'] = $this->get('sign_wx');
            }

            p_update('vote_activity', $data, array('id' => $id));

            $this->json();
        } else {

            $vote['cover_image_url'] = getVoteImageCover($vote);
            $vote['describe_img'] = $vote['describe_img'] ? json_decode($vote['describe_img'], true) : [];
            $vote['region'] = $vote['region'] ? json_decode($vote['region'], true) : [];

            $luck = p_getall('luck', array('member_id' => $this->member['id'], 'is_delete' => 1, 'complete' => 2, 'status' => 1));

            $vote['s_start_sf'] = date('H:i', $vote['sign_start_time']);
            $vote['s_start_nyr'] = date('Y-m-d', $vote['sign_start_time']);

            $vote['s_end_nyr'] = date('Y-m-d', $vote['sign_end_time']);
            $vote['s_end_sf'] = date('H:i', $vote['sign_end_time']);

            $vote['start_nyr'] = date('Y-m-d', $vote['start_time']);
            $vote['start_sf'] = date('H:i', $vote['start_time']);
            $vote['end_nyr'] = date('Y-m-d', $vote['end_time']);
            $vote['end_sf'] = date('H:i', $vote['end_time']);

            $vote['xcx_title'] = getConfig('xcx_title', '投票抽奖助手');

            if ($luck) {
                foreach ($luck as & $value) {
                    $goods = p_get('luck_goods', array('luck_id' => $value['id']));
                    $value['lottery_explain'] = $goods['name'];
                }
            }
            $vote['luck'] = $luck;

            $vote['images'] = array(
                'popular_selected' => $this->image_url . 'icon/popular-selected.png',
                'brand' => $this->image_url . 'icon/brand.png',
                'activity' => $this->image_url . 'icon/activity-selected.png',
                'usercenter_selected' => $this->image_url . 'icon/usercenter-selected.png',
                'hot' => $this->image_url . 'icon/hot.png',
                'discovery_selected' => $this->image_url . 'icon/discovery-selected.png',
                'discovery' => $this->image_url . 'icon/discovery.png',
                'inventory' => $this->image_url . 'icon/inventory.png',
                'close2' => $this->image_url . 'icon/close2.png',
                'inventory_selected' => $this->image_url . 'icon/inventory-selected.png',
                'usercenter' => $this->image_url . 'icon/usercenter.png',
                'preference_selected' => $this->image_url . 'icon/preference-selected.png',
				'icon13' => $this->image_url . 'icon13.png',
            );

            $this->json($vote);
        }
    }

}