<?php

class index extends bhCommon {

    public function __construct()
    {
        parent::__construct();
    }


    /**
     *
     */
    public function index()
    {
        $daily = $this->vote->getRecommend(1, 6, $this->member['id']);
        $self = $this->vote->getRecommend(2, 10, $this->member['id']);
        $cover = $this->vote->getRecommend(4, 10, $this->member['id']);

        $config = array(
            'home_public_number' => getConfig('home_public_number'),
            'is_front_page' => getConfig('is_front_page', 1),
            'integral_name' => getConfig('integral_name', '积分'),
            'home_title' => getConfig('home_title', '公共福利'),
            'daily_benefits' => getConfig('daily_benefits', '每日福利'),
            'self_service' => getConfig('self_service', '自助福利'),
            'cover_red_bag' => getConfig('cover_red_bag', '封面红包'),
            'home_public_number_url' => getConfig('home_public_number_url'),
            'is_new_home' => getConfig('is_new_home', 2),
            'open_withdrawal' => getConfig('open_withdrawal', 1),
            'guide_bg_color' => getConfig('guide_bg_color', '#149F5B'),
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FE5555'),
            'home_show_guide' => getConfig('home_show_guide', 1),
            'screen_second' => intval(getConfig('screen_second', 0)) * 1000,
        );
        $config['home_public_number_url'] && $config['home_public_number_url'] = urlencode($config['home_public_number_url']);
        $images = array(
            'xin' => $this->images('integral_img', 'pop_gold.png')
        );
        $is_integral_plugin = $this->vote->is_show_integral();

        $sgin = array();
        if ($is_integral_plugin) {
            $sgin['is_sign'] = $this->vote->is_sign($this->member['id']);
        }

        $isIntegralUser = $this->vote->isIntegralUser();
        $order_count = 0;
        if ($config['open_withdrawal'] == 1 && $isIntegralUser) {
            $order_count = p_getcolumn('order', array('member_id' => $this->member['id']), 'COUNT(*)') ? : 0;
        }

        $data = array(
            'config' => $config,
            'daily' => $daily,
            'self' => $self,
            'cover' => $cover,
            'ad' => $this->vote->getAdvertisement(1),
            'member' => $this->member,
            'is_integral_plugin' => $is_integral_plugin,
            'images' => $images,
            'sgin' => $sgin,
            'order_count' => $order_count,
            'home_top_ad' => $this->vote->getAdvertisement(6, 4),
            'isIntegralUser' => $isIntegralUser,
            'home_screen' => getConfig('home_screen', 1),
            'screen_ad' => getConfig('screen_ad'),
            'is_union' => $this->vote->is_union(),
            'date' => date('Y-md')
        );
        $data['yy'] = yanyi();
        if ($data['yy']) {
            $data['images_bg'] = $this->image_url . '20190701102654167.png';
            $data['currency_name'] = getConfig('currency_name', '燃力币');
            $data['yy_ad'] = $this->vote->getAdvertisement(8, 4);
        }

        $this->json($data);
    }


    /**
     *
     */
    public function selfHelp()
    {
        $p = $this->get('p', 1);
        $page_size = 10;
        $limit = ($p - 1) * $page_size . ',' . $page_size;

        $daily = $this->vote->getRecommend(2, $limit);

        $this->json(array('daily' => $daily));
    }


    public function decode()
    {
        $path = $this->get('path');
        $path = urldecode($path);
        $this->json(array('path' => $path));
    }


    /**
     *
     */
    public function register()
    {
        $iv = $this->get('iv');
        $encryptedData = $this->get('encryptedData');

        $wxbd = new WXBizDataCrypt($this->w['uniaccount']['key'], $this->session_key);

        $res = $wxbd->decryptData($encryptedData, $iv, $data);
        if ($res != ErrorCode::$OK) {
            p_delete('token', array('member_id' => $this->member['id']));
            $this->json('更新失败', -1);
        }

        $data = json_decode($data, true);
        $member_id = $this->member['id'];

        $update = array(
            'nickname' => $data['nickName'],
            'headimgurl' => $data['avatarUrl'],
            'city' => $data['city'],
            'province' => $data['province'],
            'country' => $data['country'],
            'sex' => $data['gender'],
            'u_time' => time()
        );

        if (isset($data['unionId']) && $this->vote->isIntegralUser()) {
            $update['unionid'] = $data['unionId'];
        }


        if (!$this->member['nickname'] && !$this->member['headimgurl'] && $this->member['parent_id'] > 0) {
            $this->vote->add_share_number($this->member['parent_id']);
        }

        p_update('memberinfo', $update, array('id' => $member_id));

        if (yanyi() && !p_get('currency_log', array('member_id' => $this->member['id'], 'type' => 9))) {
            include IA_ROOT . '/addons/bh_vote/model/shop.mod.php';
            $m = new shopModel();
            $m->change_currency($this->member['id'], getConfig('auth_currency'), 9);
        }

        $this->json();
    }


    public function authorization()
    {
        $update = array(
            'nickname' => $this->get('nickName'),
            'headimgurl' => $this->get('avatarUrl'),
            'city' => $this->get('city'),
            'province' => $this->get('province'),
            'country' => $this->get('country'),
            'sex' => $this->get('gender'),
            'u_time' => time()
        );
        if (!$this->member['nickname'] && !$this->member['headimgurl'] && $this->member['parent_id'] > 0) {
            $this->vote->add_share_number($this->member['parent_id']);
        }
        p_update('memberinfo', $update, array('id' => $this->member['id']));
        $this->json();
    }

    /**
     *
     */
    public function launch()
    {
        if ($launch = p_getall('launch', array('status' => 1), array(), '', 'sort DESC')) {
            foreach ($launch as & $value) {
                $value['describe'] = json_decode($value['describe'], true);
                $value['bgcolor'] = json_decode($value['bgcolor'], true);
                $value['icon'] = getImage($value['icon']);
            }
        }
        $data = array(
            'launch' => $launch,
            'vote_introduce_url' => urlencode(getConfig('vote_introduce_url')),
            'is_auth' => $this->is_auth,
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FE5555')
        );


        $this->json($data);
    }


    public function newLaunch()
    {
        if ($launch = p_getall('launch', array('status' => 1), array(), '', 'sort DESC')) {
            foreach ($launch as & $value) {
                //$value['describe'] = json_decode($value['describe'], true);
                //$value['bgcolor'] = json_decode($value['bgcolor'], true);
                $value['icon'] = getImage($value['icon']);
            }
        }

        $ad = array(
            'banner' => $this->vote->getAdvertisement(7),
            'icon' => $this->vote->getAdvertisement(8, 4)
        );

        $config = array(
            'xcx_title' => getConfig('xcx_title'),
            'xcx_describe' => getConfig('xcx_describe', '一款上千万人使用的小程序'),
        );

        $data = array(
            'launch' => $launch,
            //'vote_introduce_url' => urlencode(getConfig('vote_introduce_url')),
            'is_auth' => $this->is_auth,
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FE5555'),
            'ad' => $ad,
            'config' => $config,

        );

        $this->json($data);

    }


    /**
     *
     */
    public function share()
    {
        $share_img = getImageLocal($this, getConfig('down_share_img', '24ae836fab36bf789aa68efb3afbcd4.png'));
        $data = array('share_img' => $share_img);
        $this->json($data);
    }


    /**
     *
     */
    public function use_substance()
    {
        $use_substance = getConfig('use_substance', 1) ? : 1;

        $data = array('use_substance' => $use_substance, 'isIntegralUser' => $this->vote->isIntegralUser());
        $this->json($data);
    }
}