<?php

class interaction extends bhCommon {


    /**
     * 活动列表
     */
    public function activity()
    {
        $t = time();
        $sql = 'SELECT id,name,share_img FROM ' . prefix('hd_activity') . " WHERE {$t} >= start_time AND {$t} <= end_time AND is_home =1 AND is_delete=1" . get_uniacid();
        $list = p_fetchall($sql);

        if ($list) {
            foreach ($list as & $value) {
                $head_picture = p_getall('hd_head_picture', array('activity_id' => $value['id']));
                $value['share_img'] = getImage($value['share_img']);
                $value['head_picture'] = array_map('ad', $head_picture);
                $value['participate'] = p_get('hd_activity_participate', array('member_id' => $this->member['id'], 'activity_id' => $value['id']));
            }
        }
        $config = array(
            'interaction_title' => getConfig('interaction_title', '奥佳锦鲤'),
            'theme_color' => getConfig('my_title_bg_color'),
        );


        $data = array(
            'list' => $list,
            'config' => $config,
            'is_auth' => $this->is_auth
        );
        $this->json($data);
    }


    /**
     *  活动是否进行中
     */
    public function is_activity()
    {
        $id = intval($this->get('id'));
        if (empty($id)) {
            $this->json(array('is_activity' => 2));
        }

        $sql = 'SELECT * FROM ' . prefix('hd_activity') . " WHERE id ={$id} AND is_delete=1" . get_uniacid();
        $activity = p_fetch($sql);

        if (empty($activity)) {
            $this->json(array('is_activity' => 2));
        }
        $t = time();
        if ($activity['start_time'] > $t) {
            $this->json(array('is_activity' => 2));
        }
        if ($activity['end_time'] < $t) {
            $this->json(array('is_activity' => 2));
        }

        $this->json(array('is_activity' => 1));
    }


    /**
     * 活动内容
     */
    public function content()
    {
        $p = $this->get('p', 1);
        $id = intval($this->get('id'));
        if (empty($id)) {
            $this->json('参数错误', 0);
        }
        $page_size = 10;
        $limit = ($p - 1) * $page_size;
        $content = p_getall('hd_activity_participate', array('activity_id' => $id, 'status' => 2), array(),'', 'sort desc,fabulous desc,id desc', "{$limit}, {$page_size}");

        if ($content) {
            foreach ($content as & $value) {
                $cover = json_decode($value['images']);
                $value['cover_image'] = getImage($cover[0]);
                $value['member'] = p_get('memberinfo', array('id' => $value['member_id']), array('nickname', 'headimgurl'));
            }
        }

        $data = array(
            'content' => $content
        );
        $this->json($data);
    }



    /**poster
     * 初始化
     */
    public function getready()
    {
        $id =  intval($this->get('id'));
        $sql = 'SELECT * FROM ' . prefix('hd_activity') . " WHERE id ={$id} AND is_delete=1" . get_uniacid();
        $activity = p_fetch($sql);

        if (empty($activity)) {
            $this->json('活动不存在', 0);
        }
        $t = time();
        if ($activity['start_time'] > $t) {
            $this->json('活动暂未开始', 0);
        }
        if ($activity['end_time'] < $t) {
            $this->json('活动已结束', 0);
        }

        $participate = p_get('hd_activity_participate', array('activity_id' => $id, 'member_id' => $this->member['id']));
        if ($participate) {
            $participate['images'] = json_decode($participate['images'], true);
        }
        $config = array(
            'examine_notice_id' => getConfig('examine_notice_id'),
            'theme_color' => getConfig('my_title_bg_color'),
            'image_domain' => getImage('/'),
            'open_hd' => getConfig('open_hd', 2)
        );

        $data = array(
            'participate' => $participate,
            'config' => $config

        );
        $this->json($data);
    }



    /**
     * 发布编辑活动
     */
    public function save()
    {
        $id =  intval($this->get('id'));

        $sql = 'SELECT * FROM ' . prefix('hd_activity') . " WHERE id ={$id} AND is_delete=1" . get_uniacid();
        $activity = p_fetch($sql);

        if (empty($activity)) {
            $this->json('活动不存在', 0);
        }
        $t = time();
        if ($activity['start_time'] > $t) {
            $this->json('活动暂未开始', 0);
        }
        if ($activity['end_time'] < $t) {
            $this->json('活动已结束', 0);
        }

        $title = $this->get('title');
        $content = $this->get('content');
        $images = $this->get('images');

        if (empty($title)) {
            $this->json('请输入标题', 0);
        }

        if (empty($content)) {
            $this->json('请输入正文内容', 0);
        }

        if (empty($images)) {
            $this->json('请上传图片', 0);
        }
        $images = json_encode(explode(',', $images));
        $data = array(
            'activity_id' => $id,
            'member_id' => $this->member['id'],
            'title' => $title,
            'content' => $content,
            'images' => $images,
            'status' => 1,
            'updated' => time()
        );

        $option = array(
            'appid' => $this->w['uniaccount']['key'],
            'secret' => $this->w['uniaccount']['secret'],
        );

        $wxObj = new Wxadoc($option);

        $res = $wxObj->checkText($data['title'] . $data['content']);

        if (isset($res['errcode']) && $res['errcode'] == 87014) {
            $this->json('内容包含敏感信息,修改后再提交', 0);
        }

        $participate = p_get('hd_activity_participate', array('activity_id' => $id, 'member_id' => $this->member['id']));
        if ($participate) {
            if ($participate['status'] < 3) {
                $this->json(array('id' => $participate['id']));
            }
            p_update('hd_activity_participate', $data, array('id' => $participate['id']));
            $id = $participate['id'];
        } else {
            $data['created'] = time();
            p_insert('hd_activity_participate', $data);
            $id = pdo_insertid();
        }

        $this->json(array('id' => $id));
    }


    /**
     * 活动详情
     */
    public function details()
    {
        $id =  intval($this->get('id'));
        $participate = p_get('hd_activity_participate', array('id' => $id));
        if (empty($participate)) {
            $this->json('内容不存在', 0);
        }

        $member = p_get('memberinfo', array('id' => $participate['member_id']), array('nickname', 'headimgurl'));

        $config = array(
            'theme_color' => getConfig('my_title_bg_color')
        );

        $participate['images'] = json_decode($participate['images'], true);
        $participate['images'] = array_map('getImage', $participate['images']);

        $data = array(
            'participate' => $participate,
            'member' => $member,
            'config' => $config,
            'is_auth' => $this->is_auth,
            'my' => $this->member,
            'is_fabulous' => !empty(p_get('hd_activity_fabulous', array('member_id' => $this->member['id'], 'participate_id' => $id)))
        );

        $this->json($data);
    }


    /**
     * 转发
     */
    public function forward()
    {
        $id =  intval($this->get('id'));
        $participate = p_get('hd_activity_participate', array('id' => $id));
        if (empty($participate)) {
            $this->json('内容不存在', 0);
        }

        p_update('hd_activity_participate', array('forward' => $participate['forward'] + 1), array('id' => $id));
        $this->json();

    }


    /**
     * 点赞
     */
    public function fabulous()
    {
        $id =  intval($this->get('id'));
        $participate = p_get('hd_activity_participate', array('id' => $id));
        if (empty($participate)) {
            $this->json('内容不存在', 0);
        }
        if ($participate['status'] != 2) {
            $this->json('审核通过后才能点赞', 0);
        }

        if (!$this->is_auth) {
            $this->json('授权后才能点赞', 0);
        }

        $activity = p_get('hd_activity', array('id' => $participate['activity_id']));

        if (empty($activity)) {
            $this->json('活动不存在', 0);
        }
        $t = time();
        if ($activity['start_time'] > $t) {
            $this->json('活动还未开始', 0);
        }
        if ($activity['end_time'] < $t) {
            $this->json('活动已结束', 0);
        }

        if (p_get('hd_activity_fabulous', array('member_id' => $this->member['id'], 'participate_id' => $id))) {
            $this->json();
        }
        $count = p_getcolumn('hd_activity_fabulous', array('member_id' => $this->member['id']), 'COUNT(*)') ? : 0;
        if ($count >= $activity['fabulous_number']) {
            $this->json('每个活动下最多只能给' . $activity['fabulous_number'] . '人点赞', 0);
        }

        try{
            pdo_begin();
            $sql = 'UPDATE ' . prefix('hd_activity_participate') . ' SET fabulous= fabulous + 1 WHERE id=' . $id;
            if (!pdo_query($sql)) {
                throw new Exception('点赞失败,稍后再试');
            }

            $insert = array(
                'activity_id' => $participate['activity_id'],
                'participate_id' => $participate['id'],
                'member_id' => $this->member['id'],
                'created' => time()
            );
            if (!p_insert('hd_activity_fabulous', $insert)) {
                throw new Exception('点赞失败,稍后再试');
            }
            pdo_commit();
            $this->json();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 0);
        }


    }


    /**
     * 取消
     */
    public function cancel()
    {
        $id =  intval($this->get('id'));
        $participate = p_get('hd_activity_participate', array('id' => $id));
        if (empty($participate)) {
            $this->json('内容不存在', 0);
        }
        if ($participate['status'] != 2) {
            $this->json();
        }
        $fabulous = p_get('hd_activity_fabulous', array('member_id' => $this->member['id'], 'participate_id' => $id));
        if (!$fabulous || $participate['fabulous'] < 1
        ) {
            $this->json();
        }

        try{
            pdo_begin();
            $sql = 'UPDATE ' . prefix('hd_activity_participate') . ' SET fabulous= fabulous - 1 WHERE id=' . $id;
            if (!pdo_query($sql)) {
                throw new Exception('取消失败,稍后再试1');
            }
            if (!p_delete('hd_activity_fabulous', array('id' => $fabulous['id']))) {
                pdo_debug();
                throw new Exception('取消失败,稍后再试2');
            }
            pdo_commit();
            $this->json();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 0);
        }
    }


    /**
     * 点赞列表
     */
    public function fabulousList()
    {
        $id =  intval($this->get('id'));
        $p =  intval($this->get('p', 1));
        $page_size = 42;
        $limit = ($p - 1) * $page_size;

        $sql = 'SELECT B.headimgurl FROM ' . prefix('hd_activity_fabulous') . ' A INNER JOIN ' . prefix('memberinfo') . " B ON A.member_id=B.id WHERE A.participate_id={$id} AND A.member_id!={$this->member['id']} ORDER BY A.id ASC LIMIT {$limit},{$page_size}";
        $list = p_fetchall($sql);

        $config = array(
            'theme_color' => getConfig('my_title_bg_color')
        );
        $data = array(
            'list' => $list,
            'config' => $config,
        );
        $this->json($data);
    }



    /**
     * 点赞排行榜
     */
    public function rank()
    {
        $p = $this->get('p', 1);
        $id = intval($this->get('id'));
        if (empty($id)) {
            $this->json('参数错误', 0);
        }
        $page_size = 10;
        $limit = ($p - 1) * $page_size;
        $content = p_getall('hd_activity_participate', array('activity_id' => $id, 'status' => 2), array(),'', 'fabulous desc,id desc', "{$limit}, {$page_size}");

        if ($content) {
            foreach ($content as & $value) {
                $value['member'] = p_get('memberinfo', array('id' => $value['member_id']), array('nickname', 'headimgurl'));
            }
        }

        $activity = p_get('hd_activity', array('id' => $id));

        $data = array(
            'content' => $content,
            'activity' => $activity
        );
        $this->json($data);
    }


    /**
     * 我发布的
     */
    public function my()
    {
        $p = $this->get('p', 1);
        $page_size = 10;
        $limit = ($p - 1) * $page_size;
        $content = p_getall('hd_activity_participate', array('member_id' => $this->member['id']), array(),'', array('id desc'), "{$limit}, {$page_size}");

        if ($content) {
            foreach ($content as & $value) {
                $cover = json_decode($value['images']);
                $value['cover_image'] = getImage($cover[0]);
            }
        }

        $config = array(
            'theme_color' => getConfig('my_title_bg_color')
        );
        $data = array(
            'list' => $content,
            'config' => $config,
            'member' => $this->member
        );
        $this->json($data);
    }


    /**
     * 海报
     */
    public function poster()
    {
        $id =  intval($this->get('id'));
        $participate = p_get('hd_activity_participate', array('id' => $id));
        if (empty($participate)) {
            $this->json('内容不存在', 0);
        }
        if ($participate['status'] != 2) {
            $this->json('还未通过审核', 0);
        }


        $participate['images'] = json_decode($participate['images']);
        $participate['cover_image'] = getImage($participate['images'][0]);

        $activity = p_get('hd_activity', array('id' => $participate['activity_id']));
        $activity['base_map'] = getImage($activity['base_map']);


        $path = 'interaction/pages/detail/detail';
        //$path = '';
        $code = $this->vote->createWxCode($this, $id, $path, 'interaction' . $id . '.png');
        $config = array(
            'theme_color' => getConfig('my_title_bg_color')
        );
        $initiator = p_get('memberinfo', array('id' => $participate['member_id']));

        $data = array(
            'code' => $code,
            'participate' => $participate,
            'config' => $config,
            'initiator' => $initiator,
            'activity' => $activity,
        );
        $this->json($data);
    }


}