<?php
include IA_ROOT . '/addons/bh_vote/model/jizi.mod.php';
class jizi extends bhCommon {

    public $jz;

    public function __construct()
    {
        parent::__construct();
        if (!$this->vote->is_show_integral()) {
            $this->json('请先安装插件', 0);
        }
        $this->jz = new jiziModel();
    }


    /**
     * 活动详情
     */
    public function index()
    {
        $id = $this->get('id');

        $calligraphy = p_get('calligraphy', array('id' => $id, 'is_delete' => 1));

        if (empty($calligraphy)) {
            $this->json('活动不存在', 0);
        }
        $calligraphy['images'] = json_decode($calligraphy['images'], true);
        $calligraphy['images'] = array_map('getImage', $calligraphy['images']);
        $calligraphy['share_image'] = getImage($calligraphy['share_image']);
        $calligraphy['share_txt'] = str_replace('{name}', $this->member['nickname'], $calligraphy['share_txt']);



        $words = p_getall('calligraphy_details', array('calligraphy_id' => $id), array(), '', 'sort desc,id desc');

        $calligraphy_member = p_get('calligraphy_member', array('member_id' => $this->member['id'], 'calligraphy_id' => $id));

        $succ = false;
        if ($words && $calligraphy_member) {
            $w = array(
                'member_id' => $this->member['id'],
                'calligraphy_id' => $id,
                'status' => 1
            );
            $succ = true;
            foreach ($words as & $value) {
                $w['calligraphy_details_id'] = $value['id'];
                $value['number'] = p_getcolumn('calligraphy_member_log', $w, 'COUNT(*)') ? : 0;
                if ($value['number'] < 1) {
                    $succ = false;
                }
            }
        }

        // 领取数量
        $calligraphy['receive'] = p_getcolumn('calligraphy_member', array('calligraphy_id' => $id), 'SUM(success)') ? : 0;
        $calligraphy['participate'] = p_getcolumn('calligraphy_member', array('calligraphy_id' => $id), 'COUNT(*)') ? : 0;
        $is_end = $calligraphy['end_time'] > time() && $calligraphy['stock'] > $calligraphy['receive'];

        $participate = [];

        if ($calligraphy['participate'] > 0) {
            $limit = $calligraphy['participate'] > 8 ? 8 : $calligraphy['participate'];
            $participate = p_fetchall('SELECT B.headimgurl FROM ' . prefix('calligraphy_member') . ' AS A LEFT JOIN ' . prefix('memberinfo') . ' AS B ON A.member_id = B.id WHERE A.calligraphy_id=' . $id .'  ORDER BY A.id DESC LIMIT ' . $limit);
        }


        // 剩余时间
        $surplus_time = $is_end ? $calligraphy['end_time'] - time() : 0;


        $config = array(
            'video_ad' => getConfig('video_ad'),
            'banner_id' => getConfig('goods_flow_group', 'adunit-c58290afc7b0598d'),
            'integral_name' => getConfig('integral_name'),
            'jizi_integral' => getConfig('jizi_integral', 1),
            'my_title_color' => getConfig('my_title_color', '#000000'),
            'screen_ad' => getConfig('screen_ad'),
            'screen_second' => getConfig('screen_second', 0),
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FFFFFF'),
        );
        $address = p_get('address', array('member_id' => $this->member['id']));

        $data = array(
            'calligraphy' => $calligraphy,
            'words' => $words,
            'config' => $config,
            'is_end' => $is_end,
            'succ' => $succ,
            'participate' => $participate,
            'address' => $address,
            'surplus_time' => $surplus_time
        );
        $this->json($data);
    }


    /**
     * 集字
     */
    public function extract()
    {
        $id = $this->get('id');

        pdo_begin();
        try{
            $res = $this->jz->extract($id, $this->member['id'], $this);
            if ($res === false) {
                throw new Exception($this->jz->error);
            }
            pdo_commit();
            $this->json(array('res' => $res));
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }
    }


    /**
     * 兑换
     */
    public function exchange()
    {
        $id = $this->get('id');
        $words = p_getall('calligraphy_details', array('calligraphy_id' => $id));

        $calligraphy_member = p_get('calligraphy_member', array('member_id' => $this->member['id'], 'calligraphy_id' => $id));
        if (!$calligraphy_member) {
            $this->json('集字不足', 2);
        }


        $calligraphy = p_get('calligraphy', array('id' => $id, 'is_delete' => 1));

        if (empty($calligraphy)) {
            $this->json('活动不存在', 2);
        }

        $receive = p_getcolumn('calligraphy_member', array('calligraphy_id' => $id), 'SUM(success)') ? : 0;

        $is_end = $calligraphy['end_time'] > time() && $calligraphy['stock'] > $receive;

        if (!$is_end) {
            $this->json('活动已结束', 2);
        }

        $address = p_get('address', array('member_id' => $this->member['id']));
        if (empty($address)) {
            $this->json('请填写收货地址', 2);
        }

        $w = array(
            'member_id' => $this->member['id'],
            'calligraphy_id' => $id,
            'status' => 1
        );
        pdo_begin();
        try {
            foreach ($words as $value) {
                $w['calligraphy_details_id'] = $value['id'];
                $word = p_get('calligraphy_member_log', $w);
                if (empty($word)) {
                    throw new Exception('集字不足');
                }
                if (!p_update('calligraphy_member_log', array('status' => 2), array('id' => $word['id'], 'status' => 1))) {
                    throw new Exception('兑换失败2');
                }
            }

            $order = array(
                'calligraphy_id' => $id,
                'member_id' => $this->member['id'],
                'address' => $address['address'],
                'phone' => $address['phone'],
                'name' => $address['name'],
                'created' => time()
            );
            if (!p_insert('calligraphy_order', $order)) {
                throw new Exception('兑换失败1');
            }
            if (!p_update('calligraphy_member', array('success' => $calligraphy_member['success'] + 1), array('id' => $calligraphy_member['id']))) {
                throw new Exception('兑换失败3');
            }

            pdo_commit();
            $this->json();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }
    }



    /**
     * 我参与的集字列表
     */
    public function participate()
    {
        $participate = p_getall('calligraphy_member', array('member_id' => $this->member['id']), array(), array(), 'id desc');
        if ($participate) {
            $t = time();
            foreach ($participate as & $value) {
                $value['calligraphy'] = p_get('calligraphy', array('id' => $value['calligraphy_id']));
                $value['calligraphy']['cover_img'] = getImage($value['calligraphy']['cover_img']);
                $value['receive'] = p_getcolumn('calligraphy_member', array('calligraphy_id' => $value['calligraphy_id']), 'SUM(success)') ? : 0;
                $value['is_end'] = $value['calligraphy']['end_time'] > $t && $value['calligraphy']['stock'] > $value['receive'];
                $value['surplus_time'] = $value['is_end'] ? $value['calligraphy']['end_time'] - $t : 0;
            }
        }

        $data = array(
            'participate' => $participate
        );
        $this->json($data);
    }


    public function order()
    {
        $order = p_getall('calligraphy_order', array('member_id' => $this->member['id']), array(),'', array('id desc')) ? : array();
        if ($order) {
            $status = array(
                1 => '未发货',
                2 => '已发货',
                3 => '已完成',
                4 => '已取消'
            );
            foreach ($order as & $value) {
                $value['calligraphy'] = p_get('calligraphy', array('id' => $value['calligraphy_id']));
                $value['calligraphy']['cover_img'] = getImage($value['calligraphy']['cover_img']);
                $value['created'] = date('Y-m-d H:i:s', $value['created']);
                $value['status_msg'] = $status[$value['status']];
            }
        }
        $images = array(
            'my_orders_nodata' => $this->image_url . 'my_orders_nodata.png',
            'my_express_icon' => $this->image_url . 'my_express_icon.png',
            'address_locate' => $this->image_url . 'address_locate.png',
            'attention' => $this->image_url . 'attention.png'
        );
        $config = array(
            'my_title_color' => getConfig('my_title_color', '#000000'),
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FFFFFF'),
        );
        $data = array(
            'orders' => $order,
            'currency_name' => getConfig('integral_name'),
            'images' => $images,
            'config' => $config
        );
        $this->json($data);
    }
}