<?php

class new_vote extends bhCommon {

    public function __construct()
    {
        parent::__construct();
    }


    /**
     *
     */
    public function template()
    {
        if ($template = p_getall('vote_template', array(), array(), '', 'sort DESC')) {
            foreach ($template as & $value) {
                $value['cover_image'] = getImage($value['cover_image']);
            }
        }

        $this->json(array('template' => $template));
    }


    /**
     *
     */
    public function init()
    {
        $template_id = $this->get('id', 23);
        $template = p_get('vote_template', array('id' => $template_id));
        $template['cover'] = getVoteImageCover($template);

        $isqq = isQq() ? 2 : 1;

        $url = $this->app->createUrl('voteTemplate', array('id' => $template_id, 'token' => $this->get('token'), 'isqq' => $isqq));
        $url = str_replace('./index.php', '', $url);

        $data = array(
            'template' => $template,
            'url' => $url
        );
        $this->json($data);
    }


    /**
     *
     */
    public function new_index()
    {
        $id = $this->get('id');
        $vote = p_get('vote_activity', array('id' => $id, 'status' => 2, 'complete' => 2, 'is_delete' => 1));
        if (empty($vote)) {
            $this->json('投票不存在', 0);
        }
        $vote['cover_image'] = getVoteImageCover($vote);


        $screen_ad = '';
        $vote_cost_ad = getConfig('vote_cost_ad', 1);
        $vote_index_ad = getConfig('vote_index_ad', 1);
        if ($vote_index_ad == 1 && ($vote_cost_ad == 3 || ($vote['prize_type'] == 1 && $vote_cost_ad == 2))) {
            $screen_ad = getConfig('screen_ad');
        }
        $group_id = '';

        if ($vote['appoint_group'] == 2) {
            $encryptedData = $this->get('encryptedData');
            $iv = $this->get('iv');

            if ($encryptedData && $iv) {
                $wxbd = new WXBizDataCrypt($this->w['uniaccount']['key'], $this->session_key);
                $res = $wxbd->decryptData($encryptedData, $iv, $data);
                if ($res != ErrorCode::$OK) {
                    $this->json('unlogin', -1);
                }
                $data = json_decode($data, true);
                $group_id = $data['openGId'];
                if (empty($vote['group_id'])) {
                    p_update('vote_activity', array('group_id' => $group_id), array('id' => $id));
                }
            }
        }
        $isqq = isQq() ? 2 : 1;
        $url = $this->app->createUrl('voteIndex', array('id' => $id, 'token' => $this->get('token'), 'group_id' => $group_id, 'isqq' => $isqq));
        $url = str_replace('./index.php', '', $url);
        $screen_second = intval(getConfig('screen_second', 10)) * 1000;

        $this->json(array('vote' => $vote, 'url' => $url, 'screen_ad' => $screen_ad, 'screen_second' => $screen_second));
    }


    /**
     *
     */
    public function index($id)
    {

        $vote = p_get('vote_activity', array('id' => $id, 'status' => 2, 'complete' => 2, 'is_delete' => 1));

        if (empty($vote)) {
            $this->json('投票不存在', 0);
        }

        $sql = "UPDATE " . prefix('vote_activity') . " SET view_num = view_num + 1 WHERE id={$id}";
        if (!pdo_query($sql)) {
            throw new Exception('投票失败');
        }

        $vote['cover_image'] = getVoteImageCover($vote);

        $vote['bg_image'] = getImage($vote['bg_image']);
        $vote['votes_bg_image'] = getImage($vote['votes_bg_image']);

        $vote['start_time_msg'] = date('Y年m月d日', $vote['start_time']);
        $vote['end_time_msg'] = date('Y年m月d日', $vote['end_time']);

        $vote['end_time_msg_jq'] = date('Y年m月d日 H时 i分', $vote['end_time']);
        $vote['end_time_year'] = date('Y', $vote['end_time']);
        $vote['end_time_month'] = date('m', $vote['end_time']);
        $vote['end_time_day'] = date('d', $vote['end_time']);
        $vote['end_time_hour'] = date('H', $vote['end_time']);
        $vote['end_time_minute'] = date('i', $vote['end_time']);

        $vote['describe_img'] = $vote['describe_img'] ? json_decode($vote['describe_img'], true) : [];
        $vote['view_num']++;

        $joins = p_getall('vote_join', array('activity_id' => $id));
        $my_joins = false;

        $new_joins = array();
        foreach ($joins as $k => & $line) {
            if ($line['thumb']) {
                $line['thumb'] = json_decode($line['thumb'], true);
                if (is_array($line['thumb'])) {
                    $line['thumb'] = array_map('getImage', $line['thumb']);
                } else {
                    $line['thumb'] = array(getImage($line['thumb']));
                }

            } else {
                $line['thumb'] = array('');
            }

            if ($line['uid'] == $this->member['id']) {
                $my_joins = true;
            }
            $line['no'] = $k + 1;
            if ($line['status'] == 1) {
                $new_joins[] = $line;
            }
        }
        //$new_joins = $joins;

        $is_joins = $vote['sign_enabled'] == 2 && $vote['sign_start_time'] < time() && $vote['sign_end_time'] > time();

        $vote_complaint = getConfig('vote_complaint');
        $vote_complaint = $vote_complaint ? json_decode($vote_complaint, true) : [];

        $vote_goods = p_getall('vote_goods', array('vote_id' => $id));
        if ($vote_goods) {
            foreach ($vote_goods as & $value) {
                $value['image'] = getImage($value['image']);
            }
        }
        $ad = array();
        if ($vote['is_luck'] == 2 && $vote['luck_id'] > 0) {
            $vote['luck'] = p_get('luck', array('id' => $vote['luck_id']));
            $luck_goods = p_get('luck_goods', array('luck_id' => $vote['luck']['id']));
            $luck_goods['image'] = $luck_goods['image'] ? getImage($luck_goods['image']) : $this->images('prize_default_picture', 'prize_default_picture.png');
            $vote['luck_goods'] = $luck_goods;
        } else {
            $ad = p_get('advertisement', array('position' => 4));
            $ad && $ad['image'] = getImage($ad['image']);
        }

        $succ_status = isset($vote['luck_goods']) ? 3 : ($ad ? 2 : 1);

        if ($succ_status == 1 && yanyi() && getConfig('vote_step_shop', 1) == 1) {
            $succ_status = 4;
        }

        $data = array(
            'vote' => $vote,
            'is_my' => $vote['member_id'] == $this->member['id'],
            //'rank' => $joins,
            'joins' => $new_joins,
            'my_joins' => $my_joins,
            'is_joins' => $is_joins,
            'vote_complaint' => $vote_complaint,
            'map_appkey' => getConfig('map_appkey'),
            'surplus_time' => $vote['end_time'] - time(),
            'is_auth' => $this->is_auth,
            'vote_goods' => $vote_goods,
            'ad' => $ad,
            'succ_status' =>$succ_status,
            'xcx_title' => getConfig('xcx_title'),
            'vote_article' => getConfig('vote_introduce_url')
        );
        return $data;
    }


    public function rank($id)
    {
        $joins = p_getall('vote_join', array('activity_id' => $id));
        $vote = p_get('vote_activity', array('id' => $id, 'status' => 2, 'complete' => 2, 'is_delete' => 1));

        foreach ($joins as $k => & $line) {
            if ($line['status'] != 1) {
                unset($joins[$k]);
                continue;
            }
            if ($line['thumb']) {
                $line['thumb'] = json_decode($line['thumb'], true);
                $line['thumb'] = array_map('getImage', $line['thumb']);
            }

            $line['no'] = $k + 1;
            $vote_nums[] = $line['vote_num'];
        }
        array_multisort($vote_nums, SORT_DESC, $joins);
        $vote_rank_limit = getConfig('vote_rank_limit', 8) ? : 8;
        if (count($joins) > $vote_rank_limit) {
            $joins = array_slice($joins, 0, $vote_rank_limit);
        }

        return array('vote' => $vote, 'rank' => $joins, 'xcx_title' => getConfig('xcx_title'));
    }


    public function details($id)
    {
        $vote = p_get('vote_activity', array('id' => $id, 'status' => 2, 'complete' => 2, 'is_delete' => 1));
        $vote['describe_img'] = $vote['describe_img'] ? json_decode($vote['describe_img'], true) : [];

        $vote['start_time_msg'] = date('Y年m月d日', $vote['start_time']);
        $vote['end_time_msg'] = date('Y年m月d日', $vote['end_time']);

        $sex_type = array(
            '0' => '无限制',
            '1' => '限男性',
            '2' => '限女性'
        );
        $vote['sex_type_msg'] = $sex_type[$vote['sex_type']];

        $vote['region_msg'] = '无限制';

        if ($vote['region_type'] == 2) {
            $vote['region'] = json_decode($vote['region'], true);
            if ($vote['region']) {
                $vote['region_msg'] = implode(',', $vote['region']);
            }
        }

        if ($vote['sponsor_phone']) {
            $vote['sponsor_phone'] = substr($vote['sponsor_phone'],0,3)."****".substr($vote['sponsor_phone'],7,4);
        }

        $vote_goods = arrayImage(p_getall('vote_goods', array('vote_id' => $id)));

        $vote_complaint = getConfig('vote_complaint');
        $vote_complaint = $vote_complaint ? json_decode($vote_complaint, true) : [];

        return array('vote' => $vote, 'vote_goods' => $vote_goods, 'vote_complaint' => $vote_complaint, 'xcx_title' => getConfig('xcx_title'));
    }


    /**
     *
     */
    public function vote()
    {
        $id = intval($this->get('id'));
        $join = p_get('vote_join', array('id' => $id, 'status' => 1));
        if (empty($join)) {
            $this->json('选手不存在', 2);
        }
        $vote = p_get('vote_activity', array('id' => $join['activity_id']));
        if ($vote['start_time'] > time()) {
            $this->json('投票活动未开始', 2);
        }
        if ($vote['end_time'] < time()) {
            $this->json('投票活动已结束', 2);
        }

        if ($vote['is_suspend'] == 2) {
            $this->json('活动已暂停,请稍后再投', 2);
        }

        if ($vote['sex_type'] > 0 && $this->member['sex'] != $vote['sex_type']) {
            $this->json('该投票仅限用' . ($vote['sex_type'] == 1 ? '男' : '女') . '性用户参加', 2);
        }

        if ($vote['is_verification'] == 2) {
            $code = $this->get('code');
            if (!$this->vote->checkcaptcha($this->member['id'], $code)) {
                $this->json($this->vote->error, 2);
            }
        }


        if ($vote['appoint_group'] == 2) {
            $group_id = $this->get('group_id');
            if (empty($group_id) || $group_id != $vote['group_id']) {
                $this->json('只有指定群进入才能参与该投票', 2);
            }
        }

        if ($vote['region_type'] == 2 && $vote['region']) {
            if (!$local = $this->get('local')) {
                $this->json('该地区不在投票范围内', 2);
            }
            $local = explode(',', $local);
            $vote['region'] = json_decode($vote['region'], true);
            foreach ($vote['region'] as $key => $l) {
                if ($vote['region'][$key] != $local[$key]) {
                    $this->json('该地区不在投票范围内', 2);
                }
            }
        }

        $today = strtotime(date('Y-m-d'));
        $vote_num = p_getcolumn('vote_vote_log', array('uid' => $this->member['id'], 'activity_id' => $vote['id'], 'today' => $today), 'COUNT(*)') ? : 0;

        if ($vote_num >= $vote['day_votes']) {
            $this->json('每天只能投' . $vote['day_votes'] . '票', 2);
        }
        if ($vote['is_repeat'] == 1) {
            if (true || yanyi()) {
                $t = strtotime(date('Y-m-d'));
                $sql = "SELECT COUNT(*) FROM" . prefix('vote_vote_log') . " WHERE uid = {$this->member['id']} AND activity_id = {$vote['id']} AND join_id={$id} AND c_time>= $t";
                $vote_num = p_fetchcolumn($sql) ? : 0;
            } else {
                $vote_num = p_getcolumn('vote_vote_log', array('uid' => $this->member['id'], 'activity_id' => $vote['id'], 'join_id' => $id), 'COUNT(*)') ? : 0;
            }

            if ($vote_num > 0) {
                $this->json('每个选手,不能重复投票', 2);
            }
        }

        try{
            pdo_begin();

            $sql = "UPDATE " . prefix('vote_activity') . " SET vote_num = vote_num + 1 WHERE id={$vote['id']}";
            if (!pdo_query($sql)) {
                throw new Exception('投票失败');
            }
            $sql = "UPDATE " . prefix('vote_join') . " SET vote_num = vote_num + 1 WHERE id={$id}";
            if (!pdo_query($sql)) {
                throw new Exception('投票失败');
            }
            $insert = array(
                'uid' => $this->member['id'],
                'activity_id' => $vote['id'],
                'join_id' => $id,
                'today' => $today,
                'c_time' => time(),
                'ip' => getip()
            );
            if (!p_insert('vote_vote_log', $insert)) {
                throw new Exception('投票失败');
            }
            pdo_commit();
            $this->json(array('head' => $this->member['headimgurl']));
        } catch (Exception $e){
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }
    }


    /**
     *
     */
    public function detail($id)
    {
        $join = p_get('vote_join', array('id' => $id));
        if (empty($join)) {
            $this->json('选手不存在', 0);
        }
        if ($join['thumb']) {
            $join['thumb'] = json_decode($join['thumb'], true);
            $join['thumb'] = array_map('getImage', $join['thumb']);
        }

        $join['share_thumb'] = $join['share_thumb'] ? getImage($join['share_thumb']) : $join['thumb'][0];

        $vote = p_get('vote_activity', array('id' => $join['activity_id']));

        p_update('vote_activity', array('view_num' => $vote['view_num'] + 1), array('id' => $vote['id']));

        $vote['bg_image'] = getImage($vote['bg_image']);
        $is_joins = $vote['sign_enabled'] == 2 && $vote['sign_start_time'] < time() && $vote['sign_end_time'] > time();

        $limit = $join['vote_num'] > 6 ? 6 : $join['vote_num'];
        $propup = array();
        if ($limit > 0) {
            $propup = p_getall('vote_vote_log', array('join_id' => $id, 'activity_id' => $join['activity_id']), array(), '', '', $limit);

            foreach ($propup as & $value) {
                $value['member'] = p_getcolumn('memberinfo', array('id' => $value['uid']), 'headimgurl');
            }
        }
        $my_joins = p_get('vote_join', array('uid' => $this->member['id'], 'activity_id' => $vote['id']));
        $sql = "SELECT COUNt(*) FROM " . prefix('vote_join') . " WHERE activity_id={$vote['id']} AND id<{$id}";
        $num = (p_fetchcolumn($sql) ? : 0) + 1;


        $ad = array();
        if ($vote['is_luck'] == 2 && $vote['luck_id'] > 0) {
            $vote['luck'] = p_get('luck', array('id' => $vote['luck_id']));
            $luck_goods = p_get('luck_goods', array('luck_id' => $vote['luck']['id']));
            $luck_goods['image'] = $luck_goods['image'] ? getImage($luck_goods['image']) : $this->images('prize_default_picture', 'prize_default_picture.png');
            $vote['luck_goods'] = $luck_goods;
        } else {
            $ad = p_get('advertisement', array('position' => 4));
            $ad && $ad['image'] = getImage($ad['image']);
        }
        $succ_status = isset($vote['luck_goods']) ? 3 : ($ad ? 2 : 1);

        if ($succ_status == 1 && yanyi() && getConfig('vote_step_shop', 1) == 1) {
            $succ_status = 4;
        }
        if ($vote['sponsor_phone']) {
            $vote['sponsor_phone'] = substr($vote['sponsor_phone'],0,3)."****".substr($vote['sponsor_phone'],7,4);
        }

        $data = array(
            'join' => $join,
            'is_my' => $vote['member_id'] == $this->member['id'],
            'is_joins' => $is_joins,
            'propup' => $propup,
            'my_joins' => $my_joins,
            'vote' => $vote,
            'num' => $num,
            'is_auth' => $this->is_auth,
            'map_appkey' => getConfig('map_appkey'),
            'bomb_off' => getConfig('bomb_off'),
            'ad' => $ad,
            'succ_status' => $succ_status,
            'xcx_title' => getConfig('xcx_title')
        );
        return $data;
    }



    public function new_detail()
    {
        $id = $this->get('id');
        $join = p_get('vote_join', array('id' => $id));
        if (empty($join)) {
            $this->json('选手不存在', 0);
        }

        if ($join['thumb']) {
            $join['thumb'] = json_decode($join['thumb'], true);
            $join['thumb'] = array_map('getImage', $join['thumb']);
        }

        $vote = p_get('vote_activity', array('id' => $join['activity_id']));

        $group_id = '';
        if ($vote['appoint_group'] == 2) {
            $encryptedData = $this->get('encryptedData');
            $iv = $this->get('iv');

            if ($encryptedData && $iv) {
                $wxbd = new WXBizDataCrypt($this->w['uniaccount']['key'], $this->session_key);
                $res = $wxbd->decryptData($encryptedData, $iv, $data);
                if ($res != ErrorCode::$OK) {
                    $this->json('unlogin', -1);
                }
                $data = json_decode($data, true);
                $group_id = $data['openGId'];
                if (empty($vote['group_id'])) {
                    p_update('vote_activity', array('group_id' => $group_id), array('id' => $id));
                }
            }
        }

        $isqq = isQq() ? 2 : 1;

        $url = $this->app->createUrl('player', array('id' => $id, 'group_id' => $group_id, 'token' => $this->get('token'), 'isqq' => $isqq));
        $url = str_replace('./index.php', '', $url);


        $sql = "SELECT COUNt(*) FROM " . prefix('vote_join') . " WHERE activity_id={$vote['id']} AND id<{$id}";
        $num = (p_fetchcolumn($sql) ? : 0) + 1;

        $screen_ad = '';
        $vote_cost_ad = getConfig('vote_cost_ad', 1);
        if ($vote_cost_ad == 3 || ($vote['prize_type'] == 1 && $vote_cost_ad == 2)) {
            $screen_ad = getConfig('screen_ad');
        }

        $join['share_thumb'] = $join['share_thumb'] ? getImage($join['share_thumb']) : $join['thumb'][0];

        $screen_second = intval(getConfig('screen_second', 0)) * 1000;

        $this->json(array('join' => $join, 'url' => $url, 'vote' => $vote, 'num' => $num, 'screen_ad' => $screen_ad, 'screen_second' => $screen_second));
    }


    /**
     *
     */
    public function complaint()
    {
        $vote_id = $this->get('id');
        $content = $this->get('content');

        if (empty($vote_id) || empty($content)) {
            $this->json('请选择举报内容', 0);
        }
        p_insert('vote_complaint', array(
            'vote_id' => $vote_id,
            'content' => $content,
            'member_id' => $this->member['id'],
            'created' => time()
        ));
        $this->json();
    }


    /**
     *
     */
    public function sign()
    {
        $id = $this->get('id');
        $join = p_get('vote_join', array('activity_id' => $id, 'uid' => $this->member['id']));

        $imgs = array();
        if ($join) {
            if ($join['thumb_url'] = json_decode($join['thumb'], true)) {

                foreach ($join['thumb_url'] as $value) {
                    $imgs[] = array(
                        'url' => getImage($value),
                        'path' => $value
                    );
                }

            }

            $join['share_thumb_url'] = getImage($join['share_thumb']);
        }
        $join['thumb'] = $imgs;
        $join && $join['thumb_url'] = getImage(json_decode($join['thumb'], true));

        $data = array('join' => $join);

        $this->json($data);
    }


    /**
     *
     */
    public function signup()
    {
        $activity_id = intval($this->get('activity_id'));
        $vote = p_get('vote_activity', array('id' => $activity_id, 'complete' => 2, 'status' => 2, 'is_delete' => 1));
        if (empty($vote)) {
            $this->json('投票活动不存在', 0);
        }
        if ($vote['sign_enabled'] == 1
            || $vote['sign_start_time'] > time()
            || $vote['sign_end_time'] < time()
        ) {
            $this->json('暂时无法参与报名', 0);
        }

        $join = p_get('vote_join', array('activity_id' => $vote['id'], 'uid' => $this->member['id']));
        if ($join && $join['status'] == 1) {
            $this->json('审核已通过,无法修改', 0);
        }

        $thumb = $this->get('thumb');
        $thumb = json_decode(html_entity_decode($thumb), true);
        $image = array();
        foreach ($thumb as $value) {
            $image[] = $value['path'];
        }

        $data = array(
            'thumb' => json_encode($image),
            'name' => $this->get('name'),
            'phone' => $this->get('phone'),
            'wechat' => $this->get('wechat'),
            'intro' => $this->get('intro'),
            'share_thumb' => $this->get('share_thumb')
        );
        if (empty($data['thumb'])
            || empty($data['name']
        )) {
            $this->json('报名封面和报名基本信息必填', 0);
        }

        if ($vote['sign_phone'] == 2 && empty($data['phone'])) {
            $this->json('报名手机号必填', 0);
        }
        if ($vote['sign_wx'] == 2 && empty($data['wechat'])) {
            $this->json('报名微信号必填', 0);
        }

        $option = array(
            'appid' => $this->w['uniaccount']['key'],
            'secret' => $this->w['uniaccount']['secret'],
        );

        $wxObj = new Wxadoc($option);
        $res = $wxObj->checkText(json_encode($data, JSON_UNESCAPED_UNICODE));
        if (isset($res['errcode']) && $res['errcode'] == 87014) {
            $this->json('内容包含敏感信息,你修改后再提交', 0);
        }

        if ($join) {
            $join['status'] == 2 && $data['status'] = 0;
            p_update('vote_join', $data, array('activity_id' => $vote['id'], 'uid' => $this->member['id']));

        } else {
            $data['c_time'] = time();
            $data['activity_id'] = $activity_id;
            $data['type'] = 2;
            $data['uid'] = $this->member['id'];
            $data['is_img'] = $vote['type'];
            p_insert('vote_join', $data);
        }

        $this->json('');
    }


    /**
     *
     */
    public function administration()
    {
        $id = $this->get('id');
        $vote = p_get('vote_activity', array('id' => $id, 'member_id' => $this->member['id'], 'complete' => 2, 'is_delete' => 1));
        if (empty($vote)) {
            $this->json('该投票活动不存在', 0);
        }
        $vote['cover_image'] = getImage($vote['cover_image']);

        $t = time();
        if ($vote['start_time'] > $t) {
            $vote['msg'] = array(
                'color' => '#f2f1f6',
                'msg' => '未开始'
            );
        } else if ($t < $vote['end_time']) {
            $vote['msg'] = array(
                'color' => '#d15243',
                'msg' => '进行中'
            );
        } else {
            $vote['msg'] = array(
                'color' => '#999',
                'msg' => '已结束'
            );
        }
        $vote['start_time_msg'] = date('Y-m-d H:i', $vote['start_time']);

        $data = array(
            'vote' => $vote,
            'audit_number' => p_getcolumn('vote_join', array('activity_id' => $id, 'status' => 0), 'COUNT(*)') ? : 0
        );
        $this->json($data);
    }


    /**
     *
     */
    public function checkList()
    {
        $id = $this->get('id');
        $status = intval($this->get('status', 0));
        $vote = p_get('vote_activity', array('id' => $id, 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
        if (empty($vote)) {
            $this->json('无操作权限', 0);
        }
        $vote['cover_image'] = getImage($vote['cover_image']);

        $join = p_getall('vote_join', array('activity_id' => $id, 'status' => $status), array(), '', 'id desc');
        if ($join) {
            foreach ($join as & $value) {
                if ($vote['type'] == 1) {
                    $thumb = json_decode($value['thumb'], true);
                    $value['thumb'] = getImage($thumb[0]);
                }

                $value['isSelected'] = false;
            }
        }
        $data = array(
            'vote' => $vote,
            'join' => $join
        );
        $this->json($data);
    }


    /**
     *
     */
    public function joinDetails()
    {
        $id = $this->get('id');
        $join = p_get('vote_join', array('id' => $id));
        if (empty($join)) {
            $this->json('选手不存在', 0);
        }
        $vote = p_get('vote_activity', array('id' => $join['activity_id'], 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
        if (empty($vote)) {
            $this->json('无操作权限', 0);
        }
        if ($this->get('op') == 'update') {
            $data = array(
                'name' => $this->get('name'),
                'phone' => $this->get('phone'),
                'wechat' => $this->get('wechat'),
                'intro' => $this->get('intro'),
                'share_thumb' => $this->get('share_thumb')
            );
            $thumb = $this->get('thumb');
            $thumb = json_decode(html_entity_decode($thumb), true);
            $image = array();
            foreach ($thumb as $value) {
                $image[] = $value['path'];
            }
            $data['thumb'] = json_encode($image);

            if (empty($data['thumb'])|| empty($data['name'])) {
                $this->json('报名封面和报名基本信息必填', 0);
            }
            p_update('vote_join', $data, array('id' => $id));
            $this->json();

        } else {
            if ($join['thumb']) {
                $join['thumb'] = json_decode($join['thumb']);
                foreach ($join['thumb'] as & $value) {
                    $value = array(
                        'url' => getImage($value),
                        'path' =>  $value
                    );
                }
            }
            $join['share_thumb_url'] = getImage($join['share_thumb']);
            $member = p_get('memberinfo', array('id' => $join['uid']));
            $data = array(
                'join' => $join,
                'vote' => $vote,
                'member' => $member
            );
            $this->json($data);
        }
    }


    /**
     *
     */
    public function examine()
    {
        $ids = $this->get('ids');
        $status = $this->get('status');

        if (empty($ids) || !in_array($status, array(1, 2))) {
            $this->json();
        }
        $ids = explode(',', $ids);
        foreach ($ids as $id) {
            $join = p_get('vote_join', array('id' => $id));
            if (empty($join)) {
                continue;
            }
            $vote = p_get('vote_activity', array('id' => $join['activity_id'], 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
            if (empty($vote)) {
                continue;
            }
            if ($status == 1) {
                $sql = "UPDATE " . prefix('vote_activity') . " SET join_num = join_num + 1 WHERE id={$vote['id']}";
                pdo_query($sql);
            }

            p_update('vote_join', array('status' => $status), array('id' => $id));
        }
        $this->json();
    }


    /**
     *
     */
    public function delete()
    {
        $ids = $this->get('ids');
        if (!$ids = explode(',', $ids)) {
            $this->json();
        }
        foreach ($ids as $id) {
            $join = p_get('vote_join', array('id' => $id));
            if (empty($join)) {
                continue;
            }
            $vote = p_get('vote_activity', array('id' => $join['activity_id'], 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
            if (empty($vote)) {
                continue;
            }
            if ($join['status'] == 1) {
                $sql = "UPDATE " . prefix('vote_activity') . " SET join_num = join_num - 1 WHERE id={$vote['id']}";
                pdo_query($sql);
            }

            p_delete('vote_join', array('id' => $id));
        }
        $this->json();

    }



    /**
     *
     */
    public function addJoin()
    {
        $name = $this->get('name');
        $thumb = $this->get('thumb');
        $intro = $this->get('intro');
        $id = $this->get('id');

        $vote = p_get('vote_activity', array('id' => $id, 'complete' => 2, 'status' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
        if (empty($vote)) {
            $this->json('无操作权限', 0);
        }

        if (empty($name)) {
            $this->json('请填写姓名', 0);
        }
        if ($vote['type'] == 1 && empty($thumb)) {
            $this->json('请上传图片', 0);
        }

        $insert = array(
            'name' => $name,
            'thumb' => $thumb,
            'intro' => $intro,
            'status' => 1,
            'c_time' => time(),
            'activity_id' => $id,
            'is_img' => $vote['type'],
        );
        if (p_insert('vote_join', $insert)) {
            $sql = "UPDATE " . prefix('vote_activity') . " SET join_num = join_num + 1 WHERE id={$vote['id']}";
            pdo_query($sql);
        }


        $this->json();
    }


    /**
     *
     */
    public function update()
    {
        $id = $this->get('id');

        $vote = p_get('vote_activity', array('id' => $id, 'complete' => 2, 'is_delete' => 1, 'member_id' => $this->member['id']));
        if (empty($vote)) {
            $this->json('无操作权限', 0);
        }

        $update = array();
        if ($cover_image = $this->get('cover_image')) {
            $update['cover_image'] = $cover_image;
        }
        if ($suspend = $this->get('suspend')) {
            $update['is_suspend'] = $suspend;
        }
        if ($is_delete = $this->get('is_delete')) {
            $update['is_delete'] = 2;
        }

        p_update('vote_activity', $update, array('id' => $id));

        $this->json();
    }


    /**
     *
     */
    public function embed()
    {
        $data = array(
            'appid' => $this->w['uniaccount']['key']
        );

        $this->json($data);
    }


    /**
     *
     */
    public function poster()
    {
        $id = $this->get('id');

        $vote = p_get('vote_activity', array('id' => $id, 'complete' => 2, 'is_delete' => 1));
        if (empty($vote)) {
            $this->json('活动不存在', 0);
        }

        if ($vote['cover_image']) {
            $vote['cover_image'] = getImageLocal($this, $vote['cover_image']);
        } else {
            $vote['cover_image'] = getVoteImageCover($vote);
        }


        $xcx_path = 'bh_vote/pages/vote/index/index';
        $xcx_code = $this->vote->createWxCode($this, $id, $xcx_path, 'vote-' . $id . '.png');

        $data = array(
            'vote' => $vote,
            'xcx_code' => $xcx_code
        );
        $this->json($data);
    }


    /**
     *
     */
    public function addBomb()
    {
        if (getConfig('bomb_off') == 2) {
            $this->json('弹幕功能已关闭');
        }
        $content = $this->get('content');
        $id = $this->get('id');
        $vote_id = $this->get('vote_id');
        if (empty($content) || empty($id) || empty($vote_id)) {
            $this->json();
        }

        if (getConfig('bomb_status') == 2) {
            $this->json();
        }

        p_insert('vote_danmu', array(
            'uid' => $this->member['id'],
            'content' => $content,
            'activity_id' => $vote_id,
            'join_id' => $id,
            'c_time' => time(),
        ));
        $this->json();
    }


    /**
     *
     */
    public function getBomb()
    {
        $id = $this->get('id');
        $sql = "SELECT A.content,B.nickname FROM " . prefix('vote_danmu'). ' AS A LEFT JOIN ' . prefix('memberinfo') . ' AS B ON A.uid=B.id WHERE A.join_id=' . $id . get_uniacid('A.') . ' ORDER BY A.id DESC';
        $bomb = p_fetchall($sql);

        $data = array('bomb' => $bomb);
        $this->json($data);
    }


    /**
     *
     */
    public function prizeAddress()
    {
        $id = $this->get('id');
        $luck = p_get('vote_activity', array('id' => $id, 'member_id' => $this->member['id'], 'complete' => 2));
        if (empty($luck)) {
            $this->json('无查看权限');
        }
        $info = p_getall('vote_goods_info', array('luck_id' => $id));
        foreach ($info as & $value) {
            $address = p_get('address', array('member_id' => $value['in_member_id']));
            $value['address'] = "{$address['name']}, {$address['phone']}, {$address['address']}";
            $value['member'] = p_get('memberinfo', array('id' => $value['in_member_id']));
        }
        $this->json(array('address' => $info));
    }


    /**
     *
     */
    public function apply()
    {
        $p = $this->get('p', 1);
        $page_size = 8;
        $limit = ($p - 1) * $page_size;
        $where = array('uid' => $this->member['id']);
        if ($this->get('type') == 2) {
            $where['in_prize'] = 2;
        }

        $apply = p_getall('vote_join', $where, array(),'', array('id desc'), "{$limit}, {$page_size}");
        if ($apply) {
            foreach ($apply as & $value) {
                $value['vote'] = p_get('vote_activity', array('id' => $value['activity_id']));
                $value['goods'] = p_getall('vote_goods', array('vote_id' => $value['activity_id']));
                $value['vote']['cover_image'] = getVoteImageCover($value['vote']);
                $value['vote']['end_time'] = date('Y-m-d H:i', $value['vote']['end_time']). ' 结束';

                $value['member'] = p_get('memberinfo', array('id' => $value['vote']['member_id']));
            }
        }

        $data = array('apply' => $apply);
        $this->json($data);
    }


    /**
     *
     */
    public function myLaunch()
    {
        $p = $this->get('p', 1);
        $page_size = 8;
        $limit = ($p - 1) * $page_size;
        $launch = p_getall('vote_activity', array('member_id' => $this->member['id'], 'is_delete' => 1, 'complete' => 2), array(),'', array('id desc'), "{$limit}, {$page_size}");

        if (!empty($launch)) {
            foreach ($launch as & $value) {
                $value['cover_image'] = getImage($value['cover_image']);

                if ($value['lottery_type'] == 1) {
                    $value['lottery'] = date('m月d日 H:i', $value['lottery_value']);
                } elseif ($value['lottery_type'] == 2) {
                    $value['lottery'] = '满' . $value['lottery_value'] . '人';
                } else {
                    $value['lottery'] = '';
                }

                $value['end_time'] = date('Y-m-d H:i', $value['end_time']). ' 结束';
            }
        }
        $data = array('launch' => $launch);
        $this->json($data);
    }


    /**
     *
     */
    public function edit()
    {
        $id = $this->get('id');

        $vote = p_get('vote_activity', array('id' => $id, 'member_id' => $this->member['id'], 'is_delete' => 1, 'complete' => 2));

        if (empty($vote)) {
            $this->json('投票不存在或无操作权限', 0);
        }

        if ($this->get('op') == 'up') {
            $data = array(
                'cover_image' => $this->get('cover_image'),
                'title' => $this->get('title'),
                'describe' => $this->get('describe'),
                'type' => $this->get('type'),
                'start_time' => strtotime($this->get('start_time')),
                'end_time' => strtotime($this->get('end_time')),
                'sex_type' => $this->get('sex_type'),
                'sponsor_enabled' => $this->get('sponsor_enabled'),
                'sign_enabled' => $this->get('sign_enabled'),
                'day_votes' => $this->get('day_votes'),
                'is_repeat' => $this->get('is_repeat'),
                'is_luck' => $this->get('is_luck')
            );
            if ($data['is_luck'] == 2 && $this->get('luck_id') > 0) {
                $data['luck_id'] = $this->get('luck_id');
            }

            $describe_img = $this->get('describe_img');
            $describe_img = json_decode(html_entity_decode($describe_img), true);
            if ($describe_img) {
                $data['describe_img'] = json_encode($describe_img);
            }

            $region = $this->get('region');
            $region = json_decode(html_entity_decode($region), true);
            if ($region) {
                $r = array();
                if ($region[0] != '不限') {
                    foreach ($region as $value) {
                        if ($value != '不限') {
                            $r[] = $value;
                        }
                    }
                    if ($r) {
                        $data['region_type'] = 2;
                        $data['region'] = json_encode($r);
                    }
                }
            }

            if ($data['sponsor_enabled'] == 2) {
                $data['sponsor_name'] = $this->get('sponsor_name');
                $data['sponsor_phone'] = $this->get('sponsor_phone');
            }

            if ($data['sign_enabled'] == 2) {
                $data['sign_start_time'] = strtotime($this->get('sign_start_time'));
                $data['sign_end_time'] = strtotime($this->get('sign_end_time'));
                $data['sign_phone'] = $this->get('sign_phone');
                $data['sign_wx'] = $this->get('sign_wx');
            }

            p_update('vote_activity', $data, array('id' => $id));

            $this->json();
        } else {

            $vote['cover_image_url'] = getImage($vote['cover_image']);
            $vote['describe_img'] = $vote['describe_img'] ? json_decode($vote['describe_img'], true) : [];
            $vote['region'] = $vote['region'] ? json_decode($vote['region'], true) : [];

            $luck = p_getall('luck', array('member_id' => $this->member['id'], 'is_delete' => 1, 'complete' => 2, 'status' => 1));

            $vote['s_start_sf'] = date('H:i', $vote['sign_start_time']);
            $vote['s_start_nyr'] = date('Y-m-d', $vote['sign_start_time']);

            $vote['s_end_nyr'] = date('Y-m-d', $vote['sign_end_time']);
            $vote['s_end_sf'] = date('H:i', $vote['sign_end_time']);

            $vote['start_nyr'] = date('Y-m-d', $vote['start_time']);
            $vote['start_sf'] = date('H:i', $vote['start_time']);
            $vote['end_nyr'] = date('Y-m-d', $vote['end_time']);
            $vote['end_sf'] = date('H:i', $vote['end_time']);

            $vote['xcx_title'] = getConfig('xcx_title', '投票抽奖助手');

            $vote['luck'] = $luck;

            $this->json($vote);
        }
    }


    /**
     *
     */
    public function player()
    {
        $id = $this->get('id');

        $player = p_get('vote_join', array('id' => $id, 'status' => 1));
        if (empty($player)) {
            $this->json('选手不存在', 0);
        }
        if (empty($player['share_thumb'])) {
            $thumb = json_decode($player['thumb']);
            $share_img = getImage($thumb[0]);
        } else {
            $share_img = getImage($player['share_thumb']);
        }

        $is_my = $this->member['id'] == $player['uid'];

        $sql = "SELECT COUNt(*) FROM " . prefix('vote_join') . " WHERE activity_id={$player['activity_id']} AND id<{$id}";
        $num = (p_fetchcolumn($sql) ? : 0) + 1;

        $vote = p_get('vote_activity', array('id' => $player['activity_id']));
        $vote['cover_image'] = getVoteImageCover($vote);


        $xcx_path = 'bh_vote/pages/vote/detailsView/detailsView';
        $xcx_code = $this->vote->createWxCode($this, $id . '_' . $this->member['id'], $xcx_path, 'player-vote-' . $id . '_' . $this->member['id'] . '.png');

        $data = array(
            'is_my' => $is_my,
            'share_img' => $share_img,
            'player' => $player,
            'num' => $num,
            'vote' => $vote,
            'xcx_code' => $xcx_code
        );
        $this->json($data);
    }



    /**
     *
     */
    public function share_vote()
    {
        $id = $this->get('id');
        $vote = p_get('vote_activity', array('id' => $id, 'status' => 2, 'complete' => 2, 'is_delete' => 1));
        if (empty($vote)) {
            $this->json('投票不存在', 0);
        }
        $vote['cover_image'] = getVoteImageCover($vote);
        $data = array(
            'vote' => $vote
        );
        $this->json($data);
    }


    public function ad()
    {
        $id = $this->get('id');
        $ad = p_get('advertisement', array('id' => $id));

        $ad['image'] = getImage($ad['image']);
        $this->json(array('ad' => $ad, 'video_ad' => getConfig('video_ad')));
    }


    public function player_info()
    {
        $id = $this->get('id');

        $player = p_get('vote_join', array('id' => $id));
        if (empty($player)) {
            $this->json('选手不存在');
        }
        $is = p_getcolumn('vote_activity', array('id' => $player['activity_id'], 'member_id' => $this->member['id']), 'COUNT(*)') > 0;
        if (!$is) {
            $this->json('无查看权限');
        }
        $data = array(
            'player' => $player,
            's_start_nyr' => date('Y-m-d', time() - 86400),
            's_end_nyr' => date('Y-m-d', time()),
        );
        $this->json($data);
    }


    public function check_votes()
    {
        $id = intval($this->get('id'));

        $player = p_get('vote_join', array('id' => $id));
        if (empty($player)) {
            $this->json('选手不存在');
        }
        $is = p_getcolumn('vote_activity', array('id' => $player['activity_id'], 'member_id' => $this->member['id']), 'COUNT(*)') > 0;
        if (!$is) {
            $this->json('无查看权限');
        }

        $start = strtotime($this->get('start'));
        $end = strtotime($this->get('end'));
        $where = '';
        if ($start) {
            $where = 'c_time>=' . $start;
        }
        if ($end) {
            $where = $where ? ($where . ' AND c_time <=' . $end) : ('c_time <=' . $end);
        }
        $where = $where ? (' AND ' . $where) : '';

        $sql = "SELECT count(*) FROM " . prefix('vote_vote_log') . " WHERE join_id={$id} {$where}";

        $votes = pdo_fetchcolumn($sql) ? : 0;
        $data = array(
            'votes' => $votes
        );
        $this->json($data);
    }


}