<?php

class senior extends bhCommon {

    public function __construct()
    {
        parent::__construct();
    }


    /**
     *
     */
    public function index()
    {
        $senior = p_get('senior_member', array('member_id' => $this->member['id']));

        $giving = p_getcolumn('senior_giving', array('member_id' => $this->member['id'], 'status' => 1, 'confirm' => 2), 'SUM(number)') ? : 0;

        $data = array(
            'senior' => $senior,
            'giving' => $giving,
            'public_number_name' => getConfig('public_number_name'),
            'images' => array(
                'coupon' => $this->image_url . 'coupon.png',
                'close' => $this->image_url . 'close.png',
                'senior' => $this->images('senior_image', 'senior.png')
            ),
            'ios_pay' => getConfig('ios_pay', 1)
        );
        $this->json($data);
    }


    /**
     *
     */
    public function giving()
    {
        $number = intval($this->get('number'));

        $senior = p_get('senior_member', array('member_id' => $this->member['id']));
        if (empty($senior) || $senior['number'] < $number) {
            $this->json('您拥有的高级版本数量不足', 0);
        }

        $insert = array(
            'member_id' => $this->member['id'],
            'number' => $number,
            'created' => time()
        );
        if (!p_insert('senior_giving', $insert)) {
            $this->json('转赠失败', 0);
        }
        $this->json(array('giving_id' => pdo_insertid()));

    }


    /**
     *
     */
    public function givingConfirm()
    {
        $id = intval($this->get('id'));
        $giving = p_get('senior_giving', array('id' => $id, 'confirm' => 1, 'member_id' => $this->member['id']));

        if (empty($giving)) {
            $this->json('');
        }
        $senior = p_get('senior_member', array('member_id' => $this->member['id']));
        if (empty($senior) || $senior['number'] < $giving['number']) {
            $this->json('您拥有的高级版本数量不足', 0);
        }
        pdo_begin();
        try{
            $after = array(
                'number' => $senior['number'] - $giving['number']
            );
            if (!p_update('senior_member', $after, array('id' => $senior['id'], 'number' => $senior['number']))) {
                throw new Exception('转赠失败');
            }
            $update = array(
                'confirm' => 2
            );
            if (!p_update('senior_giving', $update, array('id' => $id))) {
                throw new Exception('转赠失败');
            }
            pdo_commit();
            $this->json('');
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 0);
        }

    }


    /**
     *
     */
    public function givingDetails()
    {
        $id = intval($this->get('id'));
        $giving = p_get('senior_giving', array('id' => $id, 'confirm' => 2));
        if (empty($giving)) {
            $this->json('该转赠不存在', 0);
        }
        $term = $giving['created'] + 30 * 60;
        $giving['term'] = date('Y-m-d H:i', $term);
        $giving_member = p_get('memberinfo', array('id' => $giving['member_id']));

        $data = array(
            'giving' => $giving,
            'giving_member' => $giving_member,
            'images' => array(
                'senior' => $this->images('senior_image', 'senior.png'),
                'succ' => $this->image_url .'succ.png',
            )
        );
        $this->json($data);
    }


    /**
     *
     */
    public function receive()
    {
        $id = intval($this->get('id'));
        $giving = p_get('senior_giving', array('id' => $id, 'status' => 1, 'confirm' => 2));
        if (empty($giving)) {
            $this->json('该转赠不存在或已被人领取', 0);
        }

        pdo_begin();
        try{
            $u = array('r_member_id' => $this->member['id'], 'status' => 2, 'updated' => time());
            $w = array('id' => $id, 'status' => 1);
            if (!p_update('senior_giving', $u, $w)) {
                throw new Exception('该转赠已被人领取');
            }
            if (!$this->vote->change_senior($this->member['id'], $giving['number'], 4, $id)) {
                throw new Exception($this->vote->error);
            }
            $i = array(
                'member_id' => $giving['member_id'],
                'number' => $giving['number'],
                'type' => 3,
                'remarks' => $id,
                'created' => time()
            );
            if (!p_insert('senior_member_log', $i)) {
                throw new Exception('领取失败');
            }

            pdo_commit();
            $this->json();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 0);
        }
    }


    /**
     *
     */
    public function init()
    {
        $senior_number = getConfig('senior_number', 0);
        $number = p_getcolumn('luck', array('is_senior' => 2, 'complete' => 2), 'COUNT(*)') ? : 0;
        $senior_number += $number;

        $privilege = getConfig('senior_privilege');
        $privilege = $privilege ? json_decode($privilege, true) : array();

        $senior = p_getall('senior', array('is_delete' => 1));

        $data = array(
            'senior' => $senior,
            'privilege' => $privilege,
            'senior_number' => $senior_number,
            'ios_pay' => getConfig('ios_pay', 1)
        );
        $this->json($data);
    }


}