<?php
include IA_ROOT . '/addons/bh_vote/model/shop.mod.php';

class shop extends bhCommon {

    public $shop = array();
    public $sModel;

    public function __construct()
    {
        parent::__construct();

        if ($shop_id = $this->get('shop_id')) {
            $this->shop = p_get('shop', array('id' => $shop_id));
        }
        elseif ($this->member['shop_id'] > 0) {
            $this->shop = p_get('shop', array('id' => $this->member['shop_id']));
        } else {
            $this->shop = p_get('shop', array('is_default' => 2));
        }

        $this->sModel = new shopModel();
    }


    public function getShop()
    {
        $this->json(array('shop' => $this->shop));
    }


    /**
     * shop
     */
    public function index()
    {
       $category = p_getall('shop_category_use', array('shop_id' => $this->shop['id']), array(), '', 'sort desc');

       if ($category) {
           foreach ($category as & $value) {
               $goods = p_getall('shop_goods', array('category_id' => $value['category_id'], 'status' => 1, 'is_delete' => 1, 'examine_status' => 2), array(), '', 'sort desc');
               $value['goods'] = arrayImage($goods, 'cover_image');
               $value['info'] = p_get('shop_category', array('id' => $value['category_id']));
           }
       }

       $ad = array(
           'icon' => $this->vote->getAdvertisement(6, 5),
           'stripe' => $this->vote->getShopAd($this->shop['id'],1, 3),
       );

       $addition = p_getcolumn('shop_step_log', array('member_id' => $this->member['id'], 'type' => 2), 'SUM(step)') ? : 0;
       $config = array(
           'currency_name' => getConfig('currency_name', '活力币'),
           'superior_proportion' => getConfig('superior_proportion', 1)
       );
       $this->share();

       $data = array(
           'category' => $category,
           'config' => $config,
           'addition' => $addition,
           'ad' => $ad,
           'shop' => $this->shop,
           'member_id' => $this->member['id']
       );

       $this->json($data);
    }


    public function share()
    {
        $this->shop['share_img'] = getImage($this->shop['share_img']);
        $this->shop['shop_cover'] = getImage($this->shop['shop_cover']);

        $this->shop['share_text'] = str_replace('{name}', $this->member['nickname'], $this->shop['share_text']);
        $this->shop['share_text'] = str_replace(' {shop_name}', $this->shop['shop_name'], $this->shop['share_text']);

        $this->shop['ball_image'] = getImage($this->shop['ball_image']);
    }


    /**
     *
     */
    public function goods()
    {
        $category = p_getall('shop_category_use', array('shop_id' => $this->shop['id']));

        if ($category) {
            foreach ($category as $k => $val) {
                $goods = p_getall('shop_goods', array('category_id' => $val['category_id'], 'status' => 1, 'is_delete' => 1, 'examine_status' => 2), array(), '', 'sort desc');
                $category[$k]['goods'] = arrayImage($goods, 'cover_image');
                $category['info'] = p_get('shop_category', array('id' => $val['category_id']));
            }
        }

        $this->json(array('category' => $category));
    }


    /**
     *
     */
    public function updateStep()
    {
        $encryptedData = $this->get('encryptedData');
        $iv = $this->get('iv');

        $wxbd = new WXBizDataCrypt($this->w['uniaccount']['key'], $this->session_key);
        $res = $wxbd->decryptData($encryptedData, $iv, $data);
        if ($res != ErrorCode::$OK) {
            $this->json('unlogin', -1);
        }
        $data = json_decode($data, true);

        $time = strtotime(date('Y-m-d', time()));
        $step = end($data['stepInfoList']);
        if ($step['timestamp'] == $time) {
            $step_number = $step['step'];
        } else {
            $step_number = 0;
        }


        $this->sModel->update_step($this->member['id'], $step_number);
        $this->json();
    }


    /**
     *
     */
    public function suspension()
    {
        $css = array(
            0 => 'left:75rpx;top:195rpx;',
            1 => 'right:155rpx;top:195rpx;',
            2 => 'left20rpx;top:30rpx;',
            3 => 'right:175rpx;top:15rpx;',
        );

        $icon = array(
            1 => $this->image_url . 'shop/ball.png',
            2 => $this->image_url . 'shop/ballblu.png',
            3 => $this->image_url . 'shop/ballora.png',
        );

        $text = array(
            1 => '点击领取',
            2 => '好友贡献'
        );

        $color = array(
            1 => 'rgb(220,131,236)',
            2 => '#9CC5FA',
            3 => '#DDA7B1'
        );

        $signin = array(
            'status' => $this->sModel->today_signin($this->member['id']),
            'css' => $css[3],
            'text' => '每日签到',
            'icon' => $icon[3],
            'color' => $color[3]
        );
        if (!$signin['status']) {
            $days = $this->sModel->get_signin($this->member['id']);
            $days = $days >= 7 ? 1 : ($days + 1);
            $signin['step'] = getConfig($this->sModel->signin_days[$days], 100);
        }

        $limit = !$signin['status'] ? 3 : 4;

        $where = array(
            'member_id' => $this->member['id'],
            'same_day' => strtotime(date('Y-m-d')),
            'status' => 1
        );

        $suspension_step = p_getall('shop_step_log', $where, array(), '', 'id desc', $limit);

        foreach ($suspension_step as $k => & $value) {
            $value['css'] = $css[$k];
            $value['icon'] = $icon[$value['type']];
            $value['text'] = $text[$value['type']];
            $value['color'] = $color[$value['type']];
        }

        $step = $this->sModel->get_step($this->member['id']);
        $data = array(
            'suspension_step' => $suspension_step,
            'suspension_signin' => $signin,
            'step' => $step,
            'step_currency' => $step ? $this->sModel->calculation_currency($step['effective_step']) : 0,
            'member' => $this->member
        );
        $this->json($data);
    }


    /**
     *
     */
    public function receive()
    {
        $id = $this->get('id');
        $this->sModel->receive_step($id, $this->member['id']);
        $this->json();
    }


    /**
     * 兑换
     */
    public function currency()
    {
        pdo_begin();
        try{
            if (!$this->sModel->currency($this->member['id'])) {
                throw new Exception($this->sModel->error);
            }
            pdo_commit();
            $this->json();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }
    }


    /**
     *
     */
    public function details()
    {
        $id = $this->get('id');
        if ($goods = p_get('shop_goods', array('id' => $id, 'is_delete' => 1, 'status' => 1, 'examine_status' => 2))) {
            $goods['image'] = json_decode($goods['image'], true);
            $goods['image'] = array_map('getImage', $goods['image']);
            $goods['share_image'] = getImage($goods['share_image'] ? : $goods['cover_image']);

            $goods['share_title'] = str_replace('{name}', $this->member['nickname'], $goods['share_title']);

        } else {
            $this->json('商品不存在或已下架', 0);
        }

        $goods['goods_num'] = $this->sModel->get_inventory($id);

        $address = p_get('address', array('member_id' => $this->member['id']));

        $data = array(
            'goods' => $goods,
            'shop' => $this->shop,
            'is_auth' => $this->is_auth,
            'member_id' => $this->member['id'],
            'address' => $address
        );

        $this->json($data);
    }


    /**
     *
     */
    public function signin()
    {
        $res = $this->sModel->signin($this->member['id']);
        $res === false && $this->json($this->sModel->error, 2);

        /*$signin_days = $this->sModel->signin_days;
        foreach ($signin_days as & $val) {
            $val['value'] = getConfig($val['key']) ? : $val['default'];
        }

        $data = array(
            'signin_reward' => $signin_days,
            'signin_days' => $res
        );*/
        $this->json();
    }



    public function signin_details()
    {
        $signin_days = $this->sModel->signin_days;
        foreach ($signin_days as & $val) {
            $val['value'] = getConfig($val['key']) ? : $val['default'];
        }

        $time = strtotime(date('Y-m-d', time())) + 86400;
        $days = $this->sModel->get_signin($this->member['id']);

        $d = ($days % 7) ? : 7;
        $sigin = array(
            'days' => $days,
            'days_step' => getConfig($signin_days[$d]['key'], 0)
        );
        $data = array(
            'time' => $time,
            'sigin' => $sigin,
            'signin_days' => $signin_days
        );

        $this->json($data);
    }



    /**
     *
     */
    public function exchange()
    {
        $id = intval($this->get('id'));

        $goods = p_get('shop_goods', array('id' => $id, 'status' => 1, 'is_delete' => 1, 'examine_status' => 2));
        if (empty($goods)) {
            $this->json('商品不存在或已下架', 0);
        }
        $currency_name = getConfig('currency_name', '活力币');

        if ($goods['currency'] > $this->member['currency']) {
            $this->json('您的' . $currency_name . '不足', 0);
        }

        $inventory = $this->sModel->get_inventory($id);
        if ($inventory < 1) {
            $this->json('库存不足,商家补货后再来', 0);
        }
        if ($goods['allow_number'] > 0) {
            $num = p_getcolumn('shop_order', array('member_id' => $this->member['id'], 'goods_id' => $id), 'COUNT(*)') ? : 0;
            if ($num >= $goods['allow_number']) {
                $this->json('每人限量兑换' . $goods['allow_number'] . '份', 0);
            }
        }
        $money = 0;
        if ($goods['is_free'] == 2 && $goods['free'] > 0) {
            $money += $goods['free'];
        }
        if ($goods['exchange_type'] == 2 && $goods['money'] > 0) {
            $money += $goods['money'];
        }
        if ($money > 0) {
            $pay = $this->vote->unifiedOrder($this->member['id'], $goods['money'], $id, 4);
        } else {
            if (!$this->sModel->exchange($this->member['id'], $id)) {
                $this->json($this->sModel->error, 0);
            }
        }


        $this->json();
    }


    public function order()
    {
        $order = p_getall('shop_order', array('member_id' => $this->member['id']));
        if ($order) {
            $status = array(
                1 => '未发货',
                2 => '已发货',
                3 => '已完成',
                4 => '已取消',
                5 => '已退款'
            );
            foreach ($order as & $value) {
                $value['goods'] = p_get('shop_goods', array('id' => $value['goods_id']));
                $value['goods']['img'] = getImage($value['goods']['cover_image']);
                $value['status_msg'] = $status[$value['status']];
                $value['created'] = date('Y-m-d H:i:s', $value['created']);
            }
        }
        $data = array(
            'order' => $order,
            'images' => array(
                'orders_nodata' => $this->image_url . 'my_orders_nodata.png',
                'address_locate' => $this->image_url . 'db/address_icon_1.png',
                'my_express_icon' => $this->image_url . 'db/my_express_icon_1.png',
            ),
            'currency_name' => getConfig('currency_name')
        );
        $this->json($data);
    }



    public function challenge()
    {
        $days = strtotime(date('Y-m-d'), time()) + 86400;
        $challenge = p_getall('challenge_stage', array('days' => $days), array(), '', 'step_number asc');

        $currency_name = getConfig('currency_name', '活力币');
        if ($challenge) {
            foreach ($challenge as & $value) {
                $value['days'] = date('m月d日/明天', $value['days']);
                $value['apply_number'] = $value['fictitious_number'] + (p_getcolumn('challenge_member', array('challenge_stage_id' => $value['id']), 'COUNT(*)') ? : 0);
                $value['is_apply'] = p_get('challenge_member', array('member_id' => $this->member['id'], 'challenge_stage_id' => $value['id']));
            }
        }

        //$my_center_group = getConfig('challenge_ad');

        $challenge_image = $this->images('challenge_image', 'challenge/challenge.png');


        $adUnitId = getConfig('adUnitId');


        $images = array(
            $this->image_url . 'challenge/challenge_steps_join0.png',
            $this->image_url . 'challenge/challenge_steps_join1.png',
            $this->image_url . 'challenge/challenge_steps_join2.png',
        );
        $time = strtotime(date('Y-m-d')) + 86400 - time();

        $today = $this->sModel->get_step($this->member['id']);

        $data = array(
            'adUnitId' => $adUnitId,
            'time' => $time,
            'images' => $images,
            'challenge' => $challenge,
            'currency_name' => $currency_name,
            'challenge_image' => $challenge_image,
            //'my_center_group' => $my_center_group,
            'today' => $today,
        );

        $this->json($data);
    }



    public function challengeSignup()
    {
        $id = $this->get('id');
        $days = strtotime(date('Y-m-d'), time()) + 86400;
        $details = p_get('challenge_stage', array('id' => $id, 'days' => $days));

        if (empty($details)) {
            $this->json('挑战不存在', 0);
        }
        $is_apply = p_get('challenge_member', array('member_id' => $this->member['id'], 'challenge_stage_id' => $id));
        if ($is_apply) {
            $this->json('');
        }
        $is_video = $this->get('is_video', 1);

        try {
            pdo_begin();

            if ($details['is_video'] == 1 || ($details['is_video'] == 2 && $is_video == 1)) {
                if (!$this->sModel->change_currency($this->member['id'], $details['currency'], 6)) {
                    throw new Exception($this->sModel->error);
                }
            }

            $insert = array(
                'member_id' => $this->member['id'],
                'challenge_id' => $details['challenge_id'],
                'challenge_stage_id' => $details['id'],
                'challenge_step' => $details['step_number'],
                'days' => $details['days'],
                'created' => time()
            );
            if (!p_insert('challenge_member', $insert)) {
                throw new Exception('报名失败');
            }
            pdo_commit();
            $this->json('');
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 0);
        }
    }




    public function challengeHistory()
    {
        $list = p_getall('challenge_member', array('member_id' => $this->member['id']), array(), '', array('id DESC'));

        $all_number = count($list);
        $succ_number = 0;
        if ($list) {
            $today = strtotime(date('Y-m-d', time()));

            foreach ($list as & $value) {
                $value['challenge'] = p_get('challenge_stage', array('id' => $value['challenge_stage_id']));
                if ($value['currency'] > 0) {
                    $succ_number ++;
                }

                if ($value['days'] < $today) {
                    $value['challenge_status'] = 1; // 已结束
                } elseif ($value['days'] == $today) {
                    $value['challenge_status'] = 2; // 进行中
                } else {
                    $value['challenge_status'] = 3; //未开始
                }
            }
        }
        $data = array(
            'list' => $list,
            'member' => $this->member,
            'all_number' => $all_number,
            'succ_number' => $succ_number,
            'currency_name' => getConfig('currency_name', '活力币'),
            'image' => $this->images('challenge_image', 'challenge/challenge.png')
        );

        json($data);
    }



    public function task()
    {
        $images = array(
            'task_icon1' => $this->image_url . 'task_icon1.png',
            'task_icon3' => $this->image_url . 'phone.jpg',
            'task_icon2' => $this->image_url . 'task_icon2.png',
            'bc_img' => $this->image_url . 'bc.png',
            'coin_img' => $this->image_url . 'coin.png'
        );

        $data = array(
            'images' => $images,
            'member' => $this->member,
            'currency_name' => getConfig('currency_name'),
            'is_auth' => $this->is_auth,
            'bind_phone_currency' => getConfig('bind_phone_currency', 0),
            'share_friend_currency' => getConfig('share_friend_currency', 0),
            'auth_currency' => getConfig('auth_currency', 0),
        );
        $this->json($data);
    }



    /**
     * 绑定手机号
     */
    public function bindPhone()
    {
        $iv = $this->get('iv');
        $encryptedData = $this->get('encryptedData');

        $wxbd = new WXBizDataCrypt($this->w['uniaccount']['key'], $this->session_key);

        $res = $wxbd->decryptData($encryptedData, $iv, $data);
        if ($res != ErrorCode::$OK) {
            json('unlogin', -1);
        }

        $data = json_decode($data, true);
        if (!p_get('currency_log', array('member_id' => $this->member['id'], 'type' => 8))) {
            $this->sModel->change_currency($this->member['id'], getConfig('bind_phone_currency'), 8);
        }
        p_update('memberinfo', array('phone' => $data['purePhoneNumber']), array('id' => $this->member['id']));
        $this->json();
    }


    /**
     * 活力币记录
     */
    public function currencyLog()
    {
        $currency = $this->member['currency'];
        $member_id = $this->member['id'];

        $p = $this->get('p', 1);
        $data = $this->sModel->currency_log($this->member['id'], $p);

        $time = strtotime(date('Y-m-d', time()));

        $today_currency = p_fetchcolumn("SELECT SUM(number) FROM " . prefix('currency_log') . " WHERE member_id={$member_id} AND type IN(2, 5, 7, 8, 9, 10) AND created>={$time}") ? : 0;

        $currency_name = getConfig('currency_name', '活力币');
        $this->json(compact('currency_name', 'currency', 'today_currency', 'data', 'member_id'));
    }


    public function loginfo()
    {
        $images = array(
            'bc_img' => $this->image_url . 'bc.png',
            'share' => $this->image_url . 'share.png',
        );

        $this->json(array('images' => $images));
    }



    public function shareImage()
    {
        $url = $this->w['siteroot'] . 'addons/bh_vote/template/static/images/xcx/share';
        $image = array(
            array(
                'posterImg' => $url . '/bg_9_6_1.jpg',
                'useNameStyle' => 'color:#ffffff;',
                'dateStyle' => 'color:rgba(255,255,255,0.80);',
                'stepNumStyle' => 'top:120px;right:29px;color:#ffffff;',
                'stepNumCss' => array(
                    'top' => '283rpx',
                    'right' => '70rpx',
                    'color' => '#ffffff',
                ),
                'useNameCss' => array(
                    'color' => '#ffffff'
                )
            ),
            array(
                'posterImg' => $url . '/bg_9_6_2.jpg',
                'useNameStyle' => 'color:#ffffff;',
                'dateStyle' => 'color:rgba(255,255,255,0.80);',
                'stepNumStyle' => 'top:128px;left:46px;color:#ffffff;',
                'stepNumCss' => array(
                    'top' => '302rpx',
                    'left' => '110rpx',
                    'color' => '#ffffff'
                ),
                'useNameCss' => array( 'color' => '#ffffff')
            ),
            array(
                'posterImg' => $url . '/bg_9_6_4.jpg',
                'useNameStyle' => 'color:#ffffff;',
                'dateStyle' => 'color:rgba(255,255,255,0.80);',
                'stepNumStyle' => 'top:120px;right:29px;color:#434343;',
                'stepNumCss' => array(
                    'top' => '283rpx',
                    'right' => '29px',
                    'color' => '#434343'
                ),
                'useNameCss' => array( 'color' => '#ffffff')
            ),
            array(
                'posterImg' => $url . '/bg_9_6_3.jpg',
                'useNameStyle' => 'color:#ffffff;',
                'dateStyle' => 'color:rgba(255,255,255,0.80);',
                'stepNumStyle' => 'color:#ffffff;left:46px;top:128px;',
                'stepNumCss' => array(
                    'top' => '302rpx',
                    'left' => '110rpx',
                    'color' => '#ffffff'
                ),
                'useNameCss' => array( 'color' => '#ffffff')
            ),
            array(
                'posterImg' => $url . '/bg_9_6_5.jpg',
                'useNameStyle' => 'color:#333333;',
                'dateStyle' => 'color:rgba(51,51,51,0.80);',
                'stepNumStyle' => 'color:#FF8E00;left:45px;top:126px;',
                'stepNumCss' => array(
                    'top' => '296rpx',
                    'left' => '106rpx',
                    'color' => '#FF8E00'
                ),
                'useNameCss' => array('color' => '#ffffff')
            )
        );
        $today = $this->sModel->get_step($this->member['id']);

        $xcx_path = 'bh_vote/pages/index/index';
        $code = $this->vote->createWxCode($this, $this->member['id'], $xcx_path, 'shop_' . $this->member['id'] . '.png');

        $head = headLocal($this, $this->member['headimgurl']);

        //$logo = getImage(getConfig('poster_icon'));
        //$logo = $logo ? : ($this->w['siteroot'] . 'addons/bh_step/icon.jpg');

        $data = array(
            'stepNum' => $today['own_step'],
            'userInfo' => array('avatar_url' => $head, 'nick_name' => $this->member['nickname']),
            'image' => $image,
            'date' => date('Y/m/d', time()),
            'qrcodeUrl' => $code,
            'xcx_title' => getConfig('xcx_title'),
            //'logo' => $logo
        );
        $step_journal_one = getConfig('step_journal_one') ? : '保存图片分享到朋友圈，展现自己的运动态度';
        $step_journal_two = getConfig('step_journal_two') ? : '好友通过图片分享进入你同样可获得邀请奖励';

        $audit_pattern = false;
        $data['content'] = array(
            'one' => $audit_pattern == 2 ? '' : $step_journal_one,
            'two' => $audit_pattern == 2 ? '' : $step_journal_two,
            'poster_text_one' => '长按扫码加入「' . $data['xcx_title'] . '」',
            'poster_text_two' => '努力就有收获',
        );

        json($data);
    }

}