<?php

class sign extends bhCommon {

    public $signin_days = array(
        1 => array(
            'key' => 'signin_one_day',
            'default' => 2
        ),
        2 => array(
            'key' => 'signin_two_day',
            'default' => 2
        ),
        3 => array(
            'key' => 'signin_three_day',
            'default' => 2
        ),
        4 => array(
            'key' => 'signin_four_day',
            'default' => 2
        ),
        5 => array('key' => 'signin_five_day',  'default' => 2),
        6 => array('key' => 'signin_six_day',  'default' => 2),
        7 => array('key' => 'signin_seven_day',  'default' => 2)
    );

    public function __construct()
    {
        parent::__construct();
        if (!$this->vote->is_show_integral()) {
            $this->json('请先安装插件', 0);
        }
    }



    /**
     *
     */
    public function index()
    {
        $reward = $this->signin_days;
        foreach ($reward as & $val) {
            $val['integral'] = getConfig($val['key'], 0);
        }

        $sgin = array(
            'is_sgin' => $this->vote->is_sign($this->member['id']),
            'reward' => $reward,
            'is_double' => getConfig('is_double'),
            'is_sign_double' => $this->vote->is_sign_double($this->member['id']),
            //'days' => $this->vote->get_signin($this->member['id'])
        );
        $days = $this->vote->get_signin($this->member['id']);
        $days = $days > 0 ? (($days % 7) ? : 7) : 0;
        $sgin['days'] = $days;

        $config = array(
            'integral_name' => getConfig('integral_name', '积分'),
            'sgin_subscribe' => getConfig('sign_subscribe'),
            'is_double' => getConfig('is_double', 1),
            'adUnitId' => getConfig('adUnitId'),
            'screen_ad' => getConfig('screen_ad'),
            'video_ad' => getConfig('video_ad'),
            'sigin_title' => getConfig('sigin_title', '签到'),
            'sigin_synchronization' => getConfig('sigin_synchronization', 1),
            'sign_status' => getConfig('sign_status', 1),
            'integral_rule_url' => ('/bh_vote/pages/webView/webView?url=' . urlencode(getConfig('integral_rule_url'))),
            'red_grant_hour' => getConfig('red_grant_hour', 0),
            'red_grant_minute' => getConfig('red_grant_minute', 0),
            'open_bag' => getConfig('open_bag', 1),
            'open_dividend' => getConfig('open_dividend', 1),
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FE5555'),
        );

        $images = array(
            'xin' => $this->images('integral_img', 'pop_gold.png'),
            'red_bg' => $this->image_url . 'red.png'
        );


        $red_bag = p_getall('red_bag', array(), array(), 'sort desc', 4);
        $is_red = false;

        if ($red_bag) {
            $same_day = strtotime(date('Y-m-d'));
            foreach ($red_bag as & $v) {
                $w = array(
                    'member_id' => $this->member['id'],
                    'red_bag_id' => $v['id'],
                    'same_day' => $same_day
                );
                if ($v['info'] = p_get('member_red_bag', $w)) {
                    $is_red = true;
                }
            }
        }

        $t = time();

        $time = strtotime(date('Y-m-d', $t)) + 86400;
        $remind = p_get('remind', array('member_id' => $this->member['id'], 'remind_day' => $time, 'type' => 1));

        $integral_goods = p_getall('integral_goods', array('status' => 1, 'is_delete' => 1), array(), array(), 'sort desc');
        if ($integral_goods) {
            foreach ($integral_goods as & $g) {
                if ($g['type'] != 2) {
                    $g['cover_image'] = getImage($g['cover_image']);
                }

                $g['run_away'] = p_getcolumn('order', array('goods_id' => $g['id']), 'COUNT(*)') ? : 0;
            }
        }

        $sql = 'SELECT * FROM ' . prefix('calligraphy') . ' WHERE status=1 AND is_delete=1 AND end_time >' . $t . get_uniacid();
        if ($jizi = p_fetchall($sql)) {
            foreach ($jizi as $k => $line) {
                $jizi[$k]['receive'] = p_getcolumn('calligraphy_member', array('calligraphy_id' => $line['id']), 'SUM(success)') ? : 0;
                $jizi[$k]['cover_img'] = getImage($jizi[$k]['cover_img']);
                if ($jizi[$k]['receive'] >= $line['stock']) {
                    unset($jizi[$k]);
                }
            }
        }

        $data = array(
            'sgin' => $sgin,
            'config' => $config,
            'images' => $images,
            'integral_goods' => $integral_goods,
            'member' => $this->member,
            'is_remind' => !empty($remind),
            'isIntegralUser' => $this->vote->isIntegralUser(),
            'red_bag' => $red_bag,
            'is_red' => $is_red,
            'jizi' => $jizi
        );
        if ($config['open_dividend'] == 1) {
            $bonus_level = $this->vote->memberDemotion($this->member['id']);
            $data['bonus_info'] = $this->vote->get_bonus_info($this->member['id'], $bonus_level, $this->member['integral']);

            $bonus_level != $bonus_level && $data['bonus_info']['next']['integral'] = 0;
        }


        $this->json($data);
    }


    /**
     * 升级等级
     */
    public function upgrade()
    {
        $next = p_get('bonus_level', array('level' => $this->member['bonus_level'] + 1));
        if (empty($next)) {
            $this->json('您已经升级到最高等级', 0);
        }


        pdo_begin();
        try{
            if ($next['integral'] > 0) {
                if (!$this->vote->change_integral($this->member['id'], $next['integral'], 11)) {
                    throw new Exception($this->vote->error);
                }
            }
            if ($next['share_number'] > 0) {
                $member_share = $this->vote->get_share_number($this->member['id']);
                if ($next['share_number'] > $member_share) {
                    throw new Exception('邀请人数不足');
                }
                if (!p_update('member_share', array('number' => $member_share - $next['share_number']), array('member_id' => $this->member['id']))) {
                    throw new Exception('升级失败,稍后再试');
                }
            }
            if (!p_update('memberinfo', array('bonus_level' => $this->member['bonus_level'] + 1), array('id' => $this->member['id']))) {
                throw new Exception('升级失败,稍后再试');
            }
            pdo_commit();
            $this->json();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 0);
        }
    }


    public function task()
    {
        $task = p_getall('task', array(), array(), '', 'sort desc');
        if ($task) {
            $same_day = strtotime(date('Y-m-d'));
            foreach ($task as & $line) {
                $w = array(
                    'member_id' => $this->member['id'],
                    'task_id' => $line['id'],
                    'same_day' => $same_day
                );
                $m = p_get('task_member', $w);
                $line['state'] = 1;
                $line['is_succ'] = 1;
                $line['succ_num'] = 0;

                $line['num'] = 0;

                if (!empty($m)) {

                    $line['num'] = $m['number'];

                    if (in_array($line['type'], array(1, 2, 4))) {
                        $line['state'] = 3;
                        $line['succ_num'] = 1;
                    } else {
                        $line['succ_num'] = $m['number'];
                        $line['state'] = $m['number'] >= $line['number'] ? 3 : 1;
                    }
                } else {
                    if ($line['type'] == 1) {
                        $sql = "SELECT COUNT(*) FROM " . prefix('luck_participate') . " WHERE member_id={$this->member['id']} AND created >= {$same_day}";
                        $num = p_fetchcolumn($sql) ? : 0;

                        if ($line['number'] <= $num) {
                            $line['state'] = 2;
                            $line['num'] = $line['number'];
                        } else {
                            $line['num'] = $num;
                        }

                    } elseif ($line['type'] == 2) {
                        $sql = "SELECT COUNT(*) FROM " . prefix('luck') . " WHERE member_id={$this->member['id']} AND complete=2 AND created >= {$same_day}";
                        $num = p_fetchcolumn($sql) ? : 0;

                        if ($line['number'] <= $num) {
                            $line['state'] = 2;
                            $line['num'] = $line['number'];
                        } else {
                            $line['num'] = $num;
                        }
                    }
                }
            }
        }
        $data = array(
            'task' => $task,
            'member' => $this->member
        );
        $this->json($data);
    }



    /**
     * 签到提醒
     */
    public function remind()
    {
        $time = strtotime(date('Y-m-d', time())) + 86400;
        $remind = p_get('remind', array('member_id' => $this->member['id'], 'remind_day' => $time, 'type' => 1));

        if ($remind) {
            p_delete('remind', array('id' => $remind['id']));
            $is_remind = false;
        } else {
            $data = array(
                'member_id' => $this->member['id'],
                'remind_day' => $time,
                'type' => 1,
                'created' => time()
            );
            p_insert('remind', $data);
            $is_remind = true;
        }
        $this->json(array('is_remind' => $is_remind));
    }


    /**
     * 签到翻倍
     */
    public function double()
    {
        if ($this->vote->is_sign_double($this->member['id'])) {
            $this->json();
        }
        $days = $this->vote->get_signin($this->member['id']);
        $d = ($days % 7) ? : 7;
        $integral = getConfig($this->signin_days[$d]['key'], 0);

        if ($this->vote->change_integral($this->member['id'], $integral, 2)) {
            $this->json();
        }
        $this->json('翻倍失败', 2);
    }


    /**
     * 签到
     */
    public function siginIn()
    {
        if ($this->vote->is_sign($this->member['id'])) {
            $this->json();
        }
        $days = $this->vote->get_signin($this->member['id']) + 1;
        //$days = $days > 7 ? 1 : $days;
        $days = ($days % 7) ? : 7;
        $integral = getConfig($this->signin_days[$days]['key'], 0);

        $days = $this->vote->signin($this->member['id'], $integral);
        if (!$days) {
            $this->json($this->vote->error, 2);
        }

        $data = array(
            'days' => $days,
            'sign_integral' => $integral
        );
        $this->json($data);
    }


    /**
     * 积分明细
     */
    public function log()
    {
        $p = $this->get('p', 1);
        $page_size = 10;
        $limit = ($p - 1) * $page_size;
        $log = p_getall('integral_log', array('member_id' => $this->member['id']), array(),'', array('id desc'), "{$limit}, {$page_size}");

        if ($log) {
            $msg = array(
                1 => '签到',
                2 => '签到翻倍',
                3 => '兑换商品',
                4 => '每日任务',
                5 => '接口加积分',
                6 => '接口减积分',
                7 => '积分抽奖',
                8 => '取消订单退回',
                9 => '积分清零',
                10 => '兑换红包',
                11 => '升级分红等级',
                12 => '清空积分',
                13 => '中奖赠送',
                14 => '集字消耗',
                15 => '参加活动',
            );
            foreach ($log as & $v) {
                $v['created'] = date('Y-m-d', $v['created']);
                if ($v['type'] == 15) {
                    $v['msg'] = empty($v['remarks']) ? $msg[$v['type']] : $v['remarks'];
                } else {
                    $v['msg'] = $msg[$v['type']];
                }

                $v['mold'] = in_array($v['type'], array(1,2,4,5,8,15)) ? 1 : 2;
            }
        }
        $data = array(
            'log' => $log
        );
        $this->json($data);
    }


    /**
     * 积分商品
     */
    public function details()
    {
        $id = intval($this->get('id'));

        $goods = p_get('integral_goods', array('id' => $id, 'status' => 1, 'is_delete' => 1));
        if (empty($goods)) {
            $this->json('商品不存在或者已下架', 0);
        }
        if (!empty($goods['image'])) {
            $goods['image'] = json_decode($goods['image']);
            $goods['image'] = array_map('getImage', $goods['image']);
        }


        $order = p_getall('order', array('goods_id' => $id, 'is_pay' => 2), array(), '', 'id desc', 10);
        if ($order) {
            foreach ($order as & $value) {
                $value['member'] = p_get('memberinfo', array('id' => $value['member_id']));
                $value['formatTime'] = formatTime($value['created']);
            }
        }


        $buy_status = 1;
        $count = p_getcolumn('order', array('goods_id' => $id, 'is_pay' => 2), 'COUNT(*)') ? : 0;
        if ($count >= $goods['inventory']) {
            $buy_status = 2;
            $goods['inventory'] = 0;
        } else {
            $goods['inventory'] = $goods['inventory'] - $count;
        }

        if ($buy_status == 1 && $goods['allow_number'] > 0) {
            $buy_num = p_getcolumn('order', array('member_id' => $this->member['id'], 'goods_id' => $id, 'is_pay' => 2), 'COUNT(*)') ? : 0;
            $buy_status = $buy_num >= $goods['allow_number'] ? 3 : 1;
        }
        if ($buy_status == 1) {
            $buy_status = $this->member['integral'] < $goods['exchange_number'] ? 4 : 1;
        }

        $goods['cover_image'] = getImage($goods['cover_image']);
        $goods['all_money'] = $goods['exchange_type'] == 2 ? ($goods['money'] + $goods['free']) : 0;

        $merchant = array();
        if ($goods['type'] == 3) {
            $sql = 'SELECT id,shop_name FROM ' . prefix('merchant') . " WHERE id IN({$goods['shop_ids']})";
            $merchant = p_fetchall($sql);
            $merchant && array_unshift($merchant, array('id' => 0, 'shop_name' => '请选择'));
        }

        $address = p_get('address', array('member_id' => $this->member['id']));

        $config = array(
            'integral_name' => getConfig('integral_name', '积分'),
            'goods_flow_group' => getConfig('goods_flow_group'),
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FE5555'),
            //'ad_type' => getConfig('ad_type', 1),
        );

        $data = array(
            'goods' => $goods,
            'config' => $config,
            'address' => $address,
            'order' => $order,
            'buy_status' => $buy_status,
            'merchant' => $merchant,
            'is_union' => $this->vote->is_union()
        );
        $this->json($data);
    }



    public function order()
    {
        $order = p_getall('order', array('member_id' => $this->member['id'], 'is_pay' => 2), array(),'', array('id desc')) ? : array();
        if ($order) {
            $status = array(
                1 => '未发货',
                2 => '已发货',
                3 => '已完成',
                4 => '已取消'
            );
            foreach ($order as & $value) {

                $value['goods'] = p_get('integral_goods', array('id' => $value['goods_id']));
                $value['goods']['img'] = $value['type'] != 2 ? getImage($value['goods']['cover_image']) : $value['goods']['cover_image'];
                $value['created'] = date('Y-m-d H:i:s', $value['created']);
                if ($value['type'] == 3) {
                    $value['status_msg'] = $value['status'] == 1 ? '未使用' : '已使用';
                } else {
                    $value['status_msg'] = $status[$value['status']];
                }

            }
        }
        $images = array(
            'my_orders_nodata' => $this->image_url . 'my_orders_nodata.png',
            'my_express_icon' => $this->image_url . 'my_express_icon.png',
            'address_locate' => $this->image_url . 'address_locate.png',
            'attention' => $this->image_url . 'attention.png'
        );
        $data = array(
            'orders' => $order,
            'currency_name' => getConfig('integral_name'),
            'images' => $images,
            'is_calligraphy' => $this->vote->is_calligraphy()
        );
        $this->json($data);
    }


    /**
     * 领取
     */
    public function receive()
    {
        $id = $this->get('id');
        $task = p_get('task', array('id' => $id));

        if (empty($task)) {
            $this->json('任务不存在', 2);
        }
        $same_day = strtotime(date('Y-m-d'));

        if ($task['type'] == 1) {
            $sql = "SELECT COUNT(*) FROM " . prefix('luck_participate') . " WHERE member_id={$this->member['id']} AND created >= {$same_day}";
            $num = p_fetchcolumn($sql) ? : 0;

            if ($task['number'] > $num) {
                $this->json('任务还未完成哦~', 2);
            }

        } elseif ($task['type'] == 2) {
            $sql = "SELECT COUNT(*) FROM " . prefix('luck') . " WHERE member_id={$this->member['id']} AND complete=2 AND created >= {$same_day}";
            $num = p_fetchcolumn($sql) ? : 0;

            if ($task['number'] > $num) {
                $this->json('任务还未完成哦~', 2);
            }
        }
        $task_member = p_get('task_member', array('member_id' => $this->member['id'], 'task_id' => $task['id'], 'same_day' => $same_day));

        if ($task_member && (in_array($task['type'], array(1, 2, 4)) || ($task['type'] == 3 && $task_member['number'] >= $task['number']))) {
            $this->json();
        }
        pdo_begin();
        try{
            if (!$this->vote->change_integral($this->member['id'], $task['integral'], 4, $task['title'])) {
                throw new Exception($this->vote->error);
            }
            if ($task_member && $task['type'] == 3) {
                if (!p_update('task_member', array('number' => $task_member['number'] + 1), array('id' => $task_member['id']))) {
                    throw new Exception('奖励领取失败1~');
                }
            } else {
                $insert = array(
                    'member_id' => $this->member['id'],
                    'task_id' => $id,
                    'same_day' => $same_day,
                    'created' => time()
                );
                if ($task['type'] == 1) {
                    $insert['number'] = $task['number'];
                }
                if (!p_insert('task_member', $insert)) {
                    throw new Exception('奖励领取失败2~');
                }
            }
            pdo_commit();
            $this->json();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }
    }


    /**
     * 领取红包
     */
    public function receiveRed()
    {
        $id = $this->get('id');

        pdo_begin();
        try{
            $money = $this->vote->receive($this->member['id'], $id);
            if (!$money) {
                throw new Exception($this->vote->error);
            }
            pdo_commit();
            $this->json(array('red_money' => $money));
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }
    }


    public function bonusRule()
    {
        $data = array(
            'bonus_rule' => getConfig('bonus_rule')
        );
        $this->json($data);
    }


    /**
     * 完成挑战
     */
    public function succJump()
    {
        $id = intval($this->get('id'));
        if ($demo_jump = p_get('demo_jump', array('id' => $id))) {
            p_update('demo_jump', array('current_jump_number' => $demo_jump['current_jump_number'] + 1), array('id' => $id));
        }

        $this->json();
    }

}