<?php
include IA_ROOT . '/addons/bh_vote/model/shop.mod.php';
class topic extends bhCommon {

    public $sModel;

    public function __construct()
    {
        parent::__construct();
        $this->sModel = new shopModel();
    }


    /**
     *
     */
    public function index()
    {
        $topic = p_getall('topic', array('is_delete' => 1), array(), '', array('sort DESC'));
        $popular = array();

        if ($topic) {
            foreach ($topic as $value) {
                if ($value['is_recommend'] == 2) {
                    $value['image'] = getImage($value['image']);
                    $popular[] = $value;
                }
            }
        }
        $images = array(
            'release_picture' => $this->image_url . 'topic/release_picture.png',
            'icon_recommed' => $this->image_url . 'topic/icon_recommed.png',
            'icon_link_release' => $this->image_url . 'topic/icon_link_release.png',
            'topic' => $this->image_url . 'topic/topic.png',

            'nofabulous' =>  $this->image_url . 'topic/nofabulous.png',
            'fabulous' =>  $this->image_url . 'topic/fabulous.png',
            'comment' =>  $this->image_url . 'topic/comment.png',
            'share' =>  $this->image_url . 'topic/share.png',
            'no_collection' =>  $this->image_url . 'topic/no_collection.png',
            'collection' =>  $this->image_url . 'topic/collection.png',
            'release' =>  $this->image_url . 'topic/release1.png',
        );
        $share = array(
            'text' => $this->member['nickname'] . '向你分享一个有趣的社区',
            'path' => 'packageA/pages/topic/index/index?parent_id=' . $this->member['id']
        );
        $topic_image_number = getConfig('topic_image_number', 9);

        $this->json(compact('popular', 'images', 'share', 'topic_image_number'));
    }



    /**
     *
     */
    public function info()
    {
        $id = $this->get('id');
        $topic = p_get('topic', array('id' => $id));
        if ($topic) {
            $topic['image'] = getImage($topic['image']);
        }
        $images = array(
            'userbg' => $this->image_url . 'topic/hishead.png',
            'topic' => $this->image_url . 'topic/topic.png',
            'nofabulous' => $this->image_url . 'topic/nofabulous.png',
            'comment' => $this->image_url . 'topic/comment.png',
            'share' => $this->image_url . 'topic/share.png',
            'delete' => $this->image_url . 'topic/delete.png',
            'fabulous' => $this->image_url . 'topic/fabulous.png',
            'release' => $this->image_url . 'topic/release1.png',
            'collection' => $this->image_url . 'topic/collection.png',
            'no_collection' => $this->image_url . 'topic/no_collection.png',
            'release_picture' => $this->image_url . 'topic/release_picture.png',
        );

        $share = array(
            'text' => $this->member['nickname'] . '向你推荐了一个有趣的话题',
            'path' => 'packageA/pages/index/index?parent_id=' . $this->member['id'] . '&popular_id=' . $id
        );


        $this->json(array('topic' => $topic, 'images' => $images, 'share' => $share));
    }



    /**
     *
     */
    public function release()
    {
        $popular_id = $this->get('popular_id');
        $allocation = $this->get('allocation');
        $imgs = $this->get('imgs');

        if (empty($allocation)) {
            $this->json('请输入发布内容', 0);
        }

        $data = array(
            'allocation' => $allocation,
            'member_id' => $this->member['id'],
            'created' => time(),
            'examine' => getConfig('topic_examine', 2)
        );

        if ($popular_id) {
            if (p_get('topic', array('id' => $popular_id, 'is_delete' => 1))) {
                $data['topic_id'] = $popular_id;
            }
        }

        if ($imgs) {
            $ids = array();
            $imgs = json_decode(htmlspecialchars_decode($imgs), true);
            foreach ($imgs as $value) {
                $ids[] = $value['path'];
            }

            $data['image'] = json_encode($ids);
        }

        p_insert('topic_member', $data);
        $this->json();
    }



    /**
     *
     */
    public function topicList()
    {
        $p = $this->get('p', 1);
        $page_size = 10;
        $limit = ($p - 1) * $page_size;

        $type = $this->get('type');
        $where = array(
            'is_delete' => 1,
            'examine' => 2
        );

        if ($type == 1) {
            $where['member_id'] = $this->member['id'];
        } elseif ($type == 2 && $this->get('id')) {
            $where['member_id'] = $this->get('id');
        }
         else if ($type == 3) {
            $where['topic_id'] = $this->get('topic_id');
        }



        $list = p_getall('topic_member', $where, array(), '', 'sort desc,id desc', "{$limit}, {$page_size}");
        if ($list) {
            foreach ($list as & $value) {
                if ($value['image']) {
                    $value['image'] = json_decode($value['image'], true);
                    foreach ($value['image'] as & $v) {
                        $v = getImage($v);
                    }
                }
                if ($value['topic_id'] > 0) {
                    $value['topic'] = p_get('topic', array('id' => $value['topic_id']));
                }
                $value['fabulous'] = p_getcolumn('topic_fabulous', array('f_member_id' => $this->member['id'], 'topic_member_id' => $value['id']), 'COUNT(*)') > 0;
                $value['fabulous_number'] = p_getcolumn('topic_fabulous', array('topic_member_id' => $value['id']), 'COUNT(*)') ? : 0;

                $value['comment_number'] = p_getcolumn('topic_comment', array('topic_member_id' => $value['id'], 'examine' => 2), 'COUNT(*)') ? : 0;
                if ($type == 1) {
                    $value['created'] = date('m/d H:i', $value['created']);
                    $value['collection'] = p_getcolumn('topic_collection', array('c_member_id' => $this->member['id'], 'topic_member_id' => $value['id']), 'COUNT(*)') > 0;;
                }
                else if ($type == 2 || $type == 3) {
                    $value['member'] = p_get('memberinfo', array('id' => $value['member_id']));
                    $value['follow'] = p_getcolumn('topic_follow', array('member_id' => $value['member_id'], 'follow_member_id' => $this->member['id']), 'COUNT(*)') > 0;
                    $value['created'] = formatTime($value['created']);
                    $value['collection'] = p_getcolumn('topic_collection', array('c_member_id' => $this->member['id'], 'topic_member_id' => $value['id']), 'COUNT(*)') > 0;
                }
            }
        }

        $this->json(compact('list'));
    }


    /**
     *
     */
    public function myFollow()
    {
        $p = $this->get('p', 1);
        $page_size = 10;
        $limit = ($p - 1) * $page_size;

        $sql = "SELECT B.* FROM " . prefix('topic_follow') . " AS A LEFT JOIN " . prefix('topic_member') . " AS B ON A.member_id=B.member_id WHERE A.follow_member_id={$this->member['id']} AND B.is_delete=1 AND examine=2 ORDER BY B.id DESC LIMIT {$limit}, {$page_size}";

        $list = $this->_list(p_fetchall($sql), 2);
        $this->json(compact('list'));
    }



    private function _list($list, $type)
    {
        if (empty($list)) {
            return $list;
        }
        foreach ($list as & $value) {
            if ($value['image']) {
                $value['image'] = json_decode($value['image'], true);
                foreach ($value['image'] as & $v) {
                    $v = getImage($v);
                }
            }
            if ($value['topic_id'] > 0) {
                $value['topic'] = p_get('topic', array('id' => $value['topic_id']));
            }
            $value['fabulous'] = p_getcolumn('topic_fabulous', array('f_member_id' => $this->member['id'], 'topic_member_id' => $value['id']), 'COUNT(*)') > 0;
            $value['fabulous_number'] = p_getcolumn('topic_fabulous', array('topic_member_id' => $value['id']), 'COUNT(*)') ? : 0;

            if ($type == 1) {
                $value['created'] = date('m/d H:i', $value['created']);
            }
            else if ($type == 2) {
                $value['member'] = p_get('memberinfo', array('id' => $value['member_id']));
                $value['follow'] = p_getcolumn('topic_follow', array('member_id' => $value['member_id'], 'follow_member_id' => $this->member['id']), 'COUNT(*)') > 0;
                $value['created'] = formatTime($value['created']);
                $value['collection'] = p_getcolumn('topic_collection', array('c_member_id' => $this->member['id'], 'topic_member_id' => $value['id']), 'COUNT(*)') > 0;;
            }
        }
        return $list;
    }



    /**
     *
     */
    public function fabulous()
    {
        $id = $this->get('id');
        $topic = p_get('topic_member', array('id' => $id));
        if (empty($topic)) {
            $this->json('', 2);
        }

        $fabulous = p_get('topic_fabulous', array('topic_member_id' => $id, 'f_member_id' => $this->member['id']));
        if ($fabulous) {
            p_delete('topic_fabulous', array('id' => $fabulous['id']));
            $fabulous = false;
        } else {
            $insert = array(
                'member_id' => $topic['member_id'],
                'f_member_id' => $this->member['id'],
                'topic_member_id' => $id,
                'topic_id' => $topic['topic_id'],
                'created' => time()
            );

            p_insert('topic_fabulous', $insert);
            $fabulous = true;
        }

        $data = array(
            'fabulous' => $fabulous,
            'fabulous_number' => p_getcolumn('topic_fabulous', array('topic_member_id' => $id), 'COUNT(*)') ? : 0
        );
        $this->json($data);
    }



    /**
     *
     */
    public function collection()
    {
        $id = $this->get('id');
        $topic = p_get('topic_member', array('id' => $id));
        if (empty($topic)) {
            json('', 2);
        }

        $collection = p_get('topic_collection', array('topic_member_id' => $id, 'c_member_id' => $this->member['id']));
        if ($collection) {
            p_delete('topic_collection', array('id' => $collection['id']));
            $collection = false;
        } else {
            $insert = array(
                'member_id' => $topic['member_id'],
                'c_member_id' => $this->member['id'],
                'topic_member_id' => $id,
                'topic_id' => $topic['topic_id'],
                'created' => time()
            );
            p_insert('topic_collection', $insert);
            $collection = true;
        }

        $data = array(
            'collection' => $collection
        );
        $this->json($data);
    }



    /**
     *
     */
    public function follow()
    {
        $member_id = $this->get('member_id');
        if ($member_id == $this->member['id']) {
            $this->json('');
        }
        $tpye = $this->get('type');
        if ($tpye == 2) {
            p_delete('topic_follow', array('follow_member_id' => $this->member['id'], 'member_id' => $member_id));
            json('');
        }
        if (p_get('topic_follow', array('follow_member_id' => $this->member['id'], 'member_id' => $member_id))) {
            $this->json('');
        }

        $insert = array(
            'member_id' => $member_id,
            'follow_member_id' => $this->member['id'],
            'created' => time()
        );
        p_insert('topic_follow', $insert);
        $this->json('');
    }


    /**
     *
     */
    public function topicMember()
    {
        $id = $this->get('id');
        $detail = p_get('topic_member', array('id' => $id, 'is_delete' => 1, 'examine' => 2));
        if (empty($detail)) {
            $this->json('该内容不存在', 0);
        }
        if ($detail['topic_id'] > 0) {
            $detail['topic'] = p_get('topic', array('id' => $detail['topic_id']));
        }
        if ($detail['image']) {
            $detail['image'] = json_decode($detail['image'], true);
            foreach ($detail['image'] as & $value) {
                $value = getImage($value);
            }
        }
        $detail['member'] = p_get('memberinfo', array('id' => $detail['member_id']));

        $detail['follow'] = p_getcolumn('topic_follow', array('member_id' => $detail['member_id'], 'follow_member_id' => $this->member['id']), 'COUNT(*)') > 0;
        $detail['created'] = formatTime($detail['created']);
        $detail['collection'] = p_getcolumn('topic_collection', array('c_member_id' => $this->member['id'], 'topic_member_id' => $detail['id']), 'COUNT(*)') > 0;;

        $detail['fabulous'] = p_getcolumn('topic_fabulous', array('f_member_id' => $this->member['id'], 'topic_member_id' => $detail['id']), 'COUNT(*)') > 0;
        $detail['fabulous_number'] = p_getcolumn('topic_fabulous', array('topic_member_id' => $detail['id']), 'COUNT(*)') ? : 0;
        $detail['comment_number'] = p_getcolumn('topic_comment', array('topic_member_id' => $detail['id'], 'examine' => 2), 'COUNT(*)') ? : 0;


        $images = array(
            'release_picture' => $this->image_url . 'topic/release_picture.png',
            'icon_recommed' => $this->image_url . 'topic/icon_recommed.png',
            'icon_link_release' => $this->image_url . 'topic/icon_link_release.png',
            'topic' => $this->image_url . 'topic/topic.png',

            'nofabulous' =>  $this->image_url . 'topic/nofabulous.png',
            'fabulous' =>  $this->image_url . 'topic/fabulous.png',
            'comment' =>  $this->image_url . 'topic/comment.png',
            'share' =>  $this->image_url . 'topic/share.png',
            'no_collection' =>  $this->image_url . 'topic/no_collection.png',
            'collection' =>  $this->image_url . 'topic/collection.png',

            'release' =>  $this->image_url . 'topic/release1.png',
        );
        $share = array(
            'text' => $this->member['nickname'] . '向你分享一个动态',
            'path' => 'packageA/pages/detail/detail?parent_id=' . $this->member['id'] . '&id=' . $id
        );
        $data = array(
            'detail' => $detail,
            'images' => $images,
            'share' => $share
        );
        $this->json($data);
    }



    /**
     *
     */
    public function commentList()
    {
        $id = $this->get('id');

        $list = p_getall('topic_comment', array('topic_member_id' => $id, 'examine' => 2));
        if ($list) {
            foreach ($list as & $value) {
                if ($value['comment_member_id'] > 0) {
                    $value['comment_meber'] = p_get('memberinfo', array('id' => $value['comment_member_id']));
                }
                $value['member'] = p_get('memberinfo', array('id' => $value['member_id']));
                $value['created'] = formatTime($value['created']);
            }
        }
        $this->json(array('list' => $list));
    }


    /**
     *
     */
    public function comment()
    {
        $content = $this->get('content');
        $id = $this->get('id');
        if (is_null($content)) {
            $this->json('请输入评论内容', 2);
        }

        $data = array(
            'member_id' => $this->member['id'],
            'topic_member_id' => $id,
            'content' => $content,
            'examine' => getConfig('topic_comment_examine', 2),
            'created' => time()
        );

        $comment_id = $this->get('comment_id');
        if ($comment_id) {
            if ($comment = p_get('topic_comment', array('id' => $comment_id))) {
                $data['type'] = 2;
                $data['comment_id'] = $comment_id;
                $data['comment_member_id'] = $comment['member_id'];
            }
        }

        p_insert('topic_comment', $data);
        $data['id'] = pdo_insertid();
        $this->json(array('data' => $data));
    }


    /**
     *
     */
    public function my()
    {
        $is_follow = false;
        $is_my = true;
        if ($id = $this->get('id')) {
            $is_follow = p_get('topic_follow', array('follow_member_id' => $this->member['id'], 'member_id' => $id));
            $is_my = $id == $this->member['id'];
            $this->member = p_get('memberinfo', array('id' => $id));
        }

        $share = array(
            'text' => $this->member['nickname'] . '向你分享一个有趣的人',
            'path' => 'packageA/pages/topic/user/user?parent_id=' . $this->member['id'] . '&id=' . $id
        );


        $data = array(
            'images' => array(
                'userbg' => $this->image_url . 'topic/hishead.png',
                'topic' => $this->image_url . 'topic/topic.png',
                'nofabulous' => $this->image_url . 'topic/nofabulous.png',
                'comment' => $this->image_url . 'topic/comment.png',
                'share' => $this->image_url . 'topic/share.png',
                'delete' => $this->image_url . 'topic/delete.png',
                'fabulous' => $this->image_url . 'topic/fabulous.png',
                'release' => $this->image_url . 'topic/release1.png',
                'collection' => $this->image_url . 'topic/collection.png',
                'no_collection' => $this->image_url . 'topic/no_collection.png',
            ),
            'is_my' => $is_my,
            'share' => $share,
            'member' => $this->member,
            'is_follow' => $is_follow,
            'follow_number' => p_getcolumn('topic_follow', array('follow_member_id' => $this->member['id']), 'COUNT(*)') ? : 0,
            'fans_number' => p_getcolumn('topic_follow', array('member_id' => $this->member['id']), 'COUNT(*)') ? : 0,
            'fabulous_number' => p_getcolumn('topic_fabulous', array('member_id' => $this->member['id']), 'COUNT(*)') ? : 0,
            'topic_number' => p_getcolumn('topic_member', array('member_id' => $this->member['id']), 'COUNT(*)') ? : 0,
        );


        json($data);
    }



    /**
     *
     */
    public function fans()
    {
        $p = $this->get('p', 1);
        $page_size = 10;
        $limit = ($p - 1) * $page_size;

        $images = array(
            'nofollow' => $this->image_url . 'topic/follow.png',
            'follow' => $this->image_url . 'topic/follow.png',
        );

        $type = $this->get('type');
        $member_id = $this->get('member_id');

        $is_my = $this->member['id'] == $member_id;

        if ($type == 1) {
            $where = array('follow_member_id' => $member_id);
            $key = 'member_id';
            $title = $is_my ? '我的关注' : 'TA的关注';
        } else {
            $where = array('member_id' => $member_id);
            $key = 'follow_member_id';
            $title = $is_my ? '我的粉丝' : 'TA的粉丝';
        }

        $list = p_getall('topic_follow', $where, array(), '', array('id DESC'), "{$limit}, {$page_size}");
        if ($list) {
            foreach ($list as & $value) {
                $value['member'] = p_get('memberinfo', array('id' => $value[$key]));
                $value['follow'] = p_getcolumn('topic_follow', array('follow_member_id' => $this->member['id'], 'member_id' => $value[$key]), 'COUNT(*)') > 0;
            }
        }

        $data = array(
            'images' => $images,
            'list' => $list,
            'title' => $title,
            'is_my' => $is_my
        );
        $this->json($data);
    }


    /**
     *
     */
    public function myCollection()
    {
        $p = $this->get('p', 1);
        $page_size = 10;
        $limit = ($p - 1) * $page_size;

        $sql = "SELECT B.* FROM " . prefix('topic_collection') ." AS A LEFT JOIN " . prefix('topic_member') . " AS B ON A.topic_member_id=B.id WHERE A.c_member_id={$this->member['id']}  AND B.is_delete=1 AND examine=2 ORDER BY B.id DESC LIMIT {$limit}, {$page_size}";

        $list = $this->_list(p_fetchall($sql), 1);

        $this->json(compact('list'));
    }


    /**
     *
     */
    public function deleteTopic()
    {
        $id = $this->get('id');
        $topic_member = p_get('topic_member', array('id' => $id, 'member_id' => $this->member['id']));

        if (empty($topic_member)) {
            json('', 2);
        }
        p_update('topic_member', array('is_delete' => 2), array('id' => $id));
        json('');
    }

}