<?php
include IA_ROOT . '/addons/bh_vote/model/shop.mod.php';
class treasure extends bhCommon {

    public $sModel;

    public function __construct()
    {
        parent::__construct();
        $this->sModel = new shopModel();
    }


    /**
     *
     */
    public function index()
    {
        $treasure_top_image = $this->images('treasure_top_image', 'treasure_header.png');

        $no_treasure_image = $this->image_url . 'no-friends-tip.png';
        $treasure_rules_image = $this->image_url . 'treasure_rules.png';

        $conduct = p_getall('treasure', array('is_delete' => 1, 'is_down' => 1, 'status' => 1), array(), '',  array('sort desc'));

        if (!empty($conduct)) {
            foreach ($conduct as & $value) {
                $value['cover_image'] = getImage($value['cover_image']);
                $value['treasure_code_count'] = p_getcolumn('treasure_code', array('treasure_id' => $value['id']), 'COUNT(*)') ? : 0;
            }
        }

        $ending_period_list = p_getall('treasure', array('is_delete' => 1, 'is_down' => 1, 'status' => 2), array(), '',  array('lottery_time desc'));

        if (!empty($ending_period_list)) {
            foreach ($ending_period_list as & $val) {
                $val['cover_image'] = getImage($val['cover_image']);
                $val['prize'] = p_get('treasure_code', array('treasure_id' => $val['id'], 'in_prize' => 2));
                $val['prize']['member'] = p_get('memberinfo', array('id' => $val['prize']['member_id']));
            }
        }

        $treasure_rules_font = getConfig('treasure_rules_font');
        if ($treasure_rules_font) {
            $treasure_rules_font = json_decode($treasure_rules_font, true);
        }
        if (empty($treasure_rules_font)) {
            $treasure_rules_font = array(
                '每个商品根据商品价值不同，分为不同份数，商品份数售完后，实时进行开奖；',
                '用户通过活力币购买夺宝商品份数，每购买1份可获得一个夺宝号码；',
                getConfig('xcx_title') . '不会对此活动的用户额外收取任何费用，活力币亦不能通过充值获得；',
                '若发现用户通过违规行为或恶意作弊参与夺宝，' . getConfig('xcx_title') . '有权取消用户中奖资格，并收回奖励；',
                '若出现不可抗力或情势变更（如重大灾害，活动收相关单位指令需要停止进行调整等），' . getConfig('xcx_title') . '可依据法律法规的主张免责；',
                '本活动最终解释权归' . getConfig('xcx_title') . '所有',
            );
        }


        $data = array(
            'treasure_top_image' => $treasure_top_image,
            'running_period_list' => $conduct,
            'no_treasure_image' => $no_treasure_image,
            'treasure_rules_image' => $treasure_rules_image,
            'treasure_rules_font' => $treasure_rules_font,
            'ending_period_list' => $ending_period_list,
            'member_id' => $this->member['id']
        );
        $this->json($data);
    }



    public function detail()
    {
        $id = $this->get('id');
        $treasure = p_get('treasure', array('id' => $id, 'is_delete' => 1, 'is_down' => 1));
        if (empty($treasure)) {
            $this->json('该夺宝不存在', 0);
        }
        $treasure['images'] = array();
        if ($treasure['image']) {
            $treasure['image'] = json_decode($treasure['image'], true);
            foreach ($treasure['image'] as $value) {
                $treasure['images'][] = getImage($value);
            }
        }

        if ($treasure['status'] == 2) {
            $treasure['lottery_time'] = date('Y-m-d H:i', $treasure['lottery_time']);

            $treasure['prize'] = p_get('treasure_code', array('treasure_id' => $id, 'in_prize' => 2));
            $treasure['prize']['member'] = p_get('memberinfo', array('id' => $treasure['prize']['member_id']));
            $treasure['prize']['code_num'] = p_getcolumn('treasure_code', array('treasure_id' => $id, 'member_id' => $treasure['prize']['member_id']), 'COUNT(*)') ? : 0;

            $treasure['is_luck'] = $treasure['prize']['member_id'] == $this->member['id'];

        } else {
            $treasure['treasure_code_count'] = p_getcolumn('treasure_code', array('treasure_id' => $id), 'COUNT(*)') ? : 0;
            $treasure['percent'] = round($treasure['treasure_code_count']/$treasure['number_copies'], 4) * 100;
        }

        $path = $this->image_url . 'db/';

        $image = array(
            'running_tag_1' => $path . 'running_tag_1.png',
            'zhongjian_tag' => $path . 'zhongjian_tag.png',
            'end_tag_2' => $path . 'end_tag_2.png',
            'red_arrow' => $path . 'red_arrow.png',
            'open_arrow' => $path . 'open_arrow.png',
            'no_data_img' => $path . 'no-friends-tip.png',
            'add' => $path . 'add.png',
            'del' => $path . 'del.png',
            'close' => $path . 'close.png',
            'winning_tag' => $path . 'winning_tag.png',
            'arrow' => $path . 'arrow.png',
            'currency_name' => getConfig('currency_name')
        );

        $address = p_get('address', array('member_id' => $this->member['id']));

        $this->json(array('treasure' => $treasure, 'image' => $image, 'member' => $this->member, 'address' => $address));

    }



    /**
     *
     */
    public function myCode()
    {
        $id = $this->get('id');
        $treasure_code = p_getall('treasure_code', array('member_id' => $this->member['id'], 'treasure_id' => $id));

        $this->json(array('code' => $treasure_code));
    }



    /**
     *
     */
    public function setAddress()
    {
        $data = array(
            'name' =>  $this->get('name'),
            'phone' =>  $this->get('phone'),
            'address' =>  $this->get('address'),
        );

        if ($address = p_get('address', array('member_id' => $this->member['id']))) {
            p_update('address', $data, array('address_id' => $address['id']));
        } else {
            $data['member_id'] = $this->member['id'];
            $data['created'] = time();
            p_insert('address', $data);
        }
        $this->json('设置成功');
    }


    /**
     *
     */
    public function getAddress()
    {
        $address = p_get('address', array('member_id' => $this->member['id']));
        $this->json(array('address' => $address));
    }




    /**
     *
     */
    public function buy()
    {
        $id = $this->get('id');

        $treasure = p_get('treasure', array('id' => $id, 'is_delete' => 1, 'is_down' => 1, 'status' => 1));
        if (empty($treasure)) {
            json('该夺宝不存在或者已经结束', 2);
        }
        if ($treasure['type'] == 2) {
            $pwd = $this->get('pwd');
            if (!$pwd) {
                json('请填写夺宝口令', 2);
            }
            if ($pwd != $treasure['pwd']) {
                json('夺宝口令错误', 2);
            }
        }
        $currentNun = $this->get('currentNun', 1);
        if ($currentNun < 1) {
            json('参数错误', 2);
        }
        $price = $treasure['price'] * $currentNun;

        $count = p_getcolumn('treasure_code', array('treasure_id' => $id), 'COUNT(*)') ? : 0;
        if ($count + $currentNun > $treasure['number_copies']) {
            json('超出可购买份数', 2);
        }

        if ($treasure['max_number'] > 0) {
            $number_copies = p_getcolumn('treasure_member', array('member_id' => $this->member['id'], 'treasure_id' => $id), 'SUM(number_copies)') ? : 0;
            if ($number_copies + $currentNun > $treasure['max_number']) {
                json('每个用户最多只能购买' . $treasure['max_number'] . '份', 2);
            }
        }

        pdo_begin();
        try{

            if (!$this->sModel->change_currency($this->member['id'], $price, 3)) {
                throw new Exception($this->farm->error);
            }
            $insert = array(
                'member_id' => $this->member['id'],
                'treasure_id' => $id,
                'number_copies' => $currentNun,
                'created' => time()
            );
            if (!p_insert('treasure_member', $insert)) {
                json('购买失败', 2);
            }
            $insert_id = pdo_insertid();
            if (!$this->sModel->create_treasure_code($this->member['id'], $id, $insert_id, $currentNun)) {
                throw new Exception($this->farm->error);
            }

            pdo_commit();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }

        //开奖
        if ($count + $currentNun >= $treasure['number_copies']) {
            $this->sModel->openTreasure($id);
        }

        $this->json(array('id' => $insert_id));
    }



    /**
     *
     */
    public function success()
    {
        $id = $this->get('id');
        $record = p_get('treasure_member', array('id' => $id, 'member_id' => $this->member['id']));
        if (empty($record)) {
            $this->json('购买记录不存在', 0);
        }
        $record['treasure'] = p_get('treasure', array('id' => $record['treasure_id']));

        $record['code'] = p_getall('treasure_code', array('treasure_member_id' => $id));

        $image = array(
            'result_banner' => $this->image_url . 'db/result_banner.png',
            'currency_name' => getConfig('currency_name')
        );
        $my_center_group = getConfig('flow_ad_sigin');
        $treasure_success_msg = '运气倍增';

        $this->json(array('record' => $record, 'image' => $image, 'my_center_group' => $my_center_group, 'treasure_success_msg' => $treasure_success_msg));
    }

    /**
     *
     */
    public function code()
    {
        $id = $this->get('id');
        $treasure = p_get('treasure', array('id' => $id, 'is_delete' => 1, 'is_down' => 1));
        if (empty($treasure)) {
            $this->json('该夺宝不存在', 0);
        }
        $p = $this->get('p', 1);
        $page_size = 10;
        $limit = ($p - 1) * $page_size;
        $treasure_code = p_getall('treasure_member', array('treasure_id' => $id), array(), '', array('id desc'), "{$limit}, {$page_size}");
        if (!empty($treasure_code)) {
            foreach ($treasure_code as & $value) {
                $value['member'] = p_get('memberinfo', array('id' => $value['member_id']));
                $value['created'] = formatTime($value['created']);
            }
        }
        $this->json(array('treasure_code' => $treasure_code));
    }



    /**
     *
     */
    public function log()
    {
        $sql = "SELECT distinct treasure_id FROM " . prefix('treasure_member') . " WHERE member_id={$this->member['id']} ORDER BY id DESC";
        $treasure = p_fetchall($sql);

        if ($treasure) {
            foreach ($treasure as & $value) {
                $value['treasure_member'] = p_get('treasure_member', array('treasure_id' => $value['treasure_id'], 'member_id' => $this->member['id']));
                $value['treasure_member']['created'] = date('Y-n-d H:i:s', $value['treasure_member']['created']);

                $value['treasure'] = p_get('treasure', array('id' => $value['treasure_id']));
                $value['treasure']['cover_image'] = getImage($value['treasure']['cover_image']);
                $value['code_num'] = p_getcolumn('treasure_code', array('treasure_id' => $value['treasure_id'], 'member_id' => $this->member['id']), 'COUNT(*)') ? : 0;

                if ($value['treasure']['status'] == 2) {
                    $value['treasure']['status'] = p_get('treasure_code', array('treasure_id' => $value['treasure_id'], 'member_id' => $this->member['id'], 'in_prize' => 2)) ? 3 : $value['treasure']['status'];
                    $value['treasure']['schedule_percent'] = 100;
                    $value['treasure']['code_num'] = $value['treasure']['number_copies'];

                    if ($value['treasure']['status'] == 3) {
                        $value['treasure']['prize'] = p_get('treasure_order', array('treasure_id' => $value['treasure_id'], 'member_id' => $this->member['id']));

                        if (!$value['treasure']['prize']['address']) {
                            $address = p_get('address', array('member_id' => $this->member['id']));
                            if ($address) {
                                $value['treasure']['prize']['address'] = $address['address'];
                                $value['treasure']['prize']['phone'] = $address['phone'];
                                $value['treasure']['prize']['name'] = $address['name'];
                            }
                        }
                    }
                } else {
                    $value['treasure']['code_num'] = p_getcolumn('treasure_code', array('treasure_id' => $value['treasure_id']), 'COUNT(*)') ? : 0;
                    $value['treasure']['schedule_percent'] = round($value['treasure']['code_num']/$value['treasure']['number_copies'], 4) * 100;
                }
            }
        }


        $path = $this->image_url . 'db/';


        $image = array(
            'running_tag_1' => $path . 'running_tag_1.png',
            'zhongjian_tag' => $path . 'zhongjian_tag.png',
            'end_tag_2' => $path . 'end_tag_2.png',
            'address_icon_1' => $path . 'address_icon_1.png',
            'my_express_icon_1' => $path . 'my_express_icon_1.png',
            'currency_name' => '苹果'
        );

        json(array('treasure' => $treasure, 'image' => $image));
    }


}