<?php
include IA_ROOT . '/addons/bh_vote/model/shop.mod.php';
class turntable extends bhCommon {

    public $sModel;

    public function __construct()
    {
        parent::__construct();
        $this->sModel = new shopModel();
    }


    /**
     *
     */
    public function index()
    {
        $turntable = p_getall('turntable', array('is_delete' => 1), array(), '', array('sort DESC'));

        foreach ($turntable as & $value) {
            $value['image'] = getImage($value['image']);
        }
        $currency_name = getConfig('currency_name', '活力币');
        $consume_currency = getConfig('consume_currency', 10);

        $sql = 'SELECT * FROM ' . prefix('turntable_member') . ' WHERE uniacid='. UNIACID .' AND type != 3 ORDER BY id DESC LIMIT 5';
        $list = p_fetchall($sql);

        if ($list) {
            foreach ($list as & $line) {
                $line['member'] = p_get('memberinfo', array('id' => $line['member_id']));
                $line['turntable'] = p_get('turntable', array('id' => $line['turntable_id']));
            }
        }

        $turntable_bg = $this->images('turntable_bg', 'turntable/105812ae039b300.jpg');
        $turntable_start = $this->images('turntable_start', 'turntable/rotary_btn_start.png');
        $turntable_share_bg = $this->images('turntable_share_bg', 'turntable/to_open_red_packet_again.png');


        $address = p_get('address', array('member_id' => $this->member['id']));

        $data = array(
            'turntable' => $turntable,
            'currency_name' => $currency_name,
            'consume_currency' => $consume_currency,
            'msg' => $list,
            'member' => $this->member,
            'turntable_rule' => json_decode(getConfig('turntable_rule'), true),
            'turntable_bg' => $turntable_bg,
            'turntable_start' => $turntable_start,
            'turntable_share_bg' => $turntable_share_bg,
            'address' => $address
        );
        $this->json($data);
    }



    /**
     *
     */
    public function log()
    {
        $sql = "SELECT * FROM ". prefix('turntable_member') . " WHERE member_id={$this->member['id']} AND type != 3 ORDER BY id DESC";
        $log = p_fetchall($sql);

        if ($log) {
            $status = array(
                1 => '未发货',
                2 => '已发货',
                3 => '已完成',
                4 => '已取消'
            );
            foreach ($log as & $value) {
                $value['turntable'] = p_get('turntable', array('id' => $value['turntable_id']));
                $value['turntable']['image'] = getImage($value['turntable']['image']);
                $value['created'] = date('Y-m-d H:i:s', $value['created']);

                if ($value['type'] == 1) {
                    $value['status_msg'] = '已放入您' . getConfig('currency_name', '活力币') . '余额';
                }else {
                    $value['status_msg'] = isset($status[$value['status']]) ? $status[$value['status']] : '未发货';
                    if (!$value['address']) {
                        $address = p_get('address', array('member_id' => $this->member['id']));
                        if ($address) {
                            $value['address'] = $address['address'];
                            $value['name'] = $address['name'];
                            $value['phone'] = $address['phone'];
                        }
                    }
                }
            }
        }

        $images = array(
            'address_icon' => $this->image_url . 'db/address_icon_1.png',
            'my_express_icon' => $this->image_url . 'db/my_express_icon_1.png',
            'my_orders_nodata' => $this->image_url . 'my_orders_nodata.png',
        );
        $this->json(array('orders' => $log, 'images' => $images));
    }



    /**
     *
     */
    public function prize()
    {
        $turntable = p_getall('turntable', array('is_delete' => 1));
        if (empty($turntable)) {
            $this->json('该功能暂时无法使用', 2);
        }

        $consume_currency = getConfig('consume_currency', 10);
        pdo_begin();
        try{
            if (!$this->sModel->change_currency($this->member['id'], $consume_currency, 4)) {
                throw new Exception($this->sModel->error);
            }

            $weight = 0;
            foreach ($turntable as $key => $value) {
                $weight += $value['weight'];
            }
            $rand = mt_rand(1, $weight);

            $prize = array();
            $current = 0;
            foreach ($turntable as $value) {
                $current = $current + $value['weight'];
                if ($rand <= $current) {
                    $prize = $value;
                    break;
                }
            }
            if (empty($prize)) {
                throw new Exception('抽奖失败,请稍后再试');
            }

            $insert = array(
                'member_id' => $this->member['id'],
                'turntable_id' => $prize['id'],
                'type' => $prize['type'],
                'created' => time()
            );

            if ($prize['type'] == 1) {
                if (!$this->sModel->change_currency($this->member['id'], $prize['numerical_value'], 5)) {
                    throw new Exception($this->sModel->error);
                }
            } elseif ($prize['type'] == 2) {
                $address = p_get('address', array('member_id' => $this->member['id']));
                if ($address) {
                    $insert['address'] = $address['address'];
                    $insert['name'] = $address['name'];
                    $insert['phone'] = $address['phone'];
                }
            }

            if ($prize['type'] != 2) {
                $insert['status'] = 3;
            }


            if (!p_insert('turntable_member', $insert)) {
                throw new Exception('抽奖失败,请稍后再试');
            }
            pdo_commit();
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 2);
        }
        $this->json(array('id' => $prize['id']));
    }



}