<?php

class voucher extends bhCommon {


    public function my()
    {
        $w = array('in_member_id' => $this->member['id'], 'type' => 2, 'is_under_line' => 2);
        $voucher = p_getall('luck_goods_info', $w, array(), '', 'id desc');

        if ($voucher) {
            $status_msgs = array(
                1 => '未使用',
                2 => '已使用',
                3 => '已退单'
            );
            foreach ($voucher as & $value) {
                $value['shop'] = p_get('merchant', array('id' => $value['shop_id']));
                $value['created'] = date('Y/m/d H::s', $value['created']);
                $value['status_msg'] =$status_msgs[$value['status']];
            }
        }
        $images = array(
            'notused' => $this->image_url . 'notused.png',
            'used' => $this->image_url . 'used.png',
            'my_orders_nodata' => $this->image_url . 'my_orders_nodata.png',
        );

        $data = array(
            'voucher' => $voucher,
            'images' => $images,
        );
        $this->json($data);
    }



    public function details()
    {
        $id = $this->get('id');
        $type = $this->get('type', 1);
        $write_off_code_type = getConfig('write_off_code_type', 1);

        $images = array(
            'address_locate' => $this->image_url . 'address_locate.png',
            'phone' => $this->image_url . 'phone.png',
        );

        if ($type == 2) {

            $voucher = p_get('order', array('id' => $id, 'member_id' => $this->member['id'], 'type' => 3));
            if (empty($voucher)) {
                $this->json('提货码不存在', 0);
            }
            $qrcodeUrl = '';
            $voucher['fictitious'] = 'i-' . $voucher['fictitious'];
            if ($write_off_code_type == 2) {
                $qrcodeUrl = $this->vote->createWxCode($this, $voucher['fictitious'], 'bh_vote/pages/my/my', 'integral-' . $voucher['fictitious'] . '.png');
            }

            $integral_goods = p_get('integral_goods', array('id' => $voucher['goods_id']));
            $voucher['name'] = $integral_goods['goods_name'];
            $voucher['image'] = getImage($integral_goods['cover_image']);

        } else {
            $voucher = p_get('luck_goods_info', array('id' => $id, 'in_member_id' => $this->member['id']));
            if (empty($voucher)) {
                $this->json('优惠券不存在', 0);
            }

            $qrcodeUrl = '';
            if ($write_off_code_type == 2) {
                $qrcodeUrl = $this->vote->createWxCode($this, $voucher['fictitious'], 'bh_vote/pages/my/my', 'writeoff-' . $voucher['fictitious'] . '.png');
            }
            $voucher['image'] = getImage($voucher['image']);
        }
        $shop = p_get('merchant', array('id' => $voucher['shop_id']));

        $data = array(
            'shop' => $shop,
            'voucher' => $voucher,
            'images' => $images,
            'write_off_code_type' => $write_off_code_type,
            'qrcodeUrl' => $qrcodeUrl,
            'qq_map_key' => getConfig('qq_map_key'),
            'xcx_name' => getConfig('xcx_title'),
        );
        $this->json($data);
    }


    public function goods()
    {
        $fictitious = $this->get('fictitious');

        if (strpos($fictitious, 'i-') === 0) {
            $source = 1;
            $fictitious = str_replace('i-', '', $fictitious);

            $voucher = p_get('order', array('shop_id' => $this->member['shop_id'], 'fictitious' => $fictitious, 'type' => 3));
            if (empty($voucher)) {
                $this->json('提货码不存在', 0);
            }

            $integral_goods = p_get('integral_goods', array('id' => $voucher['goods_id']));
            $voucher['name'] = $integral_goods['goods_name'];
            $voucher['image'] = getImage($integral_goods['cover_image']);


        } else {
            $voucher = p_get('luck_goods_info', array('shop_id' => $this->member['shop_id'], 'type' => 2, 'fictitious' => $fictitious));
            if (empty($voucher)) {
                $this->json('优惠券不存在', 0);
            }
            $source = 2;
            $voucher['image'] = getImage($voucher['image']);
        }
        $data = array(
            'goods' => $voucher,
            'is_show_integral' => $this->vote->is_show_integral(),
            'source' => $source,
            'images' => array(
                'hx' => $this->image_url . 'hx.png',
                'hx1' => $this->image_url . 'hx1.png',
            ),
            'integral_name' => getConfig('integral_name'),
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FE5555')
        );
        $this->json($data);
    }



    public function writeoff()
    {
        $voucher = $this->get('voucher');

        if (strpos($voucher, 'i-') === 0) {
            $voucher = str_replace('i-', '', $voucher);
            $order = p_get('order', array('fictitious' => $voucher));
            if (empty($order)) {
                $this->json('提货码不存在', 0);
            }
            if ($order['status'] != 1) {
                $this->json('提货码已被使用过', 0);
            }

            if ($order['shop_id'] != $this->member['shop_id']) {
                $this->json('你没有核销该提货码的权限', 0);
            }
            $updata = array(
                'status' => 2,
                'write_off_id' => $this->member['id'],
                'write_off_time' => time()
            );

            if (!p_update('order', $updata, array('id' => $order['id']))) {
                $this->json('核销失败', 0);
            }
            $this->json();
        } else {
            $voucher = p_get('luck_goods_info', array('fictitious' => $voucher));

            if (empty($voucher) || $voucher['shop_id'] != $this->member['shop_id']) {
                $this->json('你没有核销该优惠券的权限', 0);
            }

            if ($voucher['status'] == 2) {
                $this->json('该优惠券已经被使用', 0);
            }
            try{
                pdo_begin();
                $updata = array('status' => 2, 'write_off_id' => $this->member['id'], 'write_off_time' => time());
                if (!p_update('luck_goods_info' , $updata, array('id' => $voucher['id']))) {
                    throw new Exception('核销失败');
                }
                pdo_commit();
                $this->json();
            } catch (Exception $e) {
                pdo_rollback();
                $this->json($e->getMessage(), 0);
            }
        }
    }


}