<?php


define('PREFIX', 'bh_vl_');

/**
 * 获取图片
 * @param $route
 * @param bool $path
 * @return string
 */
function getImage($route, $path = false)
{
    if (empty($route)) {
        return '';
    }
    if ($path == true) {
        return $route;
    }
    global $_W;

    if (is_oss()) {
        return $_W['attachurl'] . $route;
    }
    return $_W['siteroot'] . 'attachment/' . $route;
}

function is_oss()
{
    global $_W;
    return (!empty($_W['setting']['remote']['type']) || !empty($_W['setting']['remote'][$_W['uniacid']]['type']));
}


function prefix($table, $prefix = true)
{
    return $prefix ? tablename(PREFIX . $table) : (PREFIX . $table);
}


function getConfig($key, $default = '', $uniacid = 0)
{
    $w = array('key' => $key);
    if ($uniacid > 0) {
        $w['uniacid'] = $uniacid;
    }
    $config = p_get('config', $w);

    return $config ? $config['value'] : $default;
}

function json($info, $status = 1)
{
    $info = array(
        'info' => $info,
        'status' => $status
    );
    $info = json_encode($info, JSON_UNESCAPED_UNICODE);
    header('Content-Type: application/json;charset=utf-8');
    die($info);
}


function p_get($table, $condition, $fields = array()) {
    if (moreOpen()) {
        $condition['uniacid'] = UNIACID;
    }
    return pdo_get(PREFIX  . $table, $condition, $fields);
}

function p_getall($table, $condition = array(), $fields = array(), $keyfield = '', $orderby = array(), $limit = array())
{
    if (moreOpen()) {
        $condition['uniacid'] = UNIACID;
    }
    return pdo_getall(PREFIX . $table, $condition, $fields, $keyfield, $orderby, $limit);
}

function p_insert($table, $data = array(), $replace = FALSE)
{
    $data['uniacid'] = UNIACID;
    return pdo_insert(PREFIX . $table, $data, $replace);
}

function p_insert_id()
{
    return pdo_insertid();
}
function p_getcolumn($table, $condition = array(), $field) {
    if (moreOpen()) {
        $condition['uniacid'] = UNIACID;
    }
    return pdo_getcolumn(PREFIX . $table, $condition, $field);
}

function p_delete($table, $params = array(), $glue = 'AND') {
    if (moreOpen()) {
        $params['uniacid'] = UNIACID;
    }
    return pdo_delete(PREFIX . $table, $params, $glue);
}

function p_update($table, $data = array(), $params = array(), $glue = 'AND') {
    if (moreOpen()) {
        $params['uniacid'] = UNIACID;
    }
    return pdo_update(PREFIX . $table, $data, $params, $glue);
}

function p_fetch($sql, $params = array()) {
    return pdo_fetch($sql, $params);
}

function p_fetchall($sql, $params = array()) {
    return pdo_fetchall($sql, $params);
}

function p_fetchcolumn($sql, $params = array(), $column = 0) {
    return pdo_fetchcolumn($sql, $params, $column);
}

function moreOpen()
{
    global $_W;
    return version_compare($_W['current_module']['version'], '4.0.0') >= 0;
}


function get_uniacid($alias = '')
{
    if (moreOpen()) {
        return ' AND '. $alias . 'uniacid=' . UNIACID;
    }
    return '';
}


function ad($advertisement)
{
    if (empty($advertisement)) {
        return $advertisement;
    }
    if ($advertisement['type'] == 5) {
        return $advertisement;
    }
    $advertisement['image'] = getImage($advertisement['image']);
    $advertisement['target'] = 'self';
    $advertisement['open_type'] = 'navigate';

    if ($advertisement['type'] == 1) {
        $advertisement['target'] = 'self';

    } else if($advertisement['type'] == 3){
        $advertisement['target'] = 'self';
        $advertisement['url'] = '/bh_vote/pages/webView/webView?url=' . urlencode($advertisement['url']);
    } else {
        $advertisement['target'] = 'miniProgram';
    }

    return $advertisement;
}


function createFile($obj, $file_name = 'mqr')
{
    if (!file_exists(ATTACHMENT_ROOT . 'xcx' . $obj->w['uniacid'] . $file_name)) {
        @mkdir(ATTACHMENT_ROOT . 'xcx' . $obj->w['uniacid'] . $file_name,0777,true);
    }

    return ATTACHMENT_ROOT . 'xcx' . $obj->w['uniacid'] .$file_name . '/';
}


/**
 * 生成本地图片
 * @param $obj
 * @param $img_url
 * @return string
 */
function getImageLocal($obj, $img_url, $type = false)
{
    if (!$img_url) {
        return '';
    }
    if (is_oss()) {
        $img_url = getImage($img_url);
        $path_name = md5($img_url) . '.png';
        $qrpath = createFile($obj) . $path_name;
        if (!is_file($qrpath)) {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_URL, $img_url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_HEADER, 0);
            $ret = curl_exec($ch);

            curl_close($ch);
            file_put_contents($qrpath, $ret);
        }
        $res = array(
            'path' => IA_ROOT . '/attachment/xcx' . $obj->w['uniacid'] .'mqr/' . $path_name,
            'url' => $obj->w['siteroot'] . 'attachment/xcx' . $obj->w['uniacid'] .'mqr/' . $path_name
        );
    } else {
        $res = array(
            'path' => IA_ROOT . '/attachment/' . $img_url,
            'url' => getImage($img_url)
        );
    }


    return $type ? $res : $res['url'];
}


/**
 * @param $obj
 * @param $head
 * @return string
 */
function headLocal($obj, $head)
{
    $path = createFile($obj, 'head') . $obj->member['id'] . '.png';
    if (!is_file($path)) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_URL, $head);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        $ret = curl_exec($ch);

        curl_close($ch);
        file_put_contents($path, $ret);
    }

    return $obj->w['siteroot'] . 'attachment/xcx' . $obj->w['uniacid'] .'head/' . $obj->member['id'] . '.png';
}

/**
 * 获取当前周几
 * @param $time
 * @return array
 */
function week($time) {
    $da = date("w", $time);
    $w = array(
        0 => '周日',
        1 => '周一',
        2 => '周二',
        3 => '周三',
        4 => '周四',
        5 => '周五',
        6 => '周六'
    );

    return array('da' => $da, 'w' => $w[$da]);
}



function buildCurl($PostArry, $request_url)
{
    $postData = $PostArry;
    $postDataString = http_build_query($postData);
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $request_url);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $postDataString);
    curl_setopt($curl, CURLOPT_TIMEOUT, 60);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    $tmpInfo = curl_exec($curl);
    if (curl_errno($curl)) {
        $tmpInfo = curl_error($curl);
    }
    curl_close($curl);
    return $tmpInfo;
}


function get_curl($url)
{
    $curl = curl_init(); // 启动一个CURL会话
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_HEADER, 0);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
    //curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, true);  // 从证书中检查SSL加密算法是否存在
    $tmpInfo = curl_exec($curl);     //返回api的json对象
    //关闭URL请求
    curl_close($curl);
    return $tmpInfo;    //返回json对象
}


function arrayImage($data, $key = 'image')
{
    if ($data) {
        foreach ($data as & $v) {
            $v[$key] = getImage($v[$key]);
        }
    }
    return $data;
}

function substr_cut($user_name){
    $strlen     = mb_strlen($user_name, 'utf-8');
    $firstStr     = mb_substr($user_name, 0, 1, 'utf-8');
    $lastStr     = mb_substr($user_name, -1, 1, 'utf-8');
    return $strlen == 2 ? $firstStr . str_repeat('*', mb_strlen($user_name, 'utf-8') - 1) : $firstStr . str_repeat("*", $strlen - 2) . $lastStr;
}


function getVoteImageCover($vote)
{
    if (isset($vote['cover_image']) && $vote['cover_image']) {
        return getImage($vote['cover_image']);
    }
    $vote['template_id'] = $vote['template_id'] ? $vote['template_id'] : 23;
    global $_W;

    return (isMy() ? $_W['attachurl'] : $_W['siteroot']) . 'addons/bh_vote/template/vote_template/vote/actual/' . $vote['template_id'] . '/cover.png?1';
}


function bh_file_upload($file, $type = 'image', $name = '', $compress = false) {
    $harmtype = array('asp', 'php', 'jsp', 'js', 'css', 'php3', 'php4', 'php5', 'ashx', 'aspx', 'exe', 'cgi');
    if (empty($file)) {
        return error(-1, '没有上传内容');
    }
    if (!in_array($type, array('image', 'thumb', 'voice', 'video', 'audio'))) {
        return error(-2, '未知的上传类型');
    }
    global $_W;
    $ext = pathinfo($file['name'], PATHINFO_EXTENSION);
    $ext = strtolower($ext);
    $setting = setting_load('upload');
    switch ($type) {
        case 'image':
        case 'thumb':
            $allowExt = array('gif', 'jpg', 'jpeg', 'bmp', 'png', 'ico');
            $limit = $setting['upload']['image']['limit'];
            break;
        case 'voice':
        case 'audio':
            $allowExt = array('mp3', 'wma', 'wav', 'amr');
            $limit = $setting['upload']['audio']['limit'];
            break;
        case 'video':
            $allowExt = array('rm', 'rmvb', 'wmv', 'avi', 'mpg', 'mpeg', 'mp4');
            $limit = $setting['upload']['audio']['limit'];
            break;
    }
    $setting = $_W['setting']['upload'][$type];
    if (!empty($setting)) {
        $allowExt = array_merge($setting['extentions'], $allowExt);
    }
    if (!in_array(strtolower($ext), $allowExt) || in_array(strtolower($ext), $harmtype)) {
        return error(-3, '不允许上传此类文件');
    }
    if (!empty($limit) && $limit * 1024 < filesize($file['tmp_name'])) {
        return error(-4, "上传的文件超过大小限制，请上传小于 {$limit}k 的文件");
    }



    $result = array();
    if (empty($name) || $name == 'auto') {
        $uniacid = intval($_W['uniacid']);
        $path = "{$type}s/{$uniacid}/bh_image/" . date('Y/m/d/') ;
        mkdirs(ATTACHMENT_ROOT . '/' . $path);
        $filename = file_random_name(ATTACHMENT_ROOT . '/' . $path, $ext);

        $result['path'] = $path . $filename;
    } else {
        mkdirs(dirname(ATTACHMENT_ROOT . '/' . $name));
        if (!strexists($name, $ext)) {
            $name .= '.' . $ext;
        }
        $result['path'] = $name;
    }

    $save_path = ATTACHMENT_ROOT . '/' . $result['path'];
    if (!file_move($file['tmp_name'], $save_path)) {
        return error(-1, '保存上传文件失败');
    }

    if ($type == 'image' && $compress) {
        file_image_quality($save_path, $save_path, $ext);
    }

    $result['success'] = true;

    return $result;
}

function unicode_to_utf8($unicode_str) {
    $utf8_str = '';
    $code = intval(hexdec($unicode_str));
    //这里注意转换出来的code一定得是整形，这样才会正确的按位操作
    $ord_1 = decbin(0xe0 | ($code >> 12));
    $ord_2 = decbin(0x80 | (($code >> 6) & 0x3f));
    $ord_3 = decbin(0x80 | ($code & 0x3f));
    $utf8_str = chr(bindec($ord_1)) . chr(bindec($ord_2)) . chr(bindec($ord_3));
    return $utf8_str;
}

function formatTime($time)
{
    $rtime = date("m-d H:i", $time);
    $time = time() - $time;
    if ($time < 60) {
        $str = '刚刚';
    } elseif ($time < 60 * 60) {
        $min = floor($time / 60);
        $str = $min . '分钟前';
    } elseif ($time < 60 * 60 * 24) {
        $h = floor($time / (60 * 60));
        $str = $h . '小时前 ';
    } elseif ($time < 60 * 60 * 24 * 3) {
        $d = floor($time / (60 * 60 * 24));
        if ($d == 1) {
            $str = '昨天 ' . $rtime;
        } else {
            $str = '前天 ' . $rtime;
        }
    } else {
        $str = $rtime;
    }
    return $str;
}


function yanyi()
{
    return false;
}


function total_station_oss()
{
    global $_W;
    return isMy() ? $_W['attachurl'] : $_W['siteroot'];
}


function isMy()
{
    return false;
}


function isSupportQQ()
{ 
    global $_W;
    return version_compare($_W['current_module']['version'], '5.0.0') >= 0;
}

function audit_model()
{
    return getConfig('audit_model', 1);
}

function qqAutograph($data)
{
    ksort($data);
    $str = '';
    foreach ($data as $k => $value) {
        $str .= ($k .'=' .$value.'&');
    }
    $str = $str . 'key='. getConfig('qq_mch_key');
    return strtoupper(md5($str));
}


function isMobile($mobile) {
    if (!is_numeric($mobile)) {
        return false;
    }
    return preg_match('#^13[\d]{9}$|^14[5,7]{1}\d{8}$|^15[^4]{1}\d{8}$|^17[0,6,7,8]{1}\d{8}$|^18[\d]{9}|^19[\d]{9}$#', $mobile) ? true : false;
}


function isWx($wx) {
    return preg_match('#^[a-zA-Z]{1}[-_a-zA-Z0-9]{5,19}$#', $wx) ? true : false;
}

function isQq()
{
    return isSupportQQ() && isset($_GET['qq_client']) && $_GET['qq_client'] == 1;
}


function autograph($data)
{
    ksort($data);
    $str = '';
    foreach ($data as $k => $value) {
        $str .= ($k . $value);
    }
    $pdd_client_secret = getConfig('pdd_client_secret');
    $str = ($pdd_client_secret . $str . $pdd_client_secret);
    return strtoupper(md5($str));
}



/**
 * POST 请求
 * @param string $url
 * @param array $param
 * @param boolean $post_file 是否文件上传
 * @return string content
 */
function httpPost($url, $param, $jsonpost = false, $post_file = false) {
    $oCurl = curl_init();
    if (stripos($url, "https://") !== FALSE) {
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($oCurl, CURLOPT_SSLVERSION, 1); //CURL_SSLVERSION_TLSv1
    }
    if ($jsonpost) {
        $strPOST = str_replace('\/', '/', json_encode($param));
    } elseif (is_string($param) || $post_file) {
        $strPOST = $param;
    } else {
        $aPOST = array();
        foreach ($param as $key => $val) {
            $aPOST[] = $key . "=" . urlencode($val);
        }
        $strPOST = join("&", $aPOST);
    }
    curl_setopt($oCurl, CURLOPT_URL, $url);
    curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($oCurl, CURLOPT_POST, true);
    curl_setopt($oCurl, CURLOPT_POSTFIELDS, $strPOST);
    $sContent = curl_exec($oCurl);
    $aStatus = curl_getinfo($oCurl);

    curl_close($oCurl);
    if (intval($aStatus["http_code"]) == 200) {
        return $sContent;
    } else {
        return false;
    }
}


function http_post($url, $param, $jsonpost = false, $post_file = false) {
    $oCurl = curl_init();
    if (stripos($url, "https://") !== FALSE) {
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($oCurl, CURLOPT_SSLVERSION, 1); //CURL_SSLVERSION_TLSv1
    }
    if ($jsonpost) {
        $strPOST = str_replace('\/', '/', json_encode($param));
    } elseif (is_string($param) || $post_file) {
        $strPOST = $param;
    } else {
        $aPOST = array();
        foreach ($param as $key => $val) {
            $aPOST[] = $key . "=" . urlencode($val);
        }
        $strPOST = join("&", $aPOST);
    }
    curl_setopt($oCurl, CURLOPT_URL, $url);
    curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($oCurl, CURLOPT_POST, true);
    curl_setopt($oCurl, CURLOPT_POSTFIELDS, $strPOST);
    $sContent = curl_exec($oCurl);
    $aStatus = curl_getinfo($oCurl);

    curl_close($oCurl);
    if (intval($aStatus["http_code"]) == 200) {
        return $sContent;
    } else {
        return false;
    }
}


function filterEmoji($emojiStr) {

    $emojiStr = preg_replace_callback('/./u', function(array $match){

        return strlen($match[0]) >= 4 ? '' : $match[0];
    }, $emojiStr);

    return $emojiStr;
}
