<?php
defined('IN_IA') or exit('Access Denied');

class jiziModel{

    public $error = '';


    /**
     * 获取用户集字剩余次数
     * @param $member_id
     * @return array
     */
    public function get_number($member_id)
    {
        $jz_day_number = getConfig('jz_day_number', 3);
        $member = p_get('memberinfo', array('id' => $member_id));

        $w = array(
            'member_id' => $member_id,
            'same_day' => date('Ymd')
        );
        $use = p_getcolumn('calligraphy_number_log', $w, 'SUM(frequency)') ? : 0;
        $today = $jz_day_number - $use > 0 ? ($jz_day_number - $use) : 0;

        $num = array(
            'total' => $today + $member['calligraphy_number'],
            'today_number' => $today,
            'calligraphy_number' => $member['calligraphy_number'],
        );

        return $num;
    }



    /**
     * 次数变更
     * @param $member_id
     * @param $number
     * @param int $type
     * @param string $remarks
     * @return bool
     */
    public function change_number($member_id, $number, $type = 1, $remarks = '')
    {
        if ($number < 1) {
            return true;
        }
        $member = p_get('memberinfo', array('id' => $member_id));
        if (empty($member) || $member['is_fictitious'] == 2) {
            return true;
        }


        if ($type != 4) {
            if (in_array($type, array(1, 2, 3))) {
                $calligraphy_number = $member['calligraphy_number'] + $number;
            } else {

                if ($member['calligraphy_number'] < $number) {
                    $this->error = '次数不足';
                    return false;
                }
                $calligraphy_number = $member['money'] - $number;
            }

            $update = array('calligraphy_number' => $calligraphy_number);
            if (!p_update('memberinfo', $update, array('id' => $member_id))) {
                $this->error = '次数变动失败';
                return false;
            }
        }

        $calligraphy_number_log = array(
            'member_id' => $member_id,
            'frequency' => $number,
            'same_day' => date('Ymd'),
            'type' => $type,
            'created' => time()
        );
        if (!empty($remarks)) {
            $calligraphy_number_log['remarks'] = $remarks;
        }

        if (p_insert('calligraphy_number_log', $calligraphy_number_log)) {
            return true;
        }

        $this->error = '日志更新出错';
        return false;
    }


    /**
     * 集字
     * @param $calligraphy_id
     * @param $member_id
     * @return bool|array
     */
    public function extract($calligraphy_id, $member_id, $obj)
    {
        $calligraphy = p_get('calligraphy', array('id' => $calligraphy_id, 'is_delete' => 1));

        if (empty($calligraphy)) {
            $this->error = '活动不存在';
            return false;
        }

        $receive = p_getcolumn('calligraphy_member', array('calligraphy_id' => $calligraphy_id), 'SUM(success)') ? : 0;

        $is_end = $calligraphy['end_time'] > time() && $calligraphy['stock'] > $receive;

        if (!$is_end) {
            $this->error = '活动已结束';
            return false;
        }

        /*$number = $this->get_number($member_id);

        if ($number['total'] < 1) {
            $this->error = '次数不足';
            return false;
        }*/

        if (!p_get('calligraphy_member', array('member_id' => $member_id, 'calligraphy_id' => $calligraphy_id))) {
            $insert = array(
                'member_id' => $member_id,
                'calligraphy_id' => $calligraphy_id,
                'created' => time()
            );
            if (!p_insert('calligraphy_member', $insert)) {
                $this->error = '集字失败1';
                return false;
            }
        }

        /*$type = $number['today_number'] > 0 ? 4 : 5;
        if (!$this->change_number($member_id, 1, $type)) {
            return false;
        }*/

        $words = p_getall('calligraphy_details', array('calligraphy_id' => $calligraphy_id));
        $weight = 0;

        foreach ($words as $value) {
            $weight += $value['weight'];
        }
        $rand = mt_rand(1, $weight);

        $word = array();
        $current = 0;
        foreach ($words as $value) {
            $current = $current + $value['weight'];
            if ($rand <= $current) {
                $word = $value;
                break;
            }
        }

        if (empty($word)) {
            $this->error = '集字失败';
            return false;
        }

        $jizi_integral = getConfig('jizi_integral', 1);

        if (!$obj->vote->change_integral($member_id, $jizi_integral, 14)) {
            $this->error = $obj->vote->error;
            return false;
        }

        $calligraphy_member_log = array(
            'member_id' => $member_id,
            'calligraphy_id' => $calligraphy_id,
            'calligraphy_details_id' => $word['id'],
            'updated' => time(),
            'created' => time()
        );

        if (p_insert('calligraphy_member_log', $calligraphy_member_log)) {
            return $word;
        }

        $this->error = '集字失败';
        return false;
    }

}