<?php
defined('IN_IA') or exit('Access Denied');

class lucks {



    protected $pageSize = 20;


    public function addMember($nickname, $headImgUrl)
    {
        if (empty($nickname) || empty($headImgUrl)) {
            return false;
        }
        $data = array(
            'nickname'      => $nickname,
            'headimgurl'    => $headImgUrl,
            'fictitious'    => 2,
            'c_time'        => time()
        );
        return p_insert('memberinfo', $data);
    }
    /**
     *
     * @param $number
     * @param $money
     * @return bool
     */
    public function addSenior($number, $money)
    {
        if (!is_numeric($number)){
            return false;
        }
        $data = array(
            'number'    => $number,
            'money'     => $money,
            'created' => time()
        );
        return p_insert('senior',$data);
    }

    /**
     *
     * @param $id
     * @param $number
     * @param $money
     * @return bool
     */
    public function editSenior($id, $number, $money)
    {
        if (!is_numeric($number)){
            return false;
        }
        $data = array(
            'number'    => $number,
            'money'     => $money,
            'created' => time()
        );
        return p_update('senior',$data, array('id' => $id));
    }

    /**
     *
     * @param $name
     * @param $sort
     * @param int $is_delete
     * @return bool
     */
    public function addCategory($name, $sort, $is_delete = 1)
    {
        if (empty($name)){
            return false;
        }
        $data = array(
            'name'      => $name,
            'sort'      => (int)$sort,
            'is_delete' => $is_delete,
            'created'   => time()
        );
        return p_insert('category', $data);

    }

    public function editCategory($id, $name, $sort, $is_delete)
    {
        if (empty($name) || empty($id)) {
            return false;
        }
        $data = array(
            'name'      => $name,
            'sort'      => (int)$sort,
            'is_delete' => $is_delete,
        );
        return p_update('category', $data, array('id' => $id));
    }

    /**
     * @param $category_id
     * @param $name
     * @param $price
     * @param $cover_image
     * @param $images
     * @param $details
     * @param $sort
     * @param $status
     * @return bool
     */
    public function addGoods($category_id, $name, $price, $cover_image, $images, $details, $sort, $status)
    {
        if(empty($category_id) || empty($name) || empty($price)) {
            return false;
        }
        $data = array(
            'category_id'   => $category_id,
            'name'          => $name,
            'price'         => $price,
            'cover_image'   => $cover_image,
            'images'        => $images,
            'details'       => $details,
            'sort'          => $sort,
            'status'        => $status,
            'created'       => time(),
        );
        return p_insert('goods', $data);
    }

    /**
     *
     * @param $id
     * @param $category_id
     * @param $name
     * @param $price
     * @param $cover_image
     * @param $images
     * @param $details
     * @param $sort
     * @param $status
     * @return bool
     */
    public function editGoods($id, $category_id, $name, $price, $cover_image, $images, $details, $sort, $status)
    {
        if(empty($category_id) || empty($name) || empty($price) || empty($id)) {
            return false;
        }
        $data = array(
            'category_id'   => $category_id,
            'name'          => $name,
            'price'         => $price,
            'cover_image'   => $cover_image,
            'images'        => $images,
            'images'        => $images,
            'details'       => $details,
            'sort'          => $sort,
            'status'        => $status,
            'created'       => time(),
        );
        return p_update('goods', $data, array('id' => $id));
    }

    /**
     * @param $title
     * @param $image
     * @param $position
     * @param $type
     * @param $group_id
     * @param $appId
     * @param $url
     * @param $sort
     * @param $describe
     * @param string $id
     * @return bool
     */
    public function addAdvertise($title, $image, $position, $type, $group_id, $appId, $url, $sort,$describe, $id = '')
    {
        if (empty($title) || empty($image)) {
            return false;
        }
        $data = array(
            'title'     => $title,
            'image'     => $image,
            'position'  => $position,
            'type'      => $type,
            'group_id'  => $group_id,'appid'     => $appId,
            'url'       => $url,
            'sort'      => $sort,
        );
       /* if ($data['position'] == 2) {
            $data['describe'] = $describe;
        }*/
        $data['describe'] = $describe;
        if ($id) {
            return p_update('advertisement', $data, array('id' => $id));
        } else {
            $data['created'] =  time();
            return p_insert('advertisement', $data);
        }
    }
    public function editVoteGoods($data)
    {

        $vote_goods_bool = p_insert('vote_goods', $data);
        if ($vote_goods_bool) {
            $vote_goods_id = p_insert_id();
            $vote_goods_info = array(
                'vote_id'   => $data['vote_id'],
                'member_id' => $data['source'] == 1 ? $data['member_id'] : 0,
                'name'      => $data['name'],
                'image'     => $data['image'],
                'source'    => $data['source'],
                'vote_goods_id' => $vote_goods_id,
                'goods_id'  =>  $data['source'] == 2 ? $data['goods_id'] : 0,
                'created'   => time()
            );
            for ($i = 1; $i <= $data['number']; $i++) {
                if (!p_insert('vote_goods_info', $vote_goods_info)){
                    return false;
                }
            }
            return true;
        } else {
            return false;
        }
    }

    public function removeVoteGoods($id)
    {
        $vote_goods = p_get('vote_goods', array('id' => $id), array('vote_id', 'id'));
        if ($vote_goods) {
            $bool1 = p_delete('vote_goods', array('id' => $id));
            $bool2 = p_delete('vote_goods_info', array('vote_goods_id' => $id));
            if ($bool1 && $bool2) {
                return true;
            }
            return false;
        }
        return false;
    }
    public function getAdvertisementOne($id)
    {
        return p_get('advertisement', array('id' => $id));

    }
    public function getSeniorOne($id)
    {
       return p_get('senior', array('id' => $id));
    }
    public function getTaskOne($id)
    {
        return p_get('task', array('id' => $id));
    }
    public function getIntegral_goodsOne($id)
    {
        return p_get('integral_goods', array('id' => $id));
    }
    public function getCategoryOne($id)
    {
        return p_get('category', array('id' => $id));
    }

    public function getGoodsOne($id)
    {
        return p_get('goods', array('id' => $id));
    }
    public function getHomeOne($id)
    {
        return p_get('home', array('id' => $id));
    }
    public function getRelationIdOne($id)
    {
        return p_get('home', array('relation_id' => $id));
    }
    public function getSalesmanOne($id)
    {
        return p_get('salesman', array('id' => $id));
    }
    public function getShopOne($id)
    {
        return p_get('shop', array('id' => $id));
    }
    public function getShop_categoryOne($id)
    {
        return p_get('shop_category', array('id' => $id));
    }
    public function delete($table, $id, $type = 1)
    {
        if ($type ==1) {
            return p_update($table, array('is_delete' =>2), array('id' => $id));
        } else {
            return p_delete($table, array('id' => $id));
        }

    }

    public function getLuckGoodsData($luck_id)
    {
        return p_getall('luck_goods', array('luck_id' => $luck_id));
    }

    public function getLuckOne($luck_id)
    {
        $sql = 'SELECT * FROM '. prefix('luck') .' as A LEFT JOIN' .prefix('luck_goods').' as B ON A.id = B.luck_id where A.id ='.$luck_id . " limit 0, 100";

        $luckInfo = p_fetchall($sql);

        if ($luckInfo) {
            foreach ($luckInfo as & $value) {
                if ($value['type'] ==2) {
                    $value['fictitious'] = implode(',', json_decode($value['fictitious']));
                }
            }
        }
        return $luckInfo;
    }

    public function getVoteOne($id)
    {
        return p_get('vote_activity', array('id' => $id));
    }

    public function changeLuckShop($luckId)
    {
        $memberId = p_getcolumn('luck', array('id' => $luckId), 'member_id');

        if ($memberId) {
            $shopId = p_getcolumn('memberinfo', array('id' => $memberId), 'shop_id');
            if ($shopId) {
               return p_update('luck', array('shop_id' =>$shopId), array('id' => $luckId));
            }
        }
        return true;
    }
    /**
     * @param $source
     * @param $lotteryType
     * @param $lotteryValue
     * @param string $memberId
     * @param string $lotteryExplain
     * @param string $imageText
     * @param string $luckMode
     * @param string $luckPwd
     * @param string $teamNumber
     * @param string $name
     * @param string $image
     * @param string $type
     * @param string $fictitious
     * @param string $number
     * @param $goods_id
     * @param $isAd
     * @param $sponsor
     * @param $sponsor_type
     * @param $sponsor_text
     * @param $appoint_group
     * @param $integral
     * @return bool
     */
    public function editingLuck($source, $lotteryType, $lotteryValue, $memberId = '', $lotteryExplain= '',$imageText ='',
                                $luckMode ='', $luckPwd ='',$teamNumber = '', $name = '', $image = '', $type = '',
                                $fictitious = '', $number = '', $goods_id, $isAd, $sponsor,$sponsor_type,$sponsor_text,
                                $appoint_group, $integral,$is_share,$automatic, $receive_type, $receive_url, $loop,$is_screen, $invite_sh, $group_money, $is_double)
    {
        $luckData = array(
            'is_senior'         => 2,
            'senior_source'     => $source,
            'lottery_type'      => $lotteryType,
            'lottery_value'     => $lotteryValue,
            'member_id'         => $memberId,
            'lottery_explain'   => $lotteryExplain,
            'image_text'        => $imageText,
            'luck_mode'         => $luckMode,
            'luck_pwd'          => $luckPwd,
            'team_number'       => $teamNumber,
            'prize_number'      => $number,
            'is_ad'             => $isAd,
            'sponsor'           => $sponsor,
            'sponsor_type'      => $sponsor_type,
            'sponsor_text'      => $sponsor_text,
            'complete'          => 2,
            'appoint_group'     => $appoint_group,
            'examine'           => 2,
            'integral'          => $integral,
            'is_share'          => $is_share,
            'automatic'         => $automatic,
            'receive_type'      => $receive_type,
            'receive_url'       => $receive_url,
            'loop'              => $loop,
            'is_screen'         => $is_screen,
            'invite_sh'         => $invite_sh,
            'group_money'       => $group_money,
            'is_double'       => $is_double,
            'created'           => time()
        );

        if (!p_insert('luck', $luckData)) {
            return false;
        }
        $luckId = p_insert_id();
        $this->changeLuckShop($luckId);
        $luckGoodsData = array(
            'luck_id'   => $luckId,
            'member_id' => $memberId,
            'type'      => $type,
            'name'      => $name,
            'image'     => $image,
            'number'    => $number,
            'source'    => $source ==1 ? 2 : 1,
            'created'   => time()
        );
        if ($type == 2 && $fictitious != '') {
            $jsonData = explode(',', $fictitious);
            if ($number != count($jsonData)) {
                return false;

            }
            $luckGoodsData['fictitious'] = json_encode($jsonData);
        }
        $luckGoodsInfo = array(
            'luck_id'   => $luckId,
            'member_id' => $memberId,
            'type'      => $type,
            'name'      => $name,
            'image'     => $image,
            'source'    => $source ==1 ? 2 : 1,
            'created'   => time()
        );

        if ($source == 1) {
            $luckGoodsData['goods_id']  = $goods_id;
            $luckGoodsInfo['goods_id']  = $goods_id;
        }
        $is_luck_goods = p_insert('luck_goods', $luckGoodsData);
        if (!$is_luck_goods) {
            return false;
        }
        if ($lotteryType != 5) {
            $luck_goods_id = p_insert_id();
            if ($type == 1) {
                $luckGoodsInfo['luck_goods_id'] = $luck_goods_id;
                for ($i = 0; $i < $number; $i++) {
                    if (!p_insert('luck_goods_info', $luckGoodsInfo)) {
                        return false;
                    }
                }
            } else {
                $luckGoodsInfo['luck_goods_id'] = $luck_goods_id;
                return $this->addLuckGoodsInfo($jsonData, $luckGoodsInfo);
            }
        }
        return true;
    }

    public function editingLuckData($id, $source, $lotteryType, $lotteryValue, $memberId = '', $lotteryExplain= '',
                                    $imageText ='', $luckMode ='', $luckPwd ='',$teamNumber = '', $name = '',
                                    $image = '',$number = '', $goods_id, $isAd, $sponsor,$sponsor_type,$sponsor_text,$appoint_group, $integral, $is_share,  $receive_type, $receive_url, $loop,$is_screen,$invite_sh,$is_double)
    {
        $luckData = array(
            'is_senior'         => 2,
            'senior_source'     => $source,
            'lottery_type'      => $lotteryType,
            'lottery_value'     => $lotteryValue,
            'member_id'         => $memberId,
            'lottery_explain'   => $lotteryExplain,
            'image_text'        => $imageText,
            'luck_mode'         => $luckMode,
            'luck_pwd'          => $luckPwd,
            'team_number'       => $teamNumber,
            'is_ad'             => $isAd,
            'sponsor'           => $sponsor,
            'sponsor_type'      => $sponsor_type,
            'sponsor_text'      => $sponsor_text,
            'appoint_group'     => $appoint_group,
            'integral'          => $integral,
            'is_share'          => $is_share,
            'receive_type'      => $receive_type,
            'receive_url'       => $receive_url,
            'loop'              => $loop,
            'is_screen'         => $is_screen,
            'invite_sh'         => $invite_sh,
            'is_double'         => $is_double,
        );

        if (!p_update('luck', $luckData, array('id' => $id))) {
            return false;
        }
        $luckGoodsData = array(
            'member_id' => $memberId,
            'name'      => $name,
            'image'     => $image,
            'number'    => $number,
            'source'    => $source,
        );

        $luckGoodsInfo = array(
            'member_id' => $memberId,
            'name'      => $name,
            'image'     => $image,
            'source'    => $source,
        );

        if ($source == 2) {
            $luckGoodsData['goods_id']  = $goods_id;
            $luckGoodsInfo['goods_id']  = $goods_id;
        }
        if(!p_update('luck_goods', $luckGoodsData, array('luck_id' => $id))){
            return false;
        }
        if (!p_update('luck_goods_info', $luckGoodsInfo, array('luck_id' => $id))) {
            return false;
        }
        return true;
    }


    public function getImagesText($image_text)
    {
        $dataDefault = array();
        if($image_text) {
            foreach ($image_text as $k => $value) {
                if (array_key_exists('type1',$value)) {
                    $data = $this->getImagesTextTypeOne($value);
                } else if (array_key_exists('type2', $value))  {
                    $data = $this->getImagesTextTypeTwo($value);
                } else if (array_key_exists('type3', $value)) {
                    $data = $this->getImagesTextTypeThree($image_text[$k], $image_text[$k+1]);

                }
                if (!empty($data)) {
                    array_push($dataDefault, $data);
                }
            }
            return $this->dataTreating($dataDefault);
        }

        return $dataDefault;
    }

    protected function dataTreating($imageText)
    {
        if ($imageText) {
            foreach ($imageText as $k => $value) {
                if ($value['type'] == 3 ) {
                    if (empty($value['text']) || empty($value['copy']) ) {
                           unset($imageText[$k]);
                    }
                }
                /*if ($value['type'] == 1) {
                    if (empty($value['value'][0])) {
                        unset($imageText[$k]);
                    }

                }*/
            }
        }
        return $imageText;

    }
    protected function getImagesTextTypeOne($typeOneData)
    {

        if (empty($typeOneData['type1'][0])) {
            return '';
        }
        return array(
            'type' => 1,
            'value' => $typeOneData['type1']
        );
    }

    protected function getImagesTextTypeTwo($typeTwoData)
    {
        if (empty($typeTwoData['type2'][0])) {
            return '';
        }
        return array(
            'type'  => 2,
            'path'  => $typeTwoData['type2'][0],
            'url'   => tomedia($typeTwoData['type2'][0]),
        );

    }
    protected function getImagesTextTypeThree($typeThreeData, $typeThreeData2)
    {
        if (empty($typeThreeData['type3']['text'][0])) {
            return '';
        }
        return array(
            'type' => 3,
            'text' => $typeThreeData['type3']['text'][0],
            'copy' => $typeThreeData2['type3']['copy'][0],
        );

    }

    public function addLuckPeople($luckId, $memberId, $goods_id)
    {
        if (empty($luckId) || empty($memberId)) {
            return false;
        }
        $goods_info = p_get('luck_goods_info', array('goods_id' => $goods_id));
        $luckInfo = p_get('luck', array('id' => $luckId));
        if ($luckInfo['luck_mode'] ==2) {
            $luckGroupId = $this->addLuckGroup($memberId, $luckId, $luckInfo['team_number']);
            if ($luckGroupId == 0) {
                return false;
            }
            return $this->addLuckParticipate($luckId,$memberId, $luckGroupId, $goods_info['id']);
        }
        return $this->addLuckParticipate($luckId,$memberId, '', $goods_info['id']);
    }

    public function addLuckAssign($luckId, $memberId, $luck_goods_info_id)
    {
        if (empty($luckId) || empty($memberId)) {
            return false;
        }

        $luck = p_get('luck', array('id' => $luckId));
        if (!$luck) {
            return false;
        }
        $luckGoodsInfo = p_get('luck_goods_info', array('is_appoint' =>1, 'luck_id' => $luckId, 'id' => $luck_goods_info_id));
        if (!$luckGoodsInfo) {
            return false;
        }
        $is_member = p_get('luck_participate', array('member_id' => $memberId, 'luck_id' => $luckGoodsInfo['luck_id']));
        /*if (!$is_member || $is_member['in_prize'] == 2) {
            return false;
        }*/
        try {
            pdo_begin();
            /*$luckParticipate = array(
                'goods_info_id' => $luckGoodsInfo['id'],
                'in_prize'      => 2,
            );
            if(!p_update('luck_participate', $luckParticipate, array('luck_id' => $is_member['luck_id'], 'member_id' => $is_member['member_id']))) {
                throw new Exception('修改失败');
            }*/
            $luckGoodsInfoData = array(
                /*'in_member_id'  => $memberId,*/
                'is_appoint'    => 2,
                'appoint_id'    => $is_member['id']
            );
            if(!p_update('luck_goods_info', $luckGoodsInfoData, array('id' => $luckGoodsInfo['id']))){
                throw  new Exception('修改失败');
            }
            pdo_commit();
            return true;
        } catch (Exception $e) {
            pdo_rollback();
            return $e->getMessage();
        }
        return true;
    }

    public function cancelLuck($luckId, $goodsId)
    {
        $luckGoodsInfo = p_get('luck_goods_info', array('luck_id' => $luckId, 'id' => $goodsId));
        if (!$luckGoodsInfo){
            return false;
        }
        /*$luckParticipate = p_get('luck_participate', array('goods_info_id' => $luckGoodsInfo['id'], 'luck_id' => $luckId));

        if (!$luckParticipate) {
            return false;
        }*/
        try {
            pdo_begin();
            /*if(!p_update('luck_participate', array('in_prize' => 1, 'goods_info_id' =>0), array('id' => $luckParticipate['id']))){
               throw  new Exception('修改失败');
            }*/
            if(!p_update('luck_goods_info', array('is_appoint' => 1, 'appoint_id' => 0), array('id' => $luckGoodsInfo['id']))){
                throw  new Exception('修改失败');
            }
            pdo_commit();
            return true;
        } catch (Exception $e) {
            pdo_rollback();
            return $e->getMessage();
        }

        return true;
    }
    public function addLuckGoods($luck_id, $goods_id, $number)
    {
        $luckInfo = p_get('luck', array('id' => $luck_id));
        if (!$luckInfo) {
            return false;
        }
        $goodsInfo = $this->getGoodsOne($goods_id);

        try {
            pdo_begin();
            if (!p_update('luck', array('prize_number' => $luckInfo['prize_number'] + $number), array('id' => $luck_id))) {
                throw new Exception('修改份数失败');
            }

            $luck_goods = array(
                'luck_id'   => $luck_id,
                'member_id' => $luckInfo['member_id'],
                'name'      => $goodsInfo['name'],
                'image'     => $goodsInfo['cover_image'],
                'number'    => $number,
                'source'    => 2,
                'goods_id'  => $goods_id,
                'created'   => time(),
            );
            if (!p_insert('luck_goods', $luck_goods)) {
                throw new Exception('添加商品失败');
            }
            if ($number >=  1) {
                $luck_goods_id  = p_insert_id();
                for ($i = 1; $i <= $number; $i++) {
                    $luck_goods_info = array(
                        'luck_id'   => $luck_id,
                        'member_id' => $luckInfo['member_id'],
                        'name'      => $goodsInfo['name'],
                        'image'     => $goodsInfo['cover_image'],
                        'source'    => 2,
                        'goods_id'  => $goods_id,
                        'luck_goods_id' => $luck_goods_id,
                        'created'   => time(),
                    );
                    if (!p_insert('luck_goods_info', $luck_goods_info)){
                        throw new Exception('添加商品详情失败');
                    }
                }
            }
            pdo_commit();
            return true;
        } catch (Exception $e) {
            pdo_rollback();
            return $e->getMessage();
        }
        return true;
    }

    /**
     * @param $id
     * @param int $type 2 通过 3 拒绝 4 取消 5 删除
     * @return bool
     */
    public function authenticationHandle($id, $type = 2)
    {
        if (empty($id)) {
            return false;
        }
        switch ($type) {
            case 2:
                $bool = $this->handleAuth($id);
                break;
            case 3:
                $bool = p_update('authentication', array('status' => 3, 'updated' => time()), array('id' => $id));
                break;
            case 4:
                $bool = $this->handleCancelAuth($id);
                break;
            case 5:
                $bool = $this->handleClearAuth($id);
                break;
            default:
                $bool =false;
        }
        return $bool;
    }

    protected function handleClearAuth($id)
    {
        $authentication = p_get('authentication', array('id' =>$id));
        if (!$authentication) {
            return false;
        }
        if (p_update('memberinfo',array('auth' => 1, 'auth_name' => ''), array('id' => $authentication['member_id']))){
            if (p_delete('authentication', array('id' => $id))) {
                return true;
            }
        }
        return false;

    }
    protected function handleCancelAuth($id)
    {
        $authentication = p_get('authentication', array('id' =>$id));
        if (!$authentication) {
            return false;
        }
        if (p_update('authentication', array('status' => 1, 'updated' => time()), array('id' => $id))){
            if (p_update('memberinfo',array('auth' => 1, 'auth_name' => ''), array('id' => $authentication['member_id']))){
                return true;
            }
        }
        return false;
    }
    protected function handleAuth($id)
    {
        $authentication = p_get('authentication', array('id' =>$id));
        if (!$authentication) {
            return false;
        }
        if (p_update('authentication', array('status' => 2, 'updated' => time()), array('id' => $id))){
            if (p_update('memberinfo',array('auth' => 2, 'auth_name' => $authentication['name']), array('id' => $authentication['member_id']))){
                return true;
            }
        }
        return false;
    }
    protected function addLuckGroup($memberId, $luckId, $maxNumber)
    {
        if (empty($memberId) || empty($luckId)) {
            return false;
        }
        $data = array(
            'member_id'     => $memberId,
            'luck_id'       => $luckId,
            'max_number'    => $maxNumber,
            'current_number'=> 1,
            'created'       => time()
        );
        if (p_insert('luck_group', $data)){
            return p_insert_id();
        }
        return 0;
    }

    protected function addLuckParticipate($luckId, $memberId, $groupId = '', $luckGoodsInfoId)
    {
        if (empty($memberId) || empty($luckId)) {
            return false;
        }
        $data = array(
            'luck_id'       => $luckId,
            'member_id'     => $memberId,
            'backstage'     => 2,
            'goods_info_id' => $luckGoodsInfoId,
            'created'       => time(),
        );
        if (!empty($groupId)) {
            $data['group_id'] = $groupId;
        }

        $shopId = p_getcolumn('memberinfo', array('id' => $memberId), 'shop_id');
        if ($shopId) {
            $data['shop_id'] = $shopId;
        }

        if (!p_get('luck_participate', array('luck_id' =>$luckId, 'member_id' => $memberId))) {
            return p_insert('luck_participate', $data);
        }
        return true;
    }

    /**
     * @param array $fictitious 虚拟兑奖码
     * @param $data             数据
     * @return bool
     */
    protected function addLuckGoodsInfo($fictitious = array(), $data)
    {
        if (empty($fictitious)) {
            return false;
        }
        foreach ($fictitious as  $val) {
            $data['fictitious'] =$val;
            if (!p_insert('luck_goods_info', $data)) {
                return false;
            }
        }
        return true;

    }

    public function addRecommend($homeId, $relation_id, $type, $position, $start, $end, $image, $sort, $tag, $tag_bg_color)
    {
        if (!$homeId) {
            if (!$relation_id) {
                return false;
            }
        }
        if ($start > $end) {
            return false;
        }
        if ($start == $end) {
            return false;
        }
        $data = array(
            'position'  => $position,
            'type'      => $type,
            'start'     => $start,
            'end'       => $end,
            'image'     => $image,
            'sort'     => $sort,
            'tag'     => $tag,
            'tag_bg_color'     => $tag_bg_color,
        );
        if ($homeId) {
            return p_update('home', $data, array('id' => $homeId));
        } else {
            $data['created'] = time();
            $data['relation_id'] = $relation_id;
            return p_insert('home', $data);
        }
    }

    public function postersHandle($icon, $bg, $color)
    {
        $poster_bg_image = p_get('config', array('key' => 'poster_bg_image'));
        $defaultData = array(array('icon' => $icon,'bg' => $bg, 'color' => $color));

        if (!$poster_bg_image) {
            return p_insert('config', array('key' => 'poster_bg_image', 'value' => json_encode($defaultData)));
        }

        $metadata = json_decode($poster_bg_image['value'], true);
        array_push($metadata, array('icon' => $icon,'bg'   => $bg, 'color' => $color));
        return p_update('config', array('value' => json_encode($metadata)), array('key' => 'poster_bg_image'));

    }

    public function editPosters($key, $behavior)
    {
        $posters = p_get('config', array('key' => 'poster_bg_image'));
        $postersData = json_decode($posters['value'], true);
        if ($behavior == 'delete') {
            unset($postersData[$key]);
            return p_update('config', array('value' => json_encode($postersData)), array('key' => 'poster_bg_image'));
        }
        return $postersData[$key];

    }

    public function editPostersHandle($key, $icon, $bg, $color)
    {
        if(!is_numeric($key)){
           return false;
        }
        $posters = p_get('config', array('key' => 'poster_bg_image'));
        $postersData = json_decode($posters['value'], true);
        $newPosters = $postersData[$key];
        $newPosters['icon'] = $icon;
        $newPosters['bg']   = $bg;
        $newPosters['color'] = $color;
        $postersData[$key] = $newPosters;
        return p_update('config', array('value' => json_encode($postersData)), array('key' => 'poster_bg_image'));
    }
    public function getPosters()
    {
        $data = p_get('config', array('key' => 'poster_bg_image'));
        if ($data) {
            return json_decode($data['value'], true);
        }
        return array();
    }


    public function addQuestion($title, $content, $sort, $id)
    {
        if (empty($title) || empty($content)) {
            return false;
        }
        $data = array(
            'title'     => $title,
            'content'   => $content,
            'sort'      => $sort,
        );
        if ($id) {
            return p_update('question', $data, array('id' => $id));
        } else {
            return p_insert('question', $data);
        }
    }

    public function editLaunch($name, $subtitle, $icon, $path, $tags, $sort = 1, $status, $id = '')
    {
        if (empty($name) || empty($subtitle)) {
            return false;
        }
        $data = array(
            'name'      => $name,
            'subtitle'  => $subtitle,
            'icon'      => $icon,
            'tags'      => $tags,
            'path'      => $path,
            'status'    => $status,
            'sort'      => $sort,
        );

        if ($id) {
            return p_update('launch', $data , array('id' => $id));
        } else {
            return p_insert('launch', $data);
        }
    }

    public function editTemplate($name, $states, $sort, $id)
    {

        $data = array(
            'name'          => $name,
            'states'        => $states,
            'sort'          => $sort
        );

        if ($id) {
            return p_update('vote_template', $data, array('id' => $id));
        } else {
            return p_insert('vote_template', $data);
        }
    }




    public function subscribeQueue($activityName, $activityTime, $activityText, $skipUrl, $id = false)
    {
        $data = array(
            'activityName' => $activityName,
            'activityTime' => $activityTime,
            'activityText' => $activityText,
            'skipUrl' => $skipUrl,

        );
        $queue['content'] = json_encode($data);
        $queue['status']  =1;
        if (!$id) {
            $queue['created'] = time();
        }

        return $id ? p_update('subscribe_queue', $queue, array('id' => $id)) : p_insert('subscribe_queue', $queue);

    }
    public function addVoteActivityJoinNum($activity_id)
    {
        $voteActivity = p_get('vote_activity', array('id' => $activity_id));
        if ($voteActivity) {
            return p_update('vote_activity', array('join_num' => $voteActivity['join_num'] +1 ), array('id' => $voteActivity['id']));
        }
        return true;

    }

    public function voteTemplate()
    {
        return p_getall('vote_template', array('states' => 1));
    }
    public function salesman($id, $data)
    {
        return $id ? p_update('salesman', $data, array('id' => $id)) : p_insert('salesman', $data);
    }
    public function shop($id, $data)
    {
        return $id ? p_update('shop', $data, array('id' => $id)) : p_insert('shop', $data);
    }
    public function shop_category($id, $data)
    {
        return $id ? p_update('shop_category', $data, array('id' => $id)) : p_insert('shop_category', $data);
    }
    public function shop_goods($id, $data)
    {
        return $id ? p_update('shop_goods', $data, array('id' => $id)) : p_insert('shop_goods', $data);
    }
    public function editVoteJoin($data , $id)
    {
        return $id ? p_update('vote_join', $data,  array('id' => $id)) : p_insert('vote_join', $data);
    }
    public function editVoteActivity($data, $id = '')
    {
        return $id ? p_update('vote_activity', $data, array('id' => $id)) :  p_insert('vote_activity', $data);
    }
    public function getVoteActivityBasis($id)
    {
        $filed = array('member_id', 'type', 'sign_enabled', 'sign_start_time', 'sign_end_time', 'sign_phone', 'sign_wx', 'vote_num');
        return p_get('vote_activity', array('id' => $id), $filed);
    }
    public function getVote_activityOne($id)
    {
        return p_get('vote_activity', array('id' => $id));
    }
    public function getVote_joinOne($id)
    {
        return p_get('vote_join', array('id' => $id));
    }
    public function getDefaultTemplateOne($is_default = 2)
    {
        return p_get('vote_template', array('is_default' => $is_default));
    }
    public function getTemplateOne($id)
    {
        return p_get('vote_template', array('id' => $id));
    }
    public function getLaunchOne($id)
    {
        return p_get('launch', array('id' => $id));
    }
    public function getQuestionOne($id)
    {
        return p_get('question', array('id' => $id));
    }
    public function getShop_goodsOne($id)
    {
        return p_get('shop_goods', array('id' => $id));
    }
    public function getLuckGoodsAll($luck_id)
    {
        return p_getall('luck_goods', array('luck_id' => $luck_id), array('goods_id', 'name'));
    }
    public function getLuckGoods($luck_id)
    {
        return p_get('luck_goods', array('luck_id' => $luck_id), array('member_id', 'type', 'name', 'image', 'goods_id'));
    }
    public function getLuckGoodsName($luck_id)
    {
        return p_getcolumn('luck_goods', array('luck_id' => $luck_id), 'name');
    }

    public function getLuckGoodsInfo($luck_id)
    {
        return p_getcolumn('luck_goods_info', array('luck_id' => $luck_id), 'COUNT(*)');
    }
    public function getLuckGoodsInfoAll($luck_id)
    {
        return p_getall('luck_goods_info', array('luck_id' => $luck_id));
    }

    public function getLuckGroup($group_id)
    {
        return p_getcolumn('luck_group_member', array('group_id' => $group_id), 'COUNT(*)');
    }
    public function luckParticipate($group_id)
    {
        return p_getcolumn('luck_participate', array('group_id' => $group_id), 'COUNT(*)');
    }

    public function luckParticipateCount($luck_id)
    {
        return p_getcolumn('luck_participate', array('luck_id' => $luck_id), 'COUNT(*)');
    }
    /**
     * @param $table
     * @param $id
     * @param $status
     * @return bool
     */
    public function upDown($table, $id, $status)
    {
        return p_update($table, array('status'  => $status), array('id' => $id));
    }

    /**
     * @param $table
     * @param $id
     * @param $is_suspend
     * @return bool
     */
    public function suspended($table, $id, $is_suspend)
    {
        return p_update($table, array('is_suspend'  => $is_suspend), array('id' => $id));
    }
    /**
     * @return array
     */
    public function getCategory()
    {
        return p_getall('category', array('is_delete' => 1), array('id', 'name', 'sort'));
    }
    /**
     * @return array
     */
    public function getGoodsCategory()
    {
        return p_getall('shop_category', array('is_delete' => 1, 'states' => 1), array('id', 'category_name', 'sort'));
    }
    public function getGoodsSalesman()
    {
        return p_getall('salesman', array(), array('id', 'salesman_name'));
    }
    public function getGoodsShop()
    {
        return p_getall('shop', array(), array('id', 'shop_name'));
    }
    public function getGoods()
    {
        return p_getall('goods', array('status' => 1, 'is_delete' => 1), array('id', 'name','cover_image'));
    }

    public function getMemberFictitious()
    {
        $sql = "SELECT * FROM ". prefix('memberinfo'). " WHERE fictitious = 2 ORDER BY id desc LIMIT 0, 3000";
        return p_fetchall($sql);
        return p_getall('memberinfo', array('fictitious' => 2), array('id', 'nickname', 'headimgurl'), '', array(), array(0, 50));
    }

    public function getParticipate($luck_id)
    {
        $sql = "SELECT member_id FROM ". prefix('luck_participate'). " WHERE luck_id = {$luck_id} AND uniacid = ".UNIACID . " ORDER BY id desc LIMIT 0, 300";
        //$member = p_getall('luck_participate', array('luck_id' => $luck_id), array('member_id'));
        $member = p_fetchall($sql);
        if ($member) {
            foreach ($member as & $value) {
                $value['nickname'] = $this->getMemberName($value);
            }
        }
        return $member;
    }

    public function getLuckIsPrize($luck_goods_id, $goods_id = 0)
    {
        $data['luck_goods_id'] = $luck_goods_id;
        if ($goods_id) {
            $data['goods_id'] = $goods_id;
        }
        $luckGoodsInfo = p_get('luck_goods_info', $data);

        $luckParticipate = p_get('luck_participate', array('luck_id' => $luckGoodsInfo['luck_id'], 'goods_info_id' => $luckGoodsInfo['id']));

        return $luckParticipate['in_prize'];

    }

    public function checkRecommend($relation_id, $position, $type)
    {
        return p_get('home', array('relation_id' => $relation_id, 'position' => $position, 'type' => $type));
    }


    public function permissionsAssign($shop_id, $categoryId)
    {

        if ($categoryId) {
            p_delete('shop_category_use',array('shop_id' => $shop_id));
            $salesman_id = p_getcolumn('shop', array('id' => $shop_id), 'salesman_id');
            foreach ($categoryId as $item) {
                $data = array(
                    'category_id' => $item,
                    'shop_id'     => $shop_id,
                    'salesman_id' => $salesman_id,
                    'created'     => time(),
                );

                p_insert('shop_category_use', $data);
            }
        }
        return true;
    }
    /**
     * @param $id
     * @return bool|mixed
     */
    public function getCategoryName($id)
    {
        return p_getcolumn('category', array('id' => $id), 'name');
    }
    public function getMemberName($member_id)
    {

        return pdo_getcolumn(PREFIX.'memberinfo', array('id' => $member_id), 'nickname');

        return p_getcolumn('memberinfo', array('id' => $member_id), 'nickname');
    }

    public function searchMember($filed = '')
    {

        if (empty($filed)) {
            return '';
        }
        $table = prefix('memberinfo');
        $where = "  nickname LIKE '%{$filed}%' AND uniacid=".UNIACID;
        $memberInfo =  p_fetchall("SELECT id FROM {$table} WHERE {$where} ORDER BY id DESC ");

        if ($memberInfo) {
            foreach ($memberInfo as $item) {
                $member_id[] =$item['id'];

            }
            return implode(',', $member_id);
        }
        $addressTable = prefix('address');
        $addressWhere = "name = {$filed} or phone = {$filed} AND uniacid = ". UNIACID;
        $memberInfo =  p_fetchall("SELECT id FROM {$addressTable} WHERE {$addressWhere} ORDER BY id DESC ");
        if ($memberInfo) {
            foreach ($memberInfo as $item) {
                $member_id[] =$item['id'];
            }
            return implode(',', $member_id);
        }
        $authenticationTable = prefix('authentication');
        $authenticationWhere = "name LIKE '%{$filed}%' or category LIKE '%{$filed}%' or full_name LIKE '%{$filed}%'  AND uniacid = ". UNIACID;
        $memberInfo =  p_fetchall("SELECT id FROM {$authenticationTable} WHERE {$authenticationWhere} ORDER BY id DESC ");
        if ($memberInfo) {
            foreach ($memberInfo as $item) {
                $member_id[] =$item['id'];
            }
            return implode(',', $member_id);
        }
        return '';
    }


    public function getDailyData()
    {
        $time = time();
        $luckTable = prefix('luck');
        $where = $this->getTime($time,$time, 'created') . get_uniacid();
        $luckCount = p_fetchcolumn("SELECT COUNT(*) FROM {$luckTable} WHERE {$where}");

        $seniorMemberLog = prefix('senior_member_log');
        $seniorMemberWhere = $where . " AND type =1";
        $seniorMemberCount = pdo_fetchcolumn("SELECT COUNT(*) FROM {$seniorMemberLog} WHERE {$seniorMemberWhere}");

        $luckParticipateTable = prefix('luck_participate');

        $luckParticipateCount = pdo_fetchcolumn("SELECT COUNT(*) FROM {$luckParticipateTable} WHERE {$where}");
        $prizeWhere = $where . " AND in_prize = 1";
        $luckParticipatePrizeCount = pdo_fetchcolumn("SELECT COUNT(*) FROM {$luckParticipateTable} WHERE {$prizeWhere}");

        return array(
            'luckCount'                 => $luckCount ? : 0,
            'seniorMemberCount'         => $seniorMemberCount ? : 0,
            'luckParticipateCount'      => $luckParticipateCount ? : 0,
            'luckParticipatePrizeCount' => $luckParticipatePrizeCount ? : 0
        );
    }

    public function getSeniorMemberLog()
    {
        $table = prefix('senior_member_log');
        $where = "1 = 1".get_uniacid();
        $seniorMemberLog   = p_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY id DESC LIMIT 6");
        if($seniorMemberLog) {
            foreach ($seniorMemberLog as & $value) {
                $value['nickname'] = $this->getMemberName($value['member_id']);
            }
        }
        return $seniorMemberLog;
    }

    public function getNewLuck()
    {
        $table = prefix('luck');
        $where = "1 = 1".get_uniacid();
        $luck  = p_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY id DESC LIMIT 6");
        return $luck;

    }
    public function getMonthLuckCount()
    {
        $luck = array(
            'luckMonth' => array(),
            'luckCount' => array(),
        );
        $luckMonth = $this->getTableMonth(prefix('luck'), 'created','id');

        if ($luckMonth) {
            $user['luckMonth'] = json_encode(array_column($luckMonth, 'months'));
            $user['luckCount'] = json_encode(array_column($luckMonth, 'count'));
        }

        return $luck;

    }

    public function getPayOrder()
    {
        $payOrder = array(
            'userMonth' => array(),
            'userCount' => array(),
        );
        $userMonth = $this->getTableMoney(prefix('pay_order'), 'created','money');
        if ($userMonth) {
            $payOrder['userMonth'] = json_encode(array_column($userMonth, 'months'));
            $payOrder['countMoney'] = json_encode(array_column($userMonth, 'countMoney'));
        }
        return $payOrder;

    }
    public function getUserMonth()
    {
        $user = array(
            'userMonth' => array(),
            'userCount' => array(),
        );
        $userMonth = $this->getTableMonth(prefix('memberinfo'), 'c_time','id');
        if ($userMonth) {
            $user['userMonth'] = json_encode(array_column($userMonth, 'months'));
            $user['userCount'] = json_encode(array_column($userMonth, 'count'));
        }
        return $user;
    }

    public function getLuckProportion()
    {
        $count          = p_getcolumn('luck', array(), 'COUNT(*)');
        $ordinaryCount  = p_getcolumn('luck', array('luck_mode' => 1), 'COUNT(*)');
        $groupCount     = p_getcolumn('luck', array('luck_mode' => 2), 'COUNT(*)');
        $codeCount      = p_getcolumn('luck', array('luck_mode' => 3), 'COUNT(*)');
        $commandCount   = p_getcolumn('luck', array('luck_mode' => 4), 'COUNT(*)');

        return array(
            'ordinaryCount' => number_format(($ordinaryCount / $count) * 100, 2),
            'groupCount'    => number_format(($groupCount / $count) * 100, 2),
            'codeCount'     => number_format(($codeCount / $count) * 100, 2),
            'commandCount'  => number_format(($commandCount / $count) * 100, 2),
        );
    }


    protected function getTableMonth($table, $filed, $groupId)
    {
        $sql = "select from_unixtime({$filed},'%Y-%m') months, count({$groupId}) count from {$table} group by months ORDER BY months DESC LIMIT 12";
        return p_fetchall($sql);
    }

    protected function getTableMoney($table, $filed, $money)
    {
        $sql = "select from_unixtime({$filed},'%Y-%m') months, SUM({$money}) countMoney from {$table} group by months ORDER BY months DESC LIMIT 12";
        return p_fetchall($sql);
    }
        /**
         * @param $table
         * @param $page
         * @param $where
         * @return array
         */
    public function getTableList($table, $page, $where, $sequence = 'id', $desc = "DESC")
    {
        $table  = prefix($table, true);
        $page   = max(1, intval($page));

        //var_dump('SELECT * FROM '.$table." WHERE {$where} ORDER BY {$sequence} {$desc} LIMIT ".($page - 1) * $this->pageSize.','.$this->pageSize);
        $list   = p_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY {$sequence} {$desc} LIMIT ".($page - 1) * $this->pageSize.','.$this->pageSize);
        $total  = p_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");
        $pager = pagination($total, $page, $this->pageSize);
        return array(
            'list' => $list,
            'pages' => $pager
        );
    }


    public function pddSearch($keyWord)
    {

        $pdd_pid = getConfig('pdd_pid');
        $url = 'http://gw-api.pinduoduo.com/api/router';
        $data = array(
            'type' =>  'pdd.ddk.goods.detail',
            'client_id' => getConfig('pdd_client_id'),
            'timestamp' => time(),
            'p_id' => $pdd_pid,
            'keyword' => '[' . $keyWord . ']'
        );
        $data['sign'] = autograph($data);
        $data = json_decode(httpPost($url, $data), true);

        var_dump($data);


    }
    /**
     *
     * @param $goods_id
     * @return mixed
     */
    public function detail($goods_id)
    {
        $pdd_pid = getConfig('pdd_pid');
        $url = 'http://gw-api.pinduoduo.com/api/router';
        $data = array(
            'type' =>  'pdd.ddk.goods.detail',
            'client_id' => getConfig('pdd_client_id'),
            'timestamp' => time(),
            'p_id' => $pdd_pid,
            //'goods_id_list' => '[' . $goods_id . ']'
            'goods_sign' => $goods_id
        );
        $data['sign'] = autograph($data);
        $data = json_decode(httpPost($url, $data), true);

        $info = $data['goods_detail_response']['goods_details'][0];
        $info['coupon_start_time'] = date('m月d日', $info['coupon_start_time']);
        $info['coupon_end_time'] = date('m月d日', $info['coupon_end_time']);

        return $info;
    }


    /**
     *
     * @return  string
     */
    public function getTime($date ,$endDate, $filed)
    {
        if ($date == $endDate) {
            $state_time = strtotime($date . ' 00:00:01');
            $end_time   = strtotime($endDate . '23:59:59');
        } else {
            $state_time = strtotime($date);
            $end_time   = strtotime($endDate);
        }
        $where = "{$filed} BETWEEN {$state_time} AND {$end_time}";
        return $where ;
    }


}