<?php
$sql="
CREATE TABLE IF NOT EXISTS `ims_bh_vl_address` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `name` varchar(30) NOT NULL,
  `phone` varchar(30) NOT NULL,
  `address` text NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_advertisement` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `describe` varchar(255) NOT NULL,
  `image` varchar(255) NOT NULL,
  `click_num` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `position` tinyint(4) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `group_id` varchar(100) NOT NULL,
  `appid` varchar(50) NOT NULL,
  `url` varchar(255) NOT NULL,
  `sort` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_authentication` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `image` text NOT NULL,
  `category` varchar(255) NOT NULL,
  `introduce` varchar(2000) NOT NULL,
  `full_name` varchar(255) NOT NULL,
  `wx` varchar(100) NOT NULL,
  `phone` char(11) NOT NULL,
  `status` int(11) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `updated` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_bonus_level` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `level` int(11) NOT NULL DEFAULT '1',
  `level_name` varchar(255) NOT NULL,
  `level_image` varchar(255) NOT NULL,
  `share_number` int(11) NOT NULL DEFAULT '0',
  `integral` int(11) NOT NULL DEFAULT '0',
  `proportion` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_calligraphy` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `end_time` int(11) NOT NULL DEFAULT '0',
  `stock` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `cover_img` varchar(255) NOT NULL,
  `is_delete` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `share_txt` varchar(255) NOT NULL,
  `share_image` varchar(255) NOT NULL,
  `images` varchar(2000) NOT NULL,
  `details` text NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_calligraphy_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `calligraphy_id` int(11) NOT NULL,
  `word` varchar(10) NOT NULL,
  `weight` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `sort` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `calligraphy_id` (`calligraphy_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_calligraphy_member` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `calligraphy_id` int(11) NOT NULL,
  `success` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `mc` (`member_id`,`calligraphy_id`) USING BTREE,
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `calligraphy_id` (`calligraphy_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_calligraphy_member_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `calligraphy_id` int(11) NOT NULL,
  `calligraphy_details_id` int(11) NOT NULL,
  `source` tinyint(4) NOT NULL DEFAULT '1',
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `give_id` int(11) NOT NULL DEFAULT '0',
  `updated` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `calligraphy_id` (`calligraphy_id`) USING BTREE,
  KEY `calligraphy_details_id` (`calligraphy_details_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=37 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_calligraphy_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `calligraphy_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `courier_name` varchar(255) NOT NULL,
  `courier_number` varchar(100) NOT NULL,
  `address` varchar(1000) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `delivery_time` int(11) NOT NULL,
  `complete_time` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `phone` varchar(50) NOT NULL,
  `created` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `calligraphy_id` (`calligraphy_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `sort` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `is_delete` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_code` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` char(32) NOT NULL,
  `member_id` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=53 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `key` varchar(50) NOT NULL,
  `value` text NOT NULL,
  `uniacid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `key` (`key`,`uniacid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=2181 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_crontab_clear_bonus_level` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `year` char(8) NOT NULL,
  `uniacid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uy` (`uniacid`,`year`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=881 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_currency_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `type` tinyint(4) NOT NULL,
  `number` decimal(10,2) NOT NULL,
  `remarks` varchar(500) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_demo_jump` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(255) NOT NULL DEFAULT '1',
  `appid` varchar(50) NOT NULL,
  `path` varchar(1000) NOT NULL,
  `need_jump_number` int(11) NOT NULL DEFAULT '0',
  `current_jump_number` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `demo_time` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `remarks` varchar(2000) NOT NULL COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_form_id` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `form_id` varchar(50) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category_id` int(11) NOT NULL,
  `name` varchar(500) NOT NULL,
  `price` decimal(10,2) NOT NULL,
  `cover_image` varchar(500) NOT NULL,
  `images` text NOT NULL,
  `details` text NOT NULL,
  `sort` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `is_delete` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category_id` (`category_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_goods_feedback` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `content` varchar(2000) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_home` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `position` tinyint(4) NOT NULL DEFAULT '1',
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `relation_id` int(11) NOT NULL,
  `start` int(11) NOT NULL,
  `end` int(11) NOT NULL,
  `image` varchar(255) NOT NULL,
  `tag` varchar(30) NOT NULL,
  `tag_bg_color` varchar(30) NOT NULL,
  `sort` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=111 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_integral_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` int(11) NOT NULL DEFAULT '1',
  `relation_goods_id` varchar(255) NOT NULL,
  `original_price` decimal(10,2) NOT NULL,
  `goods_name` varchar(255) NOT NULL,
  `share_title` varchar(300) NOT NULL,
  `exchange_type` tinyint(4) NOT NULL DEFAULT '1',
  `money` decimal(10,2) NOT NULL DEFAULT '0.00',
  `exchange_number` int(11) NOT NULL,
  `cover_image` varchar(255) NOT NULL,
  `image` text NOT NULL,
  `is_free` tinyint(4) NOT NULL DEFAULT '1',
  `free` decimal(10,2) NOT NULL,
  `inventory_type` tinyint(4) NOT NULL,
  `inventory` int(11) NOT NULL DEFAULT '0',
  `introduce` text NOT NULL,
  `allow_number` int(11) NOT NULL DEFAULT '0',
  `shop_ids` varchar(255) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `status` int(11) NOT NULL DEFAULT '1',
  `sigin` int(11) NOT NULL DEFAULT '0',
  `is_delete` tinyint(4) NOT NULL DEFAULT '1',
  `sort` int(11) NOT NULL DEFAULT '0',
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_integral_goods_fictitious` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_id` int(11) NOT NULL,
  `fictitious` varchar(1000) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_integral_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `integral` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `same_day` int(11) NOT NULL,
  `after_integral` int(11) NOT NULL DEFAULT '0',
  `remarks` varchar(1000) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=280 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_launch` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `subtitle` varchar(255) NOT NULL,
  `describe` text NOT NULL,
  `icon` varchar(255) NOT NULL,
  `path` varchar(255) NOT NULL,
  `bgcolor` varchar(50) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `tags` varchar(20) NOT NULL,
  `sort` tinyint(4) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `shop_id` int(11) NOT NULL DEFAULT '0',
  `is_senior` tinyint(4) NOT NULL DEFAULT '1',
  `senior_source` tinyint(4) NOT NULL DEFAULT '1',
  `lottery_type` tinyint(4) NOT NULL DEFAULT '1',
  `lottery_value` int(11) NOT NULL DEFAULT '0',
  `invite_sh` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `is_delete` tinyint(4) NOT NULL DEFAULT '1',
  `member_id` int(11) NOT NULL,
  `sponsor` varchar(100) NOT NULL,
  `sponsor_type` tinyint(4) NOT NULL DEFAULT '1',
  `sponsor_text` varchar(2000) NOT NULL,
  `lottery_explain` varchar(2000) NOT NULL,
  `image_text` text NOT NULL,
  `luck_mode` tinyint(4) NOT NULL DEFAULT '1',
  `luck_pwd` varchar(500) NOT NULL,
  `team_number` int(11) NOT NULL,
  `lottery_time` int(11) NOT NULL,
  `goods` text NOT NULL,
  `prize_number` int(11) NOT NULL,
  `is_ad` tinyint(4) NOT NULL DEFAULT '1',
  `integral` int(11) NOT NULL DEFAULT '0',
  `complete` tinyint(4) NOT NULL DEFAULT '1',
  `send_msg` tinyint(4) NOT NULL DEFAULT '1',
  `exposure_number` int(11) NOT NULL DEFAULT '0',
  `examine` tinyint(4) NOT NULL DEFAULT '2',
  `appoint_group` tinyint(4) NOT NULL DEFAULT '1',
  `group_id` varchar(65) NOT NULL,
  `group_money` decimal(10,2) NOT NULL DEFAULT '0.00',
  `share_images` varchar(255) NOT NULL,
  `is_share` tinyint(4) NOT NULL DEFAULT '1',
  `receive_type` tinyint(4) NOT NULL DEFAULT '1',
  `receive_url` varchar(255) NOT NULL,
  `automatic` tinyint(4) NOT NULL DEFAULT '1',
  `loop` tinyint(4) NOT NULL DEFAULT '1',
  `is_screen` tinyint(4) NOT NULL DEFAULT '1',
  `is_fans` tinyint(4) NOT NULL DEFAULT '1',
  `is_new` tinyint(4) NOT NULL DEFAULT '1',
  `fans_url` varchar(350) NOT NULL,
  `keyword` varchar(100) NOT NULL,
  `third_party_id` int(11) NOT NULL DEFAULT '0',
  `prize_integral` int(11) NOT NULL DEFAULT '0',
  `is_cover_bag` tinyint(4) NOT NULL DEFAULT '1',
  `source_id` int(11) NOT NULL DEFAULT '0',
  `is_double` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `shop_id` (`shop_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=174 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_code` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `luck_id` int(11) NOT NULL DEFAULT '0',
  `member_id` int(11) NOT NULL,
  `invitation_member_id` int(11) NOT NULL DEFAULT '0',
  `in_prize` tinyint(4) NOT NULL DEFAULT '1',
  `is_appoint` tinyint(4) NOT NULL DEFAULT '1',
  `goods_info_id` int(11) NOT NULL DEFAULT '0',
  `appoint_goods_id` int(11) NOT NULL,
  `code` char(10) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `luck_id` (`luck_id`) USING BTREE,
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=94 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_complaint` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `luck_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `content` varchar(2000) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `luck_id` (`luck_id`) USING BTREE,
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=42 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `luck_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `red_type` tinyint(4) NOT NULL DEFAULT '1',
  `red_money` decimal(10,2) NOT NULL DEFAULT '0.00',
  `name` varchar(255) NOT NULL,
  `image` varchar(255) NOT NULL,
  `number` int(11) NOT NULL,
  `probability` decimal(10,2) NOT NULL DEFAULT '0.00',
  `fictitious` text NOT NULL,
  `source` tinyint(4) NOT NULL DEFAULT '1',
  `is_under_line` tinyint(4) NOT NULL DEFAULT '1' COMMENT '1 线上 2线下',
  `shop_id` int(11) NOT NULL DEFAULT '0',
  `goods_id` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `luck_id` (`luck_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=202 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_goods_code` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uniacid` int(11) NOT NULL,
  `fictitious` varchar(255) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `luck_id` int(11) NOT NULL DEFAULT '0',
  `use_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_goods_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `luck_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL DEFAULT '0',
  `member_id` int(11) NOT NULL,
  `in_member_id` int(11) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `name` varchar(255) NOT NULL,
  `money` decimal(10,2) NOT NULL,
  `image` varchar(255) NOT NULL,
  `fictitious` text NOT NULL,
  `source` tinyint(4) NOT NULL DEFAULT '1',
  `luck_goods_id` int(11) NOT NULL,
  `goods_id` int(11) NOT NULL,
  `is_appoint` tinyint(4) NOT NULL DEFAULT '1',
  `appoint_id` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `courier_name` varchar(255) NOT NULL,
  `courier_number` varchar(100) NOT NULL,
  `complete_time` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `shop_id` int(11) NOT NULL DEFAULT '0',
  `is_under_line` tinyint(4) NOT NULL DEFAULT '1' COMMENT '1 线上 2线下',
  `write_off_id` int(11) NOT NULL COMMENT '核销人id',
  `write_off_time` int(11) NOT NULL COMMENT '核销时间',
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `luck_id` (`luck_id`) USING BTREE,
  KEY `luck_goods_id` (`luck_goods_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=3088 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `luck_id` int(11) NOT NULL,
  `max_number` int(11) NOT NULL DEFAULT '3',
  `current_number` int(11) NOT NULL,
  `luck_goods_id` int(11) NOT NULL,
  `is_appoint` tinyint(4) NOT NULL DEFAULT '1',
  `appoint_goods_id` int(11) NOT NULL DEFAULT '0',
  `in_prize` int(11) NOT NULL DEFAULT '1',
  `end_time` int(11) NOT NULL DEFAULT '0',
  `open_time` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `send_msg` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `luck_id` (`luck_id`) USING BTREE,
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_group_member` (
  `id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `l_member_id` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group_id` (`group_id`) USING BTREE,
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_keyword_reply` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `luck_id` int(11) NOT NULL,
  `appid` varchar(255) NOT NULL,
  `content` varchar(255) NOT NULL,
  `uniacid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `acu` (`appid`,`content`,`uniacid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_participate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `luck_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL DEFAULT '0',
  `shop_id` int(11) NOT NULL,
  `in_prize` tinyint(4) NOT NULL DEFAULT '1',
  `goods_info_id` int(11) NOT NULL DEFAULT '0',
  `participate_group_id` int(11) NOT NULL DEFAULT '0',
  `backstage` tinyint(4) NOT NULL DEFAULT '1',
  `msg_status` tinyint(4) NOT NULL DEFAULT '1',
  `double` int(11) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `lm` (`luck_id`,`member_id`) USING BTREE,
  KEY `luck_id` (`luck_id`) USING BTREE,
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `group_id` (`group_id`) USING BTREE,
  KEY `shop_id` (`shop_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=278 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_participate_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `luck_id` int(11) NOT NULL,
  `number` int(11) NOT NULL DEFAULT '0',
  `group_id` varchar(65) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `lg` (`luck_id`,`group_id`) USING BTREE,
  KEY `luck_id` (`luck_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_luck_sponsor` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `account` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `code` varchar(255) NOT NULL,
  `path` varchar(2550) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_member_red_bag` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `money` decimal(10,2) NOT NULL DEFAULT '0.00',
  `red_bag_id` int(11) NOT NULL,
  `same_day` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `mr` (`member_id`,`red_bag_id`) USING BTREE,
  KEY `red_bag_id` (`red_bag_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_member_share` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `number` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_memberinfo` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `unionid` varchar(50) NOT NULL,
  `uniacid` int(11) unsigned NOT NULL DEFAULT '0',
  `openid` varchar(50) NOT NULL DEFAULT '',
  `nickname` varchar(60) NOT NULL DEFAULT '',
  `headimgurl` varchar(200) NOT NULL DEFAULT '',
  `sex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `country` varchar(128) NOT NULL,
  `province` varchar(128) NOT NULL COMMENT '省份',
  `city` varchar(128) NOT NULL COMMENT '城市',
  `c_time` int(11) unsigned NOT NULL DEFAULT '0',
  `u_time` int(11) NOT NULL DEFAULT '0',
  `formid` text NOT NULL,
  `parent_id` int(11) NOT NULL,
  `integral` int(11) NOT NULL COMMENT '0',
  `blacklist` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `fictitious` tinyint(4) NOT NULL DEFAULT '1',
  `activity_fq_num` int(11) unsigned NOT NULL DEFAULT '0',
  `activity_bm_num` int(11) unsigned NOT NULL DEFAULT '0',
  `activity_cy_num` int(11) unsigned NOT NULL DEFAULT '0',
  `activity_ll_num` int(11) unsigned NOT NULL DEFAULT '0',
  `activity_ll_arrstr` text NOT NULL,
  `auth` tinyint(4) NOT NULL DEFAULT '1',
  `auth_name` varchar(100) NOT NULL,
  `is_luck` tinyint(4) NOT NULL DEFAULT '1',
  `shop_id` int(11) NOT NULL DEFAULT '0',
  `currency` decimal(10,2) NOT NULL,
  `phone` char(11) NOT NULL,
  `money` decimal(10,2) NOT NULL,
  `payment_code` varchar(255) NOT NULL,
  `cash` int(11) NOT NULL DEFAULT '0',
  `bonus_level` int(11) NOT NULL DEFAULT '1',
  `updated` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `openid` (`openid`) USING BTREE,
  KEY `uniacid` (`uniacid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=4468590 DEFAULT CHARSET=utf8mb4;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_merchant` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL DEFAULT '0',
  `shop_head` varchar(255) NOT NULL,
  `shop_name` varchar(255) NOT NULL,
  `longitude` varchar(50) NOT NULL,
  `latitude` varchar(50) NOT NULL,
  `address` varchar(1000) NOT NULL,
  `phone` char(20) NOT NULL,
  `participants` int(4) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `we_chat` varchar(255) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '2',
  `introduction` varchar(1000) NOT NULL,
  `brand` text NOT NULL,
  `industry` varchar(255) NOT NULL,
  `business_imgs` varchar(1000) NOT NULL,
  `add_group_txt` varchar(255) NOT NULL,
  `add_group_url` varchar(1000) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_money_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `money` decimal(10,2) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `after_money` decimal(10,2) NOT NULL,
  `remarks` varchar(255) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_navigation` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL,
  `position` varchar(50) NOT NULL,
  `path` varchar(255) NOT NULL,
  `selection_image` varchar(255) NOT NULL,
  `unchecked_images` varchar(255) NOT NULL,
  `selection_color` varchar(20) NOT NULL,
  `unchecked_color` varchar(20) NOT NULL,
  `sort` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `position` (`position`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=37 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `exchange_type` tinyint(11) NOT NULL DEFAULT '1',
  `exchange_number` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `relation_goods_id` varchar(255) NOT NULL,
  `money` decimal(10,2) NOT NULL,
  `free` decimal(10,2) NOT NULL,
  `courier_name` varchar(255) NOT NULL,
  `courier_number` varchar(100) NOT NULL,
  `address` varchar(1000) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `delivery_time` int(11) NOT NULL,
  `complete_time` int(11) NOT NULL,
  `fictitious` varchar(255) NOT NULL,
  `name` varchar(50) NOT NULL,
  `phone` varchar(50) NOT NULL,
  `is_under_line` tinyint(4) NOT NULL DEFAULT '1',
  `is_pay` tinyint(4) NOT NULL DEFAULT '1',
  `shop_id` int(11) NOT NULL DEFAULT '0',
  `write_off_id` int(11) NOT NULL DEFAULT '0',
  `write_off_time` int(11) NOT NULL,
  `message` varchar(2000) NOT NULL,
  `created` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `goods_id` (`goods_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_pay_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `trade_no` char(50) NOT NULL,
  `transaction_id` char(32) NOT NULL,
  `pay_time` int(11) NOT NULL,
  `money` decimal(10,2) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `relation_id` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=60 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_question` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `content` text NOT NULL,
  `sort` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_red_bag` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `describe` varchar(100) NOT NULL DEFAULT '',
  `money` decimal(10,2) NOT NULL DEFAULT '0.00',
  `integral` int(11) NOT NULL DEFAULT '0',
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `start` decimal(10,2) NOT NULL DEFAULT '0.00',
  `end` decimal(10,2) NOT NULL DEFAULT '0.00',
  `sign_days` int(11) NOT NULL DEFAULT '0',
  `number` int(11) NOT NULL,
  `receive` int(11) NOT NULL DEFAULT '1',
  `sort` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_remind` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `remind_time` int(11) NOT NULL,
  `remind_day` int(11) NOT NULL,
  `type` int(11) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=84 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_senior` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `number` int(11) NOT NULL DEFAULT '1',
  `money` decimal(10,2) NOT NULL,
  `purchase_number` int(11) NOT NULL DEFAULT '0',
  `is_delete` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_senior_giving` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `number` int(11) NOT NULL,
  `r_member_id` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `confirm` tinyint(4) NOT NULL DEFAULT '1',
  `updated` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_senior_member` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `number` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_senior_member_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `number` int(11) NOT NULL DEFAULT '1',
  `type` int(11) NOT NULL DEFAULT '1',
  `remarks` varchar(500) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_signin` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `all_sigin` int(11) NOT NULL,
  `days` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `updated` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=75 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_subscribe` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `new_activities` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=48 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_subscribe_queue` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subscribe_id` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `number` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `content` text NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_task` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `number` int(11) NOT NULL DEFAULT '1',
  `title` varchar(255) NOT NULL,
  `integral` int(11) NOT NULL DEFAULT '0',
  `appid` varchar(20) NOT NULL,
  `path` varchar(255) NOT NULL,
  `sort` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_task_member` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `task_id` int(11) NOT NULL,
  `number` int(11) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `same_day` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `mt` (`member_id`,`task_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_third_party` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `authorizer_appid` varchar(50) NOT NULL,
  `authorizer_access_token` varchar(255) NOT NULL,
  `authorizer_refresh_token` varchar(255) NOT NULL,
  `expires_in` int(11) NOT NULL DEFAULT '0',
  `authorizer_info` text NOT NULL,
  `qrcode_url` varchar(255) NOT NULL,
  `source` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_token` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `token` char(32) NOT NULL,
  `member_id` int(11) NOT NULL,
  `session_key` varchar(255) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `token` (`token`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=3662 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_vote_activity` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `template_id` int(11) NOT NULL DEFAULT '0',
  `title` varchar(1000) NOT NULL,
  `cover_image` varchar(500) NOT NULL,
  `bg_image` varchar(500) NOT NULL,
  `votes_bg_image` varchar(500) NOT NULL,
  `color` varchar(20) NOT NULL,
  `describe` varchar(2000) NOT NULL,
  `describe_img` text NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `prize_type` tinyint(4) NOT NULL DEFAULT '1',
  `end_type` tinyint(4) NOT NULL DEFAULT '1',
  `start_time` int(11) NOT NULL,
  `end_time` int(11) NOT NULL,
  `sex_type` tinyint(4) NOT NULL DEFAULT '0',
  `region_type` tinyint(4) NOT NULL DEFAULT '1',
  `region` varchar(1000) NOT NULL,
  `sponsor_enabled` tinyint(4) NOT NULL DEFAULT '1',
  `sponsor_name` varchar(500) NOT NULL,
  `sponsor_phone` char(11) NOT NULL,
  `share_thumb` varchar(500) NOT NULL,
  `sign_enabled` tinyint(4) NOT NULL DEFAULT '1',
  `sign_start_time` int(11) NOT NULL,
  `sign_end_time` int(11) NOT NULL,
  `sign_phone` tinyint(4) NOT NULL DEFAULT '1',
  `sign_wx` tinyint(4) NOT NULL DEFAULT '1',
  `day_votes` int(11) NOT NULL DEFAULT '1',
  `is_repeat` tinyint(4) NOT NULL DEFAULT '1',
  `lottery_type` tinyint(4) NOT NULL DEFAULT '1',
  `joins` text NOT NULL,
  `prize` text NOT NULL,
  `view_num` int(11) NOT NULL DEFAULT '0',
  `vote_num` int(11) NOT NULL DEFAULT '0',
  `join_num` int(11) NOT NULL DEFAULT '0',
  `complete` tinyint(4) NOT NULL DEFAULT '1',
  `status` tinyint(4) NOT NULL DEFAULT '2',
  `vote_status` tinyint(4) NOT NULL DEFAULT '1',
  `is_delete` tinyint(4) NOT NULL DEFAULT '1',
  `is_suspend` tinyint(4) NOT NULL DEFAULT '1',
  `send_msg` tinyint(4) NOT NULL DEFAULT '1',
  `is_luck` tinyint(4) NOT NULL DEFAULT '1',
  `luck_id` int(11) NOT NULL,
  `with_ip_num` int(11) NOT NULL DEFAULT '1',
  `source` tinyint(4) NOT NULL DEFAULT '1',
  `examine` tinyint(4) NOT NULL DEFAULT '2',
  `appoint_group` tinyint(4) NOT NULL DEFAULT '1',
  `group_id` varchar(65) NOT NULL,
  `is_verification` tinyint(4) NOT NULL DEFAULT '1',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_vote_complaint` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `vote_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `content` varchar(2000) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `vote_id` (`vote_id`) USING BTREE,
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_vote_danmu` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uniacid` int(11) unsigned NOT NULL DEFAULT '0',
  `uid` int(11) unsigned NOT NULL DEFAULT '0',
  `content` varchar(1000) NOT NULL DEFAULT '',
  `activity_id` int(11) unsigned NOT NULL DEFAULT '0',
  `join_id` int(11) unsigned NOT NULL DEFAULT '0',
  `c_time` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`) USING BTREE,
  KEY `activity_id` (`activity_id`) USING BTREE,
  KEY `join_id` (`join_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_vote_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `vote_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `image` varchar(255) NOT NULL,
  `number` int(11) NOT NULL DEFAULT '1',
  `source` tinyint(4) NOT NULL DEFAULT '1',
  `goods_id` int(11) NOT NULL DEFAULT '0',
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `vote_id` (`vote_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_vote_goods_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `vote_id` int(11) NOT NULL,
  `member_id` int(11) NOT NULL,
  `in_member_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `image` varchar(255) NOT NULL,
  `source` tinyint(4) NOT NULL DEFAULT '1',
  `vote_goods_id` int(11) NOT NULL,
  `goods_id` int(11) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `status` tinyint(11) NOT NULL DEFAULT '1',
  `courier_name` varchar(225) NOT NULL,
  `courier_number` varchar(100) NOT NULL,
  `complete_time` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `vote_id` (`vote_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_vote_join` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uniacid` int(11) unsigned NOT NULL DEFAULT '0',
  `name` varchar(64) NOT NULL DEFAULT '',
  `phone` varchar(32) NOT NULL DEFAULT '',
  `wechat` varchar(64) NOT NULL DEFAULT '',
  `thumb` text NOT NULL,
  `share_thumb` varchar(256) NOT NULL DEFAULT '',
  `intro` varchar(1000) NOT NULL DEFAULT '',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `c_time` int(11) unsigned NOT NULL DEFAULT '0',
  `activity_id` int(11) unsigned NOT NULL DEFAULT '0',
  `uid` int(11) unsigned NOT NULL DEFAULT '0',
  `vote_num` int(11) unsigned NOT NULL DEFAULT '0',
  `number` int(11) unsigned NOT NULL DEFAULT '0',
  `v_time` int(11) unsigned NOT NULL DEFAULT '0',
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `is_img` tinyint(4) NOT NULL DEFAULT '1',
  `in_prize` tinyint(4) NOT NULL DEFAULT '1',
  `msg_status` tinyint(4) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`) USING BTREE,
  KEY `activity_id` (`activity_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_vote_template` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uniacid` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `template_id` int(11) NOT NULL,
  `states` tinyint(4) NOT NULL DEFAULT '1',
  `sort` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `t_u` (`template_id`,`uniacid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=396 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_vote_vote_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uniacid` int(11) unsigned NOT NULL DEFAULT '0',
  `uid` int(11) unsigned NOT NULL DEFAULT '0',
  `activity_id` int(11) unsigned NOT NULL DEFAULT '0',
  `join_id` int(11) unsigned NOT NULL DEFAULT '0',
  `today` int(11) NOT NULL,
  `c_time` int(11) unsigned NOT NULL DEFAULT '0',
  `ip` varchar(64) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`) USING BTREE,
  KEY `activity_id` (`activity_id`) USING BTREE,
  KEY `join_id` (`join_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


CREATE TABLE IF NOT EXISTS `ims_bh_vl_withdrawals` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `money` decimal(10,2) NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `success_time` int(11) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `payment_code` varchar(150) NOT NULL,
  `uniacid` int(11) NOT NULL,
  `created` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;

";
pdo_run($sql);
if(!pdo_fieldexists("bh_vl_address", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_address")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_address", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_address")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_address", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_address")." ADD `name` varchar(30) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_address", "phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_address")." ADD `phone` varchar(30) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_address", "address")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_address")." ADD `address` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_address", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_address")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_address", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_address")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "title")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `title` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "describe")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `describe` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "click_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `click_num` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "position")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `position` tinyint(4) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_advertisement", "group_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `group_id` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "appid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `appid` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "url")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `url` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `sort` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_advertisement", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_advertisement")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_authentication", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `image` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "category")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `category` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "introduce")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `introduce` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "full_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `full_name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "wx")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `wx` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `phone` char(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `status` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_authentication", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "updated")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `updated` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_authentication", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_authentication")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "level")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `level` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "level_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `level_name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "level_image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `level_image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "share_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `share_number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "integral")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `integral` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "proportion")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `proportion` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_bonus_level", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_bonus_level")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "end_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `end_time` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "stock")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `stock` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "cover_img")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `cover_img` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "is_delete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `is_delete` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "share_txt")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `share_txt` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "share_image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `share_image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "images")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `images` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "details")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `details` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_details", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_details")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_details", "calligraphy_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_details")." ADD `calligraphy_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_details", "word")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_details")." ADD `word` varchar(10) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_details", "weight")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_details")." ADD `weight` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_calligraphy_details", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_details")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_details", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_details")." ADD `sort` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member", "calligraphy_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member")." ADD `calligraphy_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member", "success")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member")." ADD `success` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "calligraphy_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `calligraphy_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "calligraphy_details_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `calligraphy_details_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "source")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `source` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "give_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `give_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "updated")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `updated` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_member_log", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_member_log")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "calligraphy_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `calligraphy_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "courier_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `courier_name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "courier_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `courier_number` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "address")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `address` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "delivery_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `delivery_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "complete_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `complete_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `name` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `phone` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_calligraphy_order", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_calligraphy_order")." ADD `created` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_category", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_category")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_category", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_category")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_category", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_category")." ADD `sort` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_category", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_category")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_category", "is_delete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_category")." ADD `is_delete` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_category", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_category")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_code", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_code")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_code", "code")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_code")." ADD `code` char(32) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_code", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_code")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_code", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_code")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_code", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_code")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_config", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_config")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_config", "key")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_config")." ADD `key` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_config", "value")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_config")." ADD `value` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_config", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_config")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_crontab_clear_bonus_level", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_crontab_clear_bonus_level")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_crontab_clear_bonus_level", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_crontab_clear_bonus_level")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_crontab_clear_bonus_level", "year")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_crontab_clear_bonus_level")." ADD `year` char(8) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_crontab_clear_bonus_level", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_crontab_clear_bonus_level")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_currency_log", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_currency_log")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_currency_log", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_currency_log")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_currency_log", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_currency_log")." ADD `type` tinyint(4) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_currency_log", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_currency_log")." ADD `number` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_currency_log", "remarks")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_currency_log")." ADD `remarks` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_currency_log", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_currency_log")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_currency_log", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_currency_log")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `type` tinyint(255) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "appid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `appid` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "path")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `path` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "need_jump_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `need_jump_number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "current_jump_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `current_jump_number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "demo_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `demo_time` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_demo_jump", "remarks")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_demo_jump")." ADD `remarks` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_form_id", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_form_id")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_form_id", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_form_id")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_form_id", "form_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_form_id")." ADD `form_id` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_form_id", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_form_id")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_form_id", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_form_id")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_goods", "category_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `category_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `name` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "price")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `price` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "cover_image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `cover_image` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "images")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `images` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "details")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `details` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `sort` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_goods", "is_delete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `is_delete` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_goods", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods_feedback", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods_feedback")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_goods_feedback", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods_feedback")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods_feedback", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods_feedback")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods_feedback", "content")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods_feedback")." ADD `content` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_goods_feedback", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_goods_feedback")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_home", "position")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `position` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_home", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_home", "relation_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `relation_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "start")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `start` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "end")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `end` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "tag")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `tag` varchar(30) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "tag_bg_color")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `tag_bg_color` varchar(30) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `sort` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_home", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_home")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `type` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "relation_goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `relation_goods_id` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "original_price")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `original_price` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "goods_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `goods_name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "share_title")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `share_title` varchar(300) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "exchange_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `exchange_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `money` decimal(10,2) NOT NULL DEFAULT '0.00';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "exchange_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `exchange_number` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "cover_image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `cover_image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `image` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "is_free")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `is_free` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "free")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `free` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "inventory_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `inventory_type` tinyint(4) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "inventory")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `inventory` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "introduce")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `introduce` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "allow_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `allow_number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "shop_ids")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `shop_ids` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `status` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "sigin")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `sigin` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "is_delete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `is_delete` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `sort` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_integral_goods", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods_fictitious", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods_fictitious")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_integral_goods_fictitious", "goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods_fictitious")." ADD `goods_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods_fictitious", "fictitious")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods_fictitious")." ADD `fictitious` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods_fictitious", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods_fictitious")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_integral_goods_fictitious", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods_fictitious")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_goods_fictitious", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_goods_fictitious")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_log", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_integral_log", "integral")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `integral` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_log", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_log", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_integral_log", "same_day")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `same_day` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_log", "after_integral")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `after_integral` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_integral_log", "remarks")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `remarks` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_log", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_integral_log", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_integral_log")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_launch", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "subtitle")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `subtitle` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "describe")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `describe` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "icon")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `icon` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "path")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `path` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "bgcolor")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `bgcolor` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_launch", "tags")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `tags` varchar(20) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `sort` tinyint(4) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_launch", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_launch")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck", "shop_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `shop_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck", "is_senior")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_senior` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "senior_source")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `senior_source` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "lottery_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `lottery_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "lottery_value")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `lottery_value` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck", "invite_sh")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `invite_sh` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "is_delete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_delete` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "sponsor")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `sponsor` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "sponsor_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `sponsor_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "sponsor_text")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `sponsor_text` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "lottery_explain")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `lottery_explain` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "image_text")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `image_text` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "luck_mode")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `luck_mode` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "luck_pwd")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `luck_pwd` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "team_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `team_number` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "lottery_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `lottery_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "goods")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `goods` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "prize_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `prize_number` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "is_ad")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_ad` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "integral")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `integral` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck", "complete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `complete` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "send_msg")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `send_msg` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "exposure_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `exposure_number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck", "examine")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `examine` tinyint(4) NOT NULL DEFAULT '2';");
}
if(!pdo_fieldexists("bh_vl_luck", "appoint_group")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `appoint_group` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "group_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `group_id` varchar(65) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "group_money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `group_money` decimal(10,2) NOT NULL DEFAULT '0.00';");
}
if(!pdo_fieldexists("bh_vl_luck", "share_images")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `share_images` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "is_share")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_share` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "receive_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `receive_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "receive_url")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `receive_url` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "automatic")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `automatic` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "loop")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `loop` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "is_screen")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_screen` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "is_fans")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_fans` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "is_new")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_new` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "fans_url")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `fans_url` varchar(350) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "keyword")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `keyword` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "third_party_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `third_party_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck", "prize_integral")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `prize_integral` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck", "is_cover_bag")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_cover_bag` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "source_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `source_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck", "is_double")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `is_double` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck")." ADD `created` int(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_code", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_code", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `luck_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_code", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_code", "invitation_member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `invitation_member_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_code", "in_prize")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `in_prize` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_code", "is_appoint")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `is_appoint` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_code", "goods_info_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `goods_info_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_code", "appoint_goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `appoint_goods_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_code", "code")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `code` char(10) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_code", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_code", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_code", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_code")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_complaint", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_complaint")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_complaint", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_complaint")." ADD `luck_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_complaint", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_complaint")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_complaint", "content")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_complaint")." ADD `content` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_complaint", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_complaint")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_complaint", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_complaint")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `luck_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "red_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `red_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "red_money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `red_money` decimal(10,2) NOT NULL DEFAULT '0.00';");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `number` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "probability")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `probability` decimal(10,2) NOT NULL DEFAULT '0.00';");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "fictitious")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `fictitious` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "source")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `source` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "is_under_line")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `is_under_line` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "shop_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `shop_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `goods_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_code", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_code")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_code", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_code")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_code", "fictitious")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_code")." ADD `fictitious` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_code", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_code")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_code", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_code")." ADD `luck_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_code", "use_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_code")." ADD `use_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `luck_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "group_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `group_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "in_member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `in_member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `money` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "fictitious")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `fictitious` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "source")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `source` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "luck_goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `luck_goods_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `goods_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "is_appoint")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `is_appoint` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "appoint_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `appoint_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "courier_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `courier_name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "courier_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `courier_number` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "complete_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `complete_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "shop_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `shop_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "is_under_line")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `is_under_line` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "write_off_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `write_off_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "write_off_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `write_off_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_goods_info", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_goods_info")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_group", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `luck_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group", "max_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `max_number` int(11) NOT NULL DEFAULT '3';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "current_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `current_number` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group", "luck_goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `luck_goods_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group", "is_appoint")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `is_appoint` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "appoint_goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `appoint_goods_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "in_prize")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `in_prize` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "end_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `end_time` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "open_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `open_time` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "send_msg")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `send_msg` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_group", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group_member", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group_member")." ADD `id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group_member", "group_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group_member")." ADD `group_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group_member", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group_member")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group_member", "l_member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group_member")." ADD `l_member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group_member", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group_member")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_group_member", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_group_member")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_keyword_reply", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_keyword_reply")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_keyword_reply", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_keyword_reply")." ADD `luck_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_keyword_reply", "appid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_keyword_reply")." ADD `appid` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_keyword_reply", "content")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_keyword_reply")." ADD `content` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_keyword_reply", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_keyword_reply")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `luck_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "group_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `group_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "shop_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `shop_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "in_prize")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `in_prize` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "goods_info_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `goods_info_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "participate_group_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `participate_group_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "backstage")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `backstage` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "msg_status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `msg_status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "double")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `double` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate_group", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate_group")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_participate_group", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate_group")." ADD `luck_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate_group", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate_group")." ADD `number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_luck_participate_group", "group_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate_group")." ADD `group_id` varchar(65) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate_group", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate_group")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_participate_group", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_participate_group")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "account")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `account` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "code")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `code` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "path")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `path` varchar(2550) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_luck_sponsor", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_luck_sponsor")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_member_red_bag", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_red_bag")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_member_red_bag", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_red_bag")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_member_red_bag", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_red_bag")." ADD `money` decimal(10,2) NOT NULL DEFAULT '0.00';");
}
if(!pdo_fieldexists("bh_vl_member_red_bag", "red_bag_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_red_bag")." ADD `red_bag_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_member_red_bag", "same_day")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_red_bag")." ADD `same_day` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_member_red_bag", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_red_bag")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_member_red_bag", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_red_bag")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_member_share", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_share")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_member_share", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_share")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_member_share", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_share")." ADD `number` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_member_share", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_member_share")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `id` int(11) unsigned NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "unionid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `unionid` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `uniacid` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "openid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `openid` varchar(50) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "nickname")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `nickname` varchar(60) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "headimgurl")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `headimgurl` varchar(200) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "sex")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `sex` tinyint(3) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "country")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `country` varchar(128) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "province")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `province` varchar(128) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "city")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `city` varchar(128) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "c_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `c_time` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "u_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `u_time` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "formid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `formid` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "parent_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `parent_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "integral")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `integral` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "blacklist")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `blacklist` tinyint(3) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "fictitious")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `fictitious` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "activity_fq_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `activity_fq_num` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "activity_bm_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `activity_bm_num` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "activity_cy_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `activity_cy_num` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "activity_ll_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `activity_ll_num` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "activity_ll_arrstr")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `activity_ll_arrstr` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "auth")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `auth` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "auth_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `auth_name` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "is_luck")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `is_luck` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "shop_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `shop_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "currency")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `currency` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `phone` char(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `money` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "payment_code")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `payment_code` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "cash")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `cash` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "bonus_level")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `bonus_level` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_memberinfo", "updated")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_memberinfo")." ADD `updated` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_merchant", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_merchant", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `member_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_merchant", "shop_head")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `shop_head` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "shop_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `shop_name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "longitude")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `longitude` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "latitude")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `latitude` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "address")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `address` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `phone` char(20) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "participants")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `participants` int(4) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_merchant", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "we_chat")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `we_chat` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `status` tinyint(4) NOT NULL DEFAULT '2';");
}
if(!pdo_fieldexists("bh_vl_merchant", "introduction")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `introduction` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "brand")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `brand` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "industry")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `industry` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "business_imgs")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `business_imgs` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "add_group_txt")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `add_group_txt` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "add_group_url")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `add_group_url` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_merchant", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_merchant")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_money_log", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_money_log")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_money_log", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_money_log")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_money_log", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_money_log")." ADD `money` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_money_log", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_money_log")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_money_log", "after_money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_money_log")." ADD `after_money` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_money_log", "remarks")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_money_log")." ADD `remarks` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_money_log", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_money_log")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_money_log", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_money_log")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_navigation", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `name` varchar(20) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "position")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `position` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "path")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `path` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "selection_image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `selection_image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "unchecked_images")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `unchecked_images` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "selection_color")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `selection_color` varchar(20) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "unchecked_color")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `unchecked_color` varchar(20) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `sort` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_navigation", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_navigation")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_order", "goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `goods_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "exchange_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `exchange_type` tinyint(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_order", "exchange_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `exchange_number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_order", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_order", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_order", "relation_goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `relation_goods_id` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `money` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "free")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `free` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "courier_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `courier_name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "courier_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `courier_number` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "address")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `address` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "delivery_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `delivery_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "complete_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `complete_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "fictitious")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `fictitious` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `name` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `phone` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "is_under_line")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `is_under_line` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_order", "is_pay")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `is_pay` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_order", "shop_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `shop_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_order", "write_off_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `write_off_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_order", "write_off_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `write_off_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "message")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `message` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_order", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_order")." ADD `created` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "trade_no")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `trade_no` char(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "transaction_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `transaction_id` char(32) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "pay_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `pay_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `money` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_pay_order", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_pay_order", "relation_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `relation_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_pay_order", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_pay_order")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_question", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_question")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_question", "title")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_question")." ADD `title` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_question", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_question")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_question", "content")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_question")." ADD `content` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_question", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_question")." ADD `sort` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_red_bag", "describe")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `describe` varchar(100) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `money` decimal(10,2) NOT NULL DEFAULT '0.00';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "integral")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `integral` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "start")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `start` decimal(10,2) NOT NULL DEFAULT '0.00';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "end")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `end` decimal(10,2) NOT NULL DEFAULT '0.00';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "sign_days")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `sign_days` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `number` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_red_bag", "receive")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `receive` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `sort` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_red_bag", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_red_bag", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_red_bag")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_remind", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_remind")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_remind", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_remind")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_remind", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_remind")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_remind", "remind_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_remind")." ADD `remind_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_remind", "remind_day")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_remind")." ADD `remind_day` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_remind", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_remind")." ADD `type` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_remind", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_remind")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_remind", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_remind")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_senior", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior")." ADD `number` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_senior", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior")." ADD `money` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior", "purchase_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior")." ADD `purchase_number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_senior", "is_delete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior")." ADD `is_delete` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_senior", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `number` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "r_member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `r_member_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "confirm")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `confirm` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "updated")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `updated` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_giving", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_giving")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_member", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_senior_member", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_member", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member")." ADD `number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_senior_member", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_member", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_member_log", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member_log")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_senior_member_log", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member_log")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_member_log", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member_log")." ADD `number` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_senior_member_log", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member_log")." ADD `type` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_senior_member_log", "remarks")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member_log")." ADD `remarks` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_member_log", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member_log")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_senior_member_log", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_senior_member_log")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_signin", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_signin")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_signin", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_signin")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_signin", "all_sigin")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_signin")." ADD `all_sigin` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_signin", "days")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_signin")." ADD `days` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_signin", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_signin")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_signin", "updated")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_signin")." ADD `updated` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_signin", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_signin")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_subscribe", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_subscribe", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_subscribe", "new_activities")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe")." ADD `new_activities` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_subscribe", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_subscribe", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_subscribe_queue", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe_queue")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_subscribe_queue", "subscribe_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe_queue")." ADD `subscribe_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_subscribe_queue", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe_queue")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_subscribe_queue", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe_queue")." ADD `number` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_subscribe_queue", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe_queue")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_subscribe_queue", "content")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe_queue")." ADD `content` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_subscribe_queue", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_subscribe_queue")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_task", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_task", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `number` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_task", "title")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `title` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task", "integral")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `integral` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_task", "appid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `appid` varchar(20) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task", "path")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `path` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `sort` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_task", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task_member", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task_member")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_task_member", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task_member")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task_member", "task_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task_member")." ADD `task_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task_member", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task_member")." ADD `number` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_task_member", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task_member")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task_member", "same_day")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task_member")." ADD `same_day` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_task_member", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_task_member")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_third_party", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_third_party", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_third_party", "authorizer_appid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `authorizer_appid` varchar(50) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_third_party", "authorizer_access_token")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `authorizer_access_token` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_third_party", "authorizer_refresh_token")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `authorizer_refresh_token` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_third_party", "expires_in")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `expires_in` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_third_party", "authorizer_info")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `authorizer_info` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_third_party", "qrcode_url")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `qrcode_url` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_third_party", "source")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `source` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_third_party", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_third_party")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_token", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_token")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_token", "token")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_token")." ADD `token` char(32) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_token", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_token")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_token", "session_key")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_token")." ADD `session_key` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_token", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_token")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_token", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_token")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "template_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `template_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "title")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `title` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "cover_image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `cover_image` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "bg_image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `bg_image` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "votes_bg_image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `votes_bg_image` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "color")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `color` varchar(20) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "describe")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `describe` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "describe_img")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `describe_img` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "prize_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `prize_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "end_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `end_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "start_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `start_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "end_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `end_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sex_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sex_type` tinyint(4) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "region_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `region_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "region")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `region` varchar(1000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sponsor_enabled")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sponsor_enabled` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sponsor_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sponsor_name` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sponsor_phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sponsor_phone` char(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "share_thumb")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `share_thumb` varchar(500) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sign_enabled")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sign_enabled` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sign_start_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sign_start_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sign_end_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sign_end_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sign_phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sign_phone` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "sign_wx")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `sign_wx` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "day_votes")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `day_votes` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "is_repeat")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `is_repeat` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "lottery_type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `lottery_type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "joins")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `joins` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "prize")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `prize` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "view_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `view_num` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "vote_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `vote_num` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "join_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `join_num` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "complete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `complete` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `status` tinyint(4) NOT NULL DEFAULT '2';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "vote_status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `vote_status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "is_delete")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `is_delete` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "is_suspend")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `is_suspend` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "send_msg")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `send_msg` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "is_luck")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `is_luck` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "luck_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `luck_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "with_ip_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `with_ip_num` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "source")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `source` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "examine")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `examine` tinyint(4) NOT NULL DEFAULT '2';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "appoint_group")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `appoint_group` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "group_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `group_id` varchar(65) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "is_verification")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `is_verification` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_activity", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_activity")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_complaint", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_complaint")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_vote_complaint", "vote_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_complaint")." ADD `vote_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_complaint", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_complaint")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_complaint", "content")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_complaint")." ADD `content` varchar(2000) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_complaint", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_complaint")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_complaint", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_complaint")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_danmu", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_danmu")." ADD `id` int(11) unsigned NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_vote_danmu", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_danmu")." ADD `uniacid` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_danmu", "uid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_danmu")." ADD `uid` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_danmu", "content")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_danmu")." ADD `content` varchar(1000) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_vote_danmu", "activity_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_danmu")." ADD `activity_id` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_danmu", "join_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_danmu")." ADD `join_id` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_danmu", "c_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_danmu")." ADD `c_time` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "vote_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `vote_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `number` int(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "source")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `source` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `goods_id` int(11) NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "vote_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `vote_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "in_member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `in_member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "image")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `image` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "source")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `source` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "vote_goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `vote_goods_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "goods_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `goods_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `status` tinyint(11) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "courier_name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `courier_name` varchar(225) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "courier_number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `courier_number` varchar(100) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "complete_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `complete_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_goods_info", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_goods_info")." ADD `created` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_join", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `id` int(11) unsigned NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_vote_join", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `uniacid` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `name` varchar(64) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "phone")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `phone` varchar(32) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "wechat")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `wechat` varchar(64) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "thumb")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `thumb` text NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_join", "share_thumb")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `share_thumb` varchar(256) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "intro")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `intro` varchar(1000) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `status` tinyint(3) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "c_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `c_time` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "activity_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `activity_id` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "uid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `uid` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "vote_num")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `vote_num` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "number")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `number` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "v_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `v_time` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "is_img")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `is_img` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "in_prize")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `in_prize` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_join", "msg_status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_join")." ADD `msg_status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_template", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_template")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_vote_template", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_template")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_template", "name")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_template")." ADD `name` varchar(255) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_template", "template_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_template")." ADD `template_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_template", "states")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_template")." ADD `states` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_vote_template", "sort")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_template")." ADD `sort` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_vote_log", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_vote_log")." ADD `id` int(11) unsigned NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_vote_vote_log", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_vote_log")." ADD `uniacid` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_vote_log", "uid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_vote_log")." ADD `uid` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_vote_log", "activity_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_vote_log")." ADD `activity_id` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_vote_log", "join_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_vote_log")." ADD `join_id` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_vote_log", "today")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_vote_log")." ADD `today` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_vote_vote_log", "c_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_vote_log")." ADD `c_time` int(11) unsigned NOT NULL DEFAULT '0';");
}
if(!pdo_fieldexists("bh_vl_vote_vote_log", "ip")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_vote_vote_log")." ADD `ip` varchar(64) NOT NULL DEFAULT '';");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `id` int(11) NOT NULL AUTO_INCREMENT;");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "member_id")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `member_id` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "money")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `money` decimal(10,2) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "status")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `status` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "success_time")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `success_time` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "type")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `type` tinyint(4) NOT NULL DEFAULT '1';");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "payment_code")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `payment_code` varchar(150) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "uniacid")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `uniacid` int(11) NOT NULL;");
}
if(!pdo_fieldexists("bh_vl_withdrawals", "created")) {
 pdo_query("ALTER TABLE ".tablename("bh_vl_withdrawals")." ADD `created` int(11) NOT NULL;");
}
