<?php

/**
 * [WeEngine System] Copyright (c) 2013 WE7.CC
 * User: fanyk
 * Date: 2017/12/10
 * Time: 14:46.
 */

include IA_ROOT . '/addons/bh_vote/model/vote.mod.php';
include IA_ROOT . '/addons/bh_vote/lib/function.php';
include 'controller/common.php';
include 'lib/Wxadoc.php';
include 'lib/Qqadoc.php';

class bh_voteModuleWxapp extends WeModuleWxapp {


    public $action = '';
    public $contr = '';
    public $versions = 52;
    public $tmp_path = '';

    public function __construct() {
        global $_W;
        $this->tmp_path = IA_ROOT . '/addons/bh_vote/template/vote_template/vote/';
        define('UNIACID', $_W['uniacid']);
    }



    public function doPageDistribute()
    {
        global $_GPC;
        $this->action = $_GPC['action'] ? : 'index';
        $this->contr = $_GPC['contr'] ? : 'index';

        include_once "controller/{$this->contr}.php";

        $c = new $this->contr;

        if (method_exists($c, $this->action)) {
            $c->{$this->action}();
        }
    }


    /**
     *
     */
    public function  doPagePurchase()
    {
        $c = new bhCommon;
        $id = $c->get('id');
        $senior = p_get('senior', array('id' => $id, 'is_delete' => 1));
        if (empty($senior)) {
            $c->json('充值不存在', 0);
        }
        $trade_no = $c->vote->unifiedOrder($c->member['id'], $senior['money'], $id, 2);
        if (!$trade_no) {
            $c->json('订单生成失败', 0);
        }

        if (isQq()) {

            $notify_url  = $c->w['siteroot'] . "app/index.php?i={$c->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=qqCallBack&m=bh_vote";
            $order  = array(
                'mch_id'    => getConfig('qq_mch_id'),
                'nonce_str' => $c->vote->out_trade_no(),
                'body'      => '购买高级版',
                'out_trade_no' => $trade_no,
                'fee_type'  => 'CNY',
                'total_fee' => $senior['money'] * 100,
                'spbill_create_ip' => CLIENT_IP,
                'trade_type' => 'JSAPI',
                'notify_url' => $notify_url,
            );
            $order['sign'] = qqAutograph($order);
            $s = http_post('https://qpay.qq.com/cgi-bin/pay/qpay_unified_order.cgi', $order);
            libxml_disable_entity_loader(true);
            $paydata = json_decode(json_encode(simplexml_load_string($s, 'SimpleXMLElement', LIBXML_NOCDATA)), true);


        } else {
            $order = array(
                'tid' => $trade_no,
                'fee' => floatval($senior['money']),
                'title' => '购买高级版'
            );

            global $_W;
            $_W['openid'] = $c->member['openid'];
            $_W['member']['uid'] = $c->member['id'];
            $paydata = $this->pay($order);
            if (is_error($paydata)) {
                $c->json($paydata['message'], 0);
            }
        }

        $c->json(array('paydata' => $paydata));
    }



    /**
     *
     */
    public function doPageCreate()
    {
        $c = new bhCommon;
        if ($c->member['is_luck'] != 1) {
            $c->json('暂时不允许发布抽奖活动', 0);
        }

        $is_senior = intval($c->get('is_senior', 1));

        $lottery_type = intval($c->get('lottery_type', 1));
        $luck_mode = intval($c->get('luck_mode', 1));

        $lottery_type == 4 && $lottery_type = 6;

        $is_ad = $c->get('is_ad', 1);
        $user_look_video = getConfig('user_look_video', 1);
        $is_ad = $user_look_video == 2 ? 2 : $is_ad;
        $data = array(
            'is_senior' => $is_senior,
            'lottery_type' => $lottery_type,
            'member_id' => $c->member['id'],
            'luck_mode' => $luck_mode,
            'appoint_group' => $c->get('appoint_group', 1),
            'is_ad' => $is_ad,
            'is_fans' => intval($c->get('is_fans', 1)),
            'is_share' => intval($c->get('is_share', 1)),
            'is_double' => getConfig('user_is_double', 1),
            'created' => time()
        );

        if ($c->member['shop_id'] > 0) {
            $data['shop_id'] = $c->member['shop_id'];
        }

        if ($data['is_fans'] == 2) {
            $keyword = $c->get('keyword');
            if (empty($keyword)) {
                $c->json('请设置回复关键字', 0);
            }
            $third_party_id = $c->get('third_party_id');

            $third_party = p_get('third_party', array('id' => $third_party_id));
            if (empty($third_party)) {
                $c->json('请先授权公众号', 0);
            }

            $third_party['authorizer_info'] = json_decode($third_party['authorizer_info'], true);

            $data['is_fans'] = 3;
            $data['keyword'] = $keyword;
            $data['fans_url'] = $third_party['qrcode_url'];
            $data['third_party_id'] = $third_party_id;
        }

        if ($c->get('lottery_explain')) {
            $data['lottery_explain'] = $c->get('lottery_explain');
        }

        if ($data['appoint_group'] == 2) {
            $data['is_share'] = 2;
        }

        if ($data['lottery_type'] != 2) {
            $data['automatic'] = getConfig('automatic_default', 1);
        }

        $sponsor_id = $c->get('sponsor_id');
        if ($sponsor_id) {
            if ($luck_sponsor = p_get('luck_sponsor', array('id' => $sponsor_id, 'member_id' => $c->member['id']))) {
                $data['sponsor_type'] = $luck_sponsor['type'];
                $data['sponsor'] = $luck_sponsor['name'];
                if (in_array($data['sponsor_type'], array(3, 4, 5))) {
                    $data['sponsor_text'] = json_encode(array(
                        'type' => 1,
                        'image' => $luck_sponsor['code']
                    ));
                } elseif ($data['sponsor_type'] == 2) {
                    $data['sponsor_text'] = json_encode(array(
                        'type' => 2,
                        'appid' => $luck_sponsor['account'],
                        'path' => $luck_sponsor['path']
                    ));

                } else {
                    //$data['sponsor_text'] = $luck_sponsor['type'] == 3 ? $luck_sponsor['name'] :  $luck_sponsor['account'];
                }
            }
        }

        $image_text = $c->get('image_text');
        if ($image_text) {
            if ($image_text = json_decode(html_entity_decode($image_text), true)) {
                $data['image_text'] = json_encode($image_text);
            }
        }

        $prize = $c->get('prize');

        if (empty($prize)) {
            $c->json('请先设置奖品', 0);
        }
        $prize = json_decode(html_entity_decode($prize), true);
        if (empty($prize)) {
            $c->json('请先设置奖品', 0);
        }

        $money = 0;
        if ($is_senior == 2) {
            if ($luck_mode == 2) {
                $team_number = $c->get('team_number');
                foreach ($prize as $value) {
                    if (isset($value['type']) && $value['type'] == 2) {
                        $num = count($value['fictitious']);
                    } else {
                        $num = $value['number'];
                    }
                    if ($num % $team_number > 0) {
                        $c->json('奖品数量必须为成团人数的整数倍', 0);
                    }
                }
            }

            $data['senior_source'] = intval($c->get('senior_source', 1));
            if ($data['senior_source'] == 1) {
                foreach ($prize as $value) {
                    $goods = p_get('goods', array('id' => $value['id']));
                    $money += ($goods['price'] * $value['number']);
                }
            } else {
                if (getConfig('open_senior') != 2) {
                    $senior_member = p_get('senior_member', array('member_id' => $c->member['id']));
                    if (empty($senior_member) || $senior_member['number'] < 1) {
                        $c->json('您的高级版使用数量不足,请先购买', 0);
                    }
                }
            }

        }
        foreach ($prize as $value) {
            if ($value['type'] == 3) {
                $money += ($value['red_type'] == 1 ? $value['red_money'] : ($value['red_money'] * $value['number']));
            }
        }
        $data['goods'] = json_encode($prize);

        if ($lottery_type < 3 || $lottery_type == 6) {
            $lottery_value = $c->get('lottery_value');
            $data['lottery_value'] = $lottery_value;

            if ($lottery_type == 1 && $data['lottery_value'] < time()) {
                $c->json(($lottery_type != 6 ? '开奖时间不能小于当前时间' : '结束时间不能小于当前时间'), 0);
            }
        }

        if ($luck_mode == 4) {
            if (!$luck_pwd = $c->get('luck_pwd')) {
                $c->json('请输入抽奖口令', 0);
            }
            $data['luck_pwd'] = $luck_pwd;
        }
        else if ($luck_mode == 2) {
            $team_number = $c->get('team_number');

            $c_nunmber = json_decode(getConfig('team_number'), true);
            if (!in_array($team_number, $c_nunmber)) {
                $c->json('请选择正确的组队人数', 0);
            }
            $data['team_number'] = $team_number;
        }

        $option = array(
            'appid' => $c->w['uniaccount']['key'],
            'secret' => $c->w['uniaccount']['secret'],
        );

        if (isQq()) {
            $wxObj = new Qqadoc($option);
        } else {
            $wxObj = new Wxadoc($option);
        }
        $check = array(
            $data, $prize
        );
        $res = $wxObj->checkText(json_encode($check, JSON_UNESCAPED_UNICODE));

        if (isset($res['errcode']) && $res['errcode'] == 87014) {
            $c->json('内容包含敏感信息,修改后再提交', 0);
        }

        $data['examine'] = getConfig('luck_examine', 2) ? : 2;

        if (p_insert('luck', $data)) {
            $o_id = pdo_insertid();

            if ($money > 0) {
                $order_id = $c->vote->unifiedOrder($c->member['id'], $money, $o_id);
                if (!$order_id) {
                    $c->json('支付订单生成失败', 0);
                }

                if (isQq()) {

                    $notify_url  = $c->w['siteroot'] . "app/index.php?i={$c->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=qqCallBack&m=bh_vote";
                    $order  = array(
                        'mch_id'    => getConfig('qq_mch_id'),
                        'nonce_str' => $c->vote->out_trade_no(),
                        'body'      => getConfig('xcx_title').'-抽奖',
                        'out_trade_no' => $order_id,
                        'fee_type'  => 'CNY',
                        'total_fee' => $money * 100,
                        'spbill_create_ip' => CLIENT_IP,
                        'trade_type' => 'JSAPI',
                        'notify_url' => $notify_url,
                    );
                    $order['sign'] = qqAutograph($order);
                    $s = http_post('https://qpay.qq.com/cgi-bin/pay/qpay_unified_order.cgi', $order);
                    libxml_disable_entity_loader(true);
                    $paydata = json_decode(json_encode(simplexml_load_string($s, 'SimpleXMLElement', LIBXML_NOCDATA)), true);

                } else {
                    $order = array(
                        'tid' => $order_id,
                        'fee' => floatval($money),
                        'title' => '发起抽奖'
                    );

                    global $_W;
                    $_W['openid'] = $c->member['openid'];
                    $_W['member']['uid'] = $c->member['id'];
                    $paydata = $this->pay($order);
                    if (is_error($paydata)) {
                        $c->json($paydata['message'], 0);
                    }
                }

                $c->json(array('luck_id' => $o_id, 'paydata' => $paydata), 3);
            } else {
                if ($c->vote->create($o_id)) {
                    $c->json(array('luck_id' => $o_id));
                }
                $c->json($c->vote->error, 0);
            }
        }
        //load()->func('logging');
        //var_dump(pdo_debug());
        $c->json('发起失败', 0);
    }


    /**
     *
     */
    public function doPageCreateVote()
    {
        $c = new bhCommon;

        $template_id = $c->get('template_id', 23);

        $data = array(
            'member_id' => $c->member['id'],
            'template_id' => $template_id,
            'cover_image' => $c->get('cover_image'),
            'title' => $c->get('title'),
            'describe' => $c->get('describe'),
            'type' => $c->get('type'),
            'prize_type' => $c->get('prize_type'),
            'start_time' => strtotime($c->get('start_time')),
            'end_time' => strtotime($c->get('end_time')),
            'sex_type' => $c->get('sex_type'),
            'sponsor_enabled' => $c->get('sponsor_enabled'),
            'sign_enabled' => $c->get('sign_enabled'),
            'day_votes' => $c->get('day_votes'),
            'appoint_group' => $c->get('appoint_group', 1),
            'is_verification' => $c->get('is_verification', 1),
            'is_repeat' => $c->get('is_repeat'),
            'created' => time()
        );
        if ($c->get('is_luck') == 2 && $c->get('luck_id') > 0) {
            $data['is_luck'] = 2;
            $data['luck_id'] = $c->get('luck_id');
        }


        $describe_img = $c->get('describe_img');
        $describe_img = json_decode(html_entity_decode($describe_img), true);
        if ($describe_img) {
            $data['describe_img'] = json_encode($describe_img);
        }

        $region = $c->get('region');
        $region = json_decode(html_entity_decode($region), true);
        if ($region) {
            $r = array();
            if ($region[0] != '不限') {
                foreach ($region as $value) {
                    if ($value != '不限') {
                        $r[] = $value;
                    }
                }
                if ($r) {
                    $data['region_type'] = 2;
                    $data['region'] = json_encode($r);
                }
            }
        }

        if ($data['sponsor_enabled'] == 2) {
            $data['sponsor_name'] = $c->get('sponsor_name');
            $data['sponsor_phone'] = $c->get('sponsor_phone');
        }

        if ($data['sign_enabled'] == 2) {
            $data['sign_start_time'] = strtotime($c->get('sign_start_time'));
            $data['sign_end_time'] = strtotime($c->get('sign_end_time'));
            $data['sign_phone'] = $c->get('sign_phone');
            $data['sign_wx'] = $c->get('sign_wx');
        }
        $data['joins'] = html_entity_decode($c->get('joins'));
        $data['prize'] = html_entity_decode($c->get('prize'));

        $data['status'] = getConfig('vote_examine', 2) ? : 2;

        $option = array(
            'appid' => $c->w['uniaccount']['key'],
            'secret' => $c->w['uniaccount']['secret'],
        );

        if (isQq()) {
            $wxObj = new Qqadoc($option);
        } else {
            $wxObj = new Wxadoc($option);
        }
        $res = $wxObj->checkText(json_encode($data, JSON_UNESCAPED_UNICODE));

        if (isset($res['errcode']) && $res['errcode'] == 87014) {
            $c->json('内容包含敏感信息,你修改后再提交', 0);
        }
        if (p_insert('vote_activity', $data)) {
            $id = pdo_insertid();
            if ($data['prize_type'] == 2) {
                $data['prize'] = json_decode($data['prize'], true);
                $money = 0;
                foreach ($data['prize'] as $p) {
                    $goods = p_get('goods', array('id' => $p['id']));
                    $money += ($goods['price'] * $p['number']);
                }

                $order_id = $c->vote->unifiedOrder($c->member['id'], $money, $id, 3);
                if (!$order_id) {
                    $c->json('支付订单生成失败', 0);
                }

                if (isQq()) {

                    $notify_url  = $c->w['siteroot'] . "app/index.php?i={$c->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=qqCallBack&m=bh_vote";
                    $order  = array(
                        'mch_id'    => getConfig('qq_mch_id'),
                        'nonce_str' => $c->vote->out_trade_no(),
                        'body'      => getConfig('xcx_title').'-投票',
                        'out_trade_no' => $order_id,
                        'fee_type'  => 'CNY',
                        'total_fee' => $money * 100,
                        'spbill_create_ip' => CLIENT_IP,
                        'trade_type' => 'JSAPI',
                        'notify_url' => $notify_url,
                    );
                    $order['sign'] = qqAutograph($order);
                    $s = http_post('https://qpay.qq.com/cgi-bin/pay/qpay_unified_order.cgi', $order);
                    libxml_disable_entity_loader(true);
                    $paydata = json_decode(json_encode(simplexml_load_string($s, 'SimpleXMLElement', LIBXML_NOCDATA)), true);

                } else {
                    $order = array(
                        'tid' => $order_id,
                        'fee' => floatval($money),
                        'title' => '商城商品投票'
                    );

                    global $_W;
                    $_W['openid'] = $c->member['openid'];
                    $_W['member']['uid'] = $c->member['id'];
                    $paydata = $this->pay($order);
                    if (is_error($paydata)) {
                        $c->json($paydata['message'], 0);
                    }
                }


                $c->json(array('id' => $id, 'paydata' => $paydata), 3);

            } else if ($c->vote->voteCreate($id)){
                $home_days = intval(getConfig('home_days'));
                if ($c->get('is_home') == 2 && $home_days > 0) {
                    $insert = array(
                        'position' => 1,
                        'type' => 2,
                        'relation_id' => $id,
                        'start' => time(),
                        'end' => time() + 86400 * $home_days,
                        'created' => time()
                    );
                    p_insert('home', $insert);
                }

                $c->json(array('id' => $id));
            }


        }
        $c->json('发起失败', 0);
    }


    /**
 *
 */
    public function doPageExchange()
    {
        $c = new bhCommon;

        $id = intval($c->get('id'));
        $goods = p_get('shop_goods', array('id' => $id, 'status' => 1, 'is_delete' => 1, 'examine_status' => 2));

        if (empty($goods)) {
            $c->json('商品不存在或者已下架', 3);
        }

        $currency_name = getConfig('currency_name', '活力币');

        if ($goods['currency'] > $c->member['currency']) {
            $c->json('您的' . $currency_name . '不足', 3);
        }

        include IA_ROOT . '/addons/bh_vote/model/shop.mod.php';
        $c_model = new shopModel;
        if ($c_model->get_inventory($id) < 1) {
            $c->json('库存不足,商家补货后再来', 3);
        }

        if ($goods['allow_number'] > 0) {
            $num = p_getcolumn('shop_order', array('member_id' => $c->member['id'], 'goods_id' => $id), 'COUNT(*)') ? : 0;
            if ($num >= $goods['allow_number']) {
                $c->json('每人限量兑换' . $goods['allow_number'] . '份', 3);
            }
        }

        $money = 0;
        if ($goods['is_free'] == 2 && $goods['free'] > 0) {
            $money += $goods['free'];
        }
        if ($goods['exchange_type'] == 2 && $goods['money'] > 0) {
            $money += $goods['money'];
        }

        if ($money > 0) {
            $order_id = $c->vote->unifiedOrder($c->member['id'], $goods['money'], $id, 4);

            if (!$order_id) {
                $c->json('支付订单生成失败', 3);
            }

            $order = array(
                'tid' => $order_id,
                'fee' => floatval($money),
                'title' => '商城商品兑换'
            );

            global $_W;
            $_W['openid'] = $c->member['openid'];
            $_W['member']['uid'] = $c->member['id'];
            $paydata = $this->pay($order);
            if (is_error($paydata)) {
                $c->json($paydata['message'], 0);
            }
            $c->json(array('id' => $id, 'paydata' => $paydata), 2);
        } else {
            if (!$c_model->exchange($c->member['id'], $id)) {
                $c->json($c_model->error, 3);
            }
            $c->json();
        }
    }


    public function doPageOpenCallBack($p_id)
    {
        define('IN_SYS', true);
        include_once 'controller/open.php';
        $c = new open;
        $res = $c->apiAuth($p_id);

        include IA_ROOT . '/addons/bh_vote/template/success.php';
    }



    public function doPageReceive()
    {
        include_once IA_ROOT . '/addons/bh_vote/lib/decrypt/wxBizMsgCrypt.php';
        $encodingAesKey = getConfig('encodingAesKey', 'e10adc3949ba59abbe56e057f20f883ee10adc3949b');
        $token = getConfig('decryptToken', '541015648494nfnd1q7d2mivc1w');
        $timeStamp = $_GET['timestamp'];
        $nonce = $_GET['nonce'];
        $appId = getConfig('component_appid', 'wx86d3c80372c2c939');
        $msg_sign = $_GET['msg_signature'];
        $pc = new  WXBizMsgCrypt($token, $encodingAesKey, $appId);

        $postData = file_get_contents("php://input");

        $postStr = simplexml_load_string($postData,"SimpleXMLElement",LIBXML_NOCDATA);
        $encrypt = $postStr->Encrypt;
        $format = "<xml><ToUserName><![CDATA[toUser]]></ToUserName><Encrypt><![CDATA[%s]]></Encrypt></xml>";
        $from_xml = sprintf($format,$encrypt);
        $msg = '';
        $errCode = $pc->decryptMsg($msg_sign, $timeStamp, $nonce, $from_xml, $msg);


        if ($errCode == 0) {
            $xml = new DOMDocument();

            $xml->loadXML($msg);

            $array_e = $xml->getElementsByTagName('ComponentVerifyTicket');

            $component_verify_ticket = $array_e->item(0)->nodeValue;
            cache_write($appId . 'component_verify_ticket', $component_verify_ticket);
        } else {

        }


        echo 'success';
    }


    /**
     * 接受
     */
    public function doPageEvent()
    {
        include_once IA_ROOT . '/addons/bh_vote/lib/decrypt/wxBizMsgCrypt.php';

        $encodingAesKey = getConfig('encodingAesKey', 'e10adc3949ba59abbe56e057f20f883ee10adc3949b');
        $token = getConfig('decryptToken', '541015648494nfnd1q7d2mivc1w');
        $timeStamp = $_GET['timestamp'];
        $nonce = $_GET['nonce'];
        $appId = getConfig('component_appid', 'wx86d3c80372c2c939');
        $msg_sign = $_GET['msg_signature'];
        $pc = new  WXBizMsgCrypt($token, $encodingAesKey, $appId);

        $postData = file_get_contents("php://input");


        $postStr = simplexml_load_string($postData,"SimpleXMLElement",LIBXML_NOCDATA);

        $encrypt = $postStr->Encrypt;
        $format = "<xml><ToUserName><![CDATA[toUser]]></ToUserName><Encrypt><![CDATA[%s]]></Encrypt></xml>";
        $from_xml = sprintf($format,$encrypt);
        $msg = '';
        $errCode = $pc->decryptMsg($msg_sign, $timeStamp, $nonce, $from_xml, $msg);

        //file_put_contents(IA_ROOT . '/101.txt', '解密后'  . var_export($_GET, true), FILE_APPEND);

        if ($errCode == 0) {
            libxml_disable_entity_loader(true);
            $value_array = json_decode(json_encode(simplexml_load_string($msg, 'SimpleXMLElement', LIBXML_NOCDATA)), true);

            $appid = $_GET['appid'];
           // file_put_contents(IA_ROOT . '/102.txt', '加密后'  . var_export($value_array, true), FILE_APPEND);
            //file_put_contents(IA_ROOT . '/102.txt', 'appid:'  . var_export($appid, true), FILE_APPEND);
            include_once IA_ROOT . '/addons/bh_vote/lib/ThirdParty.php';
            $thirdParty = new ThirdParty($this);
            if ($appid == '/wx570bc396a51b8ff8') {

                if ($value_array['Content'] == 'TESTCOMPONENT_MSG_TYPE_TEXT') {
                    $res = $thirdParty->reply($value_array, 'TESTCOMPONENT_MSG_TYPE_TEXT_callback');
                    //file_put_contents(IA_ROOT . '/102.txt', 'res:'  . var_export($res, true), FILE_APPEND);
                    $encryptMsg = '';
                    $pc->encryptMsg($res, $_GET['timestamp'], $_GET['nonce'], $encryptMsg);
                    //file_put_contents(IA_ROOT . '/102.txt', 'encryptMsg:'  . var_export($encryptMsg, true), FILE_APPEND);

                    echo $encryptMsg;exit;
                }

                if (strpos($value_array['Content'], 'QUERY_AUTH_CODE') === 0) {
                    $query_auth_code = str_replace('QUERY_AUTH_CODE:', '', $value_array['Content']);
                    $authorizer_access_token = $thirdParty->api_query_auth($query_auth_code, true);
                    $res = $thirdParty->send($value_array, $authorizer_access_token, '',$query_auth_code . '_from_api');
                }
                //file_put_contents(IA_ROOT . '/102.txt', '发送:'  . var_export($res, true), FILE_APPEND);

            } else if ($value_array['MsgType'] == 'text') {

                $res = $thirdParty->send($value_array, '', $appid);
                //file_put_contents(IA_ROOT . '/101.txt', '解密1'  . var_export($res, true), FILE_APPEND);

            }
        }
        echo 'success';
    }



    /**
     * 生成订单
     */
    public function doPageExchangeGoods()
    {
        $c = new bhCommon;

        $id = $c->get('id');
        if (empty($id)) {
            json('请先选择商品', 3);
        }

        $goods = p_get('integral_goods', array('id' => $id, 'status' => 1, 'is_delete' => 1));

        if (empty($goods)) {
            $c->json('商品不存在或已下架', 3);
        }


        $volume = p_getcolumn('order', array('goods_id' => $id, 'is_pay' => 2), 'COUNT(*)') ? : 0;
        if ($volume >= $goods['inventory']) {
            $c->json('您来晚了,已经被兑换完了~', 3);
        }

        if ($goods['allow_number'] > 0) {
            $buy_num = p_getcolumn('order', array('member_id' => $c->member['id'], 'goods_id' => $id, 'is_pay' => 2), 'COUNT(*)') ? : 0;
            if ($buy_num >= $goods['allow_number']) {
                $c->json('每人最多兑换' . $goods['allow_number'] . '件~' , 3);
            }
        }

        if ($goods['exchange_number'] > $c->member['integral']) {
            $c->json('您的' . getConfig('integral_name') . '不足~', 3);
        }

        $insert = array(
            'goods_id' => $id,
            'member_id' => $c->member['id'],
            'exchange_type' => $goods['exchange_type'],
            'exchange_number' => $goods['exchange_number'],
            'type' => $goods['type'],
            'money' => $goods['money'],
            'free' => $goods['free'],
            'is_pay' => 1,
            'created' => time()
        );



        pdo_begin();
        try{
            if ($goods['type'] == 1) {
                $address = p_get('address', array('member_id' => $c->member['id']));
                $insert['address'] = $address['address'];
                $insert['name'] = $address['name'];
                $insert['phone'] = $address['phone'];
            } else if ($goods['type'] == 3) {
                $shop_id = intval($c->get('shop_id'));
                if (empty($shop_id)) {
                    $c->json('请选择提货点', 3);
                }
                $shop_ids = explode(',', $goods['shop_ids']);
                if (!in_array($shop_id, $shop_ids)) {
                    $c->json('请选择提货点', 3);
                }
                $insert['shop_id'] = $shop_id;

                $insert['fictitious'] = $c->vote->out_trade_no();
            } else if ($goods['type'] == 4) {
                $goods_fictitious = p_get('integral_goods_fictitious', array('goods_id' => $goods['id'], 'status' => 1));
                if (empty($goods_fictitious)) {
                    $c->json('您来晚了,已经被兑换完了~~', 3);
                }
                $insert['fictitious'] = $goods_fictitious['fictitious'];
            }

            if ($message = $c->get('message')) {
                $insert['message'] = $message;
            }

            $money = 0;
            if ($goods['exchange_type'] == 2 && $goods['money'] > 0) {
                $money = $goods['money'];
            }
            if ($goods['is_free'] == 2 && $goods['free'] > 0) {
                $money += $goods['free'];
            }

            if ($money <= 0) {
                $insert['is_pay'] = 2;
                if (!$c->vote->change_integral($c->member['id'], $goods['exchange_number'], 3)) {
                    throw new Exception($c->vote->error);
                }
                if (isset($goods_fictitious)) {
                    if (!p_update('integral_goods_fictitious', array('status' => 2), array('id' => $goods_fictitious['id']))) {
                        throw new Exception('兑换失败,请稍后再试');
                    }
                    $insert['status'] = 3;
                    $insert['delivery_time'] = time();
                    $insert['complete_time'] = time();

                }
            }


            if (!p_insert('order', $insert)) {
                throw new Exception('兑换失败,请稍后再试');
            }
            $o_id = pdo_insertid();
            if ($money > 0) {
                $order_id = $c->vote->unifiedOrder($c->member['id'], $money, $o_id, 5);
                if (!$order_id) {
                    throw new Exception('订单生成失败');
                }


                global $_W;
                $_W['openid'] = $c->member['openid'];
                $_W['member']['uid'] = $c->member['id'];

                if (isQq()) {
                    $notify_url  = $_W['siteroot'] . "app/index.php?i={$_W['uniacid']}&from=wxapp&c=entry&a=wxapp&do=qqCallBack&m=bh_vote";
                    $order  = array(
                        'mch_id'    => getConfig('qq_mch_id'),
                        'nonce_str' => $c->vote->out_trade_no(),
                        'body'      => getConfig('xcx_title').'-' .$goods['goods_name'],
                        'out_trade_no' => $order_id,
                        'fee_type'  => 'CNY',
                        'total_fee' => $money * 100,
                        'spbill_create_ip' => CLIENT_IP,
                        'trade_type' => 'JSAPI',
                        'notify_url' => $notify_url,
                    );
                    $order['sign'] = qqAutograph($order);
                    $s = http_post('https://qpay.qq.com/cgi-bin/pay/qpay_unified_order.cgi', $order);
                    libxml_disable_entity_loader(true);
                    $data = json_decode(json_encode(simplexml_load_string($s, 'SimpleXMLElement', LIBXML_NOCDATA)), true);

                } else {
                    $order = array(
                        'tid' => $order_id, //订单号
                        'fee' => floatval($money), //支付参数
                        'title' => '礼品' . $goods['name'] //标题
                    );
                    $paydata = $this->pay($order);
                    if (is_error($paydata)) {
                        throw new Exception($paydata['message']);
                    }
                    $data = array('paydata' => $paydata);
                }

                pdo_commit();
                $c->json($data, 2);
            }

            pdo_commit();
            $c->json(array('order_id' => $o_id));
        } catch (Exception $e) {
            pdo_rollback();
            $c->json($e->getMessage(), 3);
        }
    }



    public function doPageQuestionList()
    {
        define('IN_SYS', true); //入口常量定义
        $table = prefix('question');
        $list = p_getall('question', array(), array(), '', 'sort DESC, id DESC');
        //$where = "uniacid = {$this->w['uniacid']}";
        //$list = pdo_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY sort DESC,id DESC ");
        if ($list) {
            foreach ($list as & $value) {
                $value['content'] = str_replace("\r\n", "\n", $value['content']);
                $value['content'] = str_replace("\n", '<br/>', $value['content']);
            }
        }
        $product_name = getConfig('xcx_title', '投票抽奖');
        include $this->template('question_list');
    }


    public function createUrl($do, $query = array())
    {
        $url = "./index.php?i=" . UNIACID . "&from=wxapp&c=entry&a=wxapp&do={$do}&m=bh_vote&";
        if ($query) {
            $queryString = http_build_query($query, '', '&');
            $url .= $queryString;
        }
        return $url;
    }

    /**
     *
     */
    public function doPageVoteIndex()
    {
        define('IN_SYS', true);
        include_once 'controller/new_vote.php';
        $c = new new_vote;
        $id = intval($c->get('id'));
        $group_id = $c->get('group_id');

        $data = $c->index($id);
        $isQQ = $c->get('isqq');

        $rank_url = $this->createUrl('ranking', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));
        $details_url = $this->createUrl('details', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));

        $token = $c->get('token');
        $vote_url = $this->createUrl('distribute', array('token' => $token, 'group_id' => $group_id, 'contr' => 'new_vote', 'action' => 'vote'));

        $path = total_station_oss() . 'addons/bh_vote/template/vote_template/vote/';

        $css_path = $path. 'css/';
        $image_path = $path. 'images/';




        include $this->template('vote_template/vote/example/' . $data['vote']['template_id'] .'/index');
    }



    /**
     *
     */
    public function doPageRanking()
    {
        define('IN_SYS', true);
        include_once 'controller/new_vote.php';
        $c = new new_vote;
        $id = intval($c->get('id'));

        $data = $c->rank($id);

        $isQQ = $c->get('isqq');

        $home_url = $this->createUrl('voteIndex', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));
        $details_url = $this->createUrl('details', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));

        //$path = $c->w['siteroot'] . 'addons/bh_vote/template/vote_template/vote/';

        $path = total_station_oss() . 'addons/bh_vote/template/vote_template/vote/';

        $css_path = $path. 'css/';
        $image_path = $path. 'images/';
        include $this->template('vote_template/vote/example/' . $data['vote']['template_id'] . '/ranking');
    }


    /**
     *
     */
    public function doPageDetails()
    {
        define('IN_SYS', true);

        include_once 'controller/new_vote.php';
        $c = new new_vote;
        $id = intval($c->get('id', 1));
        $data = $c->details($id);

        $isQQ = $c->get('isqq');

        $home_url = $this->createUrl('voteIndex', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));
        $rank_url = $this->createUrl('ranking', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));

        $capital = array('一', '二', '三', '四', '五', '六', '七', '八', '九', '十');
        $repoter_url = $this->createUrl('distribute', array('token' => $c->get('token'), 'contr' => 'new_vote', 'action' => 'complaint', 'id' => $id));

        //$path = $c->w['siteroot'] . 'addons/bh_vote/template/vote_template/vote/';

        $path = total_station_oss() . 'addons/bh_vote/template/vote_template/vote/';

        $css_path = $path. 'css/';
        $image_path = $path. 'images/';
        include $this->template('vote_template/vote/example/' . $data['vote']['template_id'] . '/details');
    }


    /**
     *
     */
    public function doPagePlayer()
    {
        define('IN_SYS', true);
        include_once 'controller/new_vote.php';
        $c = new new_vote;
        $id = $c->get('id', 1);
        $data = $c->detail($id);
        $group_id = $c->get('group_id');

        $token = $c->get('token');
        $vote_url = $this->createUrl('distribute', array('token' => $token, 'group_id' => $group_id, 'contr' => 'new_vote', 'action' => 'vote'));

        global $_W;
        //$path = $_W['siteroot'] . 'addons/bh_vote/template/vote_template/vote/';

        $path = total_station_oss() . 'addons/bh_vote/template/vote_template/vote/';

        $isQQ = $c->get('isqq', 1);

        $css_path = $path. 'css/';
        $image_path = $path. 'images/';
        include $this->template('vote_template/vote/example/' . $data['vote']['template_id'] . '/player');
    }




    /**
     *
     */
     public function doPageVoteTemplate()
     {
         define('IN_SYS', true);
         include_once 'controller/new_vote.php';
         $c = new new_vote;
         $id = $c->get('id', 1);

         global $_W;

         $isQQ = $c->get('isqq', 1);

         $js_url = $isQQ == 1 ? 'https://res.wx.qq.com/open/js/jweixin-1.3.2.js' : 'https://qqq.gtimg.cn/miniprogram/webview_jssdk/qqjssdk-1.0.0.js';

         //$data = $c->index($id);
         $rank_url = $this->createUrl('voteRanking', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));
         $details_url = $this->createUrl('voteDetails', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));

         $vote_url = $this->createUrl('distribute', array('token' => $c->get('token'), 'contr' => 'new_vote', 'action' => 'vote'));

         $surplus_time = $id * mt_rand(1, 1000) * 86400 ;
         //$path = $_W['siteroot'] . 'addons/bh_vote/template/vote_template/vote/';

         $path = total_station_oss() . 'addons/bh_vote/template/vote_template/vote/';

         $css_path = $path. 'css/';
         $image_path = $path. 'images/';
         $data['xcx_title'] = getConfig('xcx_title', '365团队提供技术支持') . '提供技术支持';
         include $this->template('vote_template/vote/actual/' . $id .'/index');
     }


    /**
     *
     */
    public function doPageVoteRanking()
    {
        define('IN_SYS', true);
        $c = new bhCommon;
        $id = $c->get('id', 1);

        $isQQ = $c->get('isqq', 1);

        $js_url = $isQQ == 1 ? 'https://res.wx.qq.com/open/js/jweixin-1.3.2.js' : 'https://qqq.gtimg.cn/miniprogram/webview_jssdk/qqjssdk-1.0.0.js';

        $home_url = $this->createUrl('VoteTemplate', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));
        $details_url = $this->createUrl('VoteDetails', array('id' => $id, 'token' => $c->get('token'), 'isqq' => $isQQ));


        global $_W;
        //$path = $_W['siteroot'] . 'addons/bh_vote/template/vote_template/vote/';

        $path = total_station_oss() . 'addons/bh_vote/template/vote_template/vote/';

        $css_path = $path. 'css/';
        $image_path = $path. 'images/';
        $data['xcx_title'] = getConfig('xcx_title', '365团队提供技术支持') . '提供技术支持';
        include $this->template('vote_template/vote/actual/' . $id . '/ranking');
    }


    /**
     *
     */
    public function doPageVoteDetails()
    {
        define('IN_SYS', true);
        $c = new bhCommon;
        $id = $c->get('id', 1);

        $isQQ = $c->get('isqq', 1);

        $js_url = $isQQ == 1 ? 'https://res.wx.qq.com/open/js/jweixin-1.3.2.js' : 'https://qqq.gtimg.cn/miniprogram/webview_jssdk/qqjssdk-1.0.0.js';

        $home_url = $this->createUrl('VoteTemplate', array('id' => $id, 'token' => $c->get('token'), $isQQ = $c->get('isqq', 1)));
        $rank_url = $this->createUrl('VoteRanking', array('id' => $id, 'token' => $c->get('token'), $isQQ = $c->get('isqq', 1)));

        global $_W;
        //$path = $_W['siteroot'] . 'addons/bh_vote/template/vote_template/vote/';

        $path = total_station_oss() . 'addons/bh_vote/template/vote_template/vote/';

        $css_path = $path. 'css/';
        $image_path = $path. 'images/';
        $data['xcx_title'] = getConfig('xcx_title', '365团队提供技术支持') . '提供技术支持';
        include $this->template('vote_template/vote/actual/' . $id . '/details');
    }


    /**
     *
     */
    public function doPageVotePlayer()
    {
        define('IN_SYS', true);
        $c = new bhCommon;
        $id = $c->get('id', 1);

        global $_W;
        //$path = $_W['siteroot'] . 'addons/bh_vote/template/vote_template/vote/';

        $path = total_station_oss() . 'addons/bh_vote/template/vote_template/vote/';

        $css_path = $path. 'css/';
        $image_path = $path. 'images/';
        include $this->template('vote_template/vote/actual/' . $id . '/player');
    }



    /**
     *
     */
    public function payResult($data)
    {
        global $_GPC, $_W;
        $orderid = $data['tid'] ? $data['tid'] : $_GPC['orderid'];
        $paylog = pdo_get('core_paylog', array('uniacid' => $_W['uniacid'], 'module' => 'bh_vote', 'tid' => $orderid));

        //file_put_contents(IA_ROOT . '/addons/bh_vote/vote1.txt', var_export($paylog, true));
        $status = intval($paylog['status']) === 1;
        if (!$status) {
            exit;
        }

        $order = pdo_get('bh_vl_pay_order', array('trade_no' => $orderid));

        //file_put_contents(IA_ROOT . '/addons/bh_vote/vote1.txt', '支付订单:' . var_export($order, true), FILE_APPEND);

        if (empty($order) || $order['status'] == 2) {
            exit;
        }

        $update = array(
            'transaction_id' => $paylog['encrypt_code'],
            'pay_time' => time(),
            'status' => 2
        );
        pdo_update('bh_vl_pay_order', $update, array('id' => $order['id']));
        //充值后续操作
        $vote = new vote();
        if ($order['type'] == 1) {
            $vote->create($order['relation_id']);
            //file_put_contents(IA_ROOT . '/addons/bh_vote/vote2.txt', '原因2::' . UNIACID , FILE_APPEND);
            //file_put_contents(IA_ROOT . '/addons/bh_vote/vote2.txt', '原因3::' . getConfig('open_senior'), FILE_APPEND);
            //file_put_contents(IA_ROOT . '/addons/bh_vote/vote2.txt', '原因4::' . var_export(pdo_debug(false), true), FILE_APPEND);
        }
        elseif ($order['type'] == 2) {
            $senior = p_get('senior', array('id' => $order['relation_id'], 'is_delete' => 1));
            p_update('senior', array('purchase_number' => $senior['purchase_number'] + 1), array('id' => $order['relation_id']));
            $vote->change_senior($order['member_id'], $senior['number'], 1, $order['relation_id']);
        }
        elseif ($order['type'] == 3) {
            $vote->voteCreate($order['relation_id']);
        }
        elseif ($order['type'] == 4) {
            include IA_ROOT . '/addons/bh_vote/model/shop.mod.php';
            $c_model = new shopModel;
            $c_model->exchange($order['member_id'], $order['relation_id']);
        } elseif ($order['type'] == 5) {
            $o = p_get('order', array('id' => $order['relation_id']));
            $goods = p_get('integral_goods', array('id' => $o['goods_id']));

            $vote->change_integral($order['member_id'], $goods['exchange_number'], 3);

            p_update('order', array('is_pay' => 2), array('id' => $order['relation_id']));

            if ($o['type'] == 4 && !empty($o['fictitious'])) {
                p_update('integral_goods_fictitious', array('status' => 2), array('goods_id' => $o['goods_id'], 'fictitious' => $o['fictitious']));
                p_update('order', array('status' => 3, 'delivery_time' => time(), 'complete_time' => time()), array('id' => $order['relation_id']));

            }


        }

        exit('ok');
    }


    public function doPageTa()
    {
        $vote = new vote();
        $vote->create(1456);
        var_dump($vote->error);
    }

    public function doPageQqCallBack()
    {
        $fileContent = file_get_contents("php://input");
        libxml_disable_entity_loader(true);
        $value_array = json_decode(json_encode(simplexml_load_string($fileContent, 'SimpleXMLElement', LIBXML_NOCDATA)), true);

        //file_put_contents(ATTACHMENT_ROOT . '13.txt', 'res' . var_export($value_array, true) . "/r/n", FILE_APPEND);
        $orderid = $value_array['out_trade_no'];
        $order = pdo_get('bh_vl_pay_order', array('trade_no' => $orderid));

        if (empty($order) || $order['status'] == 2) {
            return "<xml>
                <return_code>FAIL</return_code>
                </xml>";
        }

        $update = array(
            'transaction_id' => $value_array['transaction_id'] ? : $order['transaction_id'],
            'pay_time'       => $value_array['time_end'] ? : time(),
            'status'         => 2
        );
        pdo_update('bh_vl_pay_order', $update, array('id' => $order['id']));
        //充值后续操作

        //充值后续操作
        $vote = new vote();
        if ($order['type'] == 1) {
            $vote->create($order['relation_id']);
        }
        elseif ($order['type'] == 2) {
            $senior = p_get('senior', array('id' => $order['relation_id'], 'is_delete' => 1));
            p_update('senior', array('purchase_number' => $senior['purchase_number'] + 1), array('id' => $order['relation_id']));
            $vote->change_senior($order['member_id'], $senior['number'], 1, $order['relation_id']);
        }
        elseif ($order['type'] == 3) {
            $vote->voteCreate($order['relation_id']);
        }
        elseif ($order['type'] == 4) {
            include IA_ROOT . '/addons/bh_vote/model/shop.mod.php';
            $c_model = new shopModel;
            $c_model->exchange($order['member_id'], $order['relation_id']);
        } elseif ($order['type'] == 5) {
            $o = p_get('order', array('id' => $order['relation_id']));
            $goods = p_get('integral_goods', array('id' => $o['goods_id']));

            $vote->change_integral($order['member_id'], $goods['exchange_number'], 3);

            p_update('order', array('is_pay' => 2), array('id' => $order['relation_id']));
        }

        return "<xml>
                <return_code>SUCCESS</return_code>
                </xml>";

    }


    public function doPageTe()
    {
        global $_W;

        $data = array(
            'touser' => 'lkk23112',
            'msgtype' => 'text',
            'text' => array(
                'content' => "<a href='http://www.qq.com' data-miniprogram-appid='{$_W['uniaccount']['key']}' data-miniprogram-path='bh_vote/pages/userGame/userGame?id=111'>点击跳小程序</a>"
            )
        );
        var_dump($data);
        $data = str_replace('\\', '', json_encode($data, JSON_UNESCAPED_UNICODE));
        var_dump($data);

        file_put_contents(IA_ROOT . '/101.txt', 'content:'  . var_export($data, true), FILE_APPEND);

        //var_dump($str);
        exit;
        $str = '{"touser":"lkk23112","msgtype":"text","text":{"content":"<a href="http:www.qq.com" data-miniprogram-appid="wx010b86c13349fb27" data-miniprogram-path="bh_votepagesuserGameuserGame?id=1111">点击跳小程序<a>"}}';

        $vote = new vote();
        $res = $vote->lottery(5);
        var_dump($res);
        var_dump($this->vote->error);
    }





    /**
     *
     */
    public function doPageKjCrontabDy()
    {
        $sql = ('SELECT * FROM ' . prefix('luck') . ' WHERE status = 1 AND complete = 2 AND lottery_type=1 AND lottery_value<=' . time() . get_uniacid());

        $lottery = p_fetchall($sql);
        $vote = new vote();
        if ($lottery) {
            foreach ($lottery as $value) {
                $vote->lottery($value['id']);
            }
        }

        $luck = p_getall('luck', array('send_msg' => 2));
        $dy_send_message_kj_id = getConfig('dy_send_message_kj_id');
        if ($luck) {
            $t = time() - (7 * 86400);
            global $_W;
            $option = array(
                'appid' => $_W['uniaccount']['key'],
                'secret' => $_W['uniaccount']['secret'],
            );
            $wxObj = new Wxadoc($option);

            foreach ($luck as $value) {
                $luck_goods =  p_getcolumn('luck_goods', array('luck_id' => $value['id']), 'name');
                $content = array(
                    'thing1' => array('value' => mb_substr($luck_goods, 0, 18)),
                    'thing2' => array('value' => "您参与的抽奖已开奖,点击查看"),
                );
                while (true) {
                    $participate = p_get('luck_participate', array('luck_id' => $value['id'], 'msg_status' => 1));
                    if (empty($participate)) {
                        p_update('luck', array('send_msg' => 3), array('id' => $value['id']));
                        //$f_form_id = p_fetch('SELECT * FROM ' . prefix('form_id') . " WHERE member_id={$value['member_id']} AND created > {$t}");
                        $f_openid = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'openid');
                        if ($f_openid) {
                            $content2 = array(
                                'thing1' => array('value' => mb_substr($luck_goods, 0, 18)),
                                'thing2' => array('value' => "您发起的抽奖正在开奖,点击查看"),
                            );
                            $s = $wxObj->sendSubscribe($f_openid, $dy_send_message_kj_id, 'bh_vote/pages/userGame/userGame?id=' . $value['id'], $content2);
                            var_dump($s);
                            p_update('luck_participate', array('msg_status' => 2), array('id' => $participate['id']));
                        }
                        break;
                    }
                    //$form_id = p_fetch('SELECT * FROM ' . prefix('form_id') . " WHERE member_id={$participate['member_id']} AND created > {$t}");
                    $openid = p_getcolumn('memberinfo', array('id' => $participate['member_id']), 'openid');
                    if ($openid) {
                        $s_s = $wxObj->sendSubscribe($openid, $dy_send_message_kj_id, 'bh_vote/pages/userGame/userGame?id=' . $value['id'], $content);
                        var_dump($s_s);
                    }

                    p_update('luck_participate', array('msg_status' => 2), array('id' => $participate['id']));
                }
            }



        }
        echo 'okKJ';
    }



    public function doPageRedTask()
    {

        $t = time();

        $sql = "UPDATE  " . prefix('luck_group') . " SET `status` = 3,open_time={$t} WHERE `type` = 2 AND `status` = 1 AND current_number < max_number AND end_time < {$t}";

        pdo_run($sql);

        $sql = " SELECT * FROM " . prefix('luck_group'). " WHERE `type` =2 AND send_msg = 1 AND status > 1 " . get_uniacid();
        $luckGroup = p_fetchall($sql);
        if ($luckGroup) {
            global $_W;
            $option = array(
                'appid' => $_W['uniaccount']['key'],
                'secret' => $_W['uniaccount']['secret'],
            );
            $wxObj = new Wxadoc($option);
            foreach ($luckGroup as $value) {
                $luckP = p_getall('luck_participate', array('group_id'=> $value['id'], 'msg_status' => 1));
                $luckGoods =  p_getcolumn('luck_goods', array('luck_id' => $value['luck_id']), 'name');
                if ($luckP) {
                    foreach ($luckP as $v) {
                    $openId =  p_getcolumn('memberinfo', array('id' => $v['member_id']), 'openid');
                    $content2 = array(
                        'thing1' => array('value' => mb_substr($luckGoods, 0, 18)),
                        'thing2' => array('value' => "您参与的抽奖正在开奖,点击查看"),
                    );
                    $s = $wxObj->sendSubscribe($openId, getConfig('dy_send_message_kj_id'), 'bh_vote/pages/userGame/userGame?id=' . $value['luck_id'], $content2);
                    var_dump($s);
                    p_update('luck_participate', array('msg_status' => 2), array('id' => $v['id']));
                    }
                }
                p_update('luck_group', array('send_msg' => 2), array('id' => $value['id']));
            }
        }
        echo 'ok';
    }

    /**
     *
     */
    public function doPageKjCrontabQq()
    {
        $sql = ('SELECT * FROM ' . prefix('luck') . ' WHERE status = 1 AND complete = 2 AND lottery_type=1 AND lottery_value<=' . time() . get_uniacid());

        $lottery = p_fetchall($sql);
        $vote = new vote();
        if ($lottery) {
            foreach ($lottery as $value) {
                $vote->lottery($value['id']);
            }
        }

        $luck = p_getall('luck', array('send_msg' => 2));
        $dy_send_message_kj_id = getConfig('dy_send_message_kj_id');
        if ($luck) {
            $t = time() - (7 * 86400);
            global $_W;
            $option = array(
                'appid' => $_W['uniaccount']['key'],
                'secret' => $_W['uniaccount']['secret'],
            );
            $QqObj = new Qqadoc($option);

            foreach ($luck as $value) {
                $luck_goods =  p_getcolumn('luck_goods', array('luck_id' => $value['id']), 'name');
                $content = array(
                    'keyword1' => array('value' => mb_substr($luck_goods, 0, 18)),
                    'keyword2' => array('value' => "您参与的抽奖已开奖,点击查看"),
                );
                while (true) {
                    $participate = p_get('luck_participate', array('luck_id' => $value['id'], 'msg_status' => 1));
                    if (empty($participate)) {
                        p_update('luck', array('send_msg' => 3), array('id' => $value['id']));
                        //$f_form_id = p_fetch('SELECT * FROM ' . prefix('form_id') . " WHERE member_id={$value['member_id']} AND created > {$t}");
                        $f_openid = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'openid');
                        if ($f_openid) {
                            $content2 = array(
                                'keyword1' => array('value' => mb_substr($luck_goods, 0, 18)),
                                'keyword2' => array('value' => "您发起的抽奖正在开奖,点击查看"),
                            );
                            $s = $QqObj->sendSubscribe($f_openid, $dy_send_message_kj_id, 'bh_vote/pages/userGame/userGame?id=' . $value['id'], $content2);
                            var_dump($s);
                            p_update('luck_participate', array('msg_status' => 2), array('id' => $participate['id']));
                        }
                        break;
                    }
                    //$form_id = p_fetch('SELECT * FROM ' . prefix('form_id') . " WHERE member_id={$participate['member_id']} AND created > {$t}");
                    $openid = p_getcolumn('memberinfo', array('id' => $participate['member_id']), 'openid');
                    if ($openid) {
                        $s_s = $QqObj->sendSubscribe($openid, $dy_send_message_kj_id, 'bh_vote/pages/userGame/userGame?id=' . $value['id'], $content);
                        var_dump($s_s);
                    }

                    p_update('luck_participate', array('msg_status' => 2), array('id' => $participate['id']));
                }
            }



        }
        echo 'okKJ';
    }
    /**
     *
     */
    public function doPageActivitySend()
    {
        while (true) {
            $subscribeQueue =  p_getall('subscribe_queue', array('status' => 1));
            if ($subscribeQueue) {
                global $_W;
                $option = array(
                    'appid' => $_W['uniaccount']['key'],
                    'secret' => $_W['uniaccount']['secret'],
                );
                $wxObj = new Wxadoc($option);
                $new_activities_id = getConfig('new_activities');
                foreach ($subscribeQueue as $value) {
                    $str = "SELECT * FROM " . prefix('subscribe'). " WHERE id >" .$value['subscribe_id'] . " AND new_activities > 0 AND uniacid =". UNIACID . " limit 10";
                    $memberData = p_fetchall($str);
                    if (empty($memberData)) {
                        p_update('subscribe_queue', array('status' => 2), array('id' => $value['id']));
                        continue;
                    }
                    $sendData = json_decode($value['content'], true);
                    $date = explode('-', $sendData['activityTime']);
                    $content = array(
                        'thing3' => array('value' => $sendData['activityName']),
                        'date2'  => array('value' => $date[0].'年'.$date[1]. '月'.$date[2].'日'),
                        'thing4' => array('value' => $sendData['activityText']),
                    );
                    foreach ($memberData as $val) {
                        $memberInfo = p_get('memberinfo', array('id' => $val['member_id']));
                        if ($memberInfo['openid']) {
                            if ($val['new_activities'] > 0) {
                                $s = $wxObj->sendSubscribe($memberInfo['openid'],  $new_activities_id , $sendData['skipUrl'], $content);
                                $returnData = json_decode($s, true);
                                if($returnData['errCode '] == 0) {
                                    $value['number']++;
                                    p_update('subscribe_queue', array('number' => $value['number'], 'subscribe_id' => $val['id']), array('id' => $value['id']));
                                }
                                p_update('subscribe', array('new_activities' => $val['new_activities'] -1), array('id' => $val['id']));
                                var_dump($returnData);
                            }
                        }
                    }
                }
            } else {
                break;
            }
        }


        echo 'okKJ';
    }

    /**
     *
     */
    public function doPageBonusLevel()
    {

        $year = date('Ymd');
        $activeTime = getConfig('updatedNumber');
        $vote = new vote();

        if (getConfig('open_dividend') != 1) {
            return false;
        }

        while (true) {
            $syn = p_fetch(' SELECT * FROM ' . prefix('crontab_clear_bonus_level'). ' WHERE uniacid = '. UNIACID . ' AND `year`= '. $year .' ORDER BY id DESC');
            if (empty($syn)) {
                $syn = array(
                    'member_id' => 0,
                    'year' => $year
                );
                p_insert('crontab_clear_bonus_level', $syn);
                $syn['id'] = pdo_insertid();

            }

            $mistiming = time() - ($activeTime * 86400);
            $bonus_level = getConfig('dividend_level');
            $sql = 'SELECT * FROM ' . prefix('memberinfo') . ' WHERE id > ' . $syn['member_id'] . ' AND fictitious = 1 AND updated > ' . $mistiming . '  AND bonus_level >= ' . $bonus_level . ' AND uniacid= ' . UNIACID . ' ORDER bY id ASC LIMIT 10';
            $data = pdo_fetchall($sql);
            if (empty($data)) {
                var_dump('已执行完');
                break;
            }

            $today_dividend_default = getConfig('today_dividend_default');
            try {
                pdo_begin();
                foreach ($data as $val) {
                    $memberLevel = $vote->memberDemotion($val['id']);
                    //$proportion = p_getcolumn('bonus_level', array('level' => $val['bonus_level']), 'proportion');
                    $proportion = p_getcolumn('bonus_level', array('level' => $memberLevel), 'proportion');

                    if ($proportion > 0) {
                        $money = number_format(($today_dividend_default * $proportion ) / 100, 2);
                        if (!$vote->change_money($val['id'], $money, 4)) {
                            throw new Exception($vote->error);
                        }
                    } else {
                        var_dump('当前等级设置的金额不对');
                    }
                    if (!p_update('crontab_clear_bonus_level', array('member_id' => $val['id']), array('id' => $syn['id']))) {
                        throw new Exception('写入失败');
                    }
                }
                pdo_commit();
            } catch (Exception $e) {
                pdo_rollback();
                echo $e->getMessage() .'\r\n';
                break;
            }
        }

    }



    public function doPageDemotionLevel()
    {
        $activeTime = getConfig('demotionNumber');
        $mistiming = time() - ($activeTime * 86400);
        $sql = 'UPDATE '. prefix('memberinfo'). ' SET bonus_level = bonus_level-1 WHERE fictitious =1 AND bonus_level > 0 AND updated < '. $mistiming . ' AND uniacid ='. UNIACID ;
        var_dump(p_fetchall($sql));
    }




    /**
     *
     */
    public function doPageActivitySendQq()
    {
        while (true) {
            $subscribeQueue =  p_getall('subscribe_queue', array('status' => 1));
            if ($subscribeQueue) {
                global $_W;
                $option = array(
                    'appid' => $_W['uniaccount']['key'],
                    'secret' => $_W['uniaccount']['secret'],
                );
                $QqObj = new Qqadoc($option);
                $new_activities_id = getConfig('new_activities');
                foreach ($subscribeQueue as $value) {
                    $str = "SELECT * FROM " . prefix('subscribe'). " WHERE id >" .$value['subscribe_id'] . " AND new_activities > 0 AND uniacid =". UNIACID . " limit 10";
                    $memberData = p_fetchall($str);
                    if (empty($memberData)) {
                        p_update('subscribe_queue', array('status' => 2), array('id' => $value['id']));
                        continue;
                    }
                    $sendData = json_decode($value['content'], true);
                    $date = explode('-', $sendData['activityTime']);
                    $content = array(
                        'keyword1' => array('value' => $sendData['activityName']),
                        'keyword2'  => array('value' => $date[0].'年'.$date[1]. '月'.$date[2].'日'),
                        'keyword3' => array('value' => $sendData['activityText']),
                    );
                    foreach ($memberData as $val) {
                        $memberInfo = p_get('memberinfo', array('id' => $val['member_id']));
                        if ($memberInfo['openid']) {
                            if ($val['new_activities'] > 0) {
                                $s = $QqObj->sendSubscribe($memberInfo['openid'],  $new_activities_id , $sendData['skipUrl'], $content);
                                $returnData = json_decode($s, true);
                                if($returnData['errCode '] == 0) {
                                    $value['number']++;
                                    p_update('subscribe_queue', array('number' => $value['number'], 'subscribe_id' => $val['id']), array('id' => $value['id']));
                                }
                                p_update('subscribe', array('new_activities' => $val['new_activities'] -1), array('id' => $val['id']));
                                var_dump($returnData);
                            }
                        }
                    }
                }
            } else {
                break;
            }
        }


        echo 'okKJ';
    }
    public function doPageSignRemind()
    {
        $time = strtotime(date('Y-m-d', time()));
        $vote = new vote();
        while (true) {
            $remind =  p_getall('remind', array('status' => 1, 'type' => 1, 'remind_day' => $time), array(), '', array(), 20);
            if ($remind) {
                global $_W;
                $option = array(
                    'appid' => $_W['uniaccount']['key'],
                    'secret' => $_W['uniaccount']['secret'],
                );
                $wxObj = new Wxadoc($option);
                $sign_subscribe_id = getConfig('sign_subscribe');

                $h = date('H');
                $i = date('i');
                $money_send_hour    = getConfig('earnings_send_hour');
                $money_send_minute  = getConfig('earnings_send_minute');

                $content = array(
                    'thing1'  => array('value' => "签到成功"),
                    'thing4'  => array('value' => "获得积分奖励"),
                    'thing8'  => array('value' => "连续签到奖励更丰厚哦!,点击查看"),
                );
                if ($sign_subscribe_id && ($money_send_hour < $h || ($money_send_hour == $h && $money_send_minute <= $i))) {
                    foreach ($remind as $value) {
                        if ($vote->is_sign($value['member_id'])) {
                            p_update('remind', array('status' => 3,'remind_time' => time()), array('id' => $value['id']));
                            continue;
                        }
                        $member = p_get('memberinfo', array('id' => $value['member_id']));
                        if ($member['openid']) {
                            $s = $wxObj->sendSubscribe($member['openid'], $sign_subscribe_id,'bh_vote/pages/index/index', $content);
                            var_dump($s);
                        }
                        p_update('remind', array('status' =>2,'remind_time' => time()), array('id' => $value['id']));
                    }
                }
            } else {
                break;
            }
        }

        echo 'okKJ';
    }
    /**
     *
     */
    public function doPageGjCrontab()
    {
        $time = time() - 1800;
        $sql = 'SELECT * FROM ' . prefix('senior_giving') . 'status = 1 AND confirm=2 AND created < ' . $time . get_uniacid();
        $data = p_fetchall($sql);

        if ($data) {
            foreach ($data as $value) {
                pdo_begin();
                if (!p_update('senior_giving', array('status' => 3, 'updated' => time()), array('id' => $value, 'status' => 1))) {
                    pdo_rollback();
                    continue;
                }
                $senior = p_get('senior_member', array('member_id' => $value['member_id']));
                $after = array(
                    'number' => $senior['number'] + $value['number']
                );
                if (!p_update('senior_member', $after, array('id' => $senior['id'], 'number' => $senior['number']))) {
                    pdo_rollback();
                    continue;
                }
                pdo_commit();
            }
        }
        echo 'okGJ';
    }






    /**
     *
     */
    public function doPageTPCrontabDy()
    {
        $time = time();
        $sql = "SELECT * FROM " . prefix('vote_activity') . " WHERE end_time<{$time} AND complete=2 AND status=2 AND vote_status=1 AND is_delete=1" . get_uniacid() ;

        $vote = p_fetchall($sql);

        if ($vote) {
            $m = new vote();
            foreach ($vote as $value) {
                $m->endVote($value['id']);
            }
        }

        $vote_activity = p_getall('vote_activity', array('vote_status' => 2, 'is_delete' => 1, 'send_msg' => 1));

        if ($vote_activity) {

            $dy_send_message_tp_id = getConfig('dy_send_message_tp_id');
            $t = time() - (7 * 86400);
            global $_W;
            $option = array(
                'appid' => $_W['uniaccount']['key'],
                'secret' => $_W['uniaccount']['secret'],
            );
            $wxObj = new Wxadoc($option);

            foreach ($vote_activity as $value) {
                $content = array(
                    'thing1' => array('value' => $value['title']),
                    'thing2' => array('value' => "您参与投票已经结束,点击查看"),
                );
                while (true) {
                    $vote_join = p_get('vote_join', array('activity_id' => $value['id'], 'msg_status' => 1));
                    if (empty($vote_join)) {
                        p_update('vote_activity', array('send_msg' => 3), array('id' => $value['id']));
                        //$f_form_id = p_fetch('SELECT * FROM ' . prefix('form_id') . " WHERE member_id={$value['member_id']} AND created > {$t}");
                        $f_openid = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'openid');
                        if ($f_openid) {
                            $content2 = array(
                                'thing1' => array('value' => $value['title']),
                                'thing2' => array('value' => "您发起的投票已经结束,点击查看投票结果"),
                            );
                            $wxObj->sendSubscribe($f_openid, $dy_send_message_tp_id, 'bh_vote/pages/userGame/userGame?id=' . $value['id'], $content2);
                            p_update('vote_join', array('msg_status' => 2), array('id' => $vote_join['id']));
                        }
                        break;
                    }
                    //$form_id = p_fetch('SELECT * FROM ' . prefix('form_id') . " WHERE member_id={$vote_join['uid']} AND created > {$t}");
                    $openid = p_getcolumn('memberinfo', array('id' => $vote_join['uid']), 'openid');
                    if ($openid) {
                        $wxObj->sendSubscribe($openid, $dy_send_message_tp_id,'bh_vote/pages/vote/index/index?id=' . $value['id'], $content);
                    }

                    p_update('vote_join', array('msg_status' => 2), array('id' => $vote_join['id']));

                    //p_update('luck_participate', array('msg_status' => 2), array('id' => $vote_join['id']));
                }
            }
        }
        echo 'TpOk';
    }

    /**
     *
     */
    public function doPageTPCrontabQq()
    {
        $time = time();
        $sql = "SELECT * FROM " . prefix('vote_activity') . " WHERE end_time<{$time} AND complete=2 AND status=2 AND vote_status=1 AND is_delete=1" . get_uniacid() ;

        $vote = p_fetchall($sql);

        if ($vote) {
            $m = new vote();
            foreach ($vote as $value) {
                $m->endVote($value['id']);
            }
        }

        $vote_activity = p_getall('vote_activity', array('vote_status' => 2, 'is_delete' => 1, 'send_msg' => 1));

        if ($vote_activity) {

            $dy_send_message_tp_id = getConfig('dy_send_message_tp_id');
            $t = time() - (7 * 86400);
            global $_W;
            $option = array(
                'appid' => $_W['uniaccount']['key'],
                'secret' => $_W['uniaccount']['secret'],
            );
            $QqObj = new Qqadoc($option);

            foreach ($vote_activity as $value) {
                $content = array(
                    'keyword1' => array('value' => $value['title']),
                    'keyword2' => array('value' => "您参与投票已经结束,点击查看"),
                );
                while (true) {
                    $vote_join = p_get('vote_join', array('activity_id' => $value['id'], 'msg_status' => 1));
                    if (empty($vote_join)) {
                        p_update('vote_activity', array('send_msg' => 3), array('id' => $value['id']));
                        //$f_form_id = p_fetch('SELECT * FROM ' . prefix('form_id') . " WHERE member_id={$value['member_id']} AND created > {$t}");
                        $f_openid = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'openid');
                        if ($f_openid) {
                            $content2 = array(
                                'keyword1' => array('value' => $value['title']),
                                'keyword2' => array('value' => "您发起的投票已经结束,点击查看投票结果"),
                            );
                            $a = $QqObj->sendSubscribe($f_openid, $dy_send_message_tp_id, 'bh_vote/pages/userGame/userGame?id=' . $value['id'], $content2);
                            var_dump($a);
                            p_update('vote_join', array('msg_status' => 2), array('id' => $vote_join['id']));
                        }
                        break;
                    }
                    //$form_id = p_fetch('SELECT * FROM ' . prefix('form_id') . " WHERE member_id={$vote_join['uid']} AND created > {$t}");
                    $openid = p_getcolumn('memberinfo', array('id' => $vote_join['uid']), 'openid');
                    if ($openid) {
                        $b = $QqObj->sendSubscribe($openid, $dy_send_message_tp_id,'bh_vote/pages/vote/index/index?id=' . $value['id'], $content);
                        var_dump($b);
                    }

                    p_update('vote_join', array('msg_status' => 2), array('id' => $vote_join['id']));

                    //p_update('luck_participate', array('msg_status' => 2), array('id' => $vote_join['id']));
                }
            }
        }
        echo 'TpOk';
    }

    /**
     * 同步
     */
    public function doPageSyn()
    {
        $uniacid = 70;
        $syn = pdo_get('bh_vl_syn', array('uniacid' => $uniacid));

        if (empty($syn)) {
            return;
        }

        while (true) {
            $sql = 'SELECT * FROM ims_tech_vote_activity WHERE id>' . $syn['tech_vote_activity'] . ' AND uniacid=70 LIMIT 3';

            $data = pdo_fetchall($sql);
            if (empty($data)) {
                break;
            }
            foreach ($data as $value) {
                try{
                    pdo_begin();
                    $syn['tech_vote_activity'] = $value['id'];
                    if (!pdo_update('bh_vl_syn', array('tech_vote_activity' => $value['id']), array('id' => $syn['id']))) {
                        throw new Exception('同步失败1');
                    }

                    $thumb = unserialize($value['thumb']);
                    $intro_img = unserialize($value['intro_img']);
                    $share_thumb = unserialize($value['share_thumb']);


                    $insert = array(
                        'id' => $value['id'],
                        'uniacid' => $uniacid,
                        'member_id' => $value['uid'],
                        'template_id' => 23,
                        'title' => $value['title'],
                        'cover_image' => $thumb[0],
                        'describe' => $value['intro'],
                        'describe_img' => json_encode($intro_img),
                        'is_repeat' => $value['tp_repeat_enabled'] + 1,
                        'day_votes' => $value['tp_everyday_num'],
                        'with_ip_num' => $value['dq_ip_num'],
                        'share_thumb' => isset($share_thumb[0]) ? $share_thumb[0] : '',
                        'sponsor_enabled' => $value['sponsor_enabled'] + 1,
                        'sponsor_name' => $value['sponsor_name'],
                        'sponsor_phone' => $value['sponsor_phone'],
                        'sign_enabled' => $value['sign_enabled'] + 1,
                        'sign_phone' => $value['sign_phone_need'] + 1,
                        'sign_wx' => $value['sign_wechat_need'] + 1,
                        'sign_start_time' => $value['sign_start_time'],
                        'sign_end_time' => $value['sign_stop_time'],
                        'start_time' => $value['vote_start_time'],
                        'end_time' => $value['vote_stop_time'],
                        'created' => $value['c_time'],
                        'join_num' => $value['tj_join_num'],
                        'vote_num' => $value['tj_vote_num'],
                        'view_num' => $value['tj_view_num'],
                        'status' => $value['checked'],
                        'complete' => 2,
                        'source' => 2
                    );
                    if ($insert['region_type'] == 2 && $value['dq_value']) {
                        $dq_value = explode(',', $value['dq_value']);

                        $r = array();
                        if ($dq_value[0] != '全部') {
                            foreach ($dq_value as $value) {
                                if ($value != '全部') {
                                    $r[] = $value;
                                }
                            }
                            if ($r) {
                                $insert['region_type'] = 2;
                                $insert['region'] = json_encode($r);
                            }
                        }

                    }
                    if (!pdo_insert('bh_vl_vote_activity', $insert)) {
                        throw new Exception('同步失败2');
                    }

                    if ($value['reward']) {
                        $value['reward_img'] = unserialize($value['reward_img']);


                        $reward = array(
                            'vote_id' => $value['id'],
                            'member_id' => $value['uid'],
                            'name' => $value['reward'],
                            'image' => $value['reward_img'][0],
                            'uniacid' => $uniacid,
                            'created' => time()
                        );
                        if (!pdo_insert('bh_vl_vote_goods', $reward)) {
                            throw new Exception('同步失败3');
                        }
                        $insert_id = pdo_insertid();
                        $reward['vote_goods_id'] = $insert_id;

                        if (!pdo_insert('bh_vl_vote_goods_info', $reward)) {
                            throw new Exception('同步失败4');
                        }

                    }
                    pdo_commit();

                }catch (Exception $e){
                    pdo_rollback();
                    echo $e->getMessage() .'\r\n';
                    break;
                }
            }
        }

        echo 'ok1';

        while (true) {
            $sql = 'SELECT * FROM ims_tech_vote_join WHERE id>' . $syn['tech_vote_join'] . ' AND uniacid=70 LIMIT 10';

            $data = pdo_fetchall($sql);
            if (empty($data)) {
                break;
            }
            foreach ($data as $value) {
                try{
                    pdo_begin();
                    $syn['tech_vote_join'] = $value['id'];
                    if (!pdo_update('bh_vl_syn', array('tech_vote_join' => $value['id']), array('id' => $syn['id']))) {
                        throw new Exception('同步失败5');
                    }
                    $thumb = unserialize($value['thumb']);
                    $share_thumb = unserialize($value['share_thumb']);

                    $insert = array(
                        'uniacid' => $uniacid,
                        'name' => $value['name'],
                        'phone' => $value['phone'],
                        'wechat' => $value['wechat'],
                        'thumb' => json_encode($thumb),
                        'share_thumb' => $share_thumb[0],
                        'intro' => $value['intro'],
                        'status' => $value['status'],
                        'c_time' => $value['c_time'],
                        'activity_id' => $value['activity_id'],
                        'uid' => $value['uid'],
                        'vote_num' => $value['vote_num'],
                        'v_time' => $value['v_time'],
                    );
                    if (!pdo_insert('bh_vl_vote_join', $insert)) {
                        throw new Exception('同步失败6');
                    }
                    pdo_commit();

                }catch (Exception $e){
                    pdo_rollback();
                    echo $e->getMessage() .'\r\n';
                    break;
                }
            }
        }
        echo 'ok2';

        while (true) {
            $sql = 'SELECT * FROM ims_tech_vote_memberinfo WHERE id>' . $syn['tech_vote_memberinfo'] . ' AND uniacid=70 LIMIT 10';

            $data = pdo_fetchall($sql);
            if (empty($data)) {
                break;
            }
            foreach ($data as $value) {
                try{
                    pdo_begin();
                    $syn['tech_vote_memberinfo'] = $value['id'];
                    if (!pdo_update('bh_vl_syn', array('tech_vote_memberinfo' => $value['id']), array('id' => $syn['id']))) {
                        throw new Exception('同步失败');
                    }
                    $insert = array(
                        'id' => $value['id'],
                        'uniacid' => $uniacid,
                        'openid' => $value['openid'],
                        'nickname' => $value['nickname'],
                        'headimgurl' => $value['headimgurl'],
                        'sex' => $value['sex'],
                        'country' => $value['country'],
                        'province' => $value['province'],
                        'city' => $value['city'],
                        'activity_fq_num' => $value['activity_fq_num'],
                        'activity_bm_num' => $value['activity_bm_num'],
                        'activity_cy_num' => $value['activity_cy_num'],
                        'activity_ll_num' => $value['activity_ll_num'],
                    );
                    if (!pdo_insert('bh_vl_memberinfo', $insert)) {
                        throw new Exception('同步失败7');
                    }
                    pdo_commit();
                }catch (Exception $e){
                    pdo_rollback();
                    echo $e->getMessage() .'\r\n';
                    break;
                }
            }
        }
        echo 'ok3';


        while (true) {
            $sql = 'SELECT * FROM ims_tech_vote_vote_log WHERE id>' . $syn['tech_vote_vote_log'] . ' AND uniacid=70 LIMIT 10';

            $data = pdo_fetchall($sql);
            if (empty($data)) {
                break;
            }
            foreach ($data as $value) {
                try{
                    pdo_begin();
                    $syn['tech_vote_vote_log'] = $value['id'];
                    if (!pdo_update('bh_vl_syn', array('tech_vote_vote_log' => $value['id']), array('id' => $syn['id']))) {
                        throw new Exception('同步失败');
                    }
                    $today = strtotime(date('Y-m-d', $value['c_time']));
                    $insert = array(
                        'uniacid' => $uniacid,
                        'uid' => $value['uid'],
                        'activity_id' => $value['activity_id'],
                        'join_id' => $value['join_id'],
                        'c_time' => $value['c_time'],
                        'ip' => $value['ip'],
                        'today' => $today
                    );
                    if (!pdo_insert('bh_vl_vote_vote_log', $insert)) {
                        throw new Exception('同步失败8');
                    }
                    pdo_commit();
                }catch (Exception $e){
                    pdo_rollback();
                    echo $e->getMessage() .'\r\n';
                    break;
                }
            }
        }

        echo 'ok4';

    }



    public function doPageChallengeCrontab()
    {
        $challenge = p_getall('challenge', array('is_del' => 1));

        $today = strtotime(date('Y-m-d', time()));
        if ($challenge) {
            $tomorrow = $today + 86400;
            foreach ($challenge as $value) {
                if (!p_get('challenge_stage', array('challenge_id' => $value['id'], 'days' => $tomorrow))) {
                    p_insert('challenge_stage', array(
                        'challenge_id' => $value['id'],
                        'stage' => date('Ymd', time()),
                        'fictitious_number' => $value['fictitious_number'],
                        'is_video' => $value['is_video'],
                        'step_number' => $value['step_number'],
                        'currency' => $value['currency'],
                        'days' => $tomorrow,
                        'created' => time()
                    ));
                }
            }
        }
        $yesterday = $today - 86400;
        //p_update('challenge_member', array('handle' => 2), array('days' => $yesterday, 'handle' => 1, 'status' => 1));

        $stage = p_getall('challenge_stage', array('days' => $yesterday));

        include 'model/shop.mod.php';

        $mShop = new shopModel;

        if ($stage) {
            $reward = array();
            foreach ($stage as $value) {
                if (!isset($reward[$value['id']])) {
                    $all_count = p_getcolumn('challenge_member', array('challenge_stage_id' => $value['id']), 'COUNT(*)') ? : 0;
                    $succ_count = p_getcolumn('challenge_member', array('challenge_stage_id' => $value['id'], 'status' => 2), 'COUNT(*)') ? : 0;

                    if ($all_count < 1 || $succ_count < 1) {
                        continue;
                    }
                    $reward[$value['id']] = round(($all_count * $value['currency']) / $succ_count, 2);

                    if ($reward[$value['id']] <= 0) {
                        continue;
                    }
                }
                while (true) {
                    $info = p_get('challenge_member', array('challenge_stage_id' => $value['id'], 'status' => 2, 'handle' => 1));

                    if (empty($info)) {
                        break;
                    }
                    $u = array(
                        'currency' => $reward[$value['id']],
                        'handle' => 2
                    );
                    pdo_begin();
                    if (!p_update('challenge_member', $u, array('id' => $info['id'], 'handle' => 1))) {
                        pdo_rollback();
                        break;
                    }
                    if (!$mShop->change_currency($info['member_id'], $reward[$value['id']], 7)) {
                        pdo_rollback();
                        break;
                    }

                    pdo_commit();
                }
            }
        }


        json('challenge');
    }

    /**
     * 加积分
     * 减积分
     * type 1 加 2 减
     */
    public function doPageHandleIntegral()
    {
        global $_GPC;
        $_GPC['contr'] = 'noLogin';
        $cont = new  bhCommon();

        $sign   = $cont->get('sign');
        $mobile = $cont->get('mobile');
        $number = $cont->get('number');
        $type   = $cont->get('type');
        $remark = $cont->get('remark');
        $checkSign = $this->autograph(array('mobile' => $mobile,'number' => $number,'type' => $type, 'remark' => $remark));
        if ($sign != $checkSign) {
            json('校验不正确', 0);
        }
        if (!$this->isMobile($mobile)) {
            json('手机号不正确', 0);
        }
        $member = p_get('memberinfo', array('phone' => $mobile));
        if (!$member) {
            json('用户不存在', 0);
        }
        $type = $type == 1 ? 5 : 6;
        if (!$cont->vote->change_integral($member['id'], $number, $type , $remark)) {
            json($cont->vote->error, 0);
        }
        json('操作成功', 1);

    }

    /**
     * 查询积分
     *
     */
    public function doPageQueryIntegral()
    {
        global $_GPC;
        $_GPC['contr'] = 'noLogin';
        $cont = new  bhCommon();

        $sign   = $cont->get('sign');
        $mobile = $cont->get('mobile');
        $checkSign = $this->autograph(array('mobile' => $mobile));
        if ($sign != $checkSign) {
            json('校验不正确', 0);
        }
        $member = p_get('memberinfo', array('phone' => $mobile));
        json(array('integral' => $member['integral']), 1);
    }

    /**
     * 积分明细
     */
    public function doPageIntegralList()
    {
        global $_GPC;
        $_GPC['contr'] = 'noLogin';
        $cont = new  bhCommon();

        $sign   = $cont->get('sign');
        $mobile = $cont->get('mobile');
        $page   = $cont->get('page', 1);
        $limit  = $cont->get('limit', 10);
        $sequence = "id";
        $desc     = "DESC";
        $checkSign = $this->autograph(array('mobile' => $mobile, 'page' => $page, 'limit' => $limit));
        if ($sign != $checkSign) {
            json('校验不正确', 0);
        }
        $table = prefix('integral_log');

        $member = p_get('memberinfo', array('phone' => $mobile));
        if (!$member) {
            json('用户不存在', 0);
        }
        $where = "member_id = {$member['id']} AND uniacid = ". UNIACID;
        $list   = p_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY {$sequence} {$desc} LIMIT ".($page - 1) * $limit.','.$limit);
        $total  = p_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");
        if ($list) {
            foreach ($list as & $value) {
                $value['nickname'] = p_getall('memberinfo', array('id' => $value['member_id']), 'nickname');
            }
        }
        json(array('list' => $list, 'total' =>$total, 'page' => $page), 1);
    }

    public function doPageGetUser()
    {
        global $_GPC;
        $_GPC['contr'] = 'noLogin';
        $cont = new  bhCommon();

        $sign   = $cont->get('sign');
        $member_id = $cont->get('member_id');
        $start = $cont->get('start');
        $end   = $cont->get('end');
        $page  = $cont->get('page', 1);
        $limit = $cont->get('limit', 10);

        $checkSign = $this->autograph(array('member_id' => $member_id, 'start' => $start, 'end' => $end, 'page' => $page, 'limit' => $limit));
        if ($sign != $checkSign) {
            json('校验不正确', 0);
        }
        $table = prefix('memberinfo');
        $where = "uniacid = ". UNIACID;

        if ($member_id) {
            $where .= " AND id = {$member_id}";
        }
        if ($start && $end) {
            $where .= " AND u_time between {$start} AND {$end}";
        }
        $list   = p_fetchall('SELECT id, headimgurl, nickname, c_time, u_time,integral,unionid FROM '.$table." WHERE {$where} ORDER BY u_time DESC LIMIT ".($page - 1) * $limit.','.$limit);
        $total  = p_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");

        json(array('list' => $list, 'total' => $total, 'page' => $page), 1);

    }

    /**
     * 组合查询
     */
    public function doPageGroupingIntegral()
    {
        global $_GPC;
        $_GPC['contr'] = 'noLogin';
        $cont       = new  bhCommon();
        $integral_id = $cont->get('integral_id');
        $member_id  = $cont->get('member_id');
        $type       = $cont->get('type');
        $change     = $cont->get('change'); // 1 增加 2 减少
        $integral_start = $cont->get('integral_start');
        $integral_end = $cont->get('integral_end');
        $sign       = $cont->get('sign');
        $page  = $cont->get('page', 1);
        $limit = $cont->get('limit', 10);
        $checkSign  = $this->autograph(array(
                'integral_id'   => $integral_id,
                'member_id'     => $member_id,
                'type'          => $type,
                'change'        => $change,
                'integral_start'=> $integral_start,
                'integral_end'  => $integral_end,
                'page'          => $page,
                'limit'         => $limit,
            ));
        if ($sign != $checkSign) {
            json('校验不正确', 0);
        }

        if (empty($integral_start) || empty($integral_end)) {
            json('积分查询的时间不正确', 0);
        }

        $table = prefix('integral_log');
        $where = "uniacid = ". UNIACID;

        if ($change ==1) {
            $where .= " AND type in (1, 2, 4, 5)";
        }
        if ($change ==2){
            $where .= " AND type not in (1, 2, 4, 5)";
        }
        if ($type) {
            $where .= " AND type ={$type}";
        }
        if ($member_id) {
            $where .= " AND member_id = {$member_id}";
        }
        if ($integral_id) {
            $where .= " AND id = {$integral_id}";
        }
        if ($integral_start && $integral_end) {
            $where .= " AND created between {$integral_start} AND {$integral_end}";
        }
        $list   = p_fetchall('SELECT id, member_id, `type`, integral, after_integral,created,remarks FROM '.$table." WHERE {$where} ORDER BY id DESC LIMIT ".($page - 1) * $limit.','.$limit);
        if ($list){
            foreach ($list as & $value) {
                $value['change'] = in_array($value['type'], array(1,2,4,5)) ? 1 : 2 ;
            }
        }
        $total  = p_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");
        json(array('list' => $list, 'total' => $total, 'page' => $page), 1);
    }

    public function doPageIdIntegral()
    {
        global $_GPC;
        $_GPC['contr'] = 'noLogin';
        $cont = new  bhCommon();

        $sign   = $cont->get('sign');
        $member_id = $cont->get('member_id');
        $number = $cont->get('number');
        $type   = $cont->get('type');
        $remark = $cont->get('remark');
        $rise_time = $cont->get('rise_time');
        $checkSign = $this->autograph(array('member_id' => $member_id,'number' => $number,'type'   => $type, 'rise_time' => $rise_time));
        if ($sign != $checkSign) {
            json('校验不正确', 0);
        }
        $member = p_get('memberinfo', array('id' => $member_id));
        if (!$member) {
            json('用户不存在', 0);
        }
        $type = $type == 1 ? 5 : 6;
        if (!$cont->vote->change_integral($member['id'], $number, $type , $remark, $rise_time)) {
            json($cont->vote->error, 0);
        }
        json('操作成功', 1);
    }

    public function doPageAugment()
    {
        $data = p_getall('memberinfo');
        /**
         *           $type = array(
        1 => '签到',
        2 => '签到翻倍',
        3 => '兑换礼品',
        4 => '完成任务',
        5 => '接口加积分',
        6 => '接口减积分',
        7 => '积分抽奖',
        8 => '取消订单,退回积分',
        9 => '积分清零'

        );
         */
        if ($data) {
            foreach ($data as $val) {
                $dataI = array(
                    'integral'  =>  8,
                    'member_id' => $val['id'],
                    'type'      => 3,
                    'same_day'  => date('Ymd'),
                    'after_integral' => 17,
                    'remarks' => '兑换礼品',
                    'created' =>   strtotime(date('Y-06-15',strtotime('-1 year')))
                );
                p_insert('integral_log', $dataI);
            }
        }
    }

    /**
     * 清除积分
     */
    public function doPageResetTheTime()
    {
        $clearTime = getConfig('resetTheTime');
        $year = date('Y');
        $time      = time();
        $month = date('m', $clearTime); // 月
        $day = date('d', $clearTime);  // 日
        $minutes = date('H', $clearTime);
        $points = date('i', $clearTime);
        $seconds = date('s', $clearTime);
        $thisYear = strtotime($year. '-'. $month. '-'. $day .' ' . $minutes. ':'. $points. ':'. $seconds);
        $year = date('Y',strtotime('-1 year'));
        // 执行时间要大于清零的时间
        if ($time > $thisYear) {
            // 上一年 最后一秒时间
            $lastYear = strtotime(date('Y-12-31', strtotime('-1 year'))) + 86400 -1;
            // 1, 2, 4, 5, 8  integral_log 是新增  非（1, 2, 4, 5, 8） 是消耗
            $vote = new vote();
            while (true) {
                $syn = p_fetch(' SELECT * FROM ' . prefix('crontab_clear_integral'). ' WHERE uniacid = '. UNIACID . ' AND `year`= '. $year .' ORDER BY id DESC');
                if (empty($syn)) {
                    $syn = array(
                        'member_id' => 0,
                        'time' => $time,
                        'year' => $year
                    );
                    p_insert('crontab_clear_integral', $syn);
                    $syn['id'] = pdo_insertid();

                }
                $sql = 'SELECT * FROM ' . prefix('memberinfo') . ' WHERE id >' . $syn['member_id'] . '  AND uniacid= ' . UNIACID . ' ORDER bY id ASC LIMIT 10';
                $data = pdo_fetchall($sql);

                if (empty($data)) {
                    var_dump('已执行完');
                    break;
                }
                try {
                    pdo_begin();
                    foreach ($data as $val) {
                            // 上一年度总的积分
                            $memberCountIntegral = p_fetch('SELECT SUM(integral) as integralCont FROM ' . prefix('integral_log'). ' WHERE member_id = '. $val['id'] . ' AND `type` IN (1,2,4,5,8) AND created <= '. $lastYear);
                            // 要获取设置这个时间内所消耗的积分
                            $memberIdTimeIntegral = p_fetch(' SELECT SUM(integral) as integral FROM ' . prefix('integral_log'). ' WHERE  member_id = '.$val['id']. ' AND `type` NOT IN (1,2,4,5,8) AND created <= '.$clearTime);

                            $integralPoor =  $memberCountIntegral['integralCont'] - $memberIdTimeIntegral['integral'];

                            $clearData = array('member_id' => $val['id']);
                            if ($integralPoor > 0) {
                                if ($val['integral'] < $integralPoor) {
                                    $integralPoor = $val['integral'];
                                }
                                $integral = $val['integral'] > $integralPoor ? $integralPoor : $val['integral'];
                                if (!$vote->change_integral($val['id'], $integral , 9)) {
                                    throw new Exception($vote->error);
                                }

                            }
                            if (!p_update('crontab_clear_integral', $clearData, array('id' => $syn['id']))) {
                                throw new Exception('写入失败');
                            }
                    }
                    pdo_commit();
                } catch (Exception $e) {
                    pdo_rollback();
                    echo $e->getMessage() .'\r\n';
                    break;
                }
            }
        }

    }
    /**
     *
     * @param $data
     * @return string
     */
    protected  function autograph($data)
    {
        ksort($data);
        $str = '';
        foreach ($data as $k => $value) {
            $str .= ($k . $value);
        }
        $integral_key = getConfig('integral_key');
        $str = ($integral_key . $str . $integral_key);
        return strtoupper(md5($str));
    }


    protected  function isMobile($mobile)
    {
        if (!is_numeric($mobile)) {
            return false;
        }
        return preg_match('#^13[\d]{9}$|^14[5,7]{1}\d{8}$|^15[^4]{1}\d{8}$|^17[0,6,7,8]{1}\d{8}$|^18[\d]{9}$#', $mobile) ? true : false;
    }




    public function doPageBounce()
    {
        define('IN_SYS', true);
        $openlink = urldecode($_GET['openlink']);

        include $this->template('bounce');
    }


    /**
     *
     */
    public function doPageReal()
    {
        $uniacid = get_uniacid();
        $sql = 'SELECT * FROM ' . prefix('luck') . ' WHERE `status` = 1 AND `is_delete` = 1 AND `automatic` = 3' . $uniacid;

        $data = p_fetchall($sql);
        $automatic_minute = getConfig('automatic_minute', 0);
        if ($data && $automatic_minute > 0) {
            $limit = floor($automatic_minute) * 2;

            $vote = new vote();

            foreach ($data as $value) {
                $insert = array(
                    'luck_id' => $value['id'],
                    'shop_id' => $value['shop_id'],
                    'created' => time(),
                );
                $sql1 = 'SELECT member_id FROM ' . prefix('luck_participate') . ' WHERE luck_id= ' . $value['id'];
                $sql2 = 'SELECT id FROM ' . prefix('memberinfo') . " WHERE `fictitious` = 2 AND `id` NOT IN({$sql1}) {$uniacid} ORDER BY RAND() LIMIT {$limit}";
                if ($m = p_fetchall($sql2)) {
                    foreach ($m as $line) {
                        $insert['member_id'] = $line['id'];
                        p_insert('luck_participate', $insert);
                        //$id = pdo_insertid();
                        if ($value['luck_mode'] == 3) {
                            $vote->create_luck_code($line['id'], $value['id']);
                        }
                        if ($value['lottery_type'] == 2) {
                            $count = p_getcolumn('luck_participate', array('luck_id' => $value['id']), 'COUNT(*)') ? : 0;
                            if ($count >= $value['lottery_value']) {
                                $vote->lottery($value['id']);
                                break;
                            }
                        }
                    }

                }

            }

        }

        echo 'ok';

    }

}