var utils = {
    _interopRequireDefault: function(t) {
        return t && t.__esModule ? t : {
            default: t
        };
    },
    tipsBox: function(t, e, r, n, i) {
        null == e && (e = "none"), null == r && (r = 1200), null == n && (n = !0), null == i && (i = ""), 
        wx.showToast({
            title: t,
            icon: e,
            duration: r,
            mask: n,
            image: i
        });
    },
    isNullOrEmpty: function(t) {
        return null === t || "" === t || void 0 === t;
    },
    isNull: function(t) {
        return null === t;
    },
    isNullTo: function(t) {
        return null === t ? "" : t;
    },
    isMobile: function(t) {
        return /^(?:13\d|14\d|15\d|16\d|17\d|18\d|19\d)\d{5}(\d{3}|\*{3})$/.test(t);
    },
    isFloat: function(t) {
        return /^([0-9]*[.]?[0-9])[0-9]{0,1}$/.test(t);
    },
    isFloatTo: function(t) {
        return utils.isFloat ? t : t.toFixed(2);
    },
    isNum: function(t) {
        return /^[0-9]+$/.test(t);
    },
    formatNum: function(t) {
        return utils.isMobile(t) && (t = t.replace(/^(\d{3})\d{4}(\d{4})$/, "$1****$2")), 
        t;
    },
    isEmail: function(t) {
        return /^[a-z0-9]+([._\\-]*[a-z0-9])*@([a-z0-9]+[-a-z0-9]*[a-z0-9]+.){1,63}[a-z0-9]+$/.test(t);
    },
    isChinese: function(t) {
        return "" !== t && /^[\u0391-\uFFE5]+$/.test(t) && !form.isSpecial(t) && !form.isEmoji(t);
    },
    isEnglish: function(t) {
        return /^[a-zA-Z]*$/.test(t);
    },
    isEnAndNo: function(t) {
        return /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{8,20}$/.test(t);
    },
    isSpecial: function(t) {
        return !(!/[`~!@#$%^&*()_+<>?:"{},.\/;'[\]]/im.test(t) && !/[·！#￥（——）：；“”‘、，|《。》？、【】[\]]/im.test(t));
    },
    isEmoji: function(t) {
        return /\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F]/g.test(t);
    },
    isDate: function(t) {
        var e = 1 < arguments.length && void 0 !== arguments[1] ? arguments[1] : "-";
        return new RegExp("^(?:(?!0000)[0-9]{4}" + e + "(?:(?:0[1-9]|1[0-2])" + e + "(?:0[1-9]|1[0-9]|2[0-8])|(?:0[13-9]|1[0-2])" + e + "(?:29|30)|(?:0[13578]|1[02])" + e + "31)|(?:[0-9]{2}(?:0[48]|[2468][048]|[13579][26])|(?:0[48]|[2468][048]|[13579][26])00)" + e + "02" + e + "29)$").test(t);
    },
    isUrl: function(t) {
        return /^((https?|ftp|file):\/\/)?([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?$/.test(t);
    },
    isContains: function(t, e) {
        return -1 != t.indexOf(e);
    },
    sort: function(r) {
        var n = 1 < arguments.length && void 0 !== arguments[1] ? arguments[1] : 3;
        return r.sort(function(t, e) {
            switch (n) {
              case 1:
                return t - e;

              case 2:
                return e - t;

              case 3:
                return Math.random() - .5;

              default:
                return r;
            }
        });
    },
    unique: function(t) {
        if (Array.hasOwnProperty("from")) return Array.from(new Set(t));
        for (var e = {}, r = [], n = 0; n < t.length; n++) e[t[n]] || (e[t[n]] = !0, r.push(t[n]));
        return r;
    },
    deteleObject: function(t) {
        return t = Array.from(new Set(t));
    },
    distinct: function(t) {
        var e = [], r = {}, n = !0, i = !1, u = void 0;
        try {
            for (var s = t[Symbol.iterator](); !(n = (o = s.next()).done); n = !0) {
                var o = o.value;
                r[o] || (e.push(o), r[o] = 1);
            }
        } catch (t) {
            i = !0, u = t;
        } finally {
            try {
                !n && s.return && s.return();
            } finally {
                if (i) throw u;
            }
        }
        return e;
    },
    union: function(t, e) {
        e = t.concat(e);
        return (void 0).unique(e);
    },
    intersect: function(t, e) {
        var r = void 0;
        return t = (void 0).unique(t), (void 0).map(t, function(t) {
            return r.contains(e, t) ? t : null;
        });
    },
    removeTo: function(t, e) {
        e = t.indexOf(e);
        return -1 < e && t.splice(e, 1), t;
    },
    formArray: function(t) {
        return Array.isArray(t) ? t : Array.prototype.slice.call(t);
    },
    GetMax: function(t) {
        return Math.max.apply(null, arr);
    },
    GetMin: function(t) {
        return Math.min.apply(null, arr);
    },
    GetSum: function(t) {
        return t.reduce(function(t, e) {
            return t + e;
        });
    },
    GetAverage: function(t) {
        return (void 0).sum(t) / t.length;
    },
    removeTrim: function(t, e) {
        switch (e = e || 1) {
          case 1:
            return t.replace(/\s+/g, "");

          case 2:
            return t.replace(/(^\s*)|(\s*$)/g, "");

          case 3:
            return t.replace(/(^\s*)/g, "");

          case 4:
            return t.replace(/(\s*$)/g, "");

          default:
            return t;
        }
    },
    changeCase: function(t, e) {
        switch (e = e || 4) {
          case 1:
            return t.replace(/\b\w+\b/g, function(t) {
                return t.substring(0, 1).toUpperCase() + t.substring(1).toLowerCase();
            });

          case 2:
            return t.replace(/\b\w+\b/g, function(t) {
                return t.substring(0, 1).toLowerCase() + t.substring(1).toUpperCase();
            });

          case 3:
            return t.split("").map(function(t) {
                return /[a-z]/.test(t) ? t.toUpperCase() : t.toLowerCase();
            }).join("");

          case 4:
            return t.toUpperCase();

          case 5:
            return t.toLowerCase();

          default:
            return t;
        }
    },
    checkPwdLv: function(t) {
        var e = 0;
        return t.length < 6 || (/[0-9]/.test(t) && e++, /[a-z]/.test(t) && e++, /[A-Z]/.test(t) && e++, 
        /[\.|-|_]/.test(t) && e++), e;
    },
    getType: function(t) {
        var e = t, r = e.lastIndexOf("."), t = e.length;
        return e.substring(r, t);
    },
    randomString: function(t, e) {
        for (var r = "", n = t; 0 < n; --n) r += e[Math.floor(Math.random() * e.length)];
        return r;
    },
    insertStr: function(t, e, r) {
        return t.slice(0, e) + r + t.slice(e);
    },
    isObjectEqual: function(t, e) {
        var r = Object.getOwnPropertyNames(t), n = Object.getOwnPropertyNames(e);
        if (r.length !== n.length) return !1;
        for (var i = 0; i < r.length; i++) {
            var u = r[i];
            if (t[u] !== e[u]) return !1;
        }
        return !0;
    },
    randArr: function(t) {
        for (var e = t.length - 1; 0 <= e; e--) {
            var r = Math.floor(Math.random() * (e + 1)), n = t[r];
            t[r] = t[e], t[e] = n;
        }
        return t;
    },
    randArr_new: function(t) {
        for (var e = [], r = t.length + 1; 0 < r; ) {
            r--;
            var n = Math.floor(Math.random() * t.length);
            if (e.includes(t[n])) {
                if (e.length == t.length) break;
                r++;
            } else e.push(t[n]);
        }
        return e;
    },
    timeToDate: function(t) {
        var e = 1 < arguments.length && void 0 !== arguments[1] ? arguments[1] : 3, r = 2 < arguments.length && void 0 !== arguments[2] ? arguments[2] : "-", n = (t = new Date(1e3 * t)).getFullYear() + r, i = (t.getMonth() + 1 < 10 ? "0" + (t.getMonth() + 1) : t.getMonth() + 1) + r, u = t.getDate() < 10 ? "0" + t.getDate() : t.getDate(), s = (t.getHours() < 10 ? "0" + t.getHours() : t.getHours()) + ":", o = t.getMinutes() < 10 ? "0" + t.getMinutes() : t.getMinutes(), a = ":" + (t.getSeconds() < 10 ? "0" + t.getSeconds() : t.getSeconds());
        switch (e) {
          case 1:
            return n + i + u + " " + s + o + a;

          case 2:
            return n + i + u + " " + s + o;

          case 3:
            return n + i + u;

          case 4:
            return s + o;

          default:
            return n + i + u;
        }
    },
    dateToTime: function(t) {
        var e = 1 < arguments.length && void 0 !== arguments[1] ? arguments[1] : 3, r = new Date(t);
        switch (e) {
          case 1:
            return r.getTime();

          case 2:
            return r.valueOf();

          case 3:
          default:
            return Date.parse(r);
        }
    }
};

module.exports = {
    interopRequireDefault: utils._interopRequireDefault,
    tipsBox: utils.tipsBox,
    isNullOrEmpty: utils.isNullOrEmpty,
    isNull: utils.isNull,
    isNullTo: utils.isNull,
    isMobile: utils.isMobile,
    isFloat: utils.isFloat,
    isFloatTo: utils.isFloatTo,
    isNum: utils.isNum,
    formatNum: utils.formatNum,
    isEmail: utils.isEmail,
    isChinese: utils.isChinese,
    isEnglish: utils.isEnglish,
    isEnAndNo: utils.isEnAndNo,
    isSpecial: utils.isSpecial,
    isEmoji: utils.isEmoji,
    isDate: utils.isDate,
    isUrl: utils.isUrl,
    isContains: utils.isContains,
    sort: utils.sort,
    unique: utils.unique,
    deteleObject: utils.deteleObject,
    distinct: utils.distinct,
    union: utils.union,
    intersect: utils.intersect,
    removeTo: utils.removeTo,
    formArray: utils.formArray,
    GetMax: utils.GetMax,
    GetMin: utils.GetMin,
    GetSum: utils.GetSum,
    GetAverage: utils.GetAverage,
    removeTrim: utils.removeTrim,
    changeCase: utils.changeCase,
    checkPwdLv: utils.checkPwdLv,
    getType: utils.getType,
    randomString: utils.randomString,
    insertStr: utils.insertStr,
    isObjectEqual: utils.isObjectEqual,
    randArr: utils.randArr,
    randArr_new: utils.randArr_new,
    timeToDate: utils.timeToDate,
    dateToTime: utils.dateToTime
};