var __placeImgeUrlHttps = "https", __emojisReg = "", __emojisBaseSrc = "", __emojis = {}, wxDiscode = require("./wxDiscode.js"), HTMLParser = require("./htmlparser.js"), empty = makeMap("area,base,basefont,br,col,frame,hr,img,input,link,meta,param,embed,command,keygen,source,track,wbr"), block = makeMap("br,a,code,address,article,applet,aside,audio,blockquote,button,canvas,center,dd,del,dir,div,dl,dt,fieldset,figcaption,figure,footer,form,frameset,h1,h2,h3,h4,h5,h6,header,hgroup,hr,iframe,ins,isindex,li,map,menu,noframes,noscript,object,ol,output,p,pre,section,script,table,tbody,td,tfoot,th,thead,tr,ul,video"), inline = makeMap("abbr,acronym,applet,b,basefont,bdo,big,button,cite,del,dfn,em,font,i,iframe,img,input,ins,kbd,label,map,object,q,s,samp,script,select,small,span,strike,strong,sub,sup,textarea,tt,u,var"), closeSelf = makeMap("colgroup,dd,dt,li,options,p,td,tfoot,th,thead,tr"), fillAttrs = makeMap("checked,compact,declare,defer,disabled,ismap,multiple,nohref,noresize,noshade,nowrap,readonly,selected"), special = makeMap("wxxxcode-style,script,style,view,scroll-view,block");

function makeMap(e) {
    for (var t = {}, r = e.split(","), s = 0; s < r.length; s++) t[r[s]] = !0;
    return t;
}

function q(e) {
    return '"' + e + '"';
}

function removeDOCTYPE(e) {
    return e.replace(/<\?xml.*\?>\n/, "").replace(/<.*!doctype.*\>\n/, "").replace(/<.*!DOCTYPE.*\>\n/, "");
}

function trimHtml(e) {
    return e.replace(/\r?\n+/g, "").replace(/<!--.*?-->/gi, "").replace(/\/\*.*?\*\//gi, "").replace(/[ ]+</gi, "<");
}

function html2json(e, c) {
    e = trimHtml(e = removeDOCTYPE(e)), e = wxDiscode.strDiscode(e);
    var d = [], m = {
        node: c,
        nodes: [],
        images: [],
        imageUrls: []
    }, p = 0;
    return HTMLParser(e, {
        start: function(e, t, r) {
            var s, o = {
                node: "element",
                tag: e
            };
            if (0 === d.length ? (o.index = p.toString(), p += 1) : (void 0 === (s = d[0]).nodes && (s.nodes = []), 
            o.index = s.index + "." + s.nodes.length), block[e] ? o.tagType = "block" : inline[e] ? o.tagType = "inline" : closeSelf[e] && (o.tagType = "closeSelf"), 
            0 !== t.length && (o.attr = t.reduce(function(e, t) {
                var r = t.name, t = t.value;
                return "class" == r && (console.dir(t), o.classStr = t), "style" == r && (console.dir(t), 
                o.styleStr = t), t.match(/ /) && (t = t.split(" ")), e[r] ? Array.isArray(e[r]) ? e[r].push(t) : e[r] = [ e[r], t ] : e[r] = t, 
                e;
            }, {})), "img" === o.tag && (o.imgIndex = m.images.length, "" == (t = o.attr.src)[0] && t.splice(0, 1), 
            t = wxDiscode.urlToHttpUrl(t, __placeImgeUrlHttps), o.attr.src = t, o.from = c, 
            m.images.push(o), m.imageUrls.push(t)), "font" === o.tag) {
                var a, n, i = [ "x-small", "small", "medium", "large", "x-large", "xx-large", "-webkit-xxx-large" ], l = {
                    color: "color",
                    face: "font-family",
                    size: "font-size"
                };
                for (a in o.attr.style || (o.attr.style = []), o.styleStr || (o.styleStr = ""), 
                l) o.attr[a] && (n = "size" === a ? i[o.attr[a] - 1] : o.attr[a], o.attr.style.push(l[a]), 
                o.attr.style.push(n), o.styleStr += l[a] + ": " + n + ";");
            }
            "source" === o.tag && (m.source = o.attr.src), r ? (void 0 === (s = d[0] || m).nodes && (s.nodes = []), 
            s.nodes.push(o)) : d.unshift(o);
        },
        end: function(e) {
            var t = d.shift();
            t.tag !== e && console.error("invalid state: mismatch end tag"), "video" === t.tag && m.source && (t.attr.src = m.source, 
            delete m.source), 0 === d.length ? m.nodes.push(t) : (void 0 === (e = d[0]).nodes && (e.nodes = []), 
            e.nodes.push(t));
        },
        chars: function(e) {
            var t = {
                node: "text",
                text: e,
                textArray: transEmojiStr(e)
            };
            0 === d.length ? (t.index = p.toString(), p += 1, m.nodes.push(t)) : (void 0 === (e = d[0]).nodes && (e.nodes = []), 
            t.index = e.index + "." + e.nodes.length, e.nodes.push(t));
        },
        comment: function(e) {}
    }), m;
}

function transEmojiStr(e) {
    var t = [];
    if (0 == __emojisReg.length || !__emojis) return (n = {
        node: "text"
    }).text = e, s = [ n ];
    e = e.replace(/\[([^\[\]]+)\]/g, ":$1:");
    for (var r = new RegExp("[:]"), s = e.split(r), o = 0; o < s.length; o++) {
        var a = s[o], n = {};
        __emojis[a] ? (n.node = "element", n.tag = "emoji", n.text = __emojis[a], n.baseSrc = __emojisBaseSrc) : (n.node = "text", 
        n.text = a), t.push(n);
    }
    return t;
}

function emojisInit() {
    __emojisReg = 0 < arguments.length && void 0 !== arguments[0] ? arguments[0] : "", 
    __emojisBaseSrc = 1 < arguments.length && void 0 !== arguments[1] ? arguments[1] : "/wxParse/emojis/", 
    __emojis = arguments[2];
}

module.exports = {
    html2json: html2json,
    emojisInit: emojisInit
};