var _createClass = function() {
    function i(t, e) {
        for (var o = 0; o < e.length; o++) {
            var i = e[o];
            i.enumerable = i.enumerable || !1, i.configurable = !0, "value" in i && (i.writable = !0), 
            Object.defineProperty(t, i.key, i);
        }
    }
    return function(t, e, o) {
        return e && i(t.prototype, e), o && i(t, o), t;
    };
}();

function _classCallCheck(t, e) {
    if (!(t instanceof e)) throw new TypeError("Cannot call a class as a function");
}

var ERROR_CONF = {
    KEY_ERR: 311,
    KEY_ERR_MSG: "key格式错误",
    PARAM_ERR: 310,
    PARAM_ERR_MSG: "请求参数信息有误",
    SYSTEM_ERR: 600,
    SYSTEM_ERR_MSG: "系统错误",
    WX_ERR_CODE: 1e3,
    WX_OK_CODE: 200
}, BASE_URL = "https://apis.map.qq.com/ws/", URL_SEARCH = BASE_URL + "place/v1/search", URL_SUGGESTION = BASE_URL + "place/v1/suggestion", URL_GET_GEOCODER = BASE_URL + "geocoder/v1/", URL_CITY_LIST = BASE_URL + "district/v1/list", URL_AREA_LIST = BASE_URL + "district/v1/getchildren", URL_DISTANCE = BASE_URL + "distance/v1/", Utils = {
    location2query: function(t) {
        if ("string" == typeof t) return t;
        for (var e = "", o = 0; o < t.length; o++) {
            var i = t[o];
            e && (e += ";"), i.location && (e = e + i.location.lat + "," + i.location.lng), 
            i.latitude && i.longitude && (e = e + i.latitude + "," + i.longitude);
        }
        return e;
    },
    getWXLocation: function(t, e, o) {
        wx.getLocation({
            type: "gcj02",
            success: t,
            fail: e,
            complete: o
        });
    },
    getLocationParam: function(t) {
        return "string" == typeof t && (t = 2 === t.split(",").length ? {
            latitude: t.split(",")[0],
            longitude: t.split(",")[1]
        } : {}), t;
    },
    polyfillParam: function(t) {
        t.success = t.success || function() {}, t.fail = t.fail || function() {}, t.complete = t.complete || function() {};
    },
    checkParamKeyEmpty: function(t, e) {
        if (t[e]) return !1;
        e = this.buildErrorConfig(ERROR_CONF.PARAM_ERR, ERROR_CONF.PARAM_ERR_MSG + e + "参数格式有误");
        return t.fail(e), t.complete(e), !0;
    },
    checkKeyword: function(t) {
        return !this.checkParamKeyEmpty(t, "keyword");
    },
    checkLocation: function(t) {
        var e = this.getLocationParam(t.location);
        if (e && e.latitude && e.longitude) return !0;
        e = this.buildErrorConfig(ERROR_CONF.PARAM_ERR, ERROR_CONF.PARAM_ERR_MSG + " location参数格式有误");
        return t.fail(e), t.complete(e), !1;
    },
    buildErrorConfig: function(t, e) {
        return {
            status: t,
            message: e
        };
    },
    buildWxRequestConfig: function(o, t) {
        var i = this;
        return t.header = {
            "content-type": "application/json"
        }, t.method = "GET", t.success = function(t) {
            t = t.data;
            0 === t.status ? o.success(t) : o.fail(t);
        }, t.fail = function(t) {
            t.statusCode = ERROR_CONF.WX_ERR_CODE, o.fail(i.buildErrorConfig(ERROR_CONF.WX_ERR_CODE, result.errMsg));
        }, t.complete = function(t) {
            switch (+t.statusCode) {
              case ERROR_CONF.WX_ERR_CODE:
                o.complete(i.buildErrorConfig(ERROR_CONF.WX_ERR_CODE, t.errMsg));
                break;

              case ERROR_CONF.WX_OK_CODE:
                var e = t.data;
                0 === e.status ? o.complete(e) : o.complete(i.buildErrorConfig(e.status, e.message));
                break;

              default:
                o.complete(i.buildErrorConfig(ERROR_CONF.SYSTEM_ERR, ERROR_CONF.SYSTEM_ERR_MSG));
            }
        }, t;
    },
    locationProcess: function(e, t, o, i) {
        var r = this;
        o = o || function(t) {
            t.statusCode = ERROR_CONF.WX_ERR_CODE, e.fail(r.buildErrorConfig(ERROR_CONF.WX_ERR_CODE, t.errMsg));
        }, i = i || function(t) {
            t.statusCode == ERROR_CONF.WX_ERR_CODE && e.complete(r.buildErrorConfig(ERROR_CONF.WX_ERR_CODE, t.errMsg));
        }, e.location ? r.checkLocation(e) && t(Utils.getLocationParam(e.location)) : r.getWXLocation(t, o, i);
    }
}, QQMapWX = function() {
    function e(t) {
        if (_classCallCheck(this, e), !t.key) throw Error("key值不能为空");
        this.key = t.key;
    }
    return _createClass(e, [ {
        key: "search",
        value: function(e) {
            var o, i, r;
            e = e || {}, Utils.polyfillParam(e), Utils.checkKeyword(e) && (o = {
                keyword: e.keyword,
                orderby: e.orderby || "_distance",
                page_size: e.page_size || 10,
                page_index: e.page_index || 1,
                output: "json",
                key: this.key
            }, e.address_format && (o.address_format = e.address_format), e.filter && (o.filter = e.filter), 
            i = e.distance || "1000", r = e.auto_extend || 1, Utils.locationProcess(e, function(t) {
                o.boundary = "nearby(" + t.latitude + "," + t.longitude + "," + i + "," + r + ")", 
                wx.request(Utils.buildWxRequestConfig(e, {
                    url: URL_SEARCH,
                    data: o
                }));
            }));
        }
    }, {
        key: "getSuggestion",
        value: function(t) {
            var e;
            t = t || {}, Utils.polyfillParam(t), Utils.checkKeyword(t) && (e = {
                keyword: t.keyword,
                region: t.region || "全国",
                region_fix: t.region_fix || 0,
                policy: t.policy || 0,
                output: "json",
                key: this.key
            }, wx.request(Utils.buildWxRequestConfig(t, {
                url: URL_SUGGESTION,
                data: e
            })));
        }
    }, {
        key: "reverseGeocoder",
        value: function(e) {
            e = e || {}, Utils.polyfillParam(e);
            var o = {
                coord_type: e.coord_type || 5,
                get_poi: e.get_poi || 0,
                output: "json",
                key: this.key
            };
            e.poi_options && (o.poi_options = e.poi_options);
            Utils.locationProcess(e, function(t) {
                o.location = t.latitude + "," + t.longitude, wx.request(Utils.buildWxRequestConfig(e, {
                    url: URL_GET_GEOCODER,
                    data: o
                }));
            });
        }
    }, {
        key: "geocoder",
        value: function(t) {
            var e;
            t = t || {}, Utils.polyfillParam(t), Utils.checkParamKeyEmpty(t, "address") || (e = {
                address: t.address,
                output: "json",
                key: this.key
            }, wx.request(Utils.buildWxRequestConfig(t, {
                url: URL_GET_GEOCODER,
                data: e
            })));
        }
    }, {
        key: "getCityList",
        value: function(t) {
            t = t || {}, Utils.polyfillParam(t);
            var e = {
                output: "json",
                key: this.key
            };
            wx.request(Utils.buildWxRequestConfig(t, {
                url: URL_CITY_LIST,
                data: e
            }));
        }
    }, {
        key: "getDistrictByCityId",
        value: function(t) {
            var e;
            t = t || {}, Utils.polyfillParam(t), Utils.checkParamKeyEmpty(t, "id") || (e = {
                id: t.id || "",
                output: "json",
                key: this.key
            }, wx.request(Utils.buildWxRequestConfig(t, {
                url: URL_AREA_LIST,
                data: e
            })));
        }
    }, {
        key: "calculateDistance",
        value: function(e) {
            var o;
            e = e || {}, Utils.polyfillParam(e), Utils.checkParamKeyEmpty(e, "to") || (o = {
                mode: e.mode || "walking",
                to: Utils.location2query(e.to),
                output: "json",
                key: this.key
            }, e.from && (e.location = e.from), Utils.locationProcess(e, function(t) {
                o.from = t.latitude + "," + t.longitude, wx.request(Utils.buildWxRequestConfig(e, {
                    url: URL_DISTANCE,
                    data: o
                }));
            }));
        }
    } ]), e;
}();

module.exports = QQMapWX;